define("app/ui/dialogs/age_gate_dialog",["module","require","exports","core/component","app/ui/with_dialog","core/i18n","core/utils","app/utils/cookie"],function(module, require, exports) {
function ageGateDialog(){this.defaultAttrs({submitButtonSelector:"#age-gate-dialog-submit-button",monthSelector:"#age-gate-month",daySelector:"#age-gate-day",yearSelector:"#age-gate-year",requiredSelector:".age-gate-error",ageGateCookieKey:"age-gated"}),this.setUpDialog=function(a,b){b.ageGated?this.showError():(this.reset(),this.ageData=b,this.setDateOption(),this.open())},this.fillYearSelect=function(){var a=(new Date).getFullYear();for(var b=a;b>a-100;b--)this.yearSelect.options.add(new Option(b,b));this.yearSelect.options.add(new Option(_('{{year}}\u5e74\u4ee5\u524d',{year:b}),b))},this.month={1:_('1\u6708'),2:_('2\u6708'),3:_('3\u6708'),4:_('4\u6708'),5:_('5\u6708'),6:_('6\u6708'),7:_('7\u6708'),8:_('8\u6708'),9:_('9\u6708'),10:_('10\u6708'),11:_('11\u6708'),12:_('12\u6708')},this.fillMonthSelect=function(){for(var a=1;a<=12;a++)this.monthSelect.options.add(new Option(this.month[a],a))},this.fillDaySelect=function(a,b){a||(a=1),b||(b=31);for(var c=a;c<=b;c++)this.daySelect.options.add(new Option(c,c))},this.resetSelect=function(a,b){a.options.length=0,a.options.add(new Option(b,-1,!0,!0)),a.options[0].disabled=!0},this.reset=function(){this.resetSelect(this.yearSelect,_('\u5e74')),this.resetSelect(this.monthSelect,_('\u6708')),this.resetSelect(this.daySelect,_('\u65e5')),this.hideRequired()},this.setDateOption=function(){this.fillYearSelect(),this.fillMonthSelect(),this.fillDaySelect()},this.showRequired=function(){this.select("requiredSelector").removeClass("hidden")},this.hideRequired=function(){this.select("requiredSelector").addClass("hidden")},this.getDateFromSelect=function(){var a={};return a.year=this.yearSelect.options[this.yearSelect.selectedIndex].value,a.month=this.monthSelect.options[this.monthSelect.selectedIndex].value,a.day=this.daySelect.options[this.daySelect.selectedIndex].value,a},this.getNumberOfDaysGivenMonthYear=function(a,b){return b<0&&(b=2012),(new Date(b,a,0)).getDate()},this.validateDate=function(){var a=this.getDateFromSelect(),b=0<a.year&&0<a.month&&a.month<=12&&0<a.day&&a.day<=this.getNumberOfDaysGivenMonthYear(a.month,a.year);return b?new Date(a.year,a.month-1,a.day):(a.year==-1||a.month==-1||a.day==-1?this.showRequired():this.trigger("uiShowMessage",{message:_('\u30c7\u30fc\u30bf\u304c\u7121\u52b9\u3067\u3059\u3001\u751f\u5e74\u6708\u65e5\u3092\u518d\u5ea6\u5165\u529b\u3057\u3066\u4e0b\u3055\u3044\u3002')}),null)},this.updateDays=function(){var a,b=this.getDateFromSelect();this.hideRequired();if(b.month<1||b.month>12)return;this.resetSelect(this.daySelect,"Day"),a=this.getNumberOfDaysGivenMonthYear(b.month,b.year),this.fillDaySelect(1,a),b.day>0&&b.day<=a&&(this.daySelect.selectedIndex=b.day)},this.showError=function(){this.trigger("uiShowMessage",{message:_('\u3053\u306e\u30a2\u30ab\u30a6\u30f3\u30c8\u3092\u30d5\u30a9\u30ed\u30fc\u3067\u304d\u308b\u5e74\u9f62\u306b\u9054\u3057\u3066\u3044\u307e\u305b\u3093\u3002')})},this.setAgeGateCookie=function(){cookie(this.attr.ageGateCookieKey,(new Date).getTime())},this.submitAgeGating=function(){var a=this.validateDate();a&&(a.getTime()<=this.ageData.minBirthDate?this.trigger("uiAgeGatePassed",utils.merge(this.ageData.originalData,{passedAgeGating:!0})):(this.showError(),this.setAgeGateCookie()),this.close())},this.after("initialize",function(){this.monthSelect=this.select("monthSelector")[0],this.daySelect=this.select("daySelector")[0],this.yearSelect=this.select("yearSelector")[0],this.on(document,"uiNeedsAgeGateDialog",this.setUpDialog),this.on("click",{submitButtonSelector:this.submitAgeGating}),this.on("change",{monthSelector:this.updateDays,yearSelector:this.updateDays,daySelector:this.hideRequired})})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),_=require("core/i18n"),utils=require("core/utils"),cookie=require("app/utils/cookie"),AgeGateDialog=defineComponent(ageGateDialog,withDialog);module.exports=AgeGateDialog
});
define("app/ui/dialogs/block_or_report",["module","require","exports","core/component","core/i18n","app/ui/with_dialog"],function(module, require, exports) {
function blockOrReportDialog(){this.defaultAttrs({blockUserLabelSelector:".block-user-label",blockUserTextSelector:".block-user-text",blockButtonSelector:".report-tweet-block-button",reportButtonSelector:".report-tweet-report-button",nextButtonSelector:".report-tweet-next-button",reportTypeSelector:"input[name=report_type]",abusiveTypeSelector:"input[name=abuse_type]",selectedReportTypeSelector:"input[name=report_type]:checked",selectedAnnoyingSelector:"input[value=annoying]",selectedAbusiveTypeSelector:"input[name=abuse_type]:checked",blockInputSelector:"input[name=block_user]",alsoReportInputSelector:"input[name=also_report]",impersonationLinkSelector:".report-impersonation-link",trademarkLinkSelector:".report-trademark-link",harassmentLinkSelector:".report-harassment-link",selfHarmLinkSelector:".report-self-harm-link",adsLinkSelector:".report-ads-link",twitterRulesLinkSelector:".twitter-rules-link",abuseLinks:{impersonation:"https://support.twitter.com/forms/impersonation?{{q}}",trademark:"https://support.twitter.com/forms/trademark?{{q}}",harassment:"https://support.twitter.com/forms/abusiveuser?{{q}}",selfHarm:"https://support.twitter.com/forms/general?subtopic=self_harm&{{q}}",ads:"https://support.twitter.com/forms/ads?{{q}}"}}),this.setUpDialog=function(a,b){this.reset(),this.eventData=b,this.setAlreadyBlocking(),this.setTriggeredTarget(),this.setScreenNameText(),this.setDescriptionText(),this.setAbuseReportLinks(),this.open()},this.reset=function(){this.isComplete=!1,this.$node.addClass("block-selected"),this.select("blockInputSelector").attr("checked",!0),this.select("blockButtonSelector").attr("disabled",!1),this.resetReportSection()},this.resetReportSection=function(){this.$node.removeClass("abuse-selected"),this.$node.removeClass("also-report-selected"),this.select("selectedAnnoyingSelector").attr("checked",!0),this.select("alsoReportInputSelector").attr("checked",!1),this.select("selectedAbusiveTypeSelector").attr("checked",!1),this.select("reportButtonSelector").attr("disabled",!0),this.select("nextButtonSelector").attr("disabled",!0)},this.setAlreadyBlocking=function(){this.eventData.viewerBlocksAuthor?(this.$node.addClass("already-blocking"),this.select("blockInputSelector").attr("checked",!1),this.select("alsoReportInputSelector").attr("checked",!0),this.select("reportButtonSelector").attr("disabled",!1),this.updateState()):this.$node.removeClass("already-blocking")},this.setTriggeredTarget=function(){this.eventData.target==="user"?this.$node.addClass("user-triggered"):this.$node.removeClass("user-triggered")},this.setScreenNameText=function(){var a=this.select("blockUserLabelSelector");a.text(_('@{{screenName}}\u3055\u3093\u3092\u30d6\u30ed\u30c3\u30af',this.eventData)),this.select("blockUserTextSelector").text(_('@{{screenName}}\u3055\u3093\u306f\u3001\u3042\u306a\u305f\u3092\u30d5\u30a9\u30ed\u30fc\u3057\u305f\u308a\u3001\u30e1\u30c3\u30bb\u30fc\u30b8\u3092\u9001\u4fe1\u3059\u308b\u3053\u3068\u306f\u3067\u304d\u306a\u304f\u306a\u308a\u307e\u3059\u3002',this.eventData))},this.isTriggeredByUser=function(a,b){return b.target==="user"},this.setDescriptionText=function(a,b){var c=$(".spam-desc"),d=$(".abuse-desc"),e=$(".annoying-desc");this.$node.hasClass("user-triggered")?(e.text(_('\u3053\u306e\u30a2\u30ab\u30a6\u30f3\u30c8\u306f\u8ff7\u60d1\u3067\u3059')),c.text(_('\u3053\u308c\u306f\u30b9\u30d1\u30e0\u30a2\u30ab\u30a6\u30f3\u30c8\u3067\u3059')),d.text(_('\u30e6\u30fc\u30b6\u30fc\u60c5\u5831'))):(e.text(_('\u3053\u306e\u30c4\u30a4\u30fc\u30c8\u306f\u8ff7\u60d1\u3067\u3059\u3002')),c.text(_('\u3053\u306e\u30c4\u30a4\u30fc\u30c8\u306f\u30b9\u30d1\u30e0\u3067\u3059\u3002')),d.text(_('\u30c4\u30a4\u30fc\u30c8')))},this.setAbuseReportLinks=function(){var a="reported_username={{screenName}}&reported_tweet_id={{tweetId}}",b={q:_(a,this.eventData)},c=this.attr.abuseLinks;this.select("impersonationLinkSelector").attr("data-form-link",_(c.impersonation,b)),this.select("trademarkLinkSelector").attr("data-form-link",_(c.trademark,b)),this.select("harassmentLinkSelector").attr("data-form-link",_(c.harassment,b)),this.select("selfHarmLinkSelector").attr("data-form-link",_(c.selfHarm,b)),this.select("adsLinkSelector").attr("data-form-link",_(c.ads,b))},this.updateState=function(){function a(a,b){var c=b?"addClass":"removeClass";this.$node[c](a)}function b(a,b){this.select(a).attr("disabled",!b)}var c=this.blockUserIsChecked(),d=this.alsoReportIsChecked(),e=this.reportType()=="abusive",f=this.select("abusiveTypeSelector").is(":checked"),g=[["block-selected",c],["also-report-selected",d],["abuse-selected",e]];g.forEach(function(b){a.call(this,b[0],b[1])},this);var h=[["blockButtonSelector",c],["reportButtonSelector",d],["nextButtonSelector",f]];h.forEach(function(a){b.call(this,a[0],a[1])},this),d||this.resetReportSection()},this.reportType=function(){return this.select("selectedReportTypeSelector").val()},this.abusiveType=function(){return this.select("selectedAbusiveTypeSelector").val()},this.blockUserIsChecked=function(){return this.select("blockInputSelector").attr("checked")=="checked"},this.alsoReportIsChecked=function(){return this.select("alsoReportInputSelector").attr("checked")=="checked"||this.select("alsoReportInputSelector").length==0},this.submitReport=function(){var a=this.$node.hasClass("user-triggered")?"uiReportUserAction":"uiDidBlockOrReport",b=this.alsoReportIsChecked()?this.reportType():"";this.trigger(a,{eventData:this.eventData,tweetId:this.eventData.tweetId,userId:this.eventData.userId,screenName:this.eventData.screenName,reportType:b,blockUser:this.blockUserIsChecked(),impressionId:this.eventData.impressionId,disclosureType:this.eventData.disclosureType}),this.blockUserIsChecked()&&this.trigger("uiDidTriggerBlockingAction",{userId:this.eventData.userId})},this.blockOrReport=function(){this.submitReport(),this.completeReport()},this.reportAbuseNext=function(){this.submitReport();if(this.abusiveType()){var a=this.select("selectedAbusiveTypeSelector").attr("data-form-link");this.reportAbuseToSupport(),window.open(a,"_blank")}this.completeReport()},this.reportAbuseToSupport=function(a,b){this.trigger("uiDidBlockOrReportToSupport",{eventData:this.eventData,abuseType:this.abusiveType(),userId:this.eventData.userId}),this.completeReport()},this.cancelReport=function(){this.trigger("uiDidCancelBlockOrReport",this.eventData)},this.completeReport=function(){this.isComplete=!0,this.close()},this.around("close",function(a){this.isOpen()&&!this.isComplete&&this.cancelReport(),a()}),this.twitterRulesClick=function(){this.trigger("uiDidOpenTwitterRulesLink",{eventData:this.eventData,userId:this.eventData.userId})},this.after("initialize",function(){this.isComplete=!1,this.on(document,"uiNeedsBlockOrReportDialog",this.setUpDialog),this.on("click",{blockButtonSelector:this.blockOrReport,reportButtonSelector:this.blockOrReport,nextButtonSelector:this.reportAbuseNext,twitterRulesLinkSelector:this.twitterRulesClick}),this.on("change",{blockInputSelector:this.updateState,alsoReportInputSelector:this.updateState,reportTypeSelector:this.updateState,abusiveTypeSelector:this.updateState})})}var defineComponent=require("core/component"),_=require("core/i18n"),withDialog=require("app/ui/with_dialog"),BlockOrReportDialog=defineComponent(withDialog,blockOrReportDialog);module.exports=BlockOrReportDialog
});
define("app/ui/dialogs/with_modal_tweet",["module","require","exports","app/data/user_info"],function(module, require, exports) {
function withModalTweet(){this.defaultAttrs({modalTweetContainerSelector:".modal-container",modalTweetDoGearSelector:".dogear",modalTweetLoadingClass:"tweet-loading",modalTweetSelector:".modal-tweet",modalTweetShowingClass:"tweet-showing",modalTweetTimeSelector:".time",modalTweetTextSelector:".js-tweet-text"}),this.modalTweetOptions={},this.turnOnShowingTweetClass=function(){this.$node.addClass(this.attr.modalTweetShowingClass)},this.turnOffShowingTweetClass=function(){this.$node.removeClass(this.attr.modalTweetShowingClass)},this.turnOnLoadingTweetClass=function(){this.$node.addClass(this.attr.modalTweetLoadingClass)},this.turnOffLoadingTweetClass=function(){this.$node.removeClass(this.attr.modalTweetLoadingClass)},this.displayTweet=function(a,b,c){this.modalTweetOptions=c,this.retrieveTweet(a,c)},this.retrieveTweet=function(a,b){this.turnOnLoadingTweetClass(),this.trigger("uiGetTweet",{id:a,modal:b.modal}),this.modalTweetOptions=b},this.gotTweet=function(a,b){this.turnOffLoadingTweetClass(),b.id&&b.tweet_html&&(this.addTweet(b.tweet_html),this.cleanUpTweet(this.modalTweetOptions))},this.cleanUpTweet=function(a){a&&a.userOnly&&(this.$node.find(this.attr.modalTweetTimeSelector).remove(),this.$node.find(this.attr.modalTweetDoGearSelector).remove(),this.$node.find(this.attr.modalTweetTextSelector).remove())},this.addTweet=function(a){this.select("modalTweetSelector").empty().append(a),this.turnOnShowingTweetClass()},this.removeTweet=function(){this.turnOffLoadingTweetClass(),this.turnOffShowingTweetClass(),this.select("modalTweetSelector").empty()},this.after("initialize",function(){this.on(document,"dataGotTweet",this.gotTweet),this.on(document,"uiDialogClosed",this.removeTweet)})}var userInfo=require("app/data/user_info");module.exports=withModalTweet
});
define("app/ui/dialogs/block_user_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/dialogs/with_modal_tweet"],function(module, require, exports) {
function blockUserDialog(){this.defaults={cancelSelector:".cancel-action",blockSelector:".block-action"},this.openBlockUser=function(a,b){var c={userOnly:!0,modal:"block"};this.attr.sourceEventData=b,this.displayTweet(b.tweetId,$(a.target.children[0]).clone(),c),this.open()},this.blockUser=function(){this.trigger("uiDidBlockUser",{sourceEventData:this.attr.sourceEventData}),this.close()},this.after("initialize",function(){this.on("click",{cancelSelector:this.close,blockSelector:this.blockUser}),this.on(document,"uiOpenBlockUserDialog",this.openBlockUser)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withModalTweet=require("app/ui/dialogs/with_modal_tweet");module.exports=defineComponent(blockUserDialog,withDialog,withModalTweet)
});
define("app/ui/with_position",["module","require","exports"],function(module, require, exports) {
function Position(){this.adjacent=function(a,b,c){var d,e;c=c||{},d=e=b.offset(),e.gravity=c.gravity,e.weight=c.weight;var f={height:b.outerHeight(),width:b.outerWidth()},g={height:a.outerHeight(),width:a.outerWidth()},h={height:$(window).height(),width:$(window).width()},i={height:$("body").height(),width:$("body").width()};return e.gravity||(e.gravity="vertical"),"vertical,vertical-north,north,south".indexOf(e.gravity)!=-1&&("right,left,center".indexOf(e.weight)==-1&&(e.weight=d.left+g.width>h.width?"right":"left"),e.gravity=="vertical-north"?e.gravity=d.top-g.height<$(window).scrollTop()?"north":"south":e.gravity=="vertical"&&(e.gravity=d.top+g.height>$(window).scrollTop()+h.height?"south":"north"),c.position=="relative"&&(d={left:0,top:0},e.left=0),e.weight=="right"?e.left=d.left-g.width+f.width:e.weight=="center"&&(e.left=d.left-(g.width-f.width)/2),e.top=e.gravity=="north"?d.top+f.height:d.top-g.height),"horizontal,east,west".indexOf(e.gravity)!=-1&&("top,bottom,center".indexOf(e.weight)==-1&&(d.top-g.height/2<0?e.weight="top":d.top+g.height/2>Math.max(h.height,i.height)?e.weight="bottom":e.weight="center"),e.gravity=="horizontal"&&(e.gravity=d.left+f.width/2>h.width/2?"east":"west"),c.position=="relative"&&(d={left:0,top:0},e.top=0),e.weight=="center"?e.top=d.top+f.height/2-g.height/2:e.weight=="bottom"&&(e.top=d.top-g.height+f.height),e.left=e.gravity=="west"?d.left+f.width:d.left-g.width),e}}module.exports=Position
});
define("app/utils/with_iframe_height_adjuster",["module","require","exports"],function(module, require, exports) {
function withIframeHeightAdjuster(){this.fitIframeHeight=function(a,b){if(!a||!b)return;var c=b.iframeSelector||this.attr.iframeSelector,d={};a.originalEvent&&(a=a.originalEvent);if(a.origin===window.location.protocol+"//"+window.location.host){if(typeof a.data=="string"&&a.data!="undefined"&&a.data!="[object Object]")try{d=JSON.parse(a.data)}catch(e){console.log("Failed to JSON.parse: "+a.data)}$.isFunction(b.isQualified)&&b.isQualified(d)&&(this.$node.find(c).css("height",d.height+"px"),$.isFunction(b.additonalTreatment)&&b.additonalTreatment(this.$node.find(c)))}}}module.exports=withIframeHeightAdjuster
});
define("app/ui/dialogs/buy_now_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/with_position","app/utils/with_iframe_height_adjuster"],function(module, require, exports) {
function buyNowConfirmDialog(){this.defaultAttrs({buyNowDialogIframeSelector:".buy-now-card-iframe",buyNowActionSelector:".BuyNowCard-buyNowAction",defaultHeight:"400px"}),this.openDialog=function(a,b){var c;b&&b.tweetId&&(c="/i/pay/status/"+b.tweetId,this.select("buyNowDialogIframeSelector").attr("src",c),this.open())},this.closeDialog=function(a,b){this.select("buyNowDialogIframeSelector").attr("src","about:blank"),this.select("buyNowDialogIframeSelector").css("height",this.attr.defaultHeight)},this.adjustIframeHeight=function(a){var b={iframeSelector:this.attr.buyNowDialogIframeSelector,isQualified:function(a){return a.name&&a.name==="buy_now"&&a.height}};this.fitIframeHeight(a,b)},this.buyNowActionClicked=function(a,b){var c=$(b.el).closest(".tweet").data("tweet-id");this.trigger("uiNeedsBuyNowDialog",{tweetId:c})},this.after("initialize",function(){this.on(window,"message",this.adjustIframeHeight),this.on("uiDialogClosed",this.closeDialog),this.on("uiNeedsBuyNowDialog",this.openDialog),this.on(document,"click",{buyNowActionSelector:this.buyNowActionClicked})}),this.before("teardown",function(){this.off(window,"message",this.adjustIframeHeight)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withPosition=require("app/ui/with_position"),withIframeHeightAdjuster=require("app/utils/with_iframe_height_adjuster"),BuyNowConfirmDialog=defineComponent(buyNowConfirmDialog,withDialog,withPosition,withIframeHeightAdjuster);module.exports=BuyNowConfirmDialog
});
define("app/ui/dialogs/captcha_challenge_dialog",["module","require","exports","core/component","app/ui/with_dialog"],function(module, require, exports) {
function captchaChallengeDialog(){this.defaultAttrs({challengeSelector:"#recaptcha_challenge_field",responseSelector:"#recaptcha_response_field",submitSelector:"#recaptcha_submit",captchaName:"Captcha",bodyTextSelector:".modal-text",captchaFormSelector:"#captcha-challenge-form",recaptchaPublicKey:"6LfbTAAAAAAAAE0hk8Vnfd1THHnn9lJuow6fgulO"}),this.refreshCaptchaDialog=function(a,b){this.reloadCaptcha(),this.open()},this.reloadCaptcha=function(){Recaptcha&&Recaptcha.reload()},this.submitCaptcha=function(){var a=this.select("challengeSelector").val(),b=this.select("responseSelector").val();this.trigger("uiSubmitSpamChallenge",{challenge:a,response:b,challengeName:this.attr.captchaName})},this.getRecaptcha=function(a,b){this.isRecaptchaDefined()&&Recaptcha.create(this.attr.recaptchaPublicKey,"captcha-challenge-form",{theme:"clean",callback:function(){Recaptcha.focus_response_field(),a&&b.select("bodyTextSelector").text(a),b.open()}})},this.isRecaptchaDefined=function(){return typeof Recaptcha!="undefined"},this.openCaptchaDialog=function(a,b){this.getRecaptcha(b.message,this)},this.after("initialize",function(){this.on("click",{submitSelector:this.submitCaptcha}),this.on(document,"uiOpenSpamCaptchaChallenge",this.openCaptchaDialog),this.on(document,"uiCloseSpamCaptchaChallenge",this.blurAndCloseImmediately),this.on(document,"uiRefreshSpamCaptchaChallenge",this.refreshCaptchaDialog)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog");module.exports=defineComponent(captchaChallengeDialog,withDialog)
});
define("app/utils/with_event_params",["module","require","exports","core/utils","core/parameterize"],function(module, require, exports) {
function withEventParams(){this.rewriteEventName=function(a){var b=[];for(var c=1;c<arguments.length;c++)b[c-1]=arguments[c];var d=typeof b[0]=="string"||b[0].defaultBehavior?0:1,e=b[d],f=e.type||e;b[d]=parameterize(f,this.attr.eventParams,!0),e.type&&(e.type=b[d],b[d]=e),a.apply(this,b)},this.around("on",this.rewriteEventName),this.around("off",this.rewriteEventName),this.around("trigger",this.rewriteEventName)}var util=require("core/utils"),parameterize=require("core/parameterize");module.exports=withEventParams
});
define("template",["module"],function(a){var b={};b.swift_tweet_box=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<form class="t1-form tweet-form '),d.s(d.f("preexpand_tweetbox",a,b,1),a,b,1,0,0,"")||d.b("condensed"),d.b(" "),d.s(d.f("drag_and_drop_tweet_box",a,b,1),a,b,0,116,129,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("drag-and-drop")}),a.pop()),d.b('"\n      method="post"\n      target="tweet-post-iframe"\n'),d.s(d.f("screen_names_for_tweet_box",a,b,1),a,b,0,249,384,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        data-default-text="'),c.b(c.v(c.f("screen_names_for_tweet_box",a,b,0))),c.b(' "\n        data-condensed-text="'),c.b(c.v(c.f("screen_names_for_tweet_box",a,b,0))),c.b('さんへ返信する"\n')}),a.pop()),d.s(d.f("condensed_tweet_box_text",a,b,1),a,b,0,451,517,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        data-condensed-text="'),c.b(c.v(c.f("condensed_tweet_box_text",a,b,0))),c.b('"\n')}),a.pop()),d.b('      action="//'),d.b(d.v(d.f("upload_domain",a,b,0))),d.b('/i/tweet/create_with_media.iframe"\n      enctype="multipart/form-data">\n  <input type="hidden" name="post_authenticity_token" class="auth-token">\n  <input type="hidden" name="iframe_callback" class="iframe-callback">\n  <input type="hidden" name="in_reply_to_status_id" class="in-reply-to-status-id">\n  <input type="hidden" name="impression_id" class="impression-id">\n  <input type="hidden" name="earned" class="earned">\n  <input type="hidden" name="page_context" class="page-context">\n'),d.s(d.f("media_tagging_compose_enabled",a,b,1),a,b,0,1101,1169,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('  <input type="hidden" name="tagged_users" class="tagged-users">\n')}),a.pop()),d.b("\n"+c),d.s(d.f("current_user",a,b,1),a,b,0,1224,1327,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <img class="inline-reply-user-image avatar size32" src="'),c.b(c.v(c.f("profile_image_absolute_url",a,b,0))),c.b('" alt="">\n')}),a.pop()),d.b('  <span class="inline-reply-caret">\n    <span class="caret-inner"></span>\n  </span>\n\n  <div class="tweet-content">\n    <span class="icon add-photo-icon hidden"></span>\n'),d.b('    <span class="icon nav-tweet hidden"></span>\n    <span class="tweet-drag-help tweet-drag-photo-here hidden">画像をこちらにドラッグしてください</span>\n    <span class="tweet-drag-help tweet-or-drag-photo-here hidden">または画像をこちらにドラッグしてください</span>\n    <span class="visuallyhidden" id="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('-label">ツイート内</br>テキスト</span>\n\n'),d.b('    <div aria-labelledby="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('-label" id="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('" class="tweet-box rich-editor '),d.s(d.f("use_user_colors",a,b,1),a,b,0,2123,2222,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("u-textUserColor u-borderUserColorLight u-borderUserColorLightFocus u-boxShadowUserColorLighterFocus")}),a.pop()),d.b('" contenteditable="true" spellcheck="true" role="textbox"\n      aria-multiline="true">'),d.b(d.rp("<prefilled_tweetbox_content0",a,b,"")),d.b('</div>\n    <div class="rich-normalizer"></div>\n\n'),d.b(d.rp("<swift_typeahead_dropdown1",a,b,"    ")),d.b("\n"+c),d.b('    <textarea aria-hidden="true" class="tweet-box-shadow" name="status"></textarea>\n\n'),d.b('    <div class="thumbnail-container">\n      <div class="previews"></div>\n      <div class="preview template">\n'),d.b(d.rp("<dismiss_button2",a,b,"        ")),d.b('        <span class="filename"></span>\n      </div>\n      <div class="preview-message">\n'),d.s(d.f("media_tagging_compose_enabled",a,b,1),a,b,0,2897,3206,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('          <button type="button" class="start-tagging js-open-user-select no-users u-borderUserColorLight u-textUserColor" disabled>\n            <span class="Icon Icon--me Icon--smallest"></span>\n            <span class="tagged-users">\n              誰が写っていますか?\n            </span>\n          </button>\n')}),a.pop()),d.b("      </div>\n    </div>\n"),d.s(d.f("media_tagging_compose_enabled",a,b,1),a,b,0,3303,4080,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('      <div class="photo-tagging-container user-select-container hidden">\n        <div class="tagging-dropdown dropdown-menu">\n          <div class="dropdown-caret center">\n            <div class="caret-outer"></div>\n            <div class="caret-inner"></div>\n          </div>\n          <div class="photo-tagging-controls user-select-controls">\n            <label class="t1-label">\n              <span class="Icon Icon--search nav-search"></span>\n              <span class="u-hiddenVisually">この画像に写っているユーザー</span>\n              <input class="js-initial-focus" type="text" placeholder="検索して10人までタグ付けする">\n            </label>\n          </div>\n          <div class="typeahead-container">\n'),c.b(c.rp("<swift_typeahead_dropdown3",a,b,"            ")),c.b("          </div>\n        </div>\n      </div>\n")}),a.pop()),d.b("  </div>\n\n"),d.s(d.f("tweetbox_skip_button",a,b,1),a,b,0,4152,4238,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <button type="button" class="btn tweet-skip-button u-floatRight">スキップ</button>\n')}),a.pop()),d.b('  <div class="toolbar js-toolbar">\n    <div class="tweet-box-extras">\n\n'),d.s(d.f("include_image_picker",a,b,1),a,b,0,4366,4405,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.rp("<media/media_picker4",a,b,"        "))}),a.pop()),d.b("\n"+c),d.s(d.f("content_view",a,b,1),a,b,0,4455,4594,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.s(c.f("include_lifeline_alert_status",a,b,1),a,b,0,4498,4553,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b(c.rp("<lifeline/lifeline_alert_status5",a,b,"          "))}),a.pop())}),a.pop()),d.b("\n"+c),d.s(d.f("include_geo_picker",a,b,1),a,b,0,4642,4677,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.rp("<geo/geo_picker6",a,b,"        "))}),a.pop()),d.b("\n"+c),d.b('    </div>\n    <div class="tweet-button">\n      <span class="spinner"></span>\n      <span class="tweet-counter">140</span>\n'),d.b(d.rp("<tweet_button7",a,b,"      ")),d.b("    </div>\n  </div>\n</form>\n"),d.fl()},partials:{"<prefilled_tweetbox_content0":{name:"prefilled_tweetbox_content",partials:{},subs:{}},"<swift_typeahead_dropdown1":{name:"swift_typeahead_dropdown",partials:{},subs:{}},"<dismiss_button2":{name:"dismiss_button",partials:{},subs:{}},"<swift_typeahead_dropdown3":{name:"swift_typeahead_dropdown",partials:{},subs:{}},"<media/media_picker4":{name:"media/media_picker",partials:{},subs:{}},"<lifeline/lifeline_alert_status5":{name:"lifeline/lifeline_alert_status",partials:{},subs:{}},"<geo/geo_picker6":{name:"geo/geo_picker",partials:{},subs:{}},"<tweet_button7":{name:"tweet_button",partials:{},subs:{}}},subs:{}}),b.dismiss_button=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<button type="button" class="dismiss js-dismiss" tabindex="-1">\n  <span class="icon dismiss-white">\n    <span class="visuallyhidden">\n      非表示にする\n    </span>\n  </span>\n</button>\n'),d.fl()},partials:{},subs:{}}),b.swift_dm_box=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<form class="t1-form dm-tweetbox tweet-form'),d.s(d.f("drag_and_drop_tweet_box",a,b,1),a,b,0,71,85,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(" drag-and-drop")}),a.pop()),d.b('"\n'),d.s(d.f("uploads_in_dms",a,b,1),a,b,0,136,280,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    method="post"\n    target="dm-post-iframe"\n    action="//'),c.b(c.v(c.f("media_upload_domain",a,b,0))),c.b('/i/media/upload.iframe"\n    enctype="multipart/form-data"\n')}),a.pop()),d.b('>\n  <div class="tweet-content">\n'),d.s(d.f("uploads_in_dms",a,b,1),a,b,0,355,619,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('      <input type="hidden" name="authenticity_token" class="auth-token">\n      <span class="tweet-drag-help tweet-drag-photo-here hidden">画像をこちらにドラッグしてください</span>\n      <span class="tweet-drag-help tweet-or-drag-photo-here hidden">または画像をこちらにドラッグしてください</span>\n')}),a.pop()),d.b('    <span class="visuallyhidden" id="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('-label">ダイレクトメッセージの本文</span>\n    <div id="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('" aria-labelledby="'),d.b(d.v(d.f("tweet_box_id",a,b,0))),d.b('-label" class="tweet-box rich-editor" contenteditable="true" spellcheck="true" role="textbox" aria-multiline="true"></div>\n    <div class="rich-normalizer"></div>\n\n'),d.b('    <div class="thumbnail-container">\n      <div class="previews"></div>\n      <div class="preview template">\n'),d.b(d.rp("<dismiss_button0",a,b,"        ")),d.b('        <span class="filename"></span>\n      </div>\n    </div>\n  </div>\n  <div class="toolbar js-toolbar">\n'),d.s(d.f("uploads_in_dms",a,b,1),a,b,0,1248,1335,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('      <div class="tweet-box-extras">\n'),c.b(c.rp("<media/media_picker1",a,b,"        ")),c.b("      </div>\n")}),a.pop()),d.b('    <div class="tweet-button">\n      <span class="spinner"></span>\n      <span class="tweet-counter">140</span>\n      <button class="btn tweet-action primary-btn messaging tweet-btn disabled" type="submit">\n        <span class="button-text messaging-text">\n          <span class="Icon Icon--dm"></span>\n          メッセージを送信\n        </span>\n      </button>\n    </div>\n  </div>\n  <div class="dm-delete-confirm js-dm-delete-confirm">\n'),d.b(d.rp("<direct_message_delete_confirm2",a,b,"    ")),d.b("  </div>\n"),d.s(d.f("dm_report_spam",a,b,1),a,b,0,1853,2065,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <div class="dm-spam-confirm js-dm-spam-confirm">\n'),c.b(c.rp("<direct_message_spam_confirm3",a,b,"      ")),c.b('    </div>\n    <div class="dm-abuse-confirm js-dm-abuse-confirm">\n'),c.b(c.rp("<direct_message_abuse_confirm4",a,b,"      ")),c.b("    </div>\n")}),a.pop()),d.b("</form>\n"),d.fl()},partials:{"<dismiss_button0":{name:"dismiss_button",partials:{},subs:{}},"<media/media_picker1":{name:"media/media_picker",partials:{},subs:{}},"<direct_message_delete_confirm2":{name:"direct_message_delete_confirm",partials:{},subs:{}},"<direct_message_spam_confirm3":{name:"direct_message_spam_confirm",partials:{},subs:{}},"<direct_message_abuse_confirm4":{name:"direct_message_abuse_confirm",partials:{},subs:{}}},subs:{}}),b.tweet_button=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<button class="btn primary-btn tweet-action'),d.s(d.f("enable_tweet_button",a,b,1),a,b,1,0,0,"")||d.b(" disabled"),d.b(' tweet-btn js-tweet-btn" type="button" '),d.s(d.f("enable_tweet_button",a,b,1),a,b,1,0,0,"")||d.b("disabled"),d.b('>\n  <span class="button-text tweeting-text">\n    <span class="Icon Icon--tweet"></span>\n    '),d.s(d.f("second_session_profile",a,b,1),a,b,0,314,345,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("ツイートして続ける")}),a.pop()),d.s(d.f("second_session_profile",a,b,1),a,b,1,0,0,"")||(d.s(d.f("first_tweet_button_text",a,b,1),a,b,0,449,502,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.v(c.f("first_tweet_button_text",a,b,0)))}),a.pop()),d.s(d.f("first_tweet_button_text",a,b,1),a,b,1,0,0,"")||d.b("ツイート")),d.b("\n"+c),d.b('  </span>\n  <span class="button-text messaging-text">\n    <span class="Icon Icon--dm Icon--small"></span>\n    メッセージを送信\n  </span>\n</button>\n'),d.fl()},partials:{},subs:{}}),b.verified_account_badge=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("large_verified_badge_with_border",a,b,1),a,b,0,37,324,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('<span class="icon verified verified-large-border"><span class="visuallyhidden">認証済みアカウント</span></span>')}),a.pop()),d.s(d.f("large_verified_badge_with_border",a,b,1),a,b,1,0,0,"")||(d.b('<span class="Icon Icon--verified Icon--small">'),d.b('<span class="u-hiddenVisually">認証済みアカウント</span>'),d.b("</span>")),d.b("\n"),d.fl()},partials:{},subs:{}}),b.user_css_color=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<style id="user-style-'),d.b(d.v(d.f("style_namespace",a,b,0))),d.b('">\n'),d.b("\n"+c),d.s(d.f("user_color",a,b,1),a,b,0,320,941,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  a,\n  a:hover,\n  a:focus,\n  a:active {\n    color: #"),c.b(c.v(c.f("user_color",a,b,0))),c.b(";\n  }\n\n  .u-textUserColor,\n  .u-textUserColorHover:hover,\n  .u-textUserColorHover:focus {\n    color: #"),c.b(c.v(c.f("user_color",a,b,0))),c.b(" !important;\n  }\n\n  .u-borderUserColor,\n  .u-borderUserColorHover:hover,\n  .u-borderUserColorHover:focus {\n    border-color: #"),c.b(c.v(c.f("user_color",a,b,0))),c.b(" !important;\n  }\n\n  .u-bgUserColor,\n  .u-bgUserColorHover:hover,\n  .u-bgUserColorHover:focus {\n    background-color: #"),c.b(c.v(c.f("user_color",a,b,0))),c.b(" !important;\n  }\n\n  .u-boxShadowInsetUserColorHover:hover,\n  .u-boxShadowInsetUserColorHover:focus {\n    box-shadow: inset 0 0 0 5px #"),c.b(c.v(c.f("user_color",a,b,0))),c.b(" !important;\n  }\n\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_light",a,b,1),a,b,0,1031,1391,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-textUserColorLight {\n    color: #"),c.b(c.v(c.f("user_color_light",a,b,0))),c.b(" !important;\n  }\n\n  .u-borderUserColorLight,\n  .u-borderUserColorLightFocus:focus,\n  .u-borderUserColorLightHover:hover,\n  .u-borderUserColorLightHover:focus {\n    border-color: #"),c.b(c.v(c.f("user_color_light",a,b,0))),c.b(" !important;\n  }\n\n  .u-bgUserColorLight {\n    background-color: #"),c.b(c.v(c.f("user_color_light",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("rgba_user_color_lighter",a,b,1),a,b,0,1501,1651,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-boxShadowUserColorLighterFocus:focus {\n    box-shadow: 0 0 8px rgba(0, 0, 0, 0.05), inset 0 1px 2px "),c.b(c.v(c.f("rgba_user_color_lighter",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_lightest",a,b,1),a,b,0,1760,2024,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-textUserColorLightest {\n    color: #"),c.b(c.v(c.f("user_color_lightest",a,b,0))),c.b(" !important;\n  }\n\n  .u-borderUserColorLightest {\n    border-color: #"),c.b(c.v(c.f("user_color_lightest",a,b,0))),c.b(" !important;\n  }\n\n  .u-bgUserColorLightest {\n    background-color: #"),c.b(c.v(c.f("user_color_lightest",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_lighter",a,b,1),a,b,0,2127,2385,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-textUserColorLighter {\n    color: #"),c.b(c.v(c.f("user_color_lighter",a,b,0))),c.b(" !important;\n  }\n\n  .u-borderUserColorLighter {\n    border-color: #"),c.b(c.v(c.f("user_color_lighter",a,b,0))),c.b(" !important;\n  }\n\n  .u-bgUserColorLighter {\n    background-color: #"),c.b(c.v(c.f("user_color_lighter",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_dark",a,b,1),a,b,0,2481,2658,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-bgUserColorDarkHover:hover {\n    background-color: #"),c.b(c.v(c.f("user_color_dark",a,b,0))),c.b(" !important;\n  }\n\n  .u-borderUserColorDark {\n    border-color: #"),c.b(c.v(c.f("user_color_dark",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_darker",a,b,1),a,b,0,2755,2855,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .u-bgUserColorDarkerActive:active {\n    background-color: #"),c.b(c.v(c.f("user_color_darker",a,b,0))),c.b(" !important;\n  }\n")}),a.pop()),d.b("\n"),d.b("\n"+c),d.b("\n"),d.b("\n"+c),d.b("\n"+c),d.b("a,\n.btn-link,\n.btn-link:focus,\n.icon-btn,\n"),d.b(".pretty-link b,\n.pretty-link:hover s,\n.pretty-link:hover b,\n.pretty-link:focus s,\n.pretty-link:focus b,\n/* Account Group */\n.metadata a:hover,\n.metadata a:focus,\n"),d.b(".account-group:hover .fullname,\n.account-group:focus .fullname,\n.account-summary:focus .fullname,\n"),d.b(".message .message-text a,\n.stats a strong,\n.plain-btn:hover,\n.plain-btn:focus,\n.dropdown.open .user-dropdown.plain-btn,\n.open > .plain-btn,\n#global-actions .new:before,\n.module .list-link:hover,\n.module .list-link:focus,\n"),d.b(".UserCompletion-step:hover,\n"),d.b(".stats a:hover,\n.stats a:hover strong,\n.stats a:focus,\n.stats a:focus strong,\n"),d.b(".profile-modal-header .fullname a:hover,\n.profile-modal-header .username a:hover,\n.profile-modal-header .fullname a:focus,\n.profile-modal-header .username a:focus,\n"),d.b(".story-article:hover .metadata,\n.story-article .metadata a:focus,\n"),d.b(".find-friends-sources li:hover .source,\n\n"),d.b("\n"+c),d.b(".stream-item a:hover .fullname,\n.stream-item a:focus .fullname,\n"),d.b(".stream-item .view-all-supplements:hover,\n.stream-item .view-all-supplements:focus,\n"),d.b(".tweet .time a:hover,\n.tweet .time a:focus,\n.tweet-actions a,\n.tweet .details.with-icn b,\n.tweet .details.with-icn .Icon,\n.tweet .tweet-geo-text a:hover,\n"),d.b(".stream-item:hover .original-tweet .expand-action-wrapper,\n.stream-item .original-tweet.focus .expand-action-wrapper,\n.opened-tweet.original-tweet  .expand-action-wrapper,\n"),d.b(".stream-item:hover .original-tweet .details b,\n.stream-item .original-tweet.focus .details b,\n.stream-item.open .original-tweet .details b,\n"),d.b(".simple-tweet:hover .details b,\n.simple-tweet.focus .details b,\n.simple-tweet.open .details b,\n.simple-tweet:hover .details .expand-action-wrapper,\n.simple-tweet.focus .details .expand-action-wrapper,\n.simple-tweet.open .details .collapse-action-wrapper,\n.simple-tweet:hover .details .simple-details-link,\n.simple-tweet.focus .details .simple-details-link,\n"),d.b(".client-and-actions a:hover,\n.client-and-actions a:focus,\n"),d.b(".dismiss-promoted:hover b,\n"),d.b(".tweet .context .pretty-link:hover s,\n.tweet .context .pretty-link:hover b,\n.tweet .context .pretty-link:focus s,\n.tweet .context .pretty-link:focus b,\n"),d.b(".list .username a:hover,\n.list .username a:focus,\n.list-membership-container .create-a-list,\n.list-membership-container .create-a-list:hover,\n\n"),d.b(".story-header:hover .view-tweets,\n.card .list-details a:hover,\n.card .list-details a:focus,\n.card .card-body:hover .attribution,\n.card .card-body .attribution:focus,\n.events-card .card-body:hover .attribution,\n.events-card .card-body .attribution:focus,\n.new-tweets-bar,\n.onebox .soccer ul.ticker a:hover,\n.onebox .soccer ul.ticker a:focus,\n\n"),d.b(".discover-item-actions a,\n\n"),d.b(".disco-stream-item.disco_exp_actions_on_btm .more-tweet-actions .btn-link,\n.disco-stream-item.disco_exp_actions_on_btm_without_stats .more-tweet-actions .btn-link,\n\n"),d.b(".remove-background-btn,\n\n"),d.b(".stream-item-activity-me .latest-tweet .tweet-row a:hover,\n.stream-item-activity-me .latest-tweet .tweet-row a:focus,\n.stream-item-activity-me .latest-tweet .tweet-row a:hover b,\n.stream-item-activity-me .latest-tweet .tweet-row a:focus b,\n"),d.b(".tweet-actions-sidebar a:hover .tweet-action-count,\n.tweet-actions-sidebar a:focus .tweet-action-count {\n"),d.s(d.f("profile_link_color",a,b,1),a,b,0,7754,7793,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    color: #"),c.b(c.v(c.f("profile_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_link_color",a,b,1),a,b,1,0,0,"")||d.b("    color: #0084B4;\n"),d.b("}\n\n"),d.s(d.f("profile_link_color",a,b,1),a,b,0,8005,11937,"{{ }}")&&(d.rs(a,b,function(a,b,d){d.b("  #global-actions > li > a {\n    border-bottom-color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  #global-actions > li:hover > a,\n  #global-actions > li > a:focus,\n  .nav.right-actions > li > a:hover,\n  .nav.right-actions > li > button:hover,\n  .nav.right-actions > li > a:focus,\n  .nav.right-actions > li > button:focus {\n    color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n"),d.s(d.f("web_notifications_badge_on",a,b,1),a,b,0,8391,8515,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  /* Surpress the new connect glow if in experiment. */\n   #global-actions .people.new:before {\n     content: none;\n   }\n")}),a.pop()),d.b("\n"+c),d.b("  /* hover state for photo select button*/\n  .photo-selector:not(.disabled):hover .btn,\n  .icon-btn:hover,\n  .icon-btn:active,\n  .icon-btn.active,\n  .icon-btn.enabled {\n    border-color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n    border-color: rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(",.5);\n    color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  /* hover state for photo select button*/\n  .photo-selector:not(.disabled):hover .btn,\n  .icon-btn:hover {\n    background-image: linear-gradient(rgba(255,255,255,0), rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(",.1));\n    filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#00FFFFFF', endColorstr='#19"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b("'); /* IE8-9 */\n  }\n\n  .icon-btn.disabled,\n  .icon-btn.disabled:hover,\n  .icon-btn[disabled],\n  .icon-btn[aria-disabled=true] {\n    color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  /* tweet-btn can have primary-btn class as well so the following rules ensure that the correct background color is applied */\n  .tweet-btn,\n  .tweet-btn:focus {\n    background-color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n    background: rgb("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(","),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(");\n  }\n\n  .tweet-btn:hover,\n  .tweet-btn:active,\n  .tweet-btn.active {\n    background-color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  .tweet-btn.btn.disabled,\n  .tweet-btn.btn.disabled:hover,\n  .tweet-btn.btn[disabled],\n  .tweet-btn.btn[aria-disabled=true] {\n    background: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  .btn:focus,\n  .btn.focus,\n  .Button:focus {\n    box-shadow:\n      0 0 0 1px #fff,\n      0 0 0 3px rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(", 0.5);\n  }\n\n  .selected-stream-item:focus {\n    box-shadow: 0 0 0 3px rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(", 0.5);\n  }\n\n  /**\n   * 1. Bring actionable tweet to top when active to ensure border\n   *    highlighting wraps entire tweet. Value must be at least at if not\n   *    higher than the z-index value of ProfileHeading to ensure first\n   *    tweet in timeline receives border on all four sides.\n   */\n\n  .ProfileTweet.is-actionable,\n  .js-stream-item.is-selected:focus .ProfileTweet,\n  .js-stream-item.is-selected:focus .ProfileCard,\n  .QuoteTweet:hover,\n  .QuoteTweet:focus,\n  .QuoteTweet:active {\n    border-color: rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(", 0.5);\n    z-index: 1; /* 1 */\n  }\n\n  .global-dm-nav.new.with-count .dm-new {\n    background: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  .navy-seal-experiment .global-dm-nav.new.with-count .dm-new {\n    background: #fff;\n  }\n\n  .navy-seal-experiment .global-dm-nav.new.with-count .dm-new .count-inner {\n    background: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  .global-nav .people .count .count-inner {\n    background: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n\n  .dropdown-menu li > a:hover,\n  .dropdown-menu li > a:focus,\n  .dropdown-menu .dropdown-link:hover,\n  .dropdown-menu .dropdown-link:focus,\n  .dropdown-menu li:hover .dropdown-link,\n  .dropdown-menu li:focus .dropdown-link,\n  .dropdown-menu .typeahead-recent-search-item.selected,\n  .dropdown-menu .typeahead-saved-search-item.selected,\n  .dropdown-menu .selected a,\n  .dropdown-menu .dropdown-link.selected {\n    background-color: #"),d.b(d.v(d.f("profile_link_color",a,b,0))),d.b(";\n  }\n")}),a.pop()),d.b("\n"+c),d.b("/* give tweet boxes 10% of the users link color as background */\n.home-tweet-box,\n.dm-tweetbox,\n.WebToast-box--altColor,\n.content-main .conversations-enabled .expansion-container .inline-reply-tweetbox {\n  background-color: #"),d.b(d.v(d.f("user_color_lightest",a,b,0))),d.b(";\n}\n\n.conversations-enabled .inline-reply-caret .caret-inner {\n  border-bottom-color: #"),d.b(d.v(d.f("user_color_lightest",a,b,0))),d.b(";\n}\n.top-timeline-tweetbox .timeline-tweet-box .tweet-form.condensed .tweet-box {\n  color: #"),d.b(d.v(d.f("user_color",a,b,0))),d.b(";\n}\n/* give tweet box containers an outline using the users link color */\n.home-tweet-box,\n.top-timeline-tweetbox .timeline-tweet-box {\n  border-color: #"),d.b(d.v(d.f("user_color_lighter",a,b,0))),d.b(' !important;\n}\n/* give tweet boxes an outline using the users link color */\n.tweet-box[contenteditable="true"] {\n  border-color: '),d.b(d.v(d.f("rgba_user_color_lighter",a,b,0))),d.b(';\n}\n\ninput:focus,\ntextarea:focus,\ndiv[contenteditable="true"]:focus,\ndiv[contenteditable="true"].fake-focus {\n  border-color: #'),d.b(d.v(d.f("profile_pretty_link_color",a,b,0))),d.b(";\n  box-shadow: inset 0 0 0 1px rgba("),d.b(d.v(d.d("profile_link_color_rgb.r",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.g",a,b,0))),d.b(", "),d.b(d.v(d.d("profile_link_color_rgb.b",a,b,0))),d.b(', 0.7);\n}\n\n.currently-dragging.modal-enabled .modal .tweet-box,\n.currently-dragging:not(.modal-enabled) .tweet-content .tweet-box,\nbody.supports-drag-and-drop .tweet-form.upload-photo-hover.drag-and-drop .tweet-box,\n.tweet-box[contenteditable="true"]:focus {\n  border-color: #'),d.b(d.v(d.f("user_color_light",a,b,0))),d.b(";\n  box-shadow: none;\n}\n\n"),d.b("\n"+c),d.b("s,\n.pretty-link:hover s,\n.pretty-link:focus s,\n.stream-item-activity-me .latest-tweet .tweet-row a:hover s,\n.stream-item-activity-me .latest-tweet .tweet-row a:focus s {\n"),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,0,13650,13696,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    color: #"),c.b(c.v(c.f("profile_pretty_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,1,0,0,"")||d.b("    color: #66B5D2;\n"),d.b("}\n\n"),d.b(".vellip,\n.vellip:before,\n.vellip:after,\n.conversation-module > li:after,\n.conversation-module > li:before {\n"),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,0,14044,14101,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    background-color: #"),c.b(c.v(c.f("profile_pretty_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,1,0,0,"")||d.b("    background-color: #66B5D2;\n"),d.b("}\n\n"),d.b(".tweet .sm-reply,\n.tweet .sm-rt,\n.tweet .sm-fav,\n.tweet .sm-image,\n.tweet .sm-video,\n.tweet .sm-audio,\n.tweet .sm-geo,\n.tweet .sm-in,\n.tweet .sm-trash,\n.tweet .sm-more,\n.tweet .sm-page,\n.tweet .sm-embed,\n.tweet .sm-summary,\n.tweet .sm-chat,\n"),d.b(".timelines-navigation .active .profile-nav-icon,\n.timelines-navigation .profile-nav-icon:hover,\n.timelines-navigation .profile-nav-link:focus .profile-nav-icon,\n"),d.b(".sm-top-tweet,\n"),d.b(".metadata a.tweet-geo-text:hover .sm-geo,\n"),d.b(".discover-item .js-action-card-search:hover .sm-search,\n.discover-item .js-action-card-search:focus .sm-search {\n"),d.s(d.f("profile_link_color",a,b,1),a,b,0,15151,15201,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    background-color: #"),c.b(c.v(c.f("profile_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_link_color",a,b,1),a,b,1,0,0,"")||d.b("    background-color: #6684B4;\n"),d.b("}\n\n"),d.b(".tweet-action-icons .tweet .tweet-actions .sm-reply, .tweet-action-icons .tweet.opened-tweet .tweet-actions .sm-reply,\n.tweet-action-icons .tweet .tweet-actions .sm-rt, .tweet-action-icons .tweet.opened-tweet .tweet-actions .sm-rt,\n.tweet-action-icons .tweet .tweet-actions .sm-fav, .tweet-action-icons .tweet.opened-tweet .tweet-actions .sm-fav,\n.tweet-action-icons .tweet .tweet-actions .sm-trash, .tweet-action-icons .tweet.opened-tweet .tweet-actions .sm-trash,\n.tweet-action-icons .tweet .tweet-actions .sm-more, .tweet-action-icons .tweet.opened-tweet .tweet-actions .sm-more {\n"),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,0,16015,16072,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    background-color: #"),c.b(c.v(c.f("profile_pretty_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,1,0,0,"")||d.b("    background-color: #66B5D2;\n"),d.b("}\n\n.persistent-tweet-actions.tweet-action-icons .tweet:hover .tweet-actions .sm-reply,\n.persistent-tweet-actions.tweet-action-icons .tweet:hover .tweet-actions .sm-rt,\n.persistent-tweet-actions.tweet-action-icons .tweet:hover .tweet-actions .sm-fav,\n.persistent-tweet-actions.tweet-action-icons .tweet:hover .tweet-actions .sm-trash,\n.persistent-tweet-actions.tweet-action-icons .tweet:hover .tweet-actions .sm-more {\n"),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,0,16650,16707,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    background-color: #"),c.b(c.v(c.f("profile_pretty_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_pretty_link_color",a,b,1),a,b,1,0,0,"")||d.b("    background-color: #66B5D2;\n"),d.b("}\n\n.tweet-action-icons .stream .tweet .tweet-actions .sm-reply:hover, .tweet-action-icons .stream .tweet .tweet-actions a:focus .sm-reply,\n.tweet-action-icons .stream .tweet .tweet-actions .sm-rt:hover, .tweet-action-icons .stream .tweet .tweet-actions a:focus .sm-rt,\n.tweet-action-icons .stream .tweet .tweet-actions .sm-fav:hover, .tweet-action-icons .stream .tweet .tweet-actions a:focus .sm-fav,\n.tweet-action-icons .stream .tweet .tweet-actions .sm-trash:hover, .tweet-action-icons .stream .tweet .tweet-actions a:focus .sm-trash,\n.tweet-action-icons .stream .tweet .tweet-actions .sm-more:hover, .tweet-action-icons .stream .tweet .tweet-actions a:focus .sm-more {\n"),d.s(d.f("profile_link_color",a,b,1),a,b,0,17532,17582,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    background-color: #"),c.b(c.v(c.f("profile_link_color",a,b,0))),c.b(";\n")}),a.pop()),d.s(d.f("profile_link_color",a,b,1),a,b,1,0,0,"")||d.b("    background-color: #6684B4;\n"),d.b("}\n"),d.b("\n"+c),d.s(d.f("mini_profile_banner_url_for_web",a,b,1),a,b,0,17772,17893,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(".enhanced-mini-profile .mini-profile .profile-summary {\n  background-image: url("),c.b(c.v(c.f("mini_profile_banner_url_for_web",a,b,0))),c.b(");\n}\n")}),a.pop()),d.b("\n"+c),d.s(d.f("profile_banner_url_for_web",a,b,1),a,b,0,17962,18092,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(".wrapper-profile .profile-card.profile-header .profile-header-inner {\n  background-image: url("),c.b(c.v(c.f("profile_banner_url_for_web",a,b,0))),c.b(");\n}\n")}),a.pop()),d.b("\n"+c),d.s(d.f("profile_link_color_rgb",a,b,1),a,b,0,18152,18547,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  #global-tweet-dialog .modal-header {\n    border-bottom: solid 1px rgba("),c.b(c.v(c.d("profile_link_color_rgb.r",a,b,0))),c.b(", "),c.b(c.v(c.d("profile_link_color_rgb.g",a,b,0))),c.b(", "),c.b(c.v(c.d("profile_link_color_rgb.b",a,b,0))),c.b(", .25);\n  }\n\n  #global-tweet-dialog .modal-tweet-form-container {\n    background-color: #"),c.b(c.v(c.f("profile_link_color",a,b,0))),c.b(";\n    background: rgba("),c.b(c.v(c.d("profile_link_color_rgb.r",a,b,0))),c.b(", "),c.b(c.v(c.d("profile_link_color_rgb.g",a,b,0))),c.b(", "),c.b(c.v(c.d("profile_link_color_rgb.b",a,b,0))),c.b(", .1);\n  }\n")}),a.pop()),d.b("\n"+c),d.s(d.f("user_color_lightest",a,b,1),a,b,0,18600,18680,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  .inline-reply-tweetbox {\n    background-color: #"),c.b(c.v(c.f("user_color_lightest",a,b,0))),c.b(";\n  }\n")}),a.pop()),d.b("\n"+c),d.b("</style>\n"),d.fl()},partials:{},subs:{}}),b.screen_reader_kb_shortcuts_message=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div id="kb-shortcuts-msg" class="visuallyhidden">\n  <h2>キーボードショートカット</h2>\n  <p>\n    キーボードのショートカットは共通のアクションとサイト内のナビゲーションに使用できます。\n'),d.b('    <button id="show-shortcuts-btn" type="button" tabindex="-1">キーボードショートカットを表示</button>\n    <button id="dismiss-shortcuts-btn" type="button" tabindex="-1">メッセージを非表示にする</button>\n  </p>\n</div>'),d.fl()},partials:{},subs:{}}),b.swift_typeahead_dropdown=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b("\n"+c),d.b('<div role="listbox" class="dropdown-menu typeahead">\n  <div aria-hidden="true" class="dropdown-caret">\n    <div class="caret-outer"></div>\n    <div class="caret-inner"></div>\n  </div>\n  <div role="presentation" class="dropdown-inner js-typeahead-results">\n'),d.s(d.f("typeahead_recent_searches",a,b,1),a,b,0,369,407,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.rp("<swift_recent_searches0",a,b,"      "))}),a.pop()),d.b(d.rp("<swift_saved_searches1",a,b,"    ")),d.s(d.f("typeahead_concierge",a,b,1),a,b,0,496,538,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.rp("<swift_typeahead_concierge2",a,b,"      "))}),a.pop()),d.b(d.rp("<swift_typeahead_topics3",a,b,"    ")),d.b(d.rp("<swift_typeahead_accounts4",a,b,"    ")),d.b(d.rp("<swift_typeahead_trend_locations5",a,b,"    ")),d.b(d.rp("<swift_typeahead_select_users6",a,b,"    ")),d.b("  </div>\n</div>\n"),d.fl()},partials:{"<swift_recent_searches0":{name:"swift_recent_searches",partials:{},subs:{}},"<swift_saved_searches1":{name:"swift_saved_searches",partials:{},subs:{}},"<swift_typeahead_concierge2":{name:"swift_typeahead_concierge",partials:{},subs:{}},"<swift_typeahead_topics3":{name:"swift_typeahead_topics",partials:{},subs:{}},"<swift_typeahead_accounts4":{name:"swift_typeahead_accounts",partials:{},subs:{}},"<swift_typeahead_trend_locations5":{name:"swift_typeahead_trend_locations",partials:{},subs:{}},"<swift_typeahead_select_users6":{name:"swift_typeahead_select_users",partials:{},subs:{}}},subs:{}}),b.prefilled_tweetbox_content=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("screen_names_for_tweet_box",a,b,1),a,b,0,31,191,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.s(c.f("preexpand_tweetbox",a,b,1),a,b,0,54,85,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b(c.v(c.f("screen_names_for_tweet_box",a,b,0))),c.b(" ")}),a.pop()),c.s(c.f("preexpand_tweetbox",a,b,1),a,b,1,0,0,"")||(c.b(c.v(c.f("screen_names_for_tweet_box",a,b,0))),c.b("さんへ返信する"))}),a.pop()),d.s(d.f("second_session_profile_prefilled_text",a,b,1),a,b,0,264,305,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.v(c.f("second_session_profile_prefilled_text",a,b,0)))}),a.pop()),d.s(d.f("second_session_profile_prefilled_text",a,b,1),a,b,1,0,0,"")||d.s(d.f("first_tweet_prefilled_text",a,b,1),a,b,0,420,450,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.v(c.f("first_tweet_prefilled_text",a,b,0)))}),a.pop()),d.b("\n"),d.fl()},partials:{},subs:{}}),b.swift_typeahead_accounts=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b("\n"+c),d.b('<ul role="presentation" class="typeahead-items typeahead-accounts js-typeahead-accounts">\n'),d.b('  <li role="presentation" data-user-id="" data-user-screenname="" data-remote="true" data-score="" class="typeahead-item typeahead-account-item js-selectable">\n'),d.b('    <a role="option" class="js-nav" data-query-source="typeahead_click" data-search-query="" data-ds="account">\n      <img class="avatar size24" alt="">\n      <span class="typeahead-user-item-info">\n        <span class="fullname"></span>\n        <span class="js-verified hidden">'),d.b(d.rp("<verified_account_badge0",a,b,"")),d.b('</span>\n        <span class="username"><s>@</s><b></b></span>\n      </span>\n    </a>\n  </li>\n  <li role="presentation" class="js-selectable typeahead-accounts-shortcut js-shortcut"><a role="option" class="js-nav" href="" data-search-query="" data-query-source="typeahead_click" data-shortcut="true" data-ds="account_search"></a></li>\n</ul>\n'),d.fl()},partials:{"<verified_account_badge0":{name:"verified_account_badge",partials:{},subs:{}}},subs:{}}),b.swift_typeahead_topics=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<ul role="presentation" class="typeahead-items typeahead-topics'),d.s(d.f("typeahead_topic_social_context",a,b,1),a,b,0,98,113,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(" social-context")}),a.pop()),d.b('">\n'),d.b('  <li role="presentation" class="typeahead-item typeahead-topic-item">\n    <a role="option" class="js-nav" href="" data-search-query="" data-query-source="typeahead_click" data-ds="topics" tabindex="-1">\n'),d.s(d.f("typeahead_topic_social_context",a,b,1),a,b,0,490,550,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        <div class="typeahead-social-context"></div>\n')}),a.pop()),d.b("    </a>\n  </li>\n</ul>\n\n"),d.fl()},partials:{},subs:{}}),b.create_custom_timeline_button=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<button type="button" class="btn-link js-create-custom-timeline-button" data-element-term="create_custom_timeline_button">新しいコレクションを作成</button>\n'),d.fl()},partials:{},subs:{}}),b.profile_help_prompt=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="ProfileHelpPrompt'),d.s(d.f("prompt_class",a,b,1),a,b,0,46,63,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(" "),c.b(c.v(c.f("prompt_class",a,b,0)))}),a.pop()),d.b(' js-prompt">\n  <div class="ProfileHelpPrompt-caret"></div>\n  <div class="ProfileHelpPrompt-content">\n    <div class="ProfileHelpPrompt-header">\n      '),d.b(d.v(d.f("header",a,b,0))),d.b("\n"+c),d.b('    </div>\n    <div class="ProfileHelpPrompt-body">\n      '),d.b(d.v(d.f("body",a,b,0))),d.b("\n"+c),d.b("    </div>\n"),d.s(d.f("hint",a,b,1),a,b,0,332,410,"{{ }}")&&(d.rs(a,b,function(a,b,d){d.b('      <div class="ProfileHelpPrompt-hint">\n        '),d.b(d.v(d.f("hint",a,b,0))),d.b("\n"+c),d.b("      </div>\n")}),a.pop()),d.b('    <div class="ProfileHelpPrompt-actions">\n      <button type="button" class="ProfileHelpPrompt-nextButton button btn js-next-prompt">\n        OK\n      </button>\n    </div>\n  </div>\n</div>\n'),d.fl()},partials:{},subs:{}}),b["start/wtf_follow_button"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("num_users_selected",a,b,1),a,b,0,23,60,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  "),c.b(c.v(c.f("num_users_selected",a,b,0))),c.b("人をフォローして続ける\n")}),a.pop()),d.s(d.f("num_users_selected",a,b,1),a,b,1,0,0,"")||d.b("  次へ\n"),d.fl()},partials:{},subs:{}}),b["start/follow_context"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<li class="StartFollowContext-item '),d.s(d.f("user",a,b,1),a,b,0,44,53,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("is-active")}),a.pop()),d.b('">\n'),d.s(d.f("user",a,b,1),a,b,0,76,157,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <img src="'),c.b(c.v(c.f("profile_url",a,b,0))),c.b('" title="'),c.b(c.v(c.f("screen_name",a,b,0))),c.b('" alt="'),c.b(c.v(c.f("screen_name",a,b,0))),c.b('">\n')}),a.pop()),d.b("</li>"),d.fl()},partials:{},subs:{}}),b["spoonbill/retweet"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast is-actionable" data-redirect-to="notifications">\n  <div class="WebToast-box u-cf">\n'),d.b(d.rp("<spoonbill/notification_box_close0",a,b,"    ")),d.b("\n"+c),d.b('    <div class="WebToast-header u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <span class="Icon Icon--retweeted Icon--small u-floatRight"></span>\n      </div>\n      <div class="WebToast-contentBox">\n        リツイート済み\n      </div>\n    </div>\n\n    <div class="u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <a class="js-user-profile-link js-action-profile-avatar" tabindex="-1" href="/'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('">\n          <img class="WebToast-avatar" width="32" height="32" src="'),d.b(d.v(d.f("user_avatar",a,b,0))),d.b('" alt="">\n        </a>\n      </div>\n      <div class="WebToast-contentBox">\n'),d.b(d.rp("<spoonbill/user_identity_fullname_link1",a,b,"        ")),d.b("        リツイート\n"),d.b(d.rp("<spoonbill/tweet_excerpt2",a,b,"        ")),d.b("      </div>\n    </div>\n  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/notification_box_close0":{name:"spoonbill/notification_box_close",partials:{},subs:{}},"<spoonbill/user_identity_fullname_link1":{name:"spoonbill/user_identity_fullname_link",partials:{},subs:{}},"<spoonbill/tweet_excerpt2":{name:"spoonbill/tweet_excerpt",partials:{},subs:{}}},subs:{}}),b["spoonbill/follow_btn"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="user-actions '),d.b(d.v(d.f("follow_state",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('" data-screen-name="'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-name="'),d.b(d.v(d.f("user_name",a,b,0))),d.b('" data-protected="'),d.b(d.v(d.f("user_protected",a,b,0))),d.b('" data-item-type="user">\n  <button class="Button WebToast-followButton">\n    <span class="follow-text button-text">\n      <span class="Icon Icon--follow Icon--medium"></span>\n      <span class="u-hiddenVisually">@'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('さんをフォロー</span>\n    </span>\n    <span class="following-text button-text">\n      <span class="Icon Icon--following Icon--medium"></span>\n      <span class="u-hiddenVisually">@'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('さんをフォローしています</span>\n    </span>\n    <span class="unfollow-text button-text">\n      <span class="Icon Icon--unfollow Icon--medium"></span>\n      <span class="u-hiddenVisually">@'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('さんのフォローを解除する</span>\n    </span>\n    <span class="pending-text button-text">\n      保留中\n      <span class="u-hiddenVisually">@'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('さんのフォローリクエストを保留中</span>\n    </span>\n    <span class="blocked-text button-text">\n      ブロック中\n      <span class="u-hiddenVisually">@'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b("さんをブロック中</span>\n    </span>\n  </button>\n</div>\n"),d.fl()},partials:{},subs:{}}),b["spoonbill/notification_box_close"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast-close">\n  <button class="WebToast-closeButton" type="button">\n    <span class="Icon Icon--close"></span>\n    <span class="u-hiddenVisually">閉じる</span>\n  </button>\n</div>\n'),d.fl()},partials:{},subs:{}}),b["spoonbill/tweet_excerpt"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast-tweetExcerpt u-dir u-textBreak" dir="ltr">\n  '),d.b(d.t(d.f("tweet_html",a,b,0))),d.b("\n"+c),d.b("</div>\n"),d.fl()},partials:{},subs:{}}),b["spoonbill/tweet"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="u-cf u-textBreak">\n'),d.b(d.rp("<spoonbill/user_identity0",a,b,"  ")),d.b("\n"+c),d.b('  <div class="WebToast-contentBox">\n    <div class="WebToast-tweetExcerpt tweet-text u-dir" dir="ltr">'),d.b(d.t(d.f("tweet_html",a,b,0))),d.b("</div>\n  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/user_identity0":{name:"spoonbill/user_identity",partials:{},subs:{}}},subs:{}}),b["spoonbill/follow"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast">\n  <div class="WebToast-box u-cf">\n'),d.b(d.rp("<spoonbill/notification_box_close0",a,b,"    ")),d.b("\n"+c),d.b('    <div class="WebToast-header u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <span class="Icon Icon--follower Icon--small u-floatRight"></span>\n      </div>\n      <div class="WebToast-contentBox">\n        新しいフォロワー\n      </div>\n    </div>\n\n    <div class="u-cf">\n'),d.s(d.f("show_follow_button",a,b,1),a,b,0,411,484,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        <div class="u-floatRight">'),c.b(c.rp("<spoonbill/follow_btn1",a,b,"")),c.b("</div>\n")}),a.pop()),d.b(d.rp("<spoonbill/user_identity2",a,b,"      ")),d.b("    </div>\n  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/notification_box_close0":{name:"spoonbill/notification_box_close",partials:{},subs:{}},"<spoonbill/follow_btn1":{name:"spoonbill/follow_btn",partials:{},subs:{}},"<spoonbill/user_identity2":{name:"spoonbill/user_identity",partials:{},subs:{}}},subs:{}}),b["spoonbill/user_identity"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="'),d.s(d.f("with_block_username",a,b,1),a,b,1,0,0,"")||d.b("u-inline"),d.b('">\n  <a class="WebToast-accountLink u-linkComplex js-action-profile-name js-user-profile-link" href="/'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('">\n    <span class="WebToast-imageBox u-floatLeft">\n      <img class="WebToast-avatar" width="32" height="32" src="'),d.b(d.v(d.f("user_avatar",a,b,0))),d.b('" alt="">\n    </span>\n\n    <span class="WebToast-contentBox u-block">\n      <b class="WebToast-fullname u-linkComplex-target '),d.s(d.f("with_block_username",a,b,1),a,b,0,496,510,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("u-block u-nbfc")}),a.pop()),d.b('">'),d.b(d.v(d.f("user_name",a,b,0))),d.b("</b>\n      "),d.s(d.f("with_block_username",a,b,1),a,b,1,0,0,"")||d.b("<span>&rlm;</span>"),d.b("\n"+c),d.b('      <span class="WebToast-username u-dir" dir="ltr">\n        <span class="at">@</span>'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b("\n"+c),d.b("      </span>\n    </span>\n  </a>\n</div>\n"),d.fl()},partials:{},subs:{}}),b["spoonbill/favorite"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast is-actionable" data-redirect-to="notifications">\n  <div class="WebToast-box u-cf">\n'),d.b(d.rp("<spoonbill/notification_box_close0",a,b,"    ")),d.b("\n"+c),d.b('    <div class="WebToast-header u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <span class="Icon Icon--favorited Icon--small u-floatRight"></span>\n      </div>\n      <div class="WebToast-contentBox">\n        お気に入り\n      </div>\n    </div>\n\n    <div class="u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <a class="js-user-profile-link js-action-profile-avatar" tabindex="-1" href="/'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('">\n          <img class="WebToast-avatar" width="32" height="32" src="'),d.b(d.v(d.f("user_avatar",a,b,0))),d.b('" alt="">\n        </a>\n      </div>\n      <div class="WebToast-contentBox">\n'),d.b(d.rp("<spoonbill/user_identity_fullname_link1",a,b,"        ")),d.b("        お気に入り\n"),d.b(d.rp("<spoonbill/tweet_excerpt2",a,b,"        ")),d.b("      </div>\n    </div>\n  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/notification_box_close0":{name:"spoonbill/notification_box_close",partials:{},subs:{}},"<spoonbill/user_identity_fullname_link1":{name:"spoonbill/user_identity_fullname_link",partials:{},subs:{}},"<spoonbill/tweet_excerpt2":{name:"spoonbill/tweet_excerpt",partials:{},subs:{}}},subs:{}}),b["spoonbill/dm"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast dm-notification" data-item-id="'),d.b(d.v(d.f("tweet_id",a,b,0))),d.b('" data-tweet-id="'),d.b(d.v(d.f("tweet_id",a,b,0))),d.b('" data-screen-name="'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-name="'),d.b(d.v(d.f("user_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('" data-retweeter="'),d.b(d.v(d.f("retweeter",a,b,0))),d.b('" data-mentions="'),d.b(d.v(d.f("mentions",a,b,0))),d.b('" data-item-type="tweet">\n  <div class="WebToast-box">\n'),d.b(d.rp("<spoonbill/notification_box_close0",a,b,"    ")),d.b("\n"+c),d.b('    <div class="WebToast-header u-cf">\n      <div class="WebToast-imageBox u-floatLeft">\n        <span class="Icon Icon--message Icon--small u-floatRight"></span>\n      </div>\n      <div class="WebToast-contentBox">\n        ダイレクトメッセージ\n      </div>\n    </div>\n'),d.b(d.rp("<spoonbill/tweet1",a,b,"    ")),d.b('  </div>\n\n  <div class="WebToast-line"></div>\n\n  <div class="WebToast-box WebToast-box--altColor js-inlineReply">\n'),d.b("  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/notification_box_close0":{name:"spoonbill/notification_box_close",partials:{},subs:{}},"<spoonbill/tweet1":{name:"spoonbill/tweet",partials:{},subs:{}}},subs:{}}),b["spoonbill/mention"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast original-tweet" data-item-id="'),d.b(d.v(d.f("tweet_id",a,b,0))),d.b('" data-tweet-id="'),d.b(d.v(d.f("tweet_id",a,b,0))),d.b('" data-screen-name="'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-name="'),d.b(d.v(d.f("user_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('" data-retweeter="'),d.b(d.v(d.f("retweeter",a,b,0))),d.b('" data-mentions="'),d.b(d.v(d.f("mentions",a,b,0))),d.b('" data-item-type="tweet">\n  <div class="WebToast-box">\n'),d.b(d.rp("<spoonbill/notification_box_close0",a,b,"    ")),d.b("\n"+c),d.b(d.rp("<spoonbill/tweet1",a,b,"    ")),d.b('  </div>\n\n  <div class="WebToast-line"></div>\n\n'),d.b(d.rp("<spoonbill/tweet_actions2",a,b,"  ")),d.b("\n"+c),d.b('  <div class="WebToast-line"></div>\n\n  <div class="WebToast-box WebToast-box--altColor js-inlineReply">\n'),d.b("  </div>\n</div>\n"),d.fl()},partials:{"<spoonbill/notification_box_close0":{name:"spoonbill/notification_box_close",partials:{},subs:{}},"<spoonbill/tweet1":{name:"spoonbill/tweet",partials:{},subs:{}},"<spoonbill/tweet_actions2":{name:"spoonbill/tweet_actions",partials:{},subs:{}}},subs:{}}),b["spoonbill/tweet_actions"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="WebToast-actionBar">\n  <ul class="Arrange Arrange--equal">\n    <li class="Arrange-sizeFill">\n      <button class="WebToast-action WebToast-action--reply js-actionReply" type="button">\n        <span class="Icon Icon--reply u-block"></span>\n        <span class="u-hiddenVisually">返信</span>\n      </button>\n    </li>\n    <li class="Arrange-sizeFill">\n      <button class="WebToast-action WebToast-action--retweet js-actionInlineRetweet" type="button">\n        <span class="Icon Icon--retweet u-block"></span>\n        <span class="u-hiddenVisually">リツイート</span>\n      </button>\n    </li>\n    <li class="Arrange-sizeFill">\n      <button class="WebToast-action WebToast-action--favorite js-actionFavorite" type="button">\n        <span class="Icon Icon--favorite u-block"></span>\n        <span class="u-hiddenVisually">お気に入りに登録</span>\n      </button>\n    </li>\n  </ul>\n</div>\n'),d.fl()},partials:{},subs:{}}),b["spoonbill/user_identity_fullname_link"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<a class="WebToast-accountLink js-user-profile-link js-action-profile-name" href="/'),d.b(d.v(d.f("user_screen_name",a,b,0))),d.b('" data-user-id="'),d.b(d.v(d.f("user_id",a,b,0))),d.b('">'),d.b('<b class="WebToast-fullname">'),d.b(d.v(d.f("user_name",a,b,0))),d.b("</b>"),d.b("</a>\n"),d.fl()},partials:{},subs:{}}),b["geo/geo_picker"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="geo-picker">\n  <button class="btn geo-picker-btn icon-btn js-tooltip" type="button" '),d.s(d.f("is_advanced",a,b,1),a,b,1,0,0,"")||d.b('tabindex="-1" '),d.b('title="位置情報を追加">\n    <span class="Icon Icon--geo"></span>\n    <span class="text geo-status">位置情報を追加</span>\n  </button>\n  <span class="dropdown-container"></span>\n  <input type="hidden" name="place_id">\n</div>\n'),d.fl()},partials:{},subs:{}}),b["geo/dropdown_search_results"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("places",a,b,1),a,b,0,11,114,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('  <li class="dropdown-link geo-search-result geo-focusable" data-place-id="'),c.b(c.v(c.f("id",a,b,0))),c.b('">'),c.b(c.v(c.f("full_name",a,b,0))),c.b("</li>\n")}),a.pop()),d.s(d.f("places",a,b,1),a,b,1,0,0,"")||d.b('  <li class="dropdown-link geo-search-result geo-no-search-results">検索結果はありません。</li>\n'),d.b('<li class="geo-search-result dropdown-divider"></li>\n'),d.fl()},partials:{},subs:{}}),b["geo/disabled_dropdown"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="dropdown-menu" tabindex="-1">\n  <div class="dropdown-caret">\n    <span class="caret-outer"></span>\n    <span class="caret-inner"></span>\n  </div>\n  <ul>\n    <li class="geo-not-enabled-yet">\n      <h2>ツイートに位置情報を追加する</h2>\n      <p>\n        位置情報と一緒にツイートした場合、Twitterはその位置情報も保存します。&#32;\n        毎回ツイートする際に、位置情報を付加する/付加しないを選択することができ、いつでも過去の位置情報を全て削除することも可能です。\n        <a href="http://support.twitter.com/forums/26810/entries/78525" target="_blank">詳しい説明</a>\n      </p>\n      <div>\n        <button type="button" class="geo-turn-on btn primary-btn">位置情報を許可</button>\n        <button type="button" class="geo-not-now btn-link">今はしない</button>\n      </div>\n    </li>\n  </ul>\n</div>'),d.fl()},partials:{},subs:{}}),b["geo/dropdown_places"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("places",a,b,1),a,b,0,11,187,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('  <li class="dropdown-link geo-place-result geo-focusable" data-place-id="'),c.b(c.v(c.f("id",a,b,0))),c.b('">'),c.s(c.f("is_first_place",a,b,1),a,b,0,113,149,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('<span class="icon checkmark"></span>')}),a.pop()),c.b(c.v(c.f("full_name",a,b,0))),c.b("</li>\n")}),a.pop()),d.b('<li class="geo-place-result dropdown-divider"></li>\n'),d.fl()},partials:{},subs:{}}),b["geo/enabled_dropdown"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="dropdown-menu" tabindex="-1">\n  <div class="dropdown-caret">\n    <span class="caret-outer"></span>\n    <span class="caret-inner"></span>\n  </div>\n  <ul>\n    <li class="geo-query-location">\n      <input type="text" autocomplete="off" placeholder="近所や市を探す">\n      <span class="icon generic-search"></span>\n    </li>\n    <li class="geo-dropdown-status"></li>\n    <li class="dropdown-link geo-turn-off-item geo-focusable">\n      <span class="icon close"></span>位置情報を無効化\n    </li>\n  </ul>\n</div>'),d.fl()},partials:{},subs:{}}),b["media/media_picker"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="photo-selector">\n  <button aria-hidden="true" class="btn icon-btn" type="button" tabindex="-1">\n    <span class="tweet-camera Icon Icon--camera"></span>\n    <span class="text add-photo-label">画像を追加</span>\n  </button>\n  <div class="image-selector">\n    <input type="hidden" name="media_data_empty" class="file-data">\n    <div class="multi-photo-data-container hidden">\n    </div>\n    <label class="t1-label">\n      <span class="visuallyhidden">画像を追加</span>\n      <input type="file" name="media_empty" class="file-input js-tooltip" tabindex="-1" title="画像を追加">\n    </label>\n    <div class="swf-container"></div>\n  </div>\n</div>\n'),d.fl()},partials:{},subs:{}}),b["dialogs/close_button"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<button type="button" class="modal-btn modal-close js-close">\n  <span class="Icon Icon--close Icon--medium">\n    <span class="visuallyhidden">閉じる</span>\n  </span>\n</button>\n'),d.fl()},partials:{},subs:{}}),b["dialogs/keyboard_shortcuts_dialog"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div id="keyboard-shortcut-dialog" class="modal-container">\n  <div class="close-modal-background-target"></div>\n  <div class="modal modal-large draggable">\n    <div class="modal-content">\n'),d.b(d.rp("<dialogs/close_button0",a,b,"      ")),d.b("\n"+c),d.b('      <div class="modal-header">\n        <h3 class="modal-title">キーボードショートカット</h3>\n      </div>\n\n'),d.b('      <div class="modal-body">\n\n        <div class="keyboard-shortcuts clearfix" id="keyboard-shortcut-menu">\n          <p class="visuallyhidden">\n            注: 音声読み上げソフトを使用している環境でこれらのショートカットを利用する場合は、仮想カーソルをオフにしてください。\n          </p>\n'),d.s(d.f("logged_in",a,b,1),a,b,0,640,7511,"{{ }}")&&(d.rs(a,b,function(a,b,d){d.b('          <table class="modal-table" summary="一般的な機能のためのショートカット">\n            <thead>\n              <tr>\n                <th colspan="2">アクション</th>\n              </tr>\n            </thead>\n            <tbody>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">n</b>\n                </td>\n                <td class="shortcut-label">ツイートを作成</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">f</b>\n                </td>\n                <td class="shortcut-label">お気に入りに登録</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">r</b>\n                </td>\n                <td class="shortcut-label">返信</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">t</b>\n                </td>\n                <td class="shortcut-label">リツイート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">m</b>\n                </td>\n                <td class="shortcut-label">ダイレクトメッセージ</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">u</b>\n                </td>\n                <td class="shortcut-label">ユーザーをミュート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">b</b>\n                </td>\n                <td class="shortcut-label">ユーザーをブロック</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">Enter</b>\n                </td>\n                <td class="shortcut-label">ツイートの詳細を開く</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">l</b>\n                </td>\n                <td class="shortcut-label">開いたすべてのツイートを閉じる</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">/</b>\n                </td>\n                <td class="shortcut-label">検索</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">'),d.s(d.f("is_mac",a,b,1),a,b,0,2935,2938,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("Cmd")}),a.pop()),d.s(d.f("is_mac",a,b,1),a,b,1,0,0,"")||d.b("Ctrl"),d.b('</b>\n                  <b class="sc-key">Enter</b>\n                </td>\n                <td class="shortcut-label">ツイートする</td>\n              </tr>\n            </tbody>\n          </table>\n          <table class="modal-table" summary="タイムライン内の項目間移動ができるショートカット">\n            <thead>\n              <tr>\n                <th colspan="2">ナビゲーション</th>\n              </tr>\n            </thead>\n            <tbody>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">?</b>\n                </td>\n                <td class="shortcut-label">このメニュー</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">j</b>\n                </td>\n                <td class="shortcut-label">次のツイート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">k</b>\n                </td>\n                <td class="shortcut-label">前のツイート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">Space</b>\n                </td>\n                <td class="shortcut-label">ページ下へ移動</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">.</b>\n                </td>\n                <td class="shortcut-label">最新ツイートを読み込む</td>\n              </tr>\n            </tbody>\n          </table>\n          <table class="modal-table" summary="別のタイムラインやページに移動できるショートカット">\n            <thead>\n              <tr>\n                <th colspan="2">タイムライン</th>\n              </tr>\n            </thead>\n            <tbody>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">h</b>\n                </td>\n                <td class="shortcut-label">ホーム</td>\n              </tr>\n\n'),d.s(d.f("enable_activity",a,b,1),a,b,0,4881,5588,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('                <tr>\n                  <td class="shortcut">\n                    <b class="sc-key">g</b> <b class="sc-key">n</b>\n                  </td>\n                  <td class="shortcut-label">通知</td>\n                </tr>\n                <tr>\n                  <td class="shortcut">\n                    <b class="sc-key">g</b> <b class="sc-key">a</b>\n                  </td>\n                  <td class="shortcut-label">アクティビティ</td>\n                </tr>\n                <tr>\n                  <td class="shortcut">\n                    <b class="sc-key">g</b> <b class="sc-key">r</b>\n                  </td>\n                  <td class="shortcut-label">@ツイート</td>\n                </tr>\n')}),a.pop()),d.s(d.f("enable_activity",a,b,1),a,b,1,0,0,"")||d.b('                  <tr>\n                    <td class="shortcut">\n                      <b class="sc-key">g</b> <b class="sc-key">r</b>\n                    </td>\n                    <td class="shortcut-label">@ツイート</td>\n                  </tr>\n'),d.b("\n"+c),d.b('              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">d</b>\n                </td>\n                <td class="shortcut-label">見つける</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">p</b>\n                </td>\n                <td class="shortcut-label">プロフィール</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">f</b>\n                </td>\n                <td class="shortcut-label">お気に入り</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">l</b>\n                </td>\n                <td class="shortcut-label">リスト</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">m</b>\n                </td>\n                <td class="shortcut-label">メッセージ</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">s</b>\n                </td>\n                <td class="shortcut-label">設定</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">u</b>\n                </td>\n                <td class="shortcut-label">プロフィールページを見る...</td>\n              </tr>\n            </tbody>\n          </table>\n')}),a.pop()),d.s(d.f("logged_in",a,b,1),a,b,1,0,0,"")||d.b('          <table class="modal-table">\n            <tbody>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">Enter</b>\n                </td>\n                <td class="shortcut-label">ツイートの詳細を開く</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">g</b> <b class="sc-key">f</b>\n                </td>\n                <td class="shortcut-label">プロフィールページを見る...</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">?</b>\n                </td>\n                <td class="shortcut-label">このメニュー</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">j</b>\n                </td>\n                <td class="shortcut-label">次のツイート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">k</b>\n                </td>\n                <td class="shortcut-label">前のツイート</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">Space</b>\n                </td>\n                <td class="shortcut-label">ページ下へ移動</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">/</b>\n                </td>\n                <td class="shortcut-label">検索</td>\n              </tr>\n              <tr>\n                <td class="shortcut">\n                  <b class="sc-key">.</b>\n                </td>\n                <td class="shortcut-label">最新ツイートを読み込む</td>\n              </tr>\n            </tbody>\n          </table>\n'),d.b("        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n\n"),d.fl()},partials:{"<dialogs/close_button0":{name:"dialogs/close_button",partials:{},subs:{}}},subs:{}}),b["dialogs/create_or_edit_custom_timeline_dialog"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="close-modal-background-target"></div>\n<div class="modal modal-medium draggable">\n  <div class="modal-content">\n'),d.b(d.rp("<dialogs/close_button0",a,b,"    ")),d.b('    <div class="modal-header">\n      <h3 class="modal-title">\n        '),d.s(d.f("is_create_dialog",a,b,1),a,b,0,244,258,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("新しいこのコレクションを作成")}),a.pop()),d.b("\n"+c),d.b("        "),d.s(d.f("is_create_dialog",a,b,1),a,b,1,0,0,"")||d.b("コレクションを編集"),d.b("\n"+c),d.b('      </h3>\n    </div>\n\n    <div class="modal-body">\n      <div class="custom-timeline-editor">\n        '),d.s(d.f("is_create_dialog",a,b,1),a,b,0,465,605,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('<p class="explanation">\n          コレクションでは公開されているツイートをご自由に集めることができます。\n          <br />\n          コレクションを作り、ツイートを集めて世界中の人と共有しよう。\n        </p>')}),a.pop()),d.b("\n"),d.b("\n"+c),d.b('        <div class="field custom-timeline-name-field">\n          <label class="t1-label" for="custom-timeline-name">コレクション名</label>\n          <input type="text" class="text" name="name" id="custom-timeline-name" value="'),d.b(d.v(d.f("timeline_name",a,b,0))),d.b('" aria-describedby="custom-timeline-name-help" />\n          <p class="help-text">\n            <span id="custom-timeline-name-help">25文字</span>\n            <span class="custom-timeline-name-count">25</span>\n          </p>\n        </div>\n        <hr/>\n\n        <div class="field custom-timeline-description-field">\n          <label class="t1-label" for="custom-timeline-description">説明</label>\n          <textarea name="custom-timeline-description" id="custom-timeline-description" aria-describedby="custom-timeline-description-help">'),d.b(d.v(d.f("timeline_description",a,b,0))),d.b('</textarea>\n          <p class="help-text">\n            <span id="custom-timeline-description-help">160文字(オプション)</span>\n            <span class="custom-timeline-description-count">160</span>\n          </p>\n        </div>\n        <hr/>\n\n        <fieldset class="field">\n          <legend class="t1-legend">コレクションの順番</legend>\n          <div class="options">\n            <label class="t1-label u-block">\n              <input class="radio u-inlineBlock" type="radio" name="'),d.b(d.v(d.f("id_prefix",a,b,0))),d.b('-timeline-order" value="curation_reverse_chron"'),d.s(d.f("curation_reverse_chron",a,b,1),a,b,0,1976,1994,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(' checked="checked"')}),a.pop()),d.b(' />\n              <b>最近追加された1件</b>\n            </label>\n            <label class="t1-label u-block">\n              <input class="radio u-inlineBlock" type="radio" name="'),d.b(d.v(d.f("id_prefix",a,b,0))),d.b('-timeline-order" value="tweet_chron"'),d.s(d.f("tweet_chron",a,b,1),a,b,0,2255,2273,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(' checked="checked"')}),a.pop()),d.b(' />\n              <b>古い順</b>\n            </label>\n            <label class="t1-label u-block">\n              <input class="radio u-inlineBlock" type="radio" name="'),d.b(d.v(d.f("id_prefix",a,b,0))),d.b('-timeline-order" value="tweet_reverse_chron"'),d.s(d.f("tweet_reverse_chron",a,b,1),a,b,0,2533,2551,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(' checked="checked"')}),a.pop()),d.b(' />\n              <b>新しい順</b>\n            </label>\n          </div>\n        </fieldset>\n        <hr/>\n\n        <div class="custom-timeline-editor-save">\n          <button type="button" class="btn btn-primary update-custom-timeline-button" data-custom-timeline-id="'),d.b(d.v(d.f("id",a,b,0))),d.b('" disabled>\n            '),d.s(d.f("is_create_dialog",a,b,1),a,b,0,2890,2899,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("コレクションを作成")}),a.pop()),d.b("\n"+c),d.b("            "),d.s(d.f("is_create_dialog",a,b,1),a,b,1,0,0,"")||d.b("コレクションを保存"),d.b("\n"+c),d.b("          </button>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n"),d.fl()},partials:{"<dialogs/close_button0":{name:"dialogs/close_button",partials:{},subs:{}}},subs:{}}),b["dialogs/curate_dialog"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="close-modal-background-target"></div>\n<div class="modal modal-medium draggable">\n  <div class="modal-content">\n'),d.b(d.rp("<dialogs/close_button0",a,b,"    ")),d.b('    <div class="modal-header">\n      <h3 class="modal-title">コレクションにツイートを追加する</h3>\n    </div>\n    <div class="modal-body">\n      <div class="timeline-selector"></div>\n    </div>\n    <div class="modal-footer">\n'),d.b(d.rp("<create_custom_timeline_button1",a,b,"      ")),d.b("\n"+c),d.b('      <button type="button" class="btn js-close">キャンセル</button>\n      <button type="button" class="btn primary-btn modal-submit js-submit">変更を保存</button>\n    </div>\n  </div>\n</div>\n'),d.fl()},partials:{"<dialogs/close_button0":{name:"dialogs/close_button",partials:{},subs:{}},"<create_custom_timeline_button1":{name:"create_custom_timeline_button",partials:{},subs:{}}},subs:{}}),b["dialogs/home_nav_headlined_popover"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b("<h2>タイムラインの準備ができました</h2>\n<p>タイムラインを見たい時はホームをクリックしてください</p>"),d.fl()},partials:{},subs:{}}),b["dialogs/confirm_dialog"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div id="confirm_dialog" class="modal-container">\n  <div class="close-modal-background-target"></div>\n  <div class="modal draggable">\n    <div class="modal-content">\n'),d.b(d.rp("<dialogs/close_button0",a,b,"      ")),d.b('      <div class="modal-header">\n        <h3 class="modal-title">'),d.b(d.v(d.f("title_text",a,b,0))),d.b("</h3>\n      </div>\n"),d.s(d.f("body_text",a,b,1),a,b,0,316,426,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        <div class="modal-body">\n          <p class="modal-body-text">'),c.b(c.v(c.f("body_text",a,b,0))),c.b("</p>\n        </div>\n")}),a.pop()),d.b('      <div class="modal-footer">\n        <button class="btn js-close" id="confirm_dialog_cancel_button">'),d.b(d.v(d.f("cancel_text",a,b,0))),d.b('</button>\n        <button id="confirm_dialog_submit_button" class="btn primary-btn modal-submit">'),d.b(d.v(d.f("submit_text",a,b,0))),d.b("</button>\n      </div>\n    </div>\n  </div>\n</div>\n"),d.fl()},partials:{"<dialogs/close_button0":{name:"dialogs/close_button",partials:{},subs:{}}},subs:{}}),b["dialogs/home_nav_follow_popover"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.s(d.f("is_first_follow",a,b,1),a,b,0,20,622,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("  <p>\n"),c.s(c.f("total_num_one",a,b,1),a,b,0,49,109,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b("      <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さんのツイートはタイムラインに表示されます。\n")}),a.pop()),c.s(c.f("total_num_two",a,b,1),a,b,0,150,239,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b("      <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さんと<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんのツイートはタイムラインに表示されます。\n")}),a.pop()),c.s(c.f("total_num_three",a,b,1),a,b,0,282,375,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b("      <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さん、<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんと他1人のツイートはタイムラインに表示されます。\n")}),a.pop()),c.s(c.f("total_num_other",a,b,1),a,b,0,420,526,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b("      <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さん、<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんと他"),c.b(c.v(c.f("num_others",a,b,0))),c.b("人のツイートはタイムラインに表示されます。\n")}),a.pop()),c.b("  </p>\n  <p>\n    <small>フォローし終えたら、ホームをクリックしてタイムラインを見てみましょう。</small>\n  </p>\n")}),a.pop()),d.s(d.f("is_first_follow",a,b,1),a,b,1,0,0,"")||(d.s(d.f("total_num_one",a,b,1),a,b,0,684,729,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さんをフォローしました\n")}),a.pop()),d.s(d.f("total_num_two",a,b,1),a,b,0,768,842,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さんと<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんをフォローしました\n")}),a.pop()),d.s(d.f("total_num_three",a,b,1),a,b,0,883,961,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さん、<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんと他1人をフォローしました\n")}),a.pop()),d.s(d.f("total_num_other",a,b,1),a,b,0,1004,1095,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    <strong>"),c.b(c.v(c.f("user1",a,b,0))),c.b("</strong>さん、<strong>"),c.b(c.v(c.f("user2",a,b,0))),c.b("</strong>さんと他"),c.b(c.v(c.f("num_others",a,b,0))),c.b("人をフォローしました\n")}),a.pop())),d.fl()},partials:{},subs:{}}),b["highline/components/image_edit_dialog"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div id="image_edit_dialog" class="ImageEditDialog modal-container">\n  <div class="close-modal-background-target"></div>\n  <div class="modal draggable">\n    <div class="modal-content">\n'),d.b(d.rp("<dialogs/close_button0",a,b,"      ")),d.b('      <div class="modal-header">\n        <h3 class="modal-title">プロフィール画像の変更</h3>\n      </div>\n      <div class="ImageEditDialog-body modal-body">\n      </div>\n      <div class="modal-footer">\n        <button type="button" class="btn js-close">キャンセル</button>\n        <button type="button" class="btn primary-btn">適用</button>\n      </div>\n    </div>\n  </div>\n</div>'),d.fl()},partials:{"<dialogs/close_button0":{name:"dialogs/close_button",partials:{},subs:{}}},subs:{}}),b["highline/components/color_picker"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="ColorPicker dropdown-menu" tabindex="-1" role="dialog" aria-labelledby="color-picker">'),d.b("<fieldset>"),d.b('<legend id="color-picker" class="u-hiddenVisually">色選択</legend>'),d.b('<div class="dropdown-caret">'),d.b('<span class="caret-outer"></span>'),d.b('<span class="caret-inner"></span>'),d.b("</div>"),d.b('<div class="ColorPicker-colorList">'),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#fa743e" style="background-color: #fa743e">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">オレンジ</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#ffcc4d" style="background-color: #ffcc4d">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">黄色</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#94d487" style="background-color: #94d487">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">黄緑</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#4a913c" style="background-color: #4a913c">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">緑</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#89c9fa" style="background-color: #89c9fa">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">青</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#3b94d9" style="background-color: #3b94d9">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">ネイビー</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#abb8c2" style="background-color: #abb8c2">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">グレー</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#dd2e44" style="background-color: #dd2e44">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">赤</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#f5abb5" style="background-color: #f5abb5">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">ピンク</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-color" data-color="#9266cc" style="background-color: #9266cc">'),d.b('<label class="Icon Icon--smallest">'),d.b('<span class="u-hiddenVisually">紫</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-transparent">'),d.b('<div class="ColorPicker-item ColorPicker-more" style="background-color: #f0f0f0">'),d.b('<label class="Icon Icon--smallest Icon--add">'),d.b('<span class="u-hiddenVisually">もっと</span>'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b("</div>"),d.b("</div>"),d.b('<div class="ColorPicker-item ColorPicker-hex" data-color="#f0f0f0" data-original-color="#f0f0f0" style="background-color: #f0f0f0">'),d.b('<label class="Icon Icon--smallest Icon--discover">'),d.b('<input class="u-hiddenVisually" type="radio" name="ColorPicker-colorGroup">'),d.b("</label>"),d.b('<input type="text" class="ColorPicker-hexInput" aria-labelledby="js-userColorButton" placeholder="" maxlength="6">'),d.b("</div>"),d.b("</div>"),d.b("</fieldset>"),d.b("</div>\n"),d.fl()},partials:{},subs:{}}),b["highline/events/event_canopy_scoreboard"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b("<table>\n  <tbody>\n    <tr>\n"),d.s(d.f("items",a,b,1),a,b,0,43,2033,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.s(c.f("teams",a,b,1),a,b,0,62,1703,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.s(c.f("score",a,b,1),a,b,0,83,855,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.s(c.f("is_home_team",a,b,1),a,b,1,0,0,"")||(c.b('              <td>\n                <img class="EventCanopy-scoreboardLogo js-awayTeamLogo" src="'),c.b(c.v(c.f("logo_url",a,b,0))),c.b(c.v(c.f("away_team_logo_url",a,b,0))),c.b('"/>\n              </td>\n              <td>\n                <span class="EventCanopy-scoreboardScore">'),c.b(c.v(c.f("score",a,b,0))),c.b('</span>\n              </td>\n              <td>\n                <span class="EventCanopy-scoreboardDash">-</span>\n              </td>\n')),c.s(c.f("is_home_team",a,b,1),a,b,0,546,827,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('              <td>\n                <span class="EventCanopy-scoreboardScore">'),c.b(c.v(c.f("score",a,b,0))),c.b('</span>\n              </td>\n              <td>\n                <img class="EventCanopy-scoreboardLogo js-homeTeamLogo" src="'),c.b(c.v(c.f("logo_url",a,b,0))),c.b(c.v(c.f("home_team_logo_url",a,b,0))),c.b('"/>\n              </td>\n')}),a.pop())}),a.pop()),c.s(c.f("score",a,b,1),a,b,1,0,0,"")||(c.s(c.f("is_home_team",a,b,1),a,b,1,0,0,"")||(c.b('              <td>\n                <img class="EventCanopy-scoreboardLogo js-awayTeamLogo" src="'),c.b(c.v(c.f("logo_url",a,b,0))),c.b(c.v(c.f("away_team_logo_url",a,b,0))),c.b('"/>\n              </td>\n              <td>\n                <span class="EventCanopy-scoreboardTeamName">'),c.b(c.v(c.f("abbreviated_name",a,b,0))),c.b('</span>\n              </td>\n              <td>\n                <span class="EventCanopy-scoreboardVs">対</span>\n              </td>\n')),c.s(c.f("is_home_team",a,b,1),a,b,0,1361,1656,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('              <td>\n                <img class="EventCanopy-scoreboardLogo js-homeTeamLogo" src="'),c.b(c.v(c.f("logo_url",a,b,0))),c.b(c.v(c.f("home_team_logo_url",a,b,0))),c.b('"/>\n              </td>\n              <td>\n                <span class="EventCanopy-scoreboardTeamName">'),c.b(c.v(c.f("abbreviated_name",a,b,0))),c.b("</span>\n              </td>\n")}),a.pop()))}),a.pop()),c.b("        <td>\n"),c.s(c.f("is_live",a,b,1),a,b,0,1749,1833,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('            <span class="EventCanopy-scoreboardStatus">'),c.b(c.v(c.f("status",a,b,0))),c.b("</span>\n")}),a.pop()),c.s(c.f("is_completed",a,b,1),a,b,0,1873,1995,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('            <span class="EventCanopy-scoreboardStatus EventCanopy-scoreboardStatus--isFinal">'),c.b(c.v(c.f("status",a,b,0))),c.b("</span>\n")}),a.pop()),c.b("        </td>\n")}),a.pop()),d.b("    </tr>\n  </tbody>\n</table>"),d.fl()},partials:{},subs:{}}),b["highline/events/sports/current_matches"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<div class="CurrentMatches '),d.s(d.f("with_background",a,b,1),a,b,0,47,84,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("CurrentMatches--withBackground module")}),a.pop()),d.b(' js-matchesModule">\n  <div class="CurrentMatches-heading">\n    <h3 class="CurrentMatches-headingText">\n'),d.s(d.f("heading_text",a,b,1),a,b,0,230,479,"{{ }}")&&(d.rs(a,b,function(a,b,d){d.s(d.f("with_heading_link",a,b,1),a,b,0,261,361,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('          <a class="js-nav" data-nav="events" href="'),c.b(c.v(c.f("heading_link",a,b,0))),c.b('">'),c.b(c.v(c.f("heading_text",a,b,0))),c.b("</a>\n")}),a.pop()),d.s(d.f("with_heading_link",a,b,1),a,b,1,0,0,"")||(d.b("          "),d.b(d.v(d.f("heading_text",a,b,0))),d.b("\n"+c))}),a.pop()),d.s(d.f("heading_text",a,b,1),a,b,1,0,0,"")||d.b("        スコアボード\n"),d.s(d.f("with_dismiss_button",a,b,1),a,b,0,590,683,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        <button class="Icon Icon--small Icon--close CurrentMatches-dismiss"></button>\n')}),a.pop()),d.b('    </h3>\n  </div>\n  <div class="CurrentMatches-undismiss">\n    <a href="#" class="u-linkComplex Arrange">\n      <span class="CurrentMatches-undismissIcon Icon Icon--medium Icon--add Arrange-sizeFit"></span>\n      <span class="CurrentMatches-undismissText u-linkComplex-target Arrange-sizeFit">スコアボードをホームに追加</span>\n    </a>\n  </div>\n  <ul class="CurrentMatches-matchesList">\n'),d.s(d.f("items",a,b,1),a,b,0,1097,1147,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b(c.rp("<highline/events/sports/match_item0",a,b,"      "))}),a.pop()),d.b("  </ul>\n"),d.s(d.f("with_opt_in_footer",a,b,1),a,b,0,1191,1501,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <div class="CurrentMatches-footer">\n'),c.s(c.f("wc_opted_in",a,b,1),a,b,0,1254,1320,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b('        <a href="/hashtag/worldcup">#ワールドカップ のすべてをチェック</a>\n')}),a.pop()),c.s(c.f("wc_opted_in",a,b,1),a,b,1,0,0,"")||c.b('        新しい機能でワールドカップの舞台裏をチェックしよう\n        <a class="btn primary-btn" href="/i/t/worldcup">応援するチームを選択</a>\n'),c.b("    </div>\n")}),a.pop()),d.s(d.f("with_league_link",a,b,1),a,b,0,1548,1900,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <div class="CurrentMatches-leagueLink">\n      <a href="'),c.b(c.v(c.f("league_link",a,b,0))),c.b('" class="u-linkComplex Arrange">\n        <span class="CurrentMatches-leagueLinkIcon Icon Icon--medium Icon--caretRight Arrange-sizeFit"></span>\n        <span class="CurrentMatches-leagueLinkText u-linkComplex-target Arrange-sizeFit">ワールドカップを楽しもう</span>\n      </a>\n    </div>\n')}),a.pop()),d.b("</div>\n"),d.fl()},partials:{"<highline/events/sports/match_item0":{name:"highline/events/sports/match_item",partials:{},subs:{}}},subs:{}}),b["highline/events/sports/match_item"]=new Hogan.Template({code:function(a,b,c){var d=this;return d.b(c=c||""),d.b('<li class="MatchItem Grid js-matchItem"\n    data-event-id="'),d.b(d.v(d.f("id",a,b,0))),d.b('"\n    data-start-time="'),d.b(d.v(d.f("start_time",a,b,0))),d.b('"\n    data-polling-id="'),d.b(d.v(d.f("polling_id",a,b,0))),d.b('"\n    data-is-completed="'),d.b(d.v(d.f("is_completed",a,b,0))),d.b('">\n'),d.s(d.f("with_match_link",a,b,1),a,b,0,205,269,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('    <a data-nav="match" class="js-nav" href="'),c.b(c.v(c.f("match_url",a,b,0))),c.b('">\n')}),a.pop()),d.b('      <div class="Grid-cell MatchItem-time">\n        <span class="MatchItem-live '),d.s(d.f("is_live",a,b,1),a,b,1,0,0,"")||d.b(" u-hidden"),d.b(' u-inlineBlock">ライブ</span>\n      <span class="MatchItem-status js-match-status">'),d.b(d.v(d.f("status",a,b,0))),d.b('</span>\n      </div>\n      <table class="MatchItem-teams">\n        <tbody>\n'),d.s(d.f("teams",a,b,1),a,b,0,589,1135,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('            <tr class="MatchItem-team" data-home-team="'),c.b(c.v(c.f("is_home_team",a,b,0))),c.b('">\n              <td class="MatchItem-logoContainer">\n                <img class="MatchItem-logoImg u-alignMiddle" height="24px" src="'),c.b(c.v(c.f("logo_url",a,b,0))),c.b('"/>\n              </td>\n              <td class="MatchItem-teamName '),c.s(c.f("long_team_name",a,b,1),a,b,0,894,926,"{{ }}")&&(c.rs(a,b,function(a,b,c){c.b("MatchItem-teamName--withLongName")}),a.pop()),c.b('">'),c.b(c.v(c.f("name",a,b,0))),c.b('</td>\n              <td class="MatchItem-scoreContainer u-textCenter">\n                <div class="MatchItem-score">'),c.b(c.v(c.f("score",a,b,0))),c.b("</div>\n              </td>\n            </tr>\n")}),a.pop()),d.b("        </tbody>\n      </table>\n"),d.s(d.f("with_match_link",a,b,1),a,b,0,1204,1274,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b('        <div class="Grid-cell MatchItem-viewMatch">試合を観る</div>\n')}),a.pop()),d.s(d.f("with_match_link",a,b,1),a,b,0,1317,1329,"{{ }}")&&(d.rs(a,b,function(a,b,c){c.b("    </a>\n")}),a.pop()),d.b("</li>\n"),d.fl()},partials:{},subs:{}}),a.exports=b})
define("app/ui/dialogs/confirm_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/utils/with_event_params","template"],function(module, require, exports) {
function confirmDialog(){this.defaultAttrs({confirmDialogSelector:"#confirm_dialog",cancelSelector:"#confirm_dialog_cancel_button",submitSelector:"#confirm_dialog_submit_button"}),this.openWithOptions=function(a,b){if(this.openState)return;this.attr.eventParams={action:b.action},this.attr.top=b.top,this.eventNode=a.target;var c={title_text:b.titleText,body_text:b.bodyText,cancel_text:b.cancelText,submit_text:b.submitText},d=template["dialogs/confirm_dialog"].render(c,template);$("#confirm_dialog").length?$("#confirm_dialog").replaceWith(d):$("body").append(d),this.$dialogContainer=$("#confirm_dialog"),this.$dialog=this.$dialogContainer.find(this.attr.modalSelector),this.open()},this.submit=function(a,b){this.trigger(this.eventNode,"ui{{action}}Confirm"),this.close()},this.cancel=function(a,b){this.trigger(this.eventNode,"ui{{action}}Cancel"),a.type=="click"&&this.close()},this.after("initialize",function(){this.on(document,"uiOpenConfirmDialog",this.openWithOptions),this.on("click",{submitSelector:this.submit,cancelSelector:this.cancel}),this.on("uiDialogCloseRequested",{confirmDialogSelector:this.cancel})})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withEventParams=require("app/utils/with_event_params"),template=require("template");module.exports=defineComponent(confirmDialog,withDialog,withEventParams)
});
define("app/ui/connect_badge",["module","require","exports","core/component","app/utils/storage/core"],function(module, require, exports) {
function ConnectBadge(){this.defaultAttrs({keepBadgeStorageKey:"keep_badge_until",keepBadgeInterval:1e3}),this.processNewNotifications=function(a,b){b&&b.b&&b.b.status=="ok"&&b.b.response&&this.possiblyUpdateBadgeAndHighlighting(b.b.response)},this.possiblyUpdateBadgeAndHighlighting=function(a){a.show_badge_highlighting&&a.count>=0&&(this.trigger("uiUpdateConnectBadge",a.count),a.timestamp>=0&&(a.count>0||this.pastStorageTime())&&this.trigger("uiUpdateActivityHighlighting",a.timestamp),this.updateStorageTime())},this.pastStorageTime=function(){var a=(new Date).getTime(),b=this.storage.getItem(this.attr.keepBadgeStorageKey)||{until:0};return b.until<a},this.updateStorageTime=function(){var a=(new Date).getTime(),b=this.storage.getItem(this.attr.keepBadgeStorageKey)||{until:0};this.storage.setItem(this.attr.keepBadgeStorageKey,{until:a+this.attr.keepBadgeInterval})},this.after("initialize",function(){this.storage=new Storage("connect_badge"),this.updateStorageTime(0),this.on(document,"dataNotificationsReceived",this.processNewNotifications)})}var defineComponent=require("core/component"),Storage=require("app/utils/storage/core");module.exports=defineComponent(ConnectBadge)
});
/*! twitter-text-js 1.9.2 (c) 2012 Twitter, Inc. http://www.apache.org/licenses/LICENSE-2.0 */provide("lib/twitter-text",function(a){var b={};/*!
 * twitter-text-js 1.9.2
 *
 * Copyright 2012 Twitter, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 */(function(){function c(a,c){return c=c||"",typeof a!="string"&&(a.global&&c.indexOf("g")<0&&(c+="g"),a.ignoreCase&&c.indexOf("i")<0&&(c+="i"),a.multiline&&c.indexOf("m")<0&&(c+="m"),a=a.source),new RegExp(a.replace(/#\{(\w+)\}/g,function(a,c){var d=b.txt.regexen[c]||"";return typeof d!="string"&&(d=d.source),d}),c)}function d(a,b){return a.replace(/#\{(\w+)\}/g,function(a,c){return b[c]||""})}function e(a,b,c){var d=String.fromCharCode(b);return c!==b&&(d+="-"+String.fromCharCode(c)),a.push(d),a}function q(a){var b={};for(var c in a)a.hasOwnProperty(c)&&(b[c]=a[c]);return b}function u(a,b,c){return c?!a||a.match(b)&&RegExp["$&"]===a:typeof a=="string"&&a.match(b)&&RegExp["$&"]===a}b.txt={},b.txt.regexen={};var a={"&":"&amp;",">":"&gt;","<":"&lt;",'"':"&quot;","'":"&#39;"};b.txt.htmlEscape=function(b){return b&&b.replace(/[&"'><]/g,function(b){return a[b]})},b.txt.regexSupplant=c,b.txt.stringSupplant=d,b.txt.addCharsToCharClass=e;var f=String.fromCharCode,g=[f(32),f(133),f(160),f(5760),f(6158),f(8232),f(8233),f(8239),f(8287),f(12288)];e(g,9,13),e(g,8192,8202);var h=[f(65534),f(65279),f(65535)];e(h,8234,8238),b.txt.regexen.spaces_group=c(g.join("")),b.txt.regexen.spaces=c("["+g.join("")+"]"),b.txt.regexen.invalid_chars_group=c(h.join("")),b.txt.regexen.punct=/\!'#%&'\(\)*\+,\\\-\.\/:;<=>\?@\[\]\^_{|}~\$/,b.txt.regexen.rtl_chars=/[\u0600-\u06FF]|[\u0750-\u077F]|[\u0590-\u05FF]|[\uFE70-\uFEFF]/gm,b.txt.regexen.non_bmp_code_pairs=/[\uD800-\uDBFF][\uDC00-\uDFFF]/gm;var i=[];e(i,1024,1279),e(i,1280,1319),e(i,11744,11775),e(i,42560,42655),e(i,1425,1471),e(i,1473,1474),e(i,1476,1477),e(i,1479,1479),e(i,1488,1514),e(i,1520,1524),e(i,64274,64296),e(i,64298,64310),e(i,64312,64316),e(i,64318,64318),e(i,64320,64321),e(i,64323,64324),e(i,64326,64335),e(i,1552,1562),e(i,1568,1631),e(i,1646,1747),e(i,1749,1756),e(i,1758,1768),e(i,1770,1775),e(i,1786,1788),e(i,1791,1791),e(i,1872,1919),e(i,2208,2208),e(i,2210,2220),e(i,2276,2302),e(i,64336,64433),e(i,64467,64829),e(i,64848,64911),e(i,64914,64967),e(i,65008,65019),e(i,65136,65140),e(i,65142,65276),e(i,8204,8204),e(i,3585,3642),e(i,3648,3662),e(i,4352,4607),e(i,12592,12677),e(i,43360,43391),e(i,44032,55215),e(i,55216,55295),e(i,65441,65500),e(i,12449,12538),e(i,12540,12542),e(i,65382,65439),e(i,65392,65392),e(i,65296,65305),e(i,65313,65338),e(i,65345,65370),e(i,12353,12438),e(i,12441,12446),e(i,13312,19903),e(i,19968,40959),e(i,173824,177983),e(i,177984,178207),e(i,194560,195103),e(i,12291,12291),e(i,12293,12293),e(i,12347,12347),b.txt.regexen.nonLatinHashtagChars=c(i.join(""));var j=[];e(j,192,214),e(j,216,246),e(j,248,255),e(j,256,591),e(j,595,596),e(j,598,599),e(j,601,601),e(j,603,603),e(j,611,611),e(j,616,616),e(j,623,623),e(j,626,626),e(j,649,649),e(j,651,651),e(j,699,699),e(j,768,879),e(j,7680,7935),b.txt.regexen.latinAccentChars=c(j.join("")),b.txt.regexen.hashSigns=/[#＃]/,b.txt.regexen.hashtagAlpha=c(/[a-z_#{latinAccentChars}#{nonLatinHashtagChars}]/i),b.txt.regexen.hashtagAlphaNumeric=c(/[a-z0-9_#{latinAccentChars}#{nonLatinHashtagChars}]/i),b.txt.regexen.endHashtagMatch=c(/^(?:#{hashSigns}|:\/\/)/),b.txt.regexen.hashtagBoundary=c(/(?:^|$|[^&a-z0-9_#{latinAccentChars}#{nonLatinHashtagChars}])/),b.txt.regexen.validHashtag=c(/(#{hashtagBoundary})(#{hashSigns})(#{hashtagAlphaNumeric}*#{hashtagAlpha}#{hashtagAlphaNumeric}*)/gi),b.txt.regexen.validMentionPrecedingChars=/(?:^|[^a-zA-Z0-9_!#$%&*@＠]|(?:rt|RT|rT|Rt):?)/,b.txt.regexen.atSigns=/[@＠]/,b.txt.regexen.validMentionOrList=c("(#{validMentionPrecedingChars})(#{atSigns})([a-zA-Z0-9_]{1,20})(/[a-zA-Z][a-zA-Z0-9_-]{0,24})?","g"),b.txt.regexen.validReply=c(/^(?:#{spaces})*#{atSigns}([a-zA-Z0-9_]{1,20})/),b.txt.regexen.endMentionMatch=c(/^(?:#{atSigns}|[#{latinAccentChars}]|:\/\/)/),b.txt.regexen.validUrlPrecedingChars=c(/(?:[^A-Za-z0-9@＠$#＃#{invalid_chars_group}]|^)/),b.txt.regexen.invalidUrlWithoutProtocolPrecedingChars=/[-_.\/]$/,b.txt.regexen.invalidDomainChars=d("#{punct}#{spaces_group}#{invalid_chars_group}",b.txt.regexen),b.txt.regexen.validDomainChars=c(/[^#{invalidDomainChars}]/),b.txt.regexen.validSubdomain=c(/(?:(?:#{validDomainChars}(?:[_-]|#{validDomainChars})*)?#{validDomainChars}\.)/),b.txt.regexen.validDomainName=c(/(?:(?:#{validDomainChars}(?:-|#{validDomainChars})*)?#{validDomainChars}\.)/),b.txt.regexen.validGTLD=c(RegExp("(?:(?:academy|accountants|active|actor|aero|agency|airforce|archi|army|arpa|asia|associates|attorney|audio|autos|axa|bar|bargains|bayern|beer|berlin|best|bid|bike|bio|biz|black|blackfriday|blue|bmw|boutique|brussels|build|builders|buzz|bzh|cab|camera|camp|cancerresearch|capetown|capital|cards|care|career|careers|cash|cat|catering|center|ceo|cheap|christmas|church|citic|claims|cleaning|clinic|clothing|club|codes|coffee|college|cologne|com|community|company|computer|condos|construction|consulting|contractors|cooking|cool|coop|country|credit|creditcard|cruises|cuisinella|dance|dating|degree|democrat|dental|dentist|desi|diamonds|digital|direct|directory|discount|dnp|domains|durban|edu|education|email|engineer|engineering|enterprises|equipment|estate|eus|events|exchange|expert|exposed|fail|farm|feedback|finance|financial|fish|fishing|fitness|flights|florist|foo|foundation|frogans|fund|furniture|futbol|gal|gallery|gift|gives|glass|global|globo|gmo|gop|gov|graphics|gratis|green|gripe|guide|guitars|guru|hamburg|haus|hiphop|hiv|holdings|holiday|homes|horse|host|house|immobilien|industries|info|ink|institute|insure|int|international|investments|jetzt|jobs|joburg|juegos|kaufen|kim|kitchen|kiwi|koeln|kred|land|lawyer|lease|lgbt|life|lighting|limited|limo|link|loans|london|lotto|luxe|luxury|maison|management|mango|market|marketing|media|meet|menu|miami|mil|mini|mobi|moda|moe|monash|mortgage|moscow|motorcycles|museum|nagoya|name|navy|net|neustar|nhk|ninja|nyc|okinawa|onl|org|organic|ovh|paris|partners|parts|photo|photography|photos|physio|pics|pictures|pink|place|plumbing|post|press|pro|productions|properties|pub|qpon|quebec|recipes|red|rehab|reise|reisen|ren|rentals|repair|report|republican|rest|reviews|rich|rio|rocks|rodeo|ruhr|ryukyu|saarland|schmidt|schule|scot|services|sexy|shiksha|shoes|singles|social|software|sohu|solar|solutions|soy|space|spiegel|supplies|supply|support|surf|surgery|suzuki|systems|tattoo|tax|technology|tel|tienda|tips|tirol|today|tokyo|tools|town|toys|trade|training|travel|university|uno|vacations|vegas|ventures|versicherung|vet|viajes|villas|vision|vlaanderen|vodka|vote|voting|voto|voyage|wang|watch|webcam|website|wed|wien|wiki|works|wtc|wtf|xxx|xyz|yachts|yokohama|zone|дети|москва|онлайн|орг|сайт|بازار|شبكة|موقع|संगठन|みんな|世界|中信|中文网|公司|公益|商城|商标|在线|我爱你|政务|机构|游戏|移动|组织机构|网址|网络|集团|삼성)(?=[^0-9a-zA-Z@]|$))")),b.txt.regexen.validCCTLD=c(RegExp("(?:(?:ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bl|bm|bn|bo|bq|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cw|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mf|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|za|zm|zw|мкд|мон|рф|срб|укр|қаз|الاردن|الجزائر|السعودية|المغرب|امارات|ایران|بھارت|تونس|سودان|سورية|عمان|فلسطين|قطر|مصر|مليسيا|پاکستان|भारत|বাংলা|ভারত|ਭਾਰਤ|ભારત|இந்தியா|இலங்கை|சிங்கப்பூர்|భారత్|ලංකා|ไทย|გე|中国|中國|台湾|台灣|新加坡|香港|한국)(?=[^0-9a-zA-Z@]|$))")),b.txt.regexen.validPunycode=c(/(?:xn--[0-9a-z]+)/),b.txt.regexen.validSpecialCCTLD=c(RegExp("(?:(?:co|tv)(?=[^0-9a-zA-Z@]|$))")),b.txt.regexen.validDomain=c(/(?:#{validSubdomain}*#{validDomainName}(?:#{validGTLD}|#{validCCTLD}|#{validPunycode}))/),b.txt.regexen.validAsciiDomain=c(/(?:(?:[\-a-z0-9#{latinAccentChars}]+)\.)+(?:#{validGTLD}|#{validCCTLD}|#{validPunycode})/gi),b.txt.regexen.invalidShortDomain=c(/^#{validDomainName}#{validCCTLD}$/i),b.txt.regexen.validSpecialShortDomain=c(/^#{validDomainName}#{validSpecialCCTLD}$/i),b.txt.regexen.validPortNumber=c(/[0-9]+/),b.txt.regexen.validGeneralUrlPathChars=c(/[a-z0-9!\*';:=\+,\.\$\/%#\[\]\-_~@|&#{latinAccentChars}]/i),b.txt.regexen.validUrlBalancedParens=c("\\((?:#{validGeneralUrlPathChars}+|(?:#{validGeneralUrlPathChars}*\\(#{validGeneralUrlPathChars}+\\)#{validGeneralUrlPathChars}*))\\)","i"),b.txt.regexen.validUrlPathEndingChars=c(/[\+\-a-z0-9=_#\/#{latinAccentChars}]|(?:#{validUrlBalancedParens})/i),b.txt.regexen.validUrlPath=c("(?:(?:#{validGeneralUrlPathChars}*(?:#{validUrlBalancedParens}#{validGeneralUrlPathChars}*)*#{validUrlPathEndingChars})|(?:@#{validGeneralUrlPathChars}+/))","i"),b.txt.regexen.validUrlQueryChars=/[a-z0-9!?\*'@\(\);:&=\+\$\/%#\[\]\-_\.,~|]/i,b.txt.regexen.validUrlQueryEndingChars=/[a-z0-9_&=#\/]/i,b.txt.regexen.extractUrl=c("((#{validUrlPrecedingChars})((https?:\\/\\/)?(#{validDomain})(?::(#{validPortNumber}))?(\\/#{validUrlPath}*)?(\\?#{validUrlQueryChars}*#{validUrlQueryEndingChars})?))","gi"),b.txt.regexen.validTcoUrl=/^https?:\/\/t\.co\/[a-z0-9]+/i,b.txt.regexen.urlHasProtocol=/^https?:\/\//i,b.txt.regexen.urlHasHttps=/^https:\/\//i,b.txt.regexen.cashtag=/[a-z]{1,6}(?:[._][a-z]{1,2})?/i,b.txt.regexen.validCashtag=c("(^|#{spaces})(\\$)(#{cashtag})(?=$|\\s|[#{punct}])","gi"),b.txt.regexen.validateUrlUnreserved=/[a-z0-9\-._~]/i,b.txt.regexen.validateUrlPctEncoded=/(?:%[0-9a-f]{2})/i,b.txt.regexen.validateUrlSubDelims=/[!$&'()*+,;=]/i,b.txt.regexen.validateUrlPchar=c("(?:#{validateUrlUnreserved}|#{validateUrlPctEncoded}|#{validateUrlSubDelims}|[:|@])","i"),b.txt.regexen.validateUrlScheme=/(?:[a-z][a-z0-9+\-.]*)/i,b.txt.regexen.validateUrlUserinfo=c("(?:#{validateUrlUnreserved}|#{validateUrlPctEncoded}|#{validateUrlSubDelims}|:)*","i"),b.txt.regexen.validateUrlDecOctet=/(?:[0-9]|(?:[1-9][0-9])|(?:1[0-9]{2})|(?:2[0-4][0-9])|(?:25[0-5]))/i,b.txt.regexen.validateUrlIpv4=c(/(?:#{validateUrlDecOctet}(?:\.#{validateUrlDecOctet}){3})/i),b.txt.regexen.validateUrlIpv6=/(?:\[[a-f0-9:\.]+\])/i,b.txt.regexen.validateUrlIp=c("(?:#{validateUrlIpv4}|#{validateUrlIpv6})","i"),b.txt.regexen.validateUrlSubDomainSegment=/(?:[a-z0-9](?:[a-z0-9_\-]*[a-z0-9])?)/i,b.txt.regexen.validateUrlDomainSegment=/(?:[a-z0-9](?:[a-z0-9\-]*[a-z0-9])?)/i,b.txt.regexen.validateUrlDomainTld=/(?:[a-z](?:[a-z0-9\-]*[a-z0-9])?)/i,b.txt.regexen.validateUrlDomain=c(/(?:(?:#{validateUrlSubDomainSegment]}\.)*(?:#{validateUrlDomainSegment]}\.)#{validateUrlDomainTld})/i),b.txt.regexen.validateUrlHost=c("(?:#{validateUrlIp}|#{validateUrlDomain})","i"),b.txt.regexen.validateUrlUnicodeSubDomainSegment=/(?:(?:[a-z0-9]|[^\u0000-\u007f])(?:(?:[a-z0-9_\-]|[^\u0000-\u007f])*(?:[a-z0-9]|[^\u0000-\u007f]))?)/i,b.txt.regexen.validateUrlUnicodeDomainSegment=/(?:(?:[a-z0-9]|[^\u0000-\u007f])(?:(?:[a-z0-9\-]|[^\u0000-\u007f])*(?:[a-z0-9]|[^\u0000-\u007f]))?)/i,b.txt.regexen.validateUrlUnicodeDomainTld=/(?:(?:[a-z]|[^\u0000-\u007f])(?:(?:[a-z0-9\-]|[^\u0000-\u007f])*(?:[a-z0-9]|[^\u0000-\u007f]))?)/i,b.txt.regexen.validateUrlUnicodeDomain=c(/(?:(?:#{validateUrlUnicodeSubDomainSegment}\.)*(?:#{validateUrlUnicodeDomainSegment}\.)#{validateUrlUnicodeDomainTld})/i),b.txt.regexen.validateUrlUnicodeHost=c("(?:#{validateUrlIp}|#{validateUrlUnicodeDomain})","i"),b.txt.regexen.validateUrlPort=/[0-9]{1,5}/,b.txt.regexen.validateUrlUnicodeAuthority=c("(?:(#{validateUrlUserinfo})@)?(#{validateUrlUnicodeHost})(?::(#{validateUrlPort}))?","i"),b.txt.regexen.validateUrlAuthority=c("(?:(#{validateUrlUserinfo})@)?(#{validateUrlHost})(?::(#{validateUrlPort}))?","i"),b.txt.regexen.validateUrlPath=c(/(\/#{validateUrlPchar}*)*/i),b.txt.regexen.validateUrlQuery=c(/(#{validateUrlPchar}|\/|\?)*/i),b.txt.regexen.validateUrlFragment=c(/(#{validateUrlPchar}|\/|\?)*/i),b.txt.regexen.validateUrlUnencoded=c("^(?:([^:/?#]+):\\/\\/)?([^/?#]*)([^?#]*)(?:\\?([^#]*))?(?:#(.*))?$","i");var k="tweet-url list-slug",l="tweet-url username",m="tweet-url hashtag",n="tweet-url cashtag",o={urlClass:!0,listClass:!0,usernameClass:!0,hashtagClass:!0,cashtagClass:!0,usernameUrlBase:!0,listUrlBase:!0,hashtagUrlBase:!0,cashtagUrlBase:!0,usernameUrlBlock:!0,listUrlBlock:!0,hashtagUrlBlock:!0,linkUrlBlock:!0,usernameIncludeSymbol:!0,suppressLists:!0,suppressNoFollow:!0,targetBlank:!0,suppressDataScreenName:!0,urlEntities:!0,symbolTag:!0,textWithSymbolTag:!0,urlTarget:!0,invisibleTagAttrs:!0,linkAttributeBlock:!0,linkTextBlock:!0,htmlEscapeNonEntities:!0},p={disabled:!0,readonly:!0,multiple:!0,checked:!0};b.txt.tagAttrs=function(a){var c="";for(var d in a){var e=a[d];p[d]&&(e=e?d:null);if(e==null)continue;c+=" "+b.txt.htmlEscape(d)+'="'+b.txt.htmlEscape(e.toString())+'"'}return c},b.txt.linkToText=function(a,c,e,f){f.suppressNoFollow||(e.rel="nofollow"),f.linkAttributeBlock&&f.linkAttributeBlock(a,e),f.linkTextBlock&&(c=f.linkTextBlock(a,c));var g={text:c,attr:b.txt.tagAttrs(e)};return d("<a#{attr}>#{text}</a>",g)},b.txt.linkToTextWithSymbol=function(a,c,d,e,f){var g=f.symbolTag?"<"+f.symbolTag+">"+c+"</"+f.symbolTag+">":c;d=b.txt.htmlEscape(d);var h=f.textWithSymbolTag?"<"+f.textWithSymbolTag+">"+d+"</"+f.textWithSymbolTag+">":d;return f.usernameIncludeSymbol||!c.match(b.txt.regexen.atSigns)?b.txt.linkToText(a,g+h,e,f):g+b.txt.linkToText(a,h,e,f)},b.txt.linkToHashtag=function(a,c,d){var e=c.substring(a.indices[0],a.indices[0]+1),f=b.txt.htmlEscape(a.hashtag),g=q(d.htmlAttrs||{});return g.href=d.hashtagUrlBase+f,g.title="#"+f,g["class"]=d.hashtagClass,f.charAt(0).match(b.txt.regexen.rtl_chars)&&(g["class"]+=" rtl"),d.targetBlank&&(g.target="_blank"),b.txt.linkToTextWithSymbol(a,e,f,g,d)},b.txt.linkToCashtag=function(a,c,d){var e=b.txt.htmlEscape(a.cashtag),f=q(d.htmlAttrs||{});return f.href=d.cashtagUrlBase+e,f.title="$"+e,f["class"]=d.cashtagClass,d.targetBlank&&(f.target="_blank"),b.txt.linkToTextWithSymbol(a,"$",e,f,d)},b.txt.linkToMentionAndList=function(a,c,d){var e=c.substring(a.indices[0],a.indices[0]+1),f=b.txt.htmlEscape(a.screenName),g=b.txt.htmlEscape(a.listSlug),h=a.listSlug&&!d.suppressLists,i=q(d.htmlAttrs||{});return i["class"]=h?d.listClass:d.usernameClass,i.href=h?d.listUrlBase+f+g:d.usernameUrlBase+f,!h&&!d.suppressDataScreenName&&(i["data-screen-name"]=f),d.targetBlank&&(i.target="_blank"),b.txt.linkToTextWithSymbol(a,e,h?f+g:f,i,d)},b.txt.linkToUrl=function(a,c,d){var e=a.url,f=e,g=b.txt.htmlEscape(f),h=d.urlEntities&&d.urlEntities[e]||a;h.display_url&&(g=b.txt.linkTextWithEntity(h,d));var i=q(d.htmlAttrs||{});return e.match(b.txt.regexen.urlHasProtocol)||(e="http://"+e),i.href=e,d.targetBlank&&(i.target="_blank"),d.urlClass&&(i["class"]=d.urlClass),d.urlTarget&&(i.target=d.urlTarget),!d.title&&h.display_url&&(i.title=h.expanded_url),b.txt.linkToText(a,g,i,d)},b.txt.linkTextWithEntity=function(a,c){var e=a.display_url,f=a.expanded_url,g=e.replace(/…/g,"");if(f.indexOf(g)!=-1){var h=f.indexOf(g),i={displayUrlSansEllipses:g,beforeDisplayUrl:f.substr(0,h),afterDisplayUrl:f.substr(h+g.length),precedingEllipsis:e.match(/^…/)?"…":"",followingEllipsis:e.match(/…$/)?"…":""};for(var j in i)i.hasOwnProperty(j)&&(i[j]=b.txt.htmlEscape(i[j]));return i.invisible=c.invisibleTagAttrs,d("<span class='tco-ellipsis'>#{precedingEllipsis}<span #{invisible}>&nbsp;</span></span><span #{invisible}>#{beforeDisplayUrl}</span><span class='js-display-url'>#{displayUrlSansEllipses}</span><span #{invisible}>#{afterDisplayUrl}</span><span class='tco-ellipsis'><span #{invisible}>&nbsp;</span>#{followingEllipsis}</span>",i)}return e},b.txt.autoLinkEntities=function(a,c,d){d=q(d||{}),d.hashtagClass=d.hashtagClass||m,d.hashtagUrlBase=d.hashtagUrlBase||"https://twitter.com/#!/search?q=%23",d.cashtagClass=d.cashtagClass||n,d.cashtagUrlBase=d.cashtagUrlBase||"https://twitter.com/#!/search?q=%24",d.listClass=d.listClass||k,d.usernameClass=d.usernameClass||l,d.usernameUrlBase=d.usernameUrlBase||"https://twitter.com/",d.listUrlBase=d.listUrlBase||"https://twitter.com/",d.htmlAttrs=b.txt.extractHtmlAttrsFromOptions(d),d.invisibleTagAttrs=d.invisibleTagAttrs||"style='position:absolute;left:-9999px;'";var e,f,g;if(d.urlEntities){e={};for(f=0,g=d.urlEntities.length;f<g;f++)e[d.urlEntities[f].url]=d.urlEntities[f];d.urlEntities=e}var h="",i=0;c.sort(function(a,b){return a.indices[0]-b.indices[0]});var j=d.htmlEscapeNonEntities?b.txt.htmlEscape:function(a){return a};for(var f=0;f<c.length;f++){var o=c[f];h+=j(a.substring(i,o.indices[0])),o.url?h+=b.txt.linkToUrl(o,a,d):o.hashtag?h+=b.txt.linkToHashtag(o,a,d):o.screenName?h+=b.txt.linkToMentionAndList(o,a,d):o.cashtag&&(h+=b.txt.linkToCashtag(o,a,d)),i=o.indices[1]}return h+=j(a.substring(i,a.length)),h},b.txt.autoLinkWithJSON=function(a,c,d){if(c.user_mentions)for(var e=0;e<c.user_mentions.length;e++)c.user_mentions[e].screenName=c.user_mentions[e].screen_name;if(c.hashtags)for(var e=0;e<c.hashtags.length;e++)c.hashtags[e].hashtag=c.hashtags[e].text;if(c.symbols)for(var e=0;e<c.symbols.length;e++)c.symbols[e].cashtag=c.symbols[e].text;var f=[];for(var g in c)f=f.concat(c[g]);return b.txt.modifyIndicesFromUnicodeToUTF16(a,f),b.txt.autoLinkEntities(a,f,d)},b.txt.extractHtmlAttrsFromOptions=function(a){var b={};for(var c in a){var d=a[c];if(o[c])continue;p[c]&&(d=d?c:null);if(d==null)continue;b[c]=d}return b},b.txt.autoLink=function(a,c){var d=b.txt.extractEntitiesWithIndices(a,{extractUrlsWithoutProtocol:!1});return b.txt.autoLinkEntities(a,d,c)},b.txt.autoLinkUsernamesOrLists=function(a,c){var d=b.txt.extractMentionsOrListsWithIndices(a);return b.txt.autoLinkEntities(a,d,c)},b.txt.autoLinkHashtags=function(a,c){var d=b.txt.extractHashtagsWithIndices(a);return b.txt.autoLinkEntities(a,d,c)},b.txt.autoLinkCashtags=function(a,c){var d=b.txt.extractCashtagsWithIndices(a);return b.txt.autoLinkEntities(a,d,c)},b.txt.autoLinkUrlsCustom=function(a,c){var d=b.txt.extractUrlsWithIndices(a,{extractUrlsWithoutProtocol:!1});return b.txt.autoLinkEntities(a,d,c)},b.txt.removeOverlappingEntities=function(a){a.sort(function(a,b){return a.indices[0]-b.indices[0]});var b=a[0];for(var c=1;c<a.length;c++)b.indices[1]>a[c].indices[0]?(a.splice(c,1),c--):b=a[c]},b.txt.extractEntitiesWithIndices=function(a,c){var d=b.txt.extractUrlsWithIndices(a,c).concat(b.txt.extractMentionsOrListsWithIndices(a)).concat(b.txt.extractHashtagsWithIndices(a,{checkUrlOverlap:!1})).concat(b.txt.extractCashtagsWithIndices(a));return d.length==0?[]:(b.txt.removeOverlappingEntities(d),d)},b.txt.extractMentions=function(a){var c=[],d=b.txt.extractMentionsWithIndices(a);for(var e=0;e<d.length;e++){var f=d[e].screenName;c.push(f)}return c},b.txt.extractMentionsWithIndices=function(a){var c=[],d,e=b.txt.extractMentionsOrListsWithIndices(a);for(var f=0;f<e.length;f++)d=e[f],d.listSlug==""&&c.push({screenName:d.screenName,indices:d.indices});return c},b.txt.extractMentionsOrListsWithIndices=function(a){if(!a||!a.match(b.txt.regexen.atSigns))return[];var c=[],d;return a.replace(b.txt.regexen.validMentionOrList,function(a,d,e,f,g,h,i){var j=i.slice(h+a.length);if(!j.match(b.txt.regexen.endMentionMatch)){g=g||"";var k=h+d.length,l=k+f.length+g.length+1;c.push({screenName:f,listSlug:g,indices:[k,l]})}}),c},b.txt.extractReplies=function(a){if(!a)return null;var c=a.match(b.txt.regexen.validReply);return!c||RegExp.rightContext.match(b.txt.regexen.endMentionMatch)?null:c[1]},b.txt.extractUrls=function(a,c){var d=[],e=b.txt.extractUrlsWithIndices(a,c);for(var f=0;f<e.length;f++)d.push(e[f].url);return d},b.txt.extractUrlsWithIndices=function(a,c){c||(c={extractUrlsWithoutProtocol:!0});if(!a||(c.extractUrlsWithoutProtocol?!a.match(/\./):!a.match(/:/)))return[];var d=[];while(b.txt.regexen.extractUrl.exec(a)){var e=RegExp.$2,f=RegExp.$3,g=RegExp.$4,h=RegExp.$5,i=RegExp.$7,j=b.txt.regexen.extractUrl.lastIndex,k=j-f.length;if(!g){if(!c.extractUrlsWithoutProtocol||e.match(b.txt.regexen.invalidUrlWithoutProtocolPrecedingChars))continue;var l=null,m=0;h.replace(b.txt.regexen.validAsciiDomain,function(a){var c=h.indexOf(a,m);m=c+a.length,l={url:a,indices:[k+c,k+m]},(i||a.match(b.txt.regexen.validSpecialShortDomain)||!a.match(b.txt.regexen.invalidShortDomain))&&d.push(l)});if(l==null)continue;i&&(l.url=f.replace(h,l.url),l.indices[1]=j)}else f.match(b.txt.regexen.validTcoUrl)&&(f=RegExp.lastMatch,j=k+f.length),d.push({url:f,indices:[k,j]})}return d},b.txt.extractHashtags=function(a){var c=[],d=b.txt.extractHashtagsWithIndices(a);for(var e=0;e<d.length;e++)c.push(d[e].hashtag);return c},b.txt.extractHashtagsWithIndices=function(a,c){c||(c={checkUrlOverlap:!0});if(!a||!a.match(b.txt.regexen.hashSigns))return[];var d=[];a.replace(b.txt.regexen.validHashtag,function(a,c,e,f,g,h){var i=h.slice(g+a.length);if(i.match(b.txt.regexen.endHashtagMatch))return;var j=g+c.length,k=j+f.length+1;d.push({hashtag:f,indices:[j,k]})});if(c.checkUrlOverlap){var e=b.txt.extractUrlsWithIndices(a);if(e.length>0){var f=d.concat(e);b.txt.removeOverlappingEntities(f),d=[];for(var g=0;g<f.length;g++)f[g].hashtag&&d.push(f[g])}}return d},b.txt.extractCashtags=function(a){var c=[],d=b.txt.extractCashtagsWithIndices(a);for(var e=0;e<d.length;e++)c.push(d[e].cashtag);return c},b.txt.extractCashtagsWithIndices=function(a){if(!a||a.indexOf("$")==-1)return[];var c=[];return a.replace(b.txt.regexen.validCashtag,function(a,b,d,e,f,g){var h=f+b.length,i=h+e.length+1;c.push({cashtag:e,indices:[h,i]})}),c},b.txt.modifyIndicesFromUnicodeToUTF16=function(a,c){b.txt.convertUnicodeIndices(a,c,!1)},b.txt.modifyIndicesFromUTF16ToUnicode=function(a,c){b.txt.convertUnicodeIndices(a,c,!0)},b.txt.getUnicodeTextLength=function(a){return a.replace(b.txt.regexen.non_bmp_code_pairs," ").length},b.txt.convertUnicodeIndices=function(a,b,c){if(b.length==0)return;var d=0,e=0;b.sort(function(a,b){return a.indices[0]-b.indices[0]});var f=0,g=b[0];while(d<a.length){if(g.indices[0]==(c?d:e)){var h=g.indices[1]-g.indices[0];g.indices[0]=c?e:d,g.indices[1]=g.indices[0]+h,f++;if(f==b.length)break;g=b[f]}var i=a.charCodeAt(d);55296<=i&&i<=56319&&d<a.length-1&&(i=a.charCodeAt(d+1),56320<=i&&i<=57343&&d++),e++,d++}},b.txt.splitTags=function(a){var b=a.split("<"),c,d=[],e;for(var f=0;f<b.length;f+=1){e=b[f];if(!e)d.push("");else{c=e.split(">");for(var g=0;g<c.length;g+=1)d.push(c[g])}}return d},b.txt.hitHighlight=function(a,c,d){var e="em";c=c||[],d=d||{};if(c.length===0)return a;var f=d.tag||e,g=["<"+f+">","</"+f+">"],h=b.txt.splitTags(a),i,j,k="",l=0,m=h[0],n=0,o=0,p=!1,q=m,r=[],s,t,u,v,w;for(i=0;i<c.length;i+=1)for(j=0;j<c[i].length;j+=1)r.push(c[i][j]);for(s=0;s<r.length;s+=1){t=r[s],u=g[s%2],v=!1;while(m!=null&&t>=n+m.length)k+=q.slice(o),p&&t===n+q.length&&(k+=u,v=!0),h[l+1]&&(k+="<"+h[l+1]+">"),n+=q.length,o=0,l+=2,m=h[l],q=m,p=!1;!v&&m!=null?(w=t-n,k+=q.slice(o,w)+u,o=w,s%2===0?p=!0:p=!1):v||(v=!0,k+=u)}if(m!=null){o<q.length&&(k+=q.slice(o));for(s=l+1;s<h.length;s+=1)k+=s%2===0?h[s]:"<"+h[s]+">"}return k};var r=140,s=[f(65534),f(65279),f(65535),f(8234),f(8235),f(8236),f(8237),f(8238)];b.txt.getTweetLength=function(a,c){c||(c={short_url_length:22,short_url_length_https:23});var d=b.txt.getUnicodeTextLength(a),e=b.txt.extractUrlsWithIndices(a);b.txt.modifyIndicesFromUTF16ToUnicode(a,e);for(var f=0;f<e.length;f++)d+=e[f].indices[0]-e[f].indices[1],e[f].url.toLowerCase().match(b.txt.regexen.urlHasHttps)?d+=c.short_url_length_https:d+=c.short_url_length;return d},b.txt.isInvalidTweet=function(a){if(!a)return"empty";if(b.txt.getTweetLength(a)>r)return"too_long";for(var c=0;c<s.length;c++)if(a.indexOf(s[c])>=0)return"invalid_characters";return!1},b.txt.isValidTweetText=function(a){return!b.txt.isInvalidTweet(a)},b.txt.isValidUsername=function(a){if(!a)return!1;var c=b.txt.extractMentions(a);return c.length===1&&c[0]===a.slice(1)};var t=c(/^#{validMentionOrList}$/);b.txt.isValidList=function(a){var b=a.match(t);return!!b&&b[1]==""&&!!b[4]},b.txt.isValidHashtag=function(a){if(!a)return!1;var c=b.txt.extractHashtags(a);return c.length===1&&c[0]===a.slice(1)},b.txt.isValidUrl=function(a,c,d){c==null&&(c=!0),d==null&&(d=!0);if(!a)return!1;var e=a.match(b.txt.regexen.validateUrlUnencoded);if(!e||e[0]!==a)return!1;var f=e[1],g=e[2],h=e[3],i=e[4],j=e[5];return(!d||u(f,b.txt.regexen.validateUrlScheme)&&f.match(/^https?$/i))&&u(h,b.txt.regexen.validateUrlPath)&&u(i,b.txt.regexen.validateUrlQuery,!0)&&u(j,b.txt.regexen.validateUrlFragment,!0)?c&&u(g,b.txt.regexen.validateUrlUnicodeAuthority)||!c&&u(g,b.txt.regexen.validateUrlAuthority):!1},typeof module!="undefined"&&module.exports&&(module.exports=b.txt)})(),a(b.txt)})
define("app/utils/tweet_helper",["module","require","exports","lib/twitter-text","core/utils","app/data/user_info"],function(module, require, exports) {
var twitterText=require("lib/twitter-text"),utils=require("core/utils"),userInfo=require("app/data/user_info"),VALID_PROTOCOL_PREFIX_REGEX=/^https?:\/\//i;LEADING_WHITESPACE_REGEX=/^\s*/;var tweetHelper={extractMentionsForReply:function(a,b){var c=a.attr("data-screen-name"),d=a.attr("data-retweeter"),e=a.attr("data-mentions")?a.attr("data-mentions").split(" "):[],f=[c,b,d];return e=e.filter(function(a){return f.indexOf(a)<0}),d&&d!=c&&d!=b&&e.unshift(d),(!e.length||c!=b)&&e.unshift(c),e},linkify:function(a,b){return b=utils.merge({hashtagClass:"twitter-hashtag pretty-link",hashtagUrlBase:"/search?q=%23",symbolTag:"s",textWithSymbolTag:"b",cashtagClass:"twitter-cashtag pretty-link",cashtagUrlBase:"/search?q=%24",usernameClass:"twitter-atreply pretty-link",usernameUrlBase:"/",usernameIncludeSymbol:!0,listClass:"twitter-listname pretty-link",urlClass:"twitter-timeline-link",urlTarget:"_blank",suppressNoFollow:!0,htmlEscapeNonEntities:!0},b||{}),twitterText.autoLinkEntities(a,twitterText.extractEntitiesWithIndices(a),b)},separateRepliesAndText:function(a,b){function h(b,c){return b.indices[0]==g||b.indices[0]==c+1&&a[c]==" "}function i(a,c){return b.indexOf(a.screenName)>=0&&f.indexOf(a.screenName)==-1}function j(){return c!=null?d.map(function(a){return a.screenName.toLowerCase()}).indexOf(c)>=0:!1}var c=b.length<=0?null:b[0].toLowerCase(),d=twitterText.extractMentionsWithIndices(a),e=0,f=[],g=a.match(LEADING_WHITESPACE_REGEX)[0].length;return d.forEach(function(a,b){if(!(h(a,e)&&i(a,b)&&j()&&f.length<10))return!1;f.push(a.screenName),e=a.indices[1]}),a=a.substr(e),{replyScreenNames:f,replyLength:e-g,text:a}}};module.exports=tweetHelper
});
define("app/ui/with_character_counter",["module","require","exports","lib/twitter-text","app/utils/tweet_helper","app/data/user_info"],function(module, require, exports) {
function withCharacterCounter(){var a=23,b=24;this.defaultAttrs({maxLength:140,superwarnLength:130,warnLength:120,superwarnClass:"superwarn",warnClass:"warn",maxReachedClass:"max-reached"}),this.updateCounter=function(){var a=this.getLength(),b=a>=this.attr.warnLength&&a<this.attr.superwarnLength,c=a>=this.attr.superwarnLength,d=this.maxReached(),e=this.attr.maxLength-a;this.$counter.html(e).toggleClass(this.attr.warnClass,b).toggleClass(this.attr.superwarnClass,c).toggleClass(this.attr.maxReachedClass,d),(b||c)&&this.trigger("uiCharCountWarningVisible",{charCount:e})},this.getLength=function(c){return c===undefined&&(c=this.val()),c!==this.prevCounterText&&(this.prevCounterText=c,this.prevCounterLength=twitterText.getTweetLength(c)),this.prevCounterLength+(this.hasMedia?this.attr.dmOnly?b:a:0)+(this.lifelineAlertMode?this.lifelineAlertText.length:0)-this.calculateReplyLength(c)},this.calculateReplyLength=function(a){return userInfo.getExperimentGroup("reply140")&&this.attr.inReplyToTweetData.screenNames?tweetHelper.separateRepliesAndText(a,this.attr.inReplyToTweetData.screenNames).replyLength:0},this.maxReached=function(){return this.getLength()>this.attr.maxLength},this.after("initialize",function(){this.$counter=this.select("counterSelector"),this.on("uiTextChanged",this.updateCounter),this.updateCounter()})}var twitterText=require("lib/twitter-text"),tweetHelper=require("app/utils/tweet_helper"),userInfo=require("app/data/user_info");module.exports=withCharacterCounter
});
define("app/ui/with_text_polling",["module","require","exports"],function(module, require, exports) {
function withTextPolling(){this.defaultAttrs({pollIntervalInMs:100}),this.pollUpdatedText=function(){this.detectUpdatedText(),this.hasFocus()||this.stopPollingUpdatedText()},this.startPollingUpdatedText=function(){this.detectUpdatedText(),this.pollUpdatedTextId===undefined&&(this.pollUpdatedTextId=setInterval(this.pollUpdatedText.bind(this),this.attr.pollIntervalInMs))},this.stopPollingUpdatedText=function(){this.pollUpdatedTextId!==undefined&&(clearInterval(this.pollUpdatedTextId),delete this.pollUpdatedTextId)},this.after("initialize",function(){this.on(this.$text,"focus",this.startPollingUpdatedText),this.hasFocus()&&this.startPollingUpdatedText()}),this.before("teardown",function(){this.stopPollingUpdatedText()})}module.exports=withTextPolling
});
define("app/ui/updating_text_counter",["module","require","exports","core/component","app/ui/with_character_counter","app/ui/with_text_polling"],function(module, require, exports) {
function updatingTextCounter(){this.defaultAttrs({inputSelector:"#user_description",counterSelector:".user_description_count"}),this.val=function(a){if(a==undefined)return this.$text.val();this.$text.val(a),this.detectUpdatedText()},this.hasFocus=function(){return document.activeElement===this.$text[0]},this.detectUpdatedText=function(){var a=this.$text.val();a!==this.prevText&&(this.prevText=a,this.trigger("uiTextChanged"))},this.after("initialize",function(){this.$text=this.select("inputSelector")})}var defineComponent=require("core/component"),withCharacterCounter=require("app/ui/with_character_counter"),withTextPolling=require("app/ui/with_text_polling");module.exports=defineComponent(updatingTextCounter,withCharacterCounter,withTextPolling)
});
define("app/ui/dialogs/with_create_or_edit_custom_timeline_dialog",["module","require","exports"],function(module, require, exports) {
module.exports=function(){var a=/^\s*$/;this.defaultAttrs({top:90,saveSelector:".update-custom-timeline-button",nameSelector:"[name=name]",descriptionSelector:"[name=custom-timeline-description]",dialogTitleSelector:".modal-title",maxReachedSelector:".max-reached"}),this.params=function(){return{name:this.$name.val(),description:this.$description.val(),order:this.select("orderSelector").val()}},this.saveCustomTimeline=function(a,b){this.disableSaveButton(),this.trigger(this.attr.createOrUpdateEventName,this.params())},this.disableSaveButton=function(){this.$saveButton.attr("disabled",!0)},this.toggleSaveButton=function(b,c){var d=a.test(this.$name.val()),e=this.select("maxReachedSelector").length>0;this.$saveButton.attr("disabled",d||e)},this.after("open",function(){this.$saveButton=this.select("saveSelector"),this.$name=this.select("nameSelector"),this.$description=this.select("descriptionSelector"),this.toggleSaveButton()}),this.after("initialize",function(){this.on(document,"dataCustomTimelineUpdated",this.close),this.on("click",{saveSelector:this.saveCustomTimeline}),this.on("input",{nameSelector:this.toggleSaveButton}),this.on("uiTextChanged",this.toggleSaveButton)})}
});
define("app/ui/dialogs/create_custom_timeline_dialog",["module","require","exports","core/component","app/ui/updating_text_counter","app/ui/with_dialog","app/ui/dialogs/with_create_or_edit_custom_timeline_dialog","template"],function(module, require, exports) {
function createCustomTimelineDialog(){this.defaultAttrs({createOrUpdateEventName:"uiCreateCustomTimeline",orderSelector:"[name=create-timeline-order]:checked"}),this.around("params",function(a){var b=a();return b.tweetId=this.tweetId,b.impressionId=this.impressionId,b}),this.openDialog=function(a,b){this.tweetId=b.tweetId,this.impressionId=b.impressionId;var c={is_create_dialog:!0,id_prefix:"create",curation_reverse_chron:!0},d=template["dialogs/create_or_edit_custom_timeline_dialog"].render(c,template);this.$node.html(d),this.$dialog=this.$dialogContainer.find(this.attr.modalSelector),this.open()},this.after("open",function(){UpdatingTextCounter.attachTo(".custom-timeline-name-field",{maxLength:25,superwarnLength:20,warnLength:15,inputSelector:"#custom-timeline-name",counterSelector:".custom-timeline-name-count"}),UpdatingTextCounter.attachTo(".custom-timeline-description-field",{maxLength:160,superwarnLength:150,warnLength:140,inputSelector:"#custom-timeline-description",counterSelector:".custom-timeline-description-count"})}),this.after("initialize",function(){this.on(document,"uiOpenCreateCustomTimelineDialog",this.openDialog)})}var defineComponent=require("core/component"),UpdatingTextCounter=require("app/ui/updating_text_counter"),withDialog=require("app/ui/with_dialog"),withCreateOrEditCustomTimelineDialog=require("app/ui/dialogs/with_create_or_edit_custom_timeline_dialog"),template=require("template");module.exports=defineComponent(withDialog,withCreateOrEditCustomTimelineDialog,createCustomTimelineDialog)
});
define("app/ui/with_custom_timeline_create_button",["module","require","exports"],function(module, require, exports) {
module.exports=function(){this.defaultAttrs({createCustomTimelineSelector:".js-create-custom-timeline-button"}),this.openCreateDialog=function(){this.trigger("uiOpenCreateCustomTimelineDialog",{tweetId:this.tweetId,impressionId:this.impressionId})},this.after("initialize",function(){this.on("click",{createCustomTimelineSelector:this.openCreateDialog})})}
});
define("app/ui/dialogs/curate_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/with_custom_timeline_create_button","app/data/with_scribe","core/i18n","template"],function(module, require, exports) {
function curateDialog(){this.defaultAttrs({top:90,closeOnOtherDialogOpened:!0,timelineSelectorSelector:".timeline-selector",wasMemberSelector:".timeline-item .was-member",wasNotMemberSelector:".timeline-item .was-not-member",submitSelector:".js-submit"}),this.openDialog=function(a,b){var c=template["dialogs/curate_dialog"].render({},template);this.$node.html(c),this.$dialog=this.$dialogContainer.find(this.attr.modalSelector),this.tweetId=b.tweetId,this.impressionId=b.impressionId,this.trigger("uiNeedsFullCustomTimelines",{tweetId:b.tweetId}),this.scribe({component:"curate_dialog",action:"open"},b),this.open()},this.renderFullTimelinesList=function(a,b){this.select("timelineSelectorSelector").html(b.html)},this.submitChanges=function(){function a(a){return a.map(function(){return $(this).attr("data-timeline-id")}).get()}this.select("submitSelector").attr("disabled",!0);var b=this.select("wasMemberSelector").filter(":not(:checked)"),c=this.select("wasNotMemberSelector").filter(":checked"),d={removed:a(b),added:a(c),tweetId:this.tweetId,impressionId:this.impressionId};this.trigger("uiCurateTweets",d)},this.after("initialize",function(){this.on(document,"uiOpenCurateDialog",this.openDialog),this.on(document,"dataGotFullCustomTimelines",this.renderFullTimelinesList),this.on(document,"dataTweetsCurated",this.close),this.on("click",{submitSelector:this.submitChanges})})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withCustomTimelineCreateButton=require("app/ui/with_custom_timeline_create_button"),withScribe=require("app/data/with_scribe"),_=require("core/i18n"),template=require("template");module.exports=defineComponent(withDialog,curateDialog,withCustomTimelineCreateButton,withScribe)
});
define("app/ui/dashboard",["module","require","exports","core/component","core/utils","core/clock"],function(module, require, exports) {
function dashboard(){this.defaultAttrs({fixedClass:"fixed-dashboard",padding:5}),this.fixDashboard=function(){var a=this.$node;this.setWtfModule(a);var b=a.height(),c=$(document).scrollTop(),d=this.fixWholeDashboard(a,this.windowHeight,b,c);if(!d){var e=this.$wtfModule.position().top;this.fixPartialDashboard(a,this.windowHeight,b,c,e)}},this.fixWholeDashboard=function(a,b,c,d){var e=this.initialDashboardTop+c;return e<=b?(this.fixDashboardElement(a,""),!0):(d<1&&this.unfixDashboard(a),!1)},this.fixPartialDashboard=function(a,b,c,d,e){if(d>e&&this.fixedDashboard)return;var f=this.topBarHeight+d+this.attr.padding,g=(e-this.topBarHeight-this.attr.padding)*-1+this.initialDashboardTop,h=this.initialDashboardTop+c+g,i=h<=b,j=f>=e;j&&i?this.fixedDashboard||this.fixDashboardElement(a,g):this.unfixDashboard(a)},this.setWtfModule=function(a){this.$wtfModule=this.$wtfModule||a.find(".js-wtf-module")},this.setWindowHeight=function(){this.windowHeight=$(window).height()},this.setTopBarHeight=function(){var a=$(".js-topbar");this.topBarHeight=a.height()},this.setWindowHeightAndFixDashboard=function(){this.setWindowHeight(),this.fixDashboard()},this.fixDashboardElement=function(a,b){a.addClass(this.attr.fixedClass).css("top",b),this.fixedDashboard=!0},this.unfixDashboard=function(a){a.removeClass(this.attr.fixedClass).css("top",""),this.fixedDashboard=!1},this.after("initialize",function(a,b){b.freezeDashboard&&(this.fixedDashboard=!1,this.initialDashboardTop=$(a).position().top,this.setWindowHeight(),this.setTopBarHeight(),this.fixDashboard(),clock.setTimeoutEvent("uiDashboardShouldCheckHeight",1e3),this.on(document,"uiDashboardShouldCheckHeight",this.fixDashboard),this.on(window,"resize",utils.debounce(this.setWindowHeightAndFixDashboard.bind(this),100)),this.on(window,"scroll",utils.debounce(this.fixDashboard.bind(this),15)))})}var defineComponent=require("core/component"),utils=require("core/utils"),clock=require("core/clock");module.exports=defineComponent(dashboard)
});
define("app/ui/dialogs/delete_tweet_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/dialogs/with_modal_tweet"],function(module, require, exports) {
function deleteTweetDialog(){this.defaultAttrs({cancelSelector:".cancel-action",deleteSelector:".delete-action"}),this.openDeleteTweet=function(a,b){var c=$(a.target).clone();this.attr.sourceEventData=b,this.displayTweet(b.tweetId,c,{modal:"delete"}),this.id=b.id,this.open()},this.deleteTweet=function(){this.trigger("uiDidDeleteTweet",{id:this.id,sourceEventData:this.attr.sourceEventData})},this.deleteTweetSuccess=function(a,b){this.trigger("uiDidDeleteTweetSuccess",this.attr.sourceEventData),this.close()},this.restoreFocusToTweet=function(a){$(a.target).is(this.$dialog)&&this.activeEl&&this.trigger($(this.activeEl).closest(".tweet"),"uiShouldAddFocusStyle")},this.after("initialize",function(){this.on("click",{cancelSelector:this.close,deleteSelector:this.deleteTweet}),this.on(document,"uiOpenDeleteDialog",this.openDeleteTweet),this.on(document,"dataDidDeleteTweet",this.deleteTweetSuccess),this.on(document,"uiDialogRestorePreviousFocus",this.restoreFocusToTweet),this.on(document,"uiCloseDeleteTweetDialog",this.close)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withModalTweet=require("app/ui/dialogs/with_modal_tweet"),DeleteTweetDialog=defineComponent(deleteTweetDialog,withDialog,withModalTweet);module.exports=DeleteTweetDialog
});
define("app/data/sms/device_verification",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function deviceVerification(){this.submitDeviceDownload=function(a,b){this.post({url:"/i/devices/download",data:{country_code:b.countryCode,phone_number:b.deviceNumber},success:"dataDidSubmitDownloadLinkRequest",error:"dataFailedToSubmitDownloadLinkRequest"})},this.resendDeviceDownload=function(a,b){this.post({url:"/i/devices/download",data:{device_id:b.deviceId,resend:!0},success:"dataDidResendDownloadLinkRequest",error:"dataFailedToResendDownloadLinkRequest"})},this.submitDeviceVerification=function(a,b){var c=function(a){a.success?this.trigger("dataDidVerifyDevice",a):this.trigger("dataFailedToVerifyDevice",a)};this.post({url:"/i/devices/verify",data:{device_id:b.deviceId,pin:b.pin},success:c.bind(this),error:"dataFailedToVerifyDevice"})},this.after("initialize",function(){this.on(document,"uiDidSubmitDownloadLinkRequest",this.submitDeviceDownload),this.on(document,"uiDidResendDownloadLinkRequest",this.resendDeviceDownload),this.on(document,"uiDidSubmitDeviceVerification",this.submitDeviceVerification)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),DeviceVerification=defineComponent(deviceVerification,withData);module.exports=DeviceVerification
});
define("app/ui/sms/with_sms_country_selector",["module","require","exports"],function(module, require, exports) {
function withSmsCountrySelector(){this.defaultAttrs({smsCountryCodeSelector:"#sms-country-code",smsCountryCodePreviewSelector:"#sms-country-code-preview"}),this.updateSmsCountryCode=function(){this.$smsCountryCodePreview.text("+"+this.$smsCountryCode.val())},this.after("initialize",function(){this.$smsCountryCode=this.select("smsCountryCodeSelector"),this.$smsCountryCodePreview=this.select("smsCountryCodePreviewSelector"),this.on(this.$smsCountryCode,"change",this.updateSmsCountryCode)})}module.exports=withSmsCountrySelector
});
define("app/ui/with_loading_indicator",["module","require","exports"],function(module, require, exports) {
function withLoadingIndicator(){this.defaultAttrs({spinnerContainer:"body",spinnerClass:"pushing-state"}),this.showSpinner=function(a,b){this.select("spinnerContainer").addClass(this.attr.spinnerClass)},this.hideSpinner=function(a,b){this.select("spinnerContainer").removeClass(this.attr.spinnerClass)}}module.exports=withLoadingIndicator
});
define("app/ui/sms/device_verification_banner",["module","require","exports","core/component","core/i18n","app/ui/sms/with_sms_country_selector","app/ui/with_loading_indicator"],function(module, require, exports) {
function deviceVerificationBanner(){var a=_('\u7aef\u672b\u304c\u8a8d\u8a3c\u3055\u308c\u307e\u3057\u305f\u3002'),b=_('\u5165\u529b\u3055\u308c\u305fPIN\u306f\u6709\u52b9\u3067\u306f\u3042\u308a\u307e\u305b\u3093\u3002\u3082\u3046\u4e00\u5ea6\u5165\u529b\u3057\u3066\u304f\u3060\u3055\u3044\u3002'),c=_('\u3054\u5229\u7528\u306e\u7aef\u672b\u306b\u65b0\u3057\u3044PIN\u3092\u9001\u4fe1\u3057\u307e\u3057\u305f\u3002'),d=_('PIN\u306e\u518d\u9001\u4fe1\u4e2d\u306b\u30a8\u30e9\u30fc\u304c\u767a\u751f\u3057\u307e\u3057\u305f\u3002');this.defaultAttrs({bannerSelector:"#device-verification-banner",idSelector:"#device-verification-id",pinSelector:"#device-verification-pin",submitSelector:"#device-verification-submit",resendSelector:"#device-verification-resend",formElementsSelector:"#device-verification-pin, #device-verification-submit",replaceBannerHTML:!1}),this.deviceId=function(){return this.select("idSelector").val()},this.pin=function(){return this.select("pinSelector").val()},this.dataStart=function(){this.select("formElementsSelector").attr("disabled",!0),this.trigger("uiShowGlobalLoadingIndicator")},this.dataEnd=function(){this.select("formElementsSelector").attr("disabled",!1),this.trigger("uiHideGlobalLoadingIndicator")},this.showVerificationBanner=function(a,b){this.attr.replaceBannerHTML?this.$node.html(b.banner_html):this.$node.prepend($(b.banner_html))},this.updateSubmit=function(a,b){this.select("submitSelector").attr("disabled",this.select("pinSelector").val()=="")},this.submitVerification=function(){this.dataStart(),this.trigger("uiDidSubmitDeviceVerification",{deviceId:this.deviceId(),pin:this.pin()})},this.deviceVerificationSuccess=function(b,c){this.dataEnd(),this.trigger("uiShowMessage",{message:a}),this.select("bannerSelector").hide()},this.deviceVerificationFailure=function(a,c){this.dataEnd(),this.trigger("uiShowMessage",{message:b})},this.resendVerification=function(){this.dataStart(),this.trigger("uiDidResendDownloadLinkRequest",{deviceId:this.deviceId()})},this.resendSuccess=function(){this.dataEnd(),this.trigger("uiShowMessage",{message:c})},this.resendFailure=function(){this.dataEnd(),this.trigger("uiShowMessage",{message:d})},this.after("initialize",function(){this.on(document,"dataDidSubmitDownloadLinkRequest",this.showVerificationBanner),this.on(document,"dataDidVerifyDevice",this.deviceVerificationSuccess),this.on(document,"dataFailedToVerifyDevice",this.deviceVerificationFailure),this.on(document,"dataDidResendDownloadLinkRequest",this.resendSuccess),this.on(document,"dataFailedToResendDownloadLinkRequest",this.resendFailure),this.on("click",{submitSelector:this.submitVerification,resendSelector:this.resendVerification}),this.on("keyup",{pinSelector:this.updateSubmit})})}var defineComponent=require("core/component"),_=require("core/i18n"),withSmsCountrySelector=require("app/ui/sms/with_sms_country_selector"),withLoadingIndicator=require("app/ui/with_loading_indicator"),DeviceVerificationBanner=defineComponent(deviceVerificationBanner);module.exports=DeviceVerificationBanner
});
define("app/utils/string",["module","require","exports"],function(module, require, exports) {
function isWhitespaceChar(a){var b=a.charCodeAt(0);return b<=32?!0:!1}function subtractOne(a,b){if(a=="")return"";var c=a.split(""),d=c.pop();return a=c.join(""),d=="0"?subtractOne(a,!0)+"9":(d-=1,a==""&&d==0?b?"":"0":a+d)}function isDigitChar(a){var b=a.charCodeAt(0);return b>=48&&b<=57?!0:!1}function compareRight(a,b){var c=0,d=0,e=0,f,g;for(;;d++,e++){f=a.charAt(d),g=b.charAt(e);if(!isDigitChar(f)&&!isDigitChar(g))return c;if(!isDigitChar(f))return-1;if(!isDigitChar(g))return 1;f<g?c===0&&(c=-1):f>g&&c===0&&(c=1)}}var utils={compare:function(a,b){var c=0,d=0,e,f,g,h,i;if(a===b)return 0;typeof a=="number"&&(a=a.toString()),typeof b=="number"&&(b=b.toString());for(;;){if(c>100)return;e=f=0,g=a.charAt(c),h=b.charAt(d);while(isWhitespaceChar(g)||g=="0")g=="0"?e++:e=0,g=a.charAt(++c);while(isWhitespaceChar(h)||h=="0")h=="0"?f++:f=0,h=b.charAt(++d);if(isDigitChar(g)&&isDigitChar(h)&&(i=compareRight(a.substring(c),b.substring(d)))!=0)return i;if(g==0&&h==0)return e-f;if(g<h)return-1;if(g>h)return 1;++c,++d}},wordAtPosition:function(a,b,c,d){c=c||/[^\s]+/g,d=d||0;var e=null;return a.replace(c,function(){var a=arguments[d],c=arguments[arguments.length-2];c<=b&&c+a.length>=b&&(e=a)}),e},parseBigInt:function(a){return isNaN(Number(a))?NaN:a.toString()},subtractOne:subtractOne};module.exports=utils
});
define("app/data/direct_messages",["module","require","exports","core/component","core/i18n","app/data/with_data","app/data/with_auth_token","app/utils/storage/core","app/utils/string"],function(module, require, exports) {
function directMessages(){var a=0,b;this.IFRAME_TIMEOUT=12e4,this.defaultAttrs({noShowError:!0}),this.pollConversationList=function(a,b){this.requestConversationList(null,{since_id:this.lastMessageId})},this.requestConversationList=function(a,b){this.get({url:"/messages",data:b,eventData:b,success:"dataDMConversationListResult",error:"dataDMError"})},this.requestConversation=function(a,b){this.get({url:"/messages/with/conversation",data:{id:b.conversation_id||b.screen_name},eventData:b,success:b.msgAction?"dataDM"+b.msgAction+"Success":"dataDMConversationResult",error:"dataDMError"})},this.submitDMForm=function(a){b=b||a.attr("action"),a.find(".auth-token").val(this.getAuthToken()),a.find(".file-data").attr("value")&&a.removeAttr("encType"),a.attr("action",b+"?origin="+encodeURIComponent(location.origin)),a.submit()},this.isValidUpload=function(a){var c=a.msgEvent,d=c,e=a.tweetBoxData;c.originalEvent&&(c=c.originalEvent);var f=c.origin&&b.indexOf(c.origin.replace(/^https?:/,""))===0;if(!f)return!1;try{d=JSON.parse(c.data)}catch(g){}return this.uploadTimedOut||clearTimeout(a.tweetTimeout),d.tweetboxId=e.tweetboxId,d.media_id_string?this.trigger("dataDMMediaUploadSuccess",$.extend(e,{media_id:d.media_id_string})):this.trigger("dataDMError",d),!0},this.uploadMedia=function(a,b){this.uploadTimedOut=!1;var c=setTimeout(function(){this.uploadTimedOut=!0,this.off(window,"message",d),this.trigger("dataDMError",{error:_('\u5199\u771f\u306e\u30a2\u30c3\u30d7\u30ed\u30fc\u30c9\u304c\u30bf\u30a4\u30e0\u30a2\u30a6\u30c8\u306b\u306a\u308a\u307e\u3057\u305f\u3002'),tweetboxId:b.tweetboxId})}.bind(this),this.IFRAME_TIMEOUT),d=function(a){var e=this.isValidUpload({msgEvent:a,tweetTimeout:c,tweetBoxData:b});e&&this.off(window,"message",d)}.bind(this);this.on(window,"message",d),this.submitDMForm($("#"+b.tweetboxId))},this.sendMessage=function(a,b){var c=function(c){c&&c.retry&&a.type!="dataDMDialogSendMessageRetry"?setTimeout(function(){this.trigger("dataDMDialogSendMessageRetry",b)}.bind(this),c.delay):this.trigger("dataDMSendSuccess",c)},d=this.attr.swift_dm_create?"/i":"";this.post({url:d+"/direct_messages/new",data:b,eventData:b,success:c.bind(this),error:"dataDMError"})},this.deleteMessage=function(a,b){var c=this.attr.swift_dm_delete?"/i":"";this.post({url:c+"/direct_messages/destroy",data:b,eventData:b,success:"dataDMDeleteSuccess",error:"dataDMError"})},this.reportDM=function(a,b){var c=function(a){a.text!="success"?this.trigger("dataDMError",a):this.trigger("uiDMDialogDeleteMessage",b)};this.post({url:"/i/direct_messages/report",data:b,eventData:b,success:c.bind(this),error:"dataDMError"})},this.triggerUnreadCount=function(b,c){a=c.msgCount,a>0?this.trigger("dataUserHasUnreadDMsWithCount",{msgCount:a}):this.trigger("dataUserHasNoUnreadDMsWithCount")},this.dispatchUnreadNotification=function(a,b){if(!b||!b.d)return;var c=b.d;c.status==="ok"&&c.response!=null&&this.triggerUnreadCount(null,{msgCount:c.response})},this.markDMsAsRead=function(a,b){if(!b.last_message_id)throw new Error("Require last_message_id to mark a DM as read");var c={last_message_id:b.last_message_id};b.recipient_id&&(c.recipient_id=b.recipient_id),b.recipient_name&&(c.recipient_name=b.recipient_name),b.retry===undefined&&(b.retry=!0);var d,e;b.from_notification?(c.get_count=!0,d=function(a){"msgCount"in a&&this.trigger("uiReadStateChanged",a)},e=$.noop):(d=function(a){a.text!="success"?e.call(this,a):(a.lastMessageId=b.last_message_id,this.trigger("dataDMReadSuccess",a))},e=function(a){b.retry?(b.retry=!1,this.trigger("dataMarkDMsAsRead",b)):this.trigger("dataDMReadError",a)}),this.post({url:"/i/messages/mark_read",data:c,eventData:b,success:d.bind(this),error:e.bind(this)})},this.checkForEnvelope=function(b,c){c&&c.section=="profile"&&this.triggerUnreadCount(null,{msgCount:a})},this.possiblyOpenDMDialog=function(a,b){var c=this.attr.dm_options;if(c&&c.show_dm_dialog){var d=c.recipient,e=c.recipient_id,f=c.recipient_name;$(document).trigger("uiNeedsDMDialog",{id:e,screen_name:d,name:f,fromInitData:!0})}},this.after("initialize",function(){this.on("uiNeedsDMConversationList",this.requestConversationList),this.on("uiNeedsDMConversation",this.requestConversation),this.on("uiDMDialogSendMessage dataDMDialogSendMessageRetry",this.sendMessage),this.on("uiSendDMWithMedia",this.uploadMedia),this.on("uiDMDialogDeleteMessage",this.deleteMessage),this.on("uiDMDialogReportDM",this.reportDM),this.on("dataRefreshDMs",this.pollConversationList),this.on("dataMarkDMsAsRead",this.markDMsAsRead),this.on("uiPageChanged",this.checkForEnvelope),this.on("uiSwiftLoaded",this.possiblyOpenDMDialog),this.on("dataNotificationsReceived",this.dispatchUnreadNotification),this.on("uiReadStateChanged",this.triggerUnreadCount),this.lastMessageId=$("#dm_dialog_conversation_list li.dm-thread").first().attr("data-last-message-id")||0,this.storage=new Storage("DM")})}var defineComponent=require("core/component"),_=require("core/i18n"),withData=require("app/data/with_data"),withAuthToken=require("app/data/with_auth_token"),Storage=require("app/utils/storage/core"),StringUtils=require("app/utils/string"),DirectMessages=defineComponent(directMessages,withData,withAuthToken);module.exports=DirectMessages
});
define("app/data/direct_messages_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function directMessagesScribe(){this.after("initialize",function(){this.scribeOnEvent("uiDMDialogOpenedNewConversation","open"),this.scribeOnEvent("uiDMDialogOpenedConversation","open"),this.scribeOnEvent("uiDMDialogOpenedConversationList","open"),this.scribeOnEvent("uiDMDialogSendMessage","send_dm"),this.scribeOnEvent("uiDMDialogDeleteMessage","delete_dm"),this.scribeOnEvent("uiDMDialogMarkSpam","report_as_spam"),this.scribeOnEvent("uiDMDialogMarkMessage",{element:"mark_all_as_read",action:"click"}),this.scribeOnEvent("uiDMMediaLoaded","media_preview"),this.scribeOnEvent("uiDMMediaFailed","media_preview")})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),DirectMessagesScribe=defineComponent(directMessagesScribe,withScribe);module.exports=DirectMessagesScribe
});
define("app/utils/user_dom_data",["module","require","exports"],function(module, require, exports) {
var userDomData={getId:function(a){return a.attr("data-user-id")},getName:function(a){return a.data("name")},getScreenName:function(a){return a.data("screen-name")}};module.exports=userDomData
});
define("app/ui/direct_message_link_handler",["module","require","exports","core/component","app/utils/user_dom_data"],function(module, require, exports) {
function directMessageLinkHandler(){this.defaultAttrs({dmLinkSelector:".js-dm-dialog, .dm-button, .global-dm-nav"}),this.openDialog=function(a,b){a.preventDefault();var c=$(b.el);b={id:userDomDataUtil.getId(c),screen_name:userDomDataUtil.getScreenName(c),name:userDomDataUtil.getName(c)},this.trigger("uiNeedsDMDialog",b)},this.after("initialize",function(){this.on(document,"click",{dmLinkSelector:this.openDialog})})}var defineComponent=require("core/component"),userDomDataUtil=require("app/utils/user_dom_data");module.exports=defineComponent(directMessageLinkHandler)
});
define("app/ui/typeahead/accounts_renderer",["module","require","exports","core/i18n","core/component"],function(module, require, exports) {
function accountsRenderer(){this.defaultAttrs({accountsListSelector:".js-typeahead-accounts",accountsItemSelector:".typeahead-account-item",accountsShortcutSelector:".typeahead-accounts-shortcut",accountsShortcutShow:!1,datasources:["accounts"],socialContextMapping:{FOLLOWING:1,FOLLOWS:8}}),this.renderAccounts=function(a,b){this.$accountsList.find(this.attr.accountsItemSelector).remove();var c=[];this.attr.datasources.forEach(function(a){c=c.concat(b.suggestions[a]||[])});if(!c.length){this.clearAccounts();return}this.updateShortcut(b.queryData.query),c.forEach(function(a){var b=this.$accountItemTemplate.clone(!1);b.attr("data-user-id",a.id),b.attr("data-user-screenname",a.screen_name),b.data("item",a);var c=b.find("a");c.attr("href","/"+a.screen_name),c.attr("data-search-query",a.id),c.find(".avatar").attr("src",this.getAvatar(a)),c.find(".fullname").text(a.name),c.find(".username b").text(a.screen_name),a.verified&&c.find(".js-verified").removeClass("hidden");if(this.attr.deciders.showDebugInfo){var d=a.prefetched;c.attr("title",(d?"local":"remote")+" user, score: "+a.rounded_score)}if(a.social_proof!==0&&this.attr.deciders.showSocialContext){var e=c.find(".typeahead-social-context"),f=this.getSocialContext(a);f&&(e.text(f),c.addClass("has-social-context"))}b.insertBefore(this.$accountsShortcut)},this),this.$accountsList.addClass("has-results"),this.$accountsList.show()},this.getAvatar=function(a){var b=a.profile_image_url_https,c=this.attr.deciders.showSocialContext;return b&&(b=b.replace(/^https?:/,""),b=c?b:b.replace(/_normal(\..*)?$/i,"_mini$1")),b},this.isMutualFollow=function(a){return this.currentUserFollowsAccount(a)&&this.accountFollowsCurrentUser(a)},this.currentUserFollowsAccount=function(a){var b=this.attr.socialContextMapping.FOLLOWING;return!!(a&b)},this.accountFollowsCurrentUser=function(a){var b=this.attr.socialContextMapping.FOLLOWS;return!!(a&b)},this.getSocialContext=function(a){var b=a.social_proof;return this.isMutualFollow(b)?_('\u76f8\u4e92\u30d5\u30a9\u30ed\u30fc\u4e2d'):this.currentUserFollowsAccount(b)?_('\u30d5\u30a9\u30ed\u30fc'):this.accountFollowsCurrentUser(b)?_('\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059'):a.first_connecting_user_name?a.connecting_user_count>1?_('{{user}}\u3055\u3093\u3068\u4ed6{{number}}\u4eba\u306b\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059',{user:a.first_connecting_user_name,number:a.connecting_user_count}):_('{{user}}\u3055\u3093\u304b\u3089\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059',{user:a.first_connecting_user_name}):!1},this.updateShortcut=function(a){this.$accountsShortcut.toggle(this.attr.accountsShortcutShow);var b=this.$accountsShortcut.find("a");b.attr("href","/search/users?q="+encodeURIComponent(a)),b.attr("data-search-query",a),a=$("<div/>").text(a).html(),b.html(_('<strong>{{query}}</strong>\u3066\u3099\u3059\u3078\u3099\u3066\u306e\u30e6\u30fc\u30b5\u3099\u30fc\u3092\u691c\u7d22',{query:a}))},this.clearAccounts=function(){this.$accountsList.removeClass("has-results"),this.$accountsList.hide()},this.after("initialize",function(){this.$accountsList=this.select("accountsListSelector").first(),this.$accountsShortcut=this.select("accountsShortcutSelector").first(),this.$accountItemTemplate=this.select("accountsItemSelector").first().clone(!1),this.$accountsList.hide(),this.on("uiTypeaheadRenderResults",this.renderAccounts)})}var _=require("core/i18n"),defineComponent=require("core/component");module.exports=defineComponent(accountsRenderer)
});
define("app/ui/typeahead/saved_searches_renderer",["module","require","exports","core/component"],function(module, require, exports) {
function savedSearchesRenderer(){this.defaultAttrs({savedSearchesListSelector:".saved-searches-list",savedSearchesSelector:".saved-searches-list",savedSearchesItemSelector:".typeahead-saved-search-item",savedSearchesItemAnchorSelector:"a.js-nav",savedSearchesTitleSelector:".saved-searches-title",savedSearchesBlockSelector:".typeahead-saved-searches",savedSearchesRemoveSelector:".typeahead-saved-search-item .close",datasources:["savedSearches"]}),this.renderSavedSearches=function(a,b){this.$savedSearchesList.empty();var c=[];this.attr.datasources.forEach(function(a){c=c.concat(b.suggestions[a]||[])});if(c.length===0){this.$savedSearchesTitle.hide(),this.$savedSearchesBlock.removeClass("has-items");return}var d=b.queryData.query==="",e=this.$savedSearchesTitle.attr("id");c.reverse(),c.forEach(function(a){var b=this.$savedSearchItemTemplate.clone(!1);b.data("item",a);var c=b.find("a");c.attr("href",a.saved_search_path),c.attr("data-search-query",a.query),c.attr("data-query-source",a.search_query_source),c.attr("data-saved-search-id",a.id),c.append($("<span>").text(a.name)),d&&c.attr("aria-describedby",e),this.$savedSearchesList.append(b)},this),this.$savedSearchesTitle.toggle(d),this.$savedSearchesBlock.addClass("has-items")},this.removeSavedSearch=function(a,b){var c=$(a.target).closest(this.attr.savedSearchesItemSelector),d=c.find(this.attr.savedSearchesItemAnchorSelector),e=d.data("saved-search-id");c.siblings().length==0&&(this.$savedSearchesTitle.hide(),this.$savedSearchesBlock.removeClass("has-items")),c.remove(),this.trigger("uiRemoveSavedSearch",{id:e,component:"top_bar_searchbox"})},this.after("initialize",function(){this.$savedSearchItemTemplate=this.select("savedSearchesItemSelector").clone(!1),this.$savedSearchesList=this.select("savedSearchesSelector"),this.$savedSearchesTitle=this.select("savedSearchesTitleSelector"),this.$savedSearchesBlock=this.select("savedSearchesBlockSelector"),this.on("uiTypeaheadRenderResults",this.renderSavedSearches),this.on("click",{savedSearchesRemoveSelector:this.removeSavedSearch})})}var defineComponent=require("core/component");module.exports=defineComponent(savedSearchesRenderer)
});
define("app/ui/typeahead/recent_searches_renderer",["module","require","exports","core/component"],function(module, require, exports) {
function recentSearchesRenderer(){this.defaultAttrs({recentSearchesSelector:".recent-searches-list",recentSearchesItemSelector:".typeahead-recent-search-item",recentSearchesDismissSelector:".typeahead-recent-search-item .close",recentSearchesBlockSelector:".typeahead-recent-searches",recentSearchesTitleSelector:".recent-searches-title",recentSearchesClearAllSelector:".clear-recent-searches",datasources:["recentSearches"]}),this.deleteRecentSearch=function(a,b){var c=$(a.target).closest(this.attr.recentSearchesItemSelector),d=c.find("a.js-nav"),e=d.data("search-query");this.$recentSearchesList.children().length==1&&(this.$recentSearchesTitle.hide(),this.$recentSearchesBlock.removeClass("has-results"),this.$recentSearchesBlock.removeClass("has-items"),this.$recentSearchesClearAll.hide()),c.remove(),this.trigger("uiTypeaheadDeleteRecentSearch",{query:e})},this.deleteAllRecentSearches=function(a,b){this.$recentSearchesList.empty(),this.$recentSearchesTitle.hide(),this.$recentSearchesBlock.removeClass("has-results"),this.$recentSearchesBlock.removeClass("has-items"),this.$recentSearchesClearAll.hide(),this.trigger("uiTypeaheadDeleteRecentSearch",{deleteAll:!0})},this.renderRecentSearches=function(a,b){this.$recentSearchesList.empty();var c=this.attr.datasources.map(function(a){return b.suggestions[a]||[]}).reduce(function(a,b){return a.concat(b)});c.forEach(function(a){var b=this.$recentSearchItemTemplate.clone(!1);b.data("item",a);var c=b.find("a");c.attr("href",a.recent_search_path),c.attr("data-search-query",a.name),c.attr("data-query-source",a.search_query_source),c.append($("<span>").text(a.name)),this.$recentSearchesList.append(b)},this);var d=c.length!==0,e=b.queryData.query==="",f=e&&d;this.$recentSearchesBlock.toggleClass("has-results",!e&&d),this.$recentSearchesBlock.toggleClass("has-items",d),this.$recentSearchesTitle.toggle(f),this.$recentSearchesClearAll.toggle(f)},this.after("initialize",function(){this.$recentSearchItemTemplate=this.select("recentSearchesItemSelector").clone(!1),this.$recentSearchesList=this.select("recentSearchesSelector"),this.$recentSearchesBlock=this.select("recentSearchesBlockSelector"),this.$recentSearchesTitle=this.select("recentSearchesTitleSelector"),this.$recentSearchesClearAll=this.select("recentSearchesClearAllSelector"),this.on("click",{recentSearchesDismissSelector:this.deleteRecentSearch,recentSearchesClearAllSelector:this.deleteAllRecentSearches}),this.on("uiTypeaheadRenderResults",this.renderRecentSearches),this.on("uiTypeaheadDeleteAllRecentSearches",this.deleteAllRecentSearches)})}var defineComponent=require("core/component");module.exports=defineComponent(recentSearchesRenderer)
});
define("app/ui/typeahead/topics_renderer",["module","require","exports","core/i18n","core/component"],function(module, require, exports) {
function topicsRenderer(){this.defaultAttrs({includeSearchGlass:!0,parseHashtags:!1,topicsListSelector:".topics-list",topicsItemSelector:".typeahead-topic-item",datasources:["topics"],emptySocialContextClass:"empty-topics-social-context"}),this.isHashOrCashtag=function(a){return a==="#"||a==="$"},this.renderTopics=function(a,b){this.$topicsList.empty();var c=[],d=b.queryData&&b.queryData.query;this.attr.datasources.forEach(function(a){c=c.concat(b.suggestions[a]||[])});if(!c.length){this.clearTopics();return}c.forEach(function(a){var b=this.$topicsItemTemplate.clone(!1);b.data("item",a);var c=b.find("a"),e=a.topic||a.hashtag;c.attr("href",a.searchPath),c.attr("data-search-query",e);var f=e.charAt(0),g=this.attr.parseHashtags&&this.isHashOrCashtag(f),h=a.location&&this.attr.deciders.showTypeaheadTopicSocialContext;if(g){var i=$("<span>").text(f);i.append($("<strong>").text(e.slice(1))),c.append(i)}else if(h){var j=c.find(".typeahead-social-context");j.text(this.getSocialContext(a)),j.show(),c.children().last().before($("<span>").text(e))}else if(d&&this.attr.deciders.reverseBoldingEnabled){var k=this.isHashOrCashtag(d.charAt(0)),l=this.isHashOrCashtag(e.charAt(0)),m=!k&&l?1:0,i=$("<span>").text(e.substr(0,d.length+m));i.append($("<strong>").text(e.slice(d.length+m))),c.append(i)}else a.name?c.html(a.name):c.append($("<span>").text(e)),this.attr.deciders.showTypeaheadTopicSocialContext&&c.addClass(this.attr.emptySocialContextClass);b.appendTo(this.$topicsList)},this),this.$topicsList.addClass("has-results"),this.$topicsList.show()},this.getSocialContext=function(a){return _('{{location}}\u306e\u30c8\u30ec\u30f3\u30c9',{location:a.location})},this.clearTopics=function(a){this.$topicsList.removeClass("has-results"),this.$topicsList.hide()},this.after("initialize",function(){this.$topicsItemTemplate=this.select("topicsItemSelector").clone(!1),this.attr.includeSearchGlass||this.$topicsItemTemplate.find(".icon.generic-search").remove(),this.$topicsList=this.select("topicsListSelector"),this.$topicsList.hide(),this.on("uiTypeaheadRenderResults",this.renderTopics)})}var _=require("core/i18n"),defineComponent=require("core/component");module.exports=defineComponent(topicsRenderer)
});
define("app/ui/typeahead/trend_locations_renderer",["module","require","exports","core/component","core/i18n"],function(module, require, exports) {
function trendLocationsRenderer(){this.defaultAttrs({typeaheadItemClass:"typeahead-item",trendLocationsListSelector:".typeahead-trend-locations-list",trendLocationsItemSelector:".typeahead-trend-locations-item",datasources:["trendLocations"]}),this.renderTrendLocations=function(a,b){this.$trendLocationsList.empty();var c=[];this.attr.datasources.forEach(function(a){c=c.concat(b.suggestions[a]||[])}),c.forEach(function(a){var b=this.$trendLocationItemTemplate.clone(!1),c=b.find("a");b.data("item",a),c.attr("data-search-query",a.name),c.attr("href","#"),c.append(this.getLocationHtml(a)),a.woeid==-1&&(b.removeClass(this.attr.typeaheadItemClass),c.attr("data-search-query","")),b.appendTo(this.$trendLocationsList)},this)},this.getLocationHtml=function(a){var b=$("<span>");switch(a.placeTypeCode){case placeTypeMapping.WORLDWIDE:case placeTypeMapping.NOT_FOUND:b.text(a.name);break;case placeTypeMapping.COUNTRY:b.html(a.name+"  "+_('(\u3059\u3079\u3066\u306e\u90fd\u5e02)'));break;default:b.text([a.name,a.countryName].join(", "))}return b},this.after("initialize",function(){this.$trendLocationItemTemplate=this.select("trendLocationsItemSelector").clone(!1),this.$trendLocationsList=this.select("trendLocationsListSelector"),this.on("uiTypeaheadRenderResults",this.renderTrendLocations)})}var defineComponent=require("core/component"),_=require("core/i18n");module.exports=defineComponent(trendLocationsRenderer);var placeTypeMapping={WORLDWIDE:19,COUNTRY:12,CITY:7,NOT_FOUND:-1}
});
define("app/ui/typeahead/concierge_renderer",["module","require","exports","core/component"],function(module, require, exports) {
function conciergeRenderer(){this.defaultAttrs({conciergeBlockSelector:".typeahead-concierge",conciergeListSelector:".typeahead-concierge-list",conciergeItemSelector:".typeahead-concierge-item",datasource:"concierge"}),this.renderConcierge=function(a,b){this.$conciergeList.empty();var c=b.suggestions&&b.suggestions[this.attr.datasource]||[],d=!!c.length;c.forEach(function(a){var b=this.$conciergeItemTemplate.clone(!1),c=b.find("a");b.data("item",a),c.attr("href",a.searchPath),c.attr("data-search-query",a.topic),c.attr("data-query-source",a.querySource),c.append($("<span>").text(a.name)),this.$conciergeList.append(b)},this),this.$conciergeBlock.toggleClass("has-items",d),this.$conciergeBlock.toggle(d)},this.after("initialize",function(){this.$conciergeItemTemplate=this.select("conciergeItemSelector").clone(!1),this.$conciergeBlock=this.select("conciergeBlockSelector"),this.$conciergeList=this.select("conciergeListSelector"),this.on("uiTypeaheadRenderResults",this.renderConcierge)})}var defineComponent=require("core/component");module.exports=defineComponent(conciergeRenderer)
});
define("app/ui/typeahead/selected_users_renderer",["module","require","exports","core/i18n","core/component"],function(module, require, exports) {
function mediaTaggingRenderer(){function a(a,b){if(!b)return!1;for(var c=0;c<b.length;c++)if(a.id==b[c].id)return!0;return!1}this.defaultAttrs({rootSelector:".typeahead-user-select",accountsListSelector:".js-typeahead-accounts",accountsItemSelector:".typeahead-account-item",selectedItemSelector:".typeahead-selected-item",accountsEndPlaceholderSelector:".typeahead-accounts-end",selectedEndPlaceholderSelector:".typeahead-selected-end",emptyTextSelector:".typeahead-empty-suggestions",selectedListSelector:".js-typeahead-selected",mediaTaggingSelector:".tagging-dropdown",datasources:["accounts","selectedUsers"],socialContextMapping:{FOLLOWING:1,FOLLOWS:8}}),this.renderAccounts=function(a,b){this.$accountsList.find(this.attr.accountsItemSelector).remove(),this.$selectedList.find(this.attr.selectedItemSelector).remove();var c=b.suggestions.selectedUsers||[],d;b.queryData?d=b.queryData.query||"":d="";var e=[];this.attr.datasources.forEach(function(a){if(a=="accounts"||a=="mediaTagAccounts"||a=="prefillUsers"&&d.length==0&&c.length==0)e=e.concat(b.suggestions[a]||[])}),e&&e.length>0?(e.forEach(function(a){var b=this.$accountItemTemplate.clone(!1);this.addUser(b,this.$accountsEnd,a,c)},this),this.$accountsList.addClass("has-results"),this.$accountsList.show()):this.clearAccounts();var f=e&&e.length>0,g=d.length>0,h=c&&c.length>0;!f&&!g&&h?(c.forEach(function(a){var b=this.$selectedItemTemplate.clone(!1);this.addUser(b,this.$selectedEnd,a,c)},this),this.$selectedList.addClass("has-results"),this.$selectedList.show()):this.clearSelected();var i=this.select("emptyTextSelector").first(),j=b.suggestions.prefillUsers&&e.length-b.suggestions.prefillUsers.length==0;j&&c.length==0&&e.length>0?i.show():i.hide(),a.stopPropagation()},this.addUser=function(b,c,d,e){b.attr("data-user-id",d.id),b.attr("data-user-screenname",d.screen_name),b.data("item",d);var f=b.find("a");f.attr("href","/"+d.screen_name),f.attr("data-search-query",d.id),f.find(".avatar").attr("src",this.getAvatar(d)),f.find(".fullname").text(d.name),f.find(".username b").text(d.screen_name),d.verified&&f.find(".js-verified").removeClass("hidden"),a(d,e)?(b.addClass("selected-user"),f.attr("aria-selected","true")):f.attr("aria-selected","false");var g=this.$node.hasClass("photo-tagging-container");g&&d.can_media_tag===!1&&b.addClass("cannot-select");if(this.attr.deciders.showDebugInfo){var h=d.prefetched;f.attr("title",(h?"local":"remote")+" user, score: "+d.rounded_score)}if(d.social_proof!==0&&this.attr.deciders.showSocialContext){var i=f.find(".typeahead-social-context"),j=this.getSocialContext(d);j&&(i.text(j),f.addClass("has-social-context"))}b.insertBefore(c)},this.getAvatar=function(a){var b=a.profile_image_url_https,c=this.attr.deciders.showSocialContext;return b&&(b=b.replace(/^https?:/,""),b=c?b:b.replace(/_normal(\..*)?$/i,"_mini$1")),b},this.isMutualFollow=function(a){return this.currentUserFollowsAccount(a)&&this.accountFollowsCurrentUser(a)},this.currentUserFollowsAccount=function(a){var b=this.attr.socialContextMapping.FOLLOWING;return!!(a&b)},this.accountFollowsCurrentUser=function(a){var b=this.attr.socialContextMapping.FOLLOWS;return!!(a&b)},this.getSocialContext=function(a){var b=a.social_proof;return this.isMutualFollow(b)?_('\u76f8\u4e92\u30d5\u30a9\u30ed\u30fc\u4e2d'):this.currentUserFollowsAccount(b)?_('\u30d5\u30a9\u30ed\u30fc'):this.accountFollowsCurrentUser(b)?_('\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059'):a.first_connecting_user_name?a.connecting_user_count>1?_('{{user}}\u3055\u3093\u3068\u4ed6{{number}}\u4eba\u306b\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059',{user:a.first_connecting_user_name,number:a.connecting_user_count}):_('{{user}}\u3055\u3093\u304b\u3089\u30d5\u30a9\u30ed\u30fc\u3055\u308c\u3066\u3044\u307e\u3059',{user:a.first_connecting_user_name}):!1},this.clearAccounts=function(){this.$accountsList.removeClass("has-results"),this.$accountsList.hide()},this.clearSelected=function(){this.$selectedList.removeClass("has-results"),this.$selectedList.hide()},this.after("initialize",function(){this.$accountsList=this.select("accountsListSelector"),this.$selectedList=this.select("selectedListSelector"),this.$accountsEnd=this.select("accountsEndPlaceholderSelector"),this.$accountItemTemplate=this.select("accountsItemSelector").clone(!1),this.$selectedItemTemplate=this.select("selectedItemSelector").clone(!1),this.$selectedEnd=this.select("selectedEndPlaceholderSelector"),this.$accountsList.hide(),this.on("uiTypeaheadRenderResults",this.renderAccounts)})}var _=require("core/i18n"),defineComponent=require("core/component");module.exports=defineComponent(mediaTaggingRenderer)
});
define("app/utils/rtl_text",["module","require","exports","lib/twitter-text"],function(module, require, exports) {
var TwitterText=require("lib/twitter-text"),RTLText=function(){function q(a){try{return document.activeElement===a}catch(b){return!1}}function r(a){if(!q(a))return 0;var b;if(typeof a.selectionStart=="number")return a.selectionStart;if(document.selection){a.focus(),b=document.selection.createRange(),b.moveStart("character",-a.value.length);var c=b.text.length;return c}}function s(a,b){if(!q(a))return;if(typeof a.selectionStart=="number")a.selectionStart=b,a.selectionEnd=b;else if(document.selection){var c=a.createTextRange();c.collapse(!0),c.moveEnd("character",b),c.moveStart("character",b),c.select()}}function t(a,b,c){var d=0,e="",f=b(a);for(var g=0;g<f.length;g++){var h=f[g],i="";h.screenName&&(i="screenName"),h.hashtag&&(i="hashtag"),h.url&&(i="url"),h.cashtag&&(i="cashtag");var j={entityText:a.slice(h.indices[0],h.indices[1]),entityType:i};e+=a.slice(d,h.indices[0])+c(j),d=h.indices[1]}return e+a.slice(d,a.length)}function u(a){var b=a.match(c),d=a;if(b||l==="rtl")d=t(d,TwitterText.extractEntitiesWithIndices,function(a){if(a.entityType==="screenName")return e+a.entityText+f;if(a.entityType==="hashtag")return a.entityText.charAt(1).match(c)?a.entityText:e+a.entityText;if(a.entityType==="url")return a.entityText+e;if(a.entityType==="cashtag")return e+a.entityText});return d}function v(a){var b,c=a.target?a.target:a.srcElement,e=a.which?a.which:a.keyCode;if(e===g.BACKSPACE)b=-1;else{if(e!==g.DELETE)return;b=0}var f=r(c),h=c.value,i=0,j;do j=h.charAt(f+b)||"",j&&(f+=b,i++,h=h.slice(0,f)+h.slice(f+1,h.length));while(j.match(d));i>1&&(c.value=h,s(c,f),a.preventDefault?a.preventDefault():a.returnValue=!1)}function w(a){return a.replace(d,"")}function x(a){var d=a.match(c);a=a.replace(k,"");var e=0,f=a.replace(m,""),g=l;if(!f||!f.replace(/#/g,""))return g==="rtl"?!0:!1;if(!d)return!1;if(a){var h=TwitterText.extractMentionsWithIndices(a),i=h.length,j;for(j=0;j<i;j++)e+=h[j].screenName.length+1;var n=TwitterText.extractUrlsWithIndices(a),o=n.length;for(j=0;j<o;j++)e+=n[j].url.length+2}var p=f.length-e;return p>0&&d.length/p>b}function y(a){var b=a.target||a.srcElement;a.type!=="keydown"||a.keyCode!==91&&a.keyCode!==16&&a.keyCode!==88&&a.keyCode!==17?a.type==="keyup"&&(a.keyCode===91||a.keyCode===16||a.keyCode===88||a.keyCode===17)&&(o[String(a.keyCode)]=!1):o[String(a.keyCode)]=!0,(!p&&o[91]||p&&o[17])&&o[16]&&o[88]&&(n=!0,b.dir==="rtl"?z("ltr",b):z("rtl",b),o={91:!1,16:!1,88:!1,17:!1})}function z(a,b){b.setAttribute("dir",a),b.style.direction=a,b.style.textAlign=a==="rtl"?"right":"left"}"use strict";var a={},b=.3,c=/[\u0590-\u083F]|[\u08A0-\u08FF]|[\uFB1D-\uFDFF]|[\uFE70-\uFEFF]/gm,d=/\u200e|\u200f/gm,e="‎",f="‏",g={BACKSPACE:8,DELETE:46},h=0,i=20,j=!1,k="",l="",m=/^\s+|\s+$/g,n=!1,o={91:!1,16:!1,88:!1,17:!1},p=navigator.userAgent.indexOf("Mac")===-1;return a.onTextChange=function(b){var c=b||window.event;y(b),c.type==="keydown"&&v(c),a.setText(c.target||c.srcElement)},a.setText=function(a){l||(a.style.direction?l=a.style.direction:a.dir?l=a.dir:document.body.style.direction?l=document.body.style.direction:l=document.body.dir),arguments.length===2&&(l=a.ownerDocument.documentElement.className,k=arguments[1]);var b=a.value;if(!b)return;var c=w(b);j=x(c);var d=u(c),e=j?"rtl":"ltr";d!==b&&(a.value=d,s(a,r(a)+d.length-c.length)),n||z(e,a)},a.textLength=function(a){var b=w(a),c=TwitterText.extractUrls(b),d=b.length-c.join("").length,e=c.length;for(var f=0;f<e;f++)d+=i,/^https:/.test(c[f])&&(d+=1);return h=d},a.cleanText=function(a){return w(a)},a.addRTLMarkers=function(a){return u(a)},a.shouldBeRTL=function(a){return x(a)},a}();typeof module!="undefined"&&module.exports&&(module.exports=RTLText)
});
define("app/ui/typeahead/typeahead_dropdown",["module","require","exports","core/component","core/utils","app/ui/typeahead/accounts_renderer","app/ui/typeahead/saved_searches_renderer","app/ui/typeahead/recent_searches_renderer","app/ui/typeahead/topics_renderer","app/ui/typeahead/trend_locations_renderer","app/ui/typeahead/concierge_renderer","app/ui/typeahead/selected_users_renderer","app/utils/rtl_text"],function(module, require, exports) {
function typeaheadDropdown(){this.defaultAttrs({inputSelector:"#search-query",dropdownSelector:".dropdown-menu.typeahead",itemsContainerSelector:".typeahead-items",itemsSelector:".typeahead-items li",itemAnchorsSelector:".typeahead-items li a",itemSelector:".typeahead-item",categoryTitle:".typeahead-category-title",selectedItemSelector:".typeahead-items li.selected",selectedClass:"selected",blockLinkActions:!1,alwaysOpen:!1,deciders:{showDebugInfo:!1,showSocialContext:!1,showTypeaheadTopicSocialContext:!1},autocompleteAccounts:!0,datasourceRenders:[["concierge",["concierge"]],["savedSearches",["savedSearches"]],["recentSearches",["recentSearches"]],["topics",["topics"]],["accounts",["accounts"]]],datasourceOptions:{},typeaheadSrc:"UNKNOWN",templateContainerSelector:".dropdown-inner",recentSearchesListSelector:".typeahead-recent-searches",savedSearchesListSelector:".typeahead-saved-searches",topicsListSelector:".typeahead-topics",accountsListSelector:".js-typeahead-accounts",trendLocationsListSelector:".typeahead-trend-locations-list",conciergeSelector:".typeahead-concierge",userSelectSelector:".typeahead-user-select",selectedListSelector:".typeahead-selected",renderLimit:undefined}),this.mouseOver=function(a,b){this.clearSelected(),$(b.el).addClass(this.attr.selectedClass)},this.clearSelected=function(){this.select("itemsSelector").removeClass(this.attr.selectedClass)},this.moveSelection=function(a){var b=this.select("itemsSelector").filter(":visible"),c=b.filter(".selected");c.removeClass(this.attr.selectedClass),c.find("a").removeAttr("aria-selected"),this.$input.removeAttr("aria-activedescendant");var d=b.index(c)+a;d=(d+1)%(b.length+1)-1;if(d===-1){this.trigger("uiTypeaheadSelectionCleared");return}d<-1&&(d=b.length-1);var e=b.eq(d),f=e.find("a");e.addClass(this.attr.selectedClass),f.attr("aria-selected",!0),this.$input.attr("aria-activedescendant",f.attr("id"))},this.moveSelectionUp=function(a){this.moveSelection(-1)},this.moveSelectionDown=function(a){this.moveSelection(1)},this.dropdownIsOpen=function(){if(this.attr.alwaysOpen)return!0;if(window.DEBUG&&window.DEBUG.enabled&&this.openState!==this.$dropdown.is(":visible"))throw new Error("Dropdown markup and internal openState variable are out of sync.");return this.openState},this.show=function(){this.$dropdown.show(),this.$input.attr("aria-expanded",!0),this.openState=!0},this.hide=function(a){if(this.mouseIsOverDropdown)return;if(!this.dropdownIsOpen()||this.attr.alwaysOpen)return;this.$dropdown.find(".selected a").removeAttr("aria-selected"),this.$dropdown.hide(),this.$input.attr("aria-expanded",!1),this.$input.removeAttr("aria-activedescendant"),this.openState=!1},this.hideAndManageEsc=function(a){if(!this.dropdownIsOpen()||this.attr.alwaysOpen)return;this.forceHide(),a.preventDefault(),a.stopPropagation()},this.forceHide=function(){this.clearMouseTracking(),this.hide()},this.inputValueUpdated=function(a,b){this.lastQuery=b.value;var c=utils.merge(this.attr.datasourceOptions,{query:b.value,tweetContext:b.tweetContext,typeaheadSrc:this.attr.typeaheadSrc});this.trigger("uiNeedsTypeaheadSuggestions",{datasources:this.datasources,queryData:c,id:this.getDropdownId()})},this.getDropdownId=function(){return this.dropdownId||(this.dropdownId="swift_typeahead_dropdown_"+Math.floor(Math.random()*1e6)),this.dropdownId},this.checkIfSelectionFromSearchInput=function(a){return a.closest("form").find("input").hasClass("search-input")},this.triggerSelectionEvent=function(a,b){this.attr.blockLinkActions&&a.preventDefault();var c=this.select("itemsSelector"),d=c.filter(".selected").first();if(d.length==0)return;var e=d.find("a"),f=d.index(),g=this.lastQuery,h=e.attr("data-search-query"),i=e.attr("data-query-source");d.removeClass(this.attr.selectedClass),this.$input.removeAttr("aria-activedescendant");if(!g&&!h&&i!=="typeahead_oneclick")return;var j=this.getItemData(d);this.trigger("uiTypeaheadItemSelected",{isSearchInput:this.checkIfSelectionFromSearchInput(e),index:f,source:e.data("ds"),query:h,input:g,display:d.data("user-screenname")||h,href:e.attr("href"),isClick:a.originalEvent?a.originalEvent.type==="click":!1,item:j}),this.forceHide()},this.getItemData=function(a){return a.data("item")},this.submitQuery=function(a,b){var c=this.select("itemsSelector").filter(".selected").first();if(c.length){this.triggerSelectionEvent(a,b);return}var d=this.$input.val();if(d.trim()==="")return;this.trigger("uiTypeaheadSubmitQuery",{query:RTLText.cleanText(d)}),this.forceHide()},this.getSelectedCompletion=function(){var a=this.select("itemsSelector").filter(".selected").first();!a.length&&this.dropdownIsOpen()&&(a=this.select("itemsSelector").filter(".typeahead-item").first());if(!a.length||this.$dropdown.attr("id")!=a.closest(this.attr.dropdownSelector).attr("id"))return;var b=a.find("a"),c=b.data("search-query"),d=this.select("itemsSelector"),e=d.index(a),f=this.lastQuery;if(b.data("ds")=="account"&&!this.attr.autocompleteAccounts)return;var g=this.getItemData(a);this.trigger("uiTypeaheadItemPossiblyComplete",{value:c,source:b.data("ds"),index:e,query:c,item:g,display:a.data("user-screenname")||c,input:f,href:b.attr("href")||""})},this.renderResults=function(a){if(!this.attr.renderLimit){this.trigger("uiTypeaheadRenderResults",a);return}var b=0,c=0,d=0,e={},f=a.suggestions,g=this.attr.renderLimit;this.datasources.forEach(function(f){a.suggestions[f]&&d<g&&(b=g-d,c=a.suggestions[f].length<b?a.suggestions[f].length:b,e[f]=a.suggestions[f].slice(0,c),d+=c)}),a.suggestions=e,this.trigger("uiTypeaheadRenderResults",a),a.suggestions=f},this.updateDropdown=function(a,b){var c=this.$input.is(document.activeElement);if(b.id!==this.getDropdownId()||!b.queryData.atSignRemoved&&b.queryData.query!==this.lastQuery||b.queryData.atSignRemoved&&b.queryData.query!==this.lastQuery.substring(1)||!c&&!this.attr.alwaysOpen)return;var d=this.select("itemsSelector").filter(".selected").first(),e=d.find("a").data("ds"),f=d.find("a").data("search-query");this.renderResults(b);if(e&&f){var g=this.select("itemsSelector").find("[data-ds='"+e+"'][data-search-query='"+f+"']");g.closest("li").addClass(this.attr.selectedClass)}var h="typeahead-item-";this.select("itemAnchorsSelector").each(function(a,b){$(b).attr("id",h+a)});var i=this.datasources.map(function(a){return b.suggestions[a]?b.suggestions[a].length:0}),j=i.reduce(function(a,b){return a+b}),k=!!b.queryData.query;j>0&&(c||this.attr.alwaysOpen)?(this.show(),this.trigger("uiTypeaheadSetPreventDefault",{preventDefault:k,key:9}),this.trigger("uiTypeaheadResultsShown",{numResults:j,query:b.queryData.query})):(this.forceHide(),this.trigger("uiTypeaheadSetPreventDefault",{preventDefault:!1,key:9}),this.trigger("uiTypeaheadResultsHidden"))},this.trackMouse=function(a,b){this.mouseIsOverDropdown=!0},this.clearMouseTracking=function(a,b){this.mouseIsOverDropdown=!1,this.clearSelected()},this.resetTemplates=function(){this.$templateContainer.empty(),this.$templateContainer.append(this.$conciergeTemplate),this.$templateContainer.append(this.$savedSearchesTemplate),this.$templateContainer.append(this.$recentSearchesTemplate),this.$templateContainer.append(this.$topicsTemplate),this.$templateContainer.append(this.$accountsTemplate),this.$templateContainer.append(this.$trendLocationsTemplate),this.$templateContainer.append(this.$userSelectTemplate)},this.addRenderer=function(a,b,c){c=utils.merge(c,{datasources:b});var d="block"+this.blockCount++;a==="accounts"?(this.$accountsTemplate.clone().addClass(d).appendTo(this.$templateContainer),AccountsRenderer.attachTo(this.$node,utils.merge(c,{accountsListSelector:this.attr.accountsListSelector+"."+d}))):a==="topics"?(this.$topicsTemplate.clone().addClass(d).appendTo(this.$templateContainer),TopicsRenderer.attachTo(this.$node,utils.merge(c,{topicsListSelector:this.attr.topicsListSelector+"."+d}))):a==="savedSearches"?(this.$savedSearchesTemplate.clone().addClass(d).appendTo(this.$templateContainer),SavedSearchesRenderer.attachTo(this.$node,utils.merge(c,{savedSearchesListSelector:this.attr.savedSearchesListSelector+"."+d}))):a==="recentSearches"?(this.$recentSearchesTemplate.clone().addClass(d).appendTo(this.$templateContainer),RecentSearchesRenderer.attachTo(this.$node,utils.merge(c,{recentSearchesListSelector:this.attr.recentSearchesListSelector+"."+d}))):a==="trendLocations"?(this.$trendLocationsTemplate.clone().addClass(d).appendTo(this.$templateContainer),TrendLocationsRenderer.attachTo(this.$node,utils.merge(c,{trendLocationsListSelector:this.attr.trendLocationsListSelector+"."+d}))):a==="concierge"?(this.$conciergeTemplate.clone().addClass(d).appendTo(this.$templateContainer),ConciergeRenderer.attachTo(this.$node,utils.merge(c,{conciergeSelector:this.attr.conciergeSelector+"."+d}))):a==="selectedUsers"&&(this.$userSelectTemplate.clone().addClass(d).appendTo(this.$templateContainer),SelectedUsersRenderer.attachTo(this.$node,utils.merge(c,{rootSelector:this.attr.userSelectSelector+"."+d,accountsListSelector:this.attr.accountsListSelector,selectedListSelector:this.attr.selectedListSelector})),this.$dropdown.attr("aria-multiselectable","true"))},this.applyARIAToInput=function(){instances+=1;var a="typeahead-dropdown-"+instances;this.$dropdown.attr("id",a),this.$input.attr({"aria-autocomplete":"list","aria-expanded":!1,"aria-owns":a})},this.before("teardown",this.resetTemplates),this.after("initialize",function(a,b){this.openState=!1,this.$input=this.select("inputSelector").first(),this.$dropdown=this.select("dropdownSelector").first(),this.applyARIAToInput(),this.$templateContainer=this.select("templateContainerSelector").first(),this.$accountsTemplate=this.select("accountsListSelector").first().clone(!1),this.$savedSearchesTemplate=this.select("savedSearchesListSelector").first().clone(!1),this.$recentSearchesTemplate=this.select("recentSearchesListSelector").first().clone(!1),this.$topicsTemplate=this.select("topicsListSelector").first().clone(!1),this.$trendLocationsTemplate=this.select("trendLocationsListSelector").first().clone(!1),this.$conciergeTemplate=this.select("conciergeSelector").first().clone(!1),this.$userSelectTemplate=this.select("userSelectSelector").first().clone(!1),this.$templateContainer.empty(),this.datasources=[],this.attr.datasourceRenders.forEach(function(a){this.datasources=this.datasources.concat(a[1])},this),this.datasources=utils.uniqueArray(this.datasources),this.blockCount=0,this.attr.datasourceRenders.forEach(function(a){this.addRenderer(a[0],a[1],b)},this),this.on(this.$input,"blur",this.hide),this.on(this.$input,"uiTypeaheadInputSubmit",this.submitQuery),this.on(this.$input,"uiTypeaheadInputChanged",this.inputValueUpdated),this.on(this.$input,"uiTypeaheadInputMoveUp",this.moveSelectionUp),this.on(this.$input,"uiTypeaheadInputMoveDown",this.moveSelectionDown),this.on(this.$input,"uiTypeaheadInputAutocomplete",this.getSelectedCompletion),this.on(this.$input,"uiTypeaheadInputTab",this.clearMouseTracking),this.on(this.$input,"uiShortcutEsc",this.hideAndManageEsc),this.on(this.$dropdown,"mouseenter",this.trackMouse),this.on(this.$dropdown,"mouseleave",this.clearMouseTracking),this.on(document,"dataTypeaheadSuggestionsResults",this.updateDropdown),this.on(document,"uiBeforePageChanged",this.forceHide),this.on("mouseover",{itemsSelector:this.mouseOver}),this.on("click",{itemsSelector:this.triggerSelectionEvent}),this.attr.alwaysOpen&&(this.$input.attr("aria-expanded",!0),this.$dropdown.show().attr("aria-hidden",!1),this.openState=!0)})}var defineComponent=require("core/component"),utils=require("core/utils"),AccountsRenderer=require("app/ui/typeahead/accounts_renderer"),SavedSearchesRenderer=require("app/ui/typeahead/saved_searches_renderer"),RecentSearchesRenderer=require("app/ui/typeahead/recent_searches_renderer"),TopicsRenderer=require("app/ui/typeahead/topics_renderer"),TrendLocationsRenderer=require("app/ui/typeahead/trend_locations_renderer"),ConciergeRenderer=require("app/ui/typeahead/concierge_renderer"),SelectedUsersRenderer=require("app/ui/typeahead/selected_users_renderer"),RTLText=require("app/utils/rtl_text"),instances=0;module.exports=defineComponent(typeaheadDropdown)
});
define("app/utils/caret",["module","require","exports"],function(module, require, exports) {
var caret={getPosition:function(a){try{if(document.selection){var b=document.selection.createRange();return b.moveStart("character",-a.value.length),b.text.length}if(typeof a.selectionStart=="number")return a.selectionStart}catch(c){}return 0},setPosition:function(a,b){try{if(document.selection){var c=a.createTextRange();c.collapse(!0),c.moveEnd("character",b),c.moveStart("character",b),c.select()}else typeof a.selectionStart=="number"&&(a.selectionStart=b,a.selectionEnd=b)}catch(d){}},getSelection:function(){return window.getSelection?window.getSelection().toString():document.selection.createRange().text}};module.exports=caret
});
define("app/utils/event_support",["module","require","exports"],function(module, require, exports) {
var supportedEvents={},checkEventsSupport=function(a,b){return a.forEach(function(a){checkEventSupported(a,b[a])},this),supportedEvents},checkEventSupported=function(a,b){var c=document.createElement(b||"div"),d="on"+a,e=d in c;return e||(c.setAttribute(d,"return;"),e=typeof c[d]=="function"),c=null,supportedEvents[a]=e,e},eventSupport={checkEvents:function(a,b){checkEventsSupport(a,b||{})},browserSupports:function(a,b){return supportedEvents[a]===undefined&&checkEventSupported(a,b),supportedEvents[a]}};module.exports=eventSupport
});
define("app/utils/typeahead_helpers",["module","require","exports"],function(module, require, exports) {
function tokenizeText(a){return a.trim().toLowerCase().split(/[\s_,.-]+/)}function getFirstChar(a){var b;return multiByteRegex.test(a.substr(0,1))?b=a.substr(0,2):b=a.charAt(0),b}var multiByteRegex=/[\uD800-\uDFFF]/;module.exports={tokenizeText:tokenizeText,getFirstChar:getFirstChar}
});
define("app/ui/typeahead/typeahead_input",["module","require","exports","core/component","app/utils/caret","app/utils/event_support","app/utils/typeahead_helpers","app/utils/string","lib/twitter-text","app/utils/rtl_text"],function(module, require, exports) {
function typeaheadInput(){this.defaultAttrs({inputSelector:"#search-query",buttonSelector:".nav-search",dropdownSelectedItemSelector:".typeahead-items li.selected",completeAllEntities:!1,includeTweetContext:!1,tweetContextEnabled:!1,allowAccountsWithoutAtSign:!1,inputIsTweetbox:!1}),this.getDefaultKeycodes=function(){var a={13:{name:"ENTER",event:"uiTypeaheadInputSubmit",on:"keypress",preventDefault:!0,enabled:!0},9:{name:"TAB",event:"uiTypeaheadInputTab",on:"keydown",preventDefault:!0,canCauseComplete:!0,enabled:!0},37:{name:"LEFT",event:"uiTypeaheadInputLeft",on:"keydown",canCauseComplete:!0,enabled:!0},39:{name:"RIGHT",event:"uiTypeaheadInputRight",on:"keydown",canCauseComplete:!0,enabled:!0},38:{name:"UP",event:"uiTypeaheadInputMoveUp",on:"keydown",preventDefault:!0,enabled:!0},40:{name:"DOWN",event:"uiTypeaheadInputMoveDown",on:"keydown",preventDefault:!0,enabled:!0}};return a},this.setPreventKeyDefault=function(a,b){this.KEY_CODE_MAP[b.key].preventDefault=b.preventDefault},this.toggleTextareaActions=function(a){this.KEY_CODE_MAP[13].enabled=a,this.KEY_CODE_MAP[38].enabled=a,this.KEY_CODE_MAP[40].enabled=a},this.enableTextareaActionWatching=function(){this.toggleTextareaActions(!0)},this.disableTextareaActionWatching=function(){this.toggleTextareaActions(!1)},this.clearCurrentQuery=function(a){this.currentQuery=null},this.focusInput=function(a){this.$input.focus()},this.click=function(a){this.updateCaretPosition()},this.ignoreNextFocus=function(a){this.ignoreFocus=!0},this.updateCaretPosition=function(){if(this.ignoreFocus){this.ignoreFocus=!1;return}this.richTextareaMode||this.trigger(this.$input,"uiTextChanged",{text:this.$input.val(),position:caret.getPosition(this.$input[0])})},this.modifierKeyPressed=function(a){var b=this.KEY_CODE_MAP[a.which||a.keyCode],c=a.type=="keydown"&&a.which==16||a.type=="keyup"&&a.which==16;if(b&&b.enabled){if(a.type!==b.on)return;if(b.name=="TAB"&&a.shiftKey)return;if(this.releaseTabKey&&b.name=="TAB")return;if(b.preventDefault)if(this.attr.inputIsTweetbox&&b.name==="ENTER"){var d=this.select("dropdownSelectedItemSelector");d.length&&a.preventDefault()}else a.preventDefault();b.canCauseComplete&&this.isValidCompletionAction(b.event)&&(this.textareaMode||(this.releaseTabKey=!0),this.trigger(this.$input,"uiTypeaheadInputAutocomplete")),this.trigger(this.$input,b.event),this.updateCaretPosition()}else{if(a.keyCode==27)return;c||(this.releaseTabKey=!1),this.supportsInputEvent||this.handleInputChange(a)}},this.handleInputChange=function(a){this.richTextareaMode||(RTLText.onTextChange(a),this.trigger(this.$input,"uiTextChanged",{text:this.$input.val(),position:caret.getPosition(this.$input[0])}))},this.getCurrentWord=function(){var a;if(this.textareaMode){var b=twitterText.extractEntitiesWithIndices(this.text);b.forEach(function(b){var c=b.screenName&&!b.listSlug,d=this.attr.completeAllEntities&&(b.cashtag||b.hashtag),e=this.position>b.indices[0]&&this.position<=b.indices[1];(c||d)&&e&&(a=this.text.slice(b.indices[0],b.indices[1]))},this),this.attr.allowAccountsWithoutAtSign&&!a&&(a=this.getCurrentWordUsingRegex(REAL_NAME_REGEXP_ONE_WORD)||this.getCurrentWordUsingRegex(REAL_NAME_REGEXP_TWO_WORD))}else a=this.text.trim()==""?"":this.text;return a},this.getCurrentWordUsingRegex=function(a){var b=stringUtils.wordAtPosition(this.text,this.position,a,1);if(b){var c=b.split(/\s+/),d=c.every(function(a){var b=helpers.getFirstChar(a);return b==b.toUpperCase()});if(d)return b}},this.completeInput=function(a,b){a.stopPropagation();var c=b.value||b.query,d=c!==this.currentQuery&&(b.source!="account"||b.item.screen_name!==this.currentQuery);if(!d)return;var e=c;b.source=="account"&&(e=(this.textareaMode?"@":"")+b.item.screen_name,this.currentQuery=b.item.screen_name);if(this.textareaMode){var f=this.replaceWordAtPosition(this.text,this.position,b.input,e+" ");(!this.richTextareaMode||a.type=="uiTypeaheadItemSelected")&&this.$input.focus(),this.$input.trigger("uiChangeTextAndPosition",f)}else b.source!="account"&&this.$input.val(e),a.type!="uiTypeaheadItemSelected"&&(this.$input.focus(),this.setQuery(e));b.fromSelectionEvent=a.type=="uiTypeaheadItemSelected",this.trigger(this.$input,"uiTypeaheadItemComplete",b)},this.replaceWordAtPosition=function(a,b,c,d){var e=null;c=c.replace(UNSAFE_REGEX_CHARS,function(a){return"\\"+a});var a=a.replace(new RegExp(c+"\\s?","g"),function(){var a=arguments[0],c=arguments[arguments.length-2];return c<=b&&c+a.length>=b?(e=c+d.length,d):a});return{text:a,position:e}},this.isValidCompletionAction=function(a){var b=this.$input.attr("dir")==="rtl";return!this.textareaMode||a!=="uiTypeaheadInputRight"&&a!=="uiTypeaheadInputLeft"?b&&a==="uiTypeaheadInputRight"?!1:!b&&a==="uiTypeaheadInputLeft"?!1:!!this.text&&this.position!=this.text.length&&(a==="uiTypeaheadInputRight"||b&&a==="uiTypeaheadInputLeft")?!1:!0:!1},this.setQuery=function(a){var b;a=a?RTLText.cleanText(a):"";if(this.currentQuery==null||this.currentQuery!==a){this.currentQuery=a,b=a.length>0?0:-1,this.$button.attr("tabIndex",b);var c=this.attr.tweetContextEnabled&&this.attr.includeTweetContext?this.text:undefined;this.trigger(this.$input,"uiTypeaheadInputChanged",{value:this.currentQuery,tweetContext:c})}},this.setRTLMarkers=function(){RTLText.setText(this.$input.get(0))},this.clearInput=function(){this.$input.val(""),this.clearCurrentQuery(),this.$button.attr("tabIndex",-1),this.releaseTabKey=!1},this.saveTextAndPosition=function(a,b){if(b.position==Number.MAX_VALUE)return;this.text=b.text,this.position=b.position;var c=this.getCurrentWord();this.setQuery(c)},this.after("initialize",function(){this.$input=this.select("inputSelector"),this.textareaMode=!this.$input.is("input"),this.richTextareaMode=this.$input.is(".rich-editor"),this.$button=this.select("buttonSelector"),this.KEY_CODE_MAP=this.getDefaultKeycodes(),this.richTextareaMode&&this.disableTextareaActionWatching(),this.supportsInputEvent=eventSupport.browserSupports("input","input"),this.$button.attr("tabIndex",-1),this.on(this.$input,"keyup keydown keypress paste",this.modifierKeyPressed),this.on(this.$input,"input",this.handleInputChange),this.on("dataTypeaheadRecentSearchDeleted",this.focusInput),this.on("uiRemoveSavedSearch",this.focusInput),this.on(this.$input,"focus",this.updateCaretPosition),this.on("uiTypeaheadSelectionCleared",this.updateCaretPosition),this.on(this.$input,"uiTypeaheadIgnoreNextFocus",this.ignoreNextFocus),this.$input.is(":focus")&&this.updateCaretPosition(),this.on(this.$input,"blur",this.clearCurrentQuery),this.textareaMode&&(this.on(this.$input,"click",this.click),this.on("uiTypeaheadResultsShown",this.enableTextareaActionWatching),this.on("uiTypeaheadResultsHidden",this.disableTextareaActionWatching)),this.on("uiTextChanged",this.saveTextAndPosition),this.on(document,"uiBeforePageChanged",this.clearInput),this.on("uiTypeaheadSetPreventDefault",this.setPreventKeyDefault),this.on(document,"uiSwiftLoaded uiPageChanged",this.setRTLMarkers),this.on("uiTypeaheadItemPossiblyComplete uiTypeaheadItemSelected",this.completeInput)})}var defineComponent=require("core/component"),caret=require("app/utils/caret"),eventSupport=require("app/utils/event_support"),helpers=require("app/utils/typeahead_helpers"),stringUtils=require("app/utils/string"),twitterText=require("lib/twitter-text"),RTLText=require("app/utils/rtl_text");module.exports=defineComponent(typeaheadInput);var UNSAFE_REGEX_CHARS=/[[\]\\*?(){}.+$^]/g,REAL_NAME_REGEXP_ONE_WORD=twitterText.regexSupplant(/([a-z#{latinAccentChars}#{nonLatinHashtagChars}]{4,})/gi),REAL_NAME_REGEXP_TWO_WORD=twitterText.regexSupplant(/(?=((^|\b)[A-Z#{nonLatinHashtagChars}][A-Za-z#{latinAccentChars}#{nonLatinHashtagChars}]*\s[A-Z#{nonLatinHashtagChars}][A-Za-z#{latinAccentChars}#{nonLatinHashtagChars}]*))/g)
});
define("app/ui/with_timestamp_updating",["module","require","exports","core/i18n","lib/twitter_cldr"],function(module, require, exports) {
function withTimestampUpdating(){this.defaultAttrs({timestampSelector:".js-relative-timestamp",timestampClass:"js-relative-timestamp"}),this.currentTimeSecs=function(){return new Date/1e3},this.isMuricanLocale=function(){var a=["en"];return $.inArray($("html").attr("lang"),a)>=0},this.updateTimestamps=function(){var a=this;this.select("timestampSelector").each(function(){var b=$(this),c=b.data("time"),d;a.isMuricanLocale()?d=a.formatMuricanTimestamp(c):d=a.formatForeignTimestamp(c),d.relative||b.removeClass(a.attr.timestampClass),b.text(d.text)})},this.formatMuricanTimestamp=function(a){var b=!0,c=this.currentTimeSecs(),d=c-a,e;if(d<3)e=_('\u73fe\u5728');else if(d<60)e=_('{{number}}\u79d2',{number:parseInt(d)});else{var f=parseInt(d/60,10);f<60?e=_('{{number}}\u5206',{number:f}):e=_('{{number}}\u6642\u9593',{number:parseInt(f/60,10)})}return{text:e,relative:b}},this.formatForeignTimestamp=function(a){var b=!0,c=this.currentTimeSecs(),d=c-a,e=new TwitterCldr.TimespanFormatter,f;return d<3?(f=_('\u73fe\u5728'),!1):f=e.format(d,{direction:"none",type:"short"}),{text:f,relative:b}},this.after("initialize",function(){this.on(document,"uiWantsToRefreshTimestamps uiPageChanged",this.updateTimestamps)})}var _=require("core/i18n"),TwitterCldr=require("lib/twitter_cldr");module.exports=withTimestampUpdating
});
define("app/ui/with_item_actions",["module","require","exports","core/utils","core/compose","app/data/user_info","app/ui/with_interaction_data","app/data/with_card_metadata"],function(module, require, exports) {
function withItemActions(){compose.mixin(this,[withInteractionData,withCardMetadata]),this.defaultAttrs({showSimpleProfilePopup:!1,profileHoversEnabled:!1,pageContainer:"#doc",nestedContainerSelector:".js-stream-item .in-reply-to, .js-expansion-container",showWithScreenNameSelector:".show-popup-with-screen-name, .twitter-atreply",showWithIdSelector:".show-popup-with-id, .js-user-profile-link",searchtagSelector:".twitter-hashtag, .twitter-cashtag",cashtagSelector:".twitter-cashtag",geoPivotSelector:".js-geo-pivot-link",itemLinkSelector:".twitter-timeline-link",cardInteractionLinkSelector:".js-card2-interaction-link",cardExternalLinkSelector:".js-card2-external-link",viewMoreItemSelector:".view-more-container",inSnapbackExperiment:!1,snapbackSkipProfilePopup:!1}),this.showProfilePopupWithScreenName=function(a,b){var c=$(a.target).closest(this.attr.showWithScreenNameSelector).text();c[0]==="@"&&(c=c.substring(1));var d={screenName:c},e=this.getCardDataFromTweet($(a.target));b=utils.merge(this.interactionData(a,d),e),this.showProfile(a,b)},this.showProfilePopupWithId=function(a,b){var c=this.getCardDataFromTweet($(a.target));b=utils.merge(this.interactionDataWithCard(a),c),this.showProfile(a,b)},this.showProfile=function(a,b){this.attr.profileHoversEnabled&&a.type=="mouseover"?this.trigger(a.target,"uiShowProfileHover",b):this.skipProfilePopup(a)||this.modifierKey(a)?this.trigger(a.target,"uiShowProfileNewWindow",b):(a.preventDefault(),this.trigger("uiShowProfilePopup",utils.merge({simple_profile:this.attr.showSimpleProfilePopup},b)))},this.hideHover=function(a,b){var c=this.getCardDataFromTweet($(a.target));b=utils.merge(this.interactionData(a),c),this.trigger("uiHideProfileHover",b)},this.searchtagClick=function(a,b){var c=$(a.target),d=c.closest(this.attr.searchtagSelector),e=d.is(this.attr.cashtagSelector)?"uiCashtagClick":"uiHashtagClick",f={query:d.text()};this.trigger(e,this.interactionData(a,f))},this.isCardUrl=function(a){var b=/^(https?:\/\/)?cards(-staging|-beta)?.twitter.com/;return b.test(a)},this.geoPivotClick=function(a,b){var c={placeId:$(b.el).data("place-id")};this.trigger("uiGeoPivotClick",this.interactionData(a,c))},this.itemLinkClick=function(a,b){function c(a){return!!a.parents(".permalink").length}var d=$(a.target).closest(this.attr.itemLinkSelector),e,f={url:d.attr("data-expanded-url")||d.attr("href"),tcoUrl:d.attr("href"),text:d.text()};f=utils.merge(f,this.getCardDataFromTweet($(a.target))),(f.cardName==="promotion"||f.cardType==="promotions")&&this.isCardUrl(f.url)&&!c($(a.target))&&(a.preventDefault(),e=d.parents(".stream-item"),this.trigger(e,"uiPromotionCardUrlClick")),this.trigger("uiItemLinkClick",this.interactionData(a,f))},this.cardLinkClick=function(a,b,c){var d=$(b.target).closest(this.attr.cardLinkSelector),e=this.getCardDataFromTweet($(b.target));this.trigger(a,this.interactionDataWithCard(b,e))},this.getUserIdFromElement=function(a){return a.length?a.data("user-id"):null},this.itemSelected=function(a,b){var c=this.getCardDataFromTweet($(a.target));b.organicExpansion&&this.trigger("uiItemSelected",utils.merge(this.interactionData(a),c))},this.itemDeselected=function(a,b){var c=this.getCardDataFromTweet($(a.target));this.trigger("uiItemDeselected",utils.merge(this.interactionData(a),c))},this.isNested=function(){return this.$node.closest(this.attr.nestedContainerSelector).length},this.skipProfilePopup=function(a){var b=$(a.target).parents(".media-tagging-block").length>0;return b?!1:this.attr.snapbackExperimentOptions?!this.attr.snapbackExperimentOptions.profilePopup:userInfo.getDecider("disable_profile_popup")||this.attr.profileHoversEnabled||this.attr.disableProfilePopup},this.modifierKey=function(a){if(a.shiftKey||a.ctrlKey||a.metaKey||a.which>1)return!0},this.removeTweetsFromUser=function(a,b){var c=this.$node.find("[data-user-id="+b.userId+"]");c.parent().remove(),this.trigger("uiRemovedSomeTweets")},this.navigateToViewMoreURL=function(a){var b=$(a.target),c;b.find(this.attr.viewMoreItemSelector).length&&(c=b.find(".view-more-link"),this.trigger(c,"uiNavigate",{href:c.attr("href")}))},this.after("initialize",function(){this.isNested()||(this.on("click",{showWithScreenNameSelector:this.showProfilePopupWithScreenName,showWithIdSelector:this.showProfilePopupWithId,searchtagSelector:this.searchtagClick,geoPivotSelector:this.geoPivotClick,itemLinkSelector:this.itemLinkClick,cardExternalLinkSelector:this.cardLinkClick.bind(this,"uiCardExternalLinkClick"),cardInteractionLinkSelector:this.cardLinkClick.bind(this,"uiCardInteractionLinkClick")}),this.attr.profileHoversEnabled&&(this.on("mouseover",{showWithScreenNameSelector:this.showProfilePopupWithScreenName,showWithIdSelector:this.showProfilePopupWithId}),this.on("mouseout",{showWithScreenNameSelector:this.hideHover,showWithIdSelector:this.hideHover})),this.on("uiHasExpandedTweet uiHasClickedTweet",this.itemSelected),this.on("uiHasCollapsedTweet",this.itemDeselected),this.on("uiRemoveTweetsFromUser",this.removeTweetsFromUser),this.on("uiShortcutEnter",this.navigateToViewMoreURL))})}var utils=require("core/utils"),compose=require("core/compose"),userInfo=require("app/data/user_info"),withInteractionData=require("app/ui/with_interaction_data"),withCardMetadata=require("app/data/with_card_metadata");module.exports=withItemActions
});
define("app/ui/with_tweetbox_initialization",["module","require","exports","core/utils"],function(module, require, exports) {
var utils=require("core/utils");module.exports=function(){this.defaultAttrs({tweetFormSelector:".tweet-form"}),this.initTweetbox=function(a){var b=this.select("tweetFormSelector"),c=this.attr.preexpandTweetbox||!1;this.trigger(b,"uiInitTweetbox",utils.merge({draftTweetId:this.attr.draftTweetId,condensable:!c},{eventData:this.attr.eventData},a)),c&&this.trigger(b,"uiPrepareTweetBox")}}
});
define("app/ui/user_actions_dropdown",["module","require","exports","core/component","app/ui/with_dropdownmenu"],function(module, require, exports) {
function userActionsDropdown(){this.defaultAttrs({dropdownThresholdSelector:".dropdown-threshold"}),this.scrollIntoView=function(){var a=this.$node.closest(this.attr.dropdownThresholdSelector),b,c;a.length&&(b=this.$node.find(this.attr.dropDownSelector),c=b.offset().top+b.outerHeight()-(a.offset().top+a.height()),c>0&&a.animate({scrollTop:a.scrollTop()+c}))},this.after("initialize",function(){this.on("uiDropdownOpened",this.scrollIntoView),this.on(document,"uiHasInjectedNewTimeline uiHasInjectedOldTimelineItems uiHasInjectedRangeTimelineItems",this.applyARIAAttrs)})}var defineComponent=require("core/component"),withDropdownMenu=require("app/ui/with_dropdownmenu"),UserActionsDropdown=defineComponent(withDropdownMenu,userActionsDropdown);module.exports=UserActionsDropdown
});
define("app/ui/with_user_actions",["module","require","exports","core/compose","core/i18n","core/utils","app/ui/with_interaction_data","app/ui/user_actions_dropdown","app/utils/string","app/utils/user_dom_data"],function(module, require, exports) {
function withUserActions(){compose.mixin(this,[withInteractionData]),this.defaultAttrs({followButtonSelector:".follow-button, .follow-link, .WebToast-followButton",topicLinkSelector:".user-topic-link",deviceFollowCheckboxSelector:".device-follow.checkbox input",emailFollowCheckboxSelector:".email-follow.checkbox input",favoriteUserButtonSelector:".favorite-user-button",userInfoSelector:".user-actions",dropdownSelector:".user-actions .dropdown",dropdownItemSelector:".user-actions .dropdown.open .dropdown-menu li",blockOrReportButtonSelector:".block-or-report-text",unmuteButtonSelector:".unmute-button",muteButtonSelector:".mute-button",followStates:["not-following","following","blocked","pending"],favoritedUserClass:"favorited-user",favoritePeopleDisabledClass:"email-follow-disabled",userActionClassesToEvents:{"mention-text":["uiMentionAction","mentionUser"],"dm-text":["uiDmAction","dmUser"],"list-text":["uiListAction"],"block-text":["uiBlockAction"],"unblock-text":["uiUnblockAction"],"hide-suggestion-text":["uiHideSuggestionAction"],"retweet-on-text":["uiRetweetOnAction"],"retweet-off-text":["uiRetweetOffAction"],"device-notifications-on-text":["uiDeviceNotificationsOnAction","deviceNotificationsOn"],"device-notifications-off-text":["uiDeviceNotificationsOffAction"],"embed-profile":["uiEmbedProfileAction","redirectToEmbedProfile"],"email-follow-text":["uiEmailFollowAction"],"email-unfollow-text":["uiEmailUnfollowAction"]}}),this.getClassNameFromList=function(a,b){var c=b.filter(function(b){return a.hasClass(b)});return c[0]},this.getUserActionEventNameAndMethod=function(a){var b=this.getClassNameFromList(a.closest("li"),Object.keys(this.attr.userActionClassesToEvents));return this.attr.userActionClassesToEvents[b]},this.getFollowState=function(a){return this.getClassNameFromList(a,this.attr.followStates)},this.getInfoElementFromEvent=function(a){var b=$(a.target);return b.closest(this.attr.userInfoSelector)},this.findInfoElementForUser=function(a){var b=this.attr.userInfoSelector+"[data-user-id="+StringUtils.parseBigInt(a)+"]";return this.$node.find(b)},this.getEventName=function(a){var b={"not-following":"uiFollowAction",following:"uiUnfollowAction",blocked:"uiUnblockAction",pending:"uiCancelFollowRequestAction"};return b[a]},this.addCancelHoverStyleClass=function(a){a.addClass("cancel-hover-style"),a.one("mouseleave",function(){a.removeClass("cancel-hover-style")})},this.handleFollowButtonClick=function(a){a.stopPropagation(),this.trigger($(a.target),"uiCloseDropdowns");var b=this.getInfoElementFromEvent(a),c=$(a.target).closest(this.attr.followButtonSelector);this.addCancelHoverStyleClass(c);var d=this.getFollowState(b);d=="not-following"&&b.data("protected")&&this.trigger("uiShowMessage",{message:_('@{{screen_name}}\u3055\u3093\u306b\u30d5\u30a9\u30ed\u30fc\u30ea\u30af\u30a8\u30b9\u30c8\u3092\u9001\u4fe1\u3057\u307e\u3057\u305f\u3002\u627f\u8a8d\u3092\u5f85\u3063\u3066\u3044\u307e\u3059\u3002',{screen_name:b.data("screen-name")})});var e=this.getEventName(d),f={originalFollowState:d,inject_tweet:d=="not-following"&&this.attr.injectTweetOnFollow};this.trigger(e,this.interactionData(a,f))},this.handleTopicLinkClick=function(a){var b=this.interactionData(a);this.trigger("uiUserTopicClickAction",b)},this.handleDeviceFollowCheckboxClick=function(a){if($("#timeline").hasClass(this.attr.favoritePeopleDisabledClass)){a.preventDefault();return}var b=this.getInfoElementFromEvent(a),c=$(a.target).closest(this.attr.favoriteUserButtonSelector);b.hasClass("notifying")?this.trigger("uiDeviceNotificationsOffAction",this.interactionData(a)):this.trigger("uiDeviceNotificationsOnAction",this.interactionData(a))},this.handleEmailFollowCheckboxClick=function(a){if($("#timeline").hasClass(this.attr.favoritePeopleDisabledClass)){a.preventDefault();return}var b=this.getInfoElementFromEvent(a),c=$(a.target).closest(this.attr.emailFollowCheckboxSelector);b.hasClass("email-following")?this.trigger("uiEmailUnfollowAction",this.interactionData(a)):this.trigger("uiEmailFollowAction",this.interactionData(a))},this.handleFavoriteUserButtonClick=function(a){var b=this.getInfoElementFromEvent(a),c=$(a.target).closest(this.attr.favoriteUserButtonSelector);a.stopPropagation(),b.hasClass("favorited-user")?this.trigger("uiUnfavoriteUserAction",this.interactionData(a)):this.trigger("uiFavoriteUserAction",this.interactionData(a))},this.handleLoggedOutFollowButtonClick=function(a){a.stopPropagation(),this.trigger($(a.target),"uiCloseDropdowns"),this.trigger("uiOpenSigninOrSignupDialog",{signUpOnly:!0,screenName:this.getInfoElementFromEvent(a).data("screen-name")}),this.trigger("uiLoggedOutFollowAttempt",this.interactionData(a))},this.handleBlockOrReportClick=function(a){var b=this.getInfoElementFromEvent(a),c=b.data("screen-name"),d=b.data("user-id").toString(),e=this.getFollowState(b),f=utils.merge(this.interactionData(a),{screenName:c,userId:d,target:"user",viewerFollowsAuthor:e=="following"});this.trigger("uiNeedsBlockOrReportDialog",f)},this.handleUserAction=function(a){var b=$(a.target),c=this.getUserActionEventNameAndMethod(b);if(!c)return;a.stopPropagation();var d=this.getInfoElementFromEvent(a),e=c[0],f=c[1],g=this.getFollowState(d),h={originalFollowState:g};f&&(h=this[f](d,e,h)),h&&this.trigger(e,this.interactionData(a,h)),this.trigger(b,"uiCloseDropdowns")},this.deviceNotificationsOn=function(a,b,c){return this.attr.deviceEnabled?c:(this.attr.smsDeviceVerified||this.attr.hasPushDevice?this.trigger("uiOpenConfirmDialog",{titleText:_('\u30c4\u30a4\u30fc\u30c8\u306e\u30e2\u30d0\u30a4\u30eb\u901a\u77e5\u3092\u6709\u52b9\u306b\u3059\u308b'),bodyText:_('@{{screenName}}\u3055\u3093\u306e\u30c4\u30a4\u30fc\u30c8\u3092\u30e2\u30d0\u30a4\u30eb\u901a\u77e5\u3067\u53d7\u4fe1\u3059\u308b\u306b\u306f\u3001\u901a\u77e5\u8a2d\u5b9a\u3092\u6709\u52b9\u306b\u3057\u3066\u304f\u3060\u3055\u3044\u3002',{screenName:a.data("screen-name")}),cancelText:_('\u9589\u3058\u308b'),submitText:_('\u30c4\u30a4\u30fc\u30c8\u306e\u901a\u77e5\u3092\u6709\u52b9\u306b\u3059\u308b'),action:this.attr.hasPushDevice?"ShowPushTweetsNotifications":"ShowMobileNotifications",top:this.attr.top}):this.trigger("uiOpenConfirmDialog",{titleText:_('\u30e2\u30d0\u30a4\u30eb\u901a\u77e5\u306e\u8a2d\u5b9a'),bodyText:_('@{{screenName}}\u3055\u3093\u306e\u30c4\u30a4\u30fc\u30c8\u306e\u30e2\u30d0\u30a4\u30eb\u901a\u77e5\u3092\u53d7\u3051\u3068\u308b\u306b\u306f\u3001\u643a\u5e2f\u96fb\u8a71\u306e\u8a2d\u5b9a\u304c\u5fc5\u8981\u3067\u3059\u3002',{screenName:a.data("screen-name")}),cancelText:_('\u30ad\u30e3\u30f3\u30bb\u30eb'),submitText:_('\u643a\u5e2f\u96fb\u8a71\u3092\u767b\u9332\u3059\u308b'),action:"ShowMobileNotifications",top:this.attr.top}),!1)},this.redirectToMobileNotifications=function(){window.location="/settings/devices"},this.redirectToPushNotificationsHelp=function(){window.location="//support.twitter.com/articles/20169887"},this.redirectToEmbedProfile=function(a,b,c){return this.trigger("uiNavigate",{href:"/settings/widgets/new/user?screen_name="+a.data("screen-name")}),!0},this.mentionUser=function(a,b,c){this.trigger("uiOpenTweetDialog",{screenName:a.data("screen-name"),title:_('{{name}}\u3055\u3093\u306b\u30c4\u30a4\u30fc\u30c8\u3059\u308b',{name:a.data("name")})})},this.dmUser=function(a,b,c){return this.trigger("uiNeedsDMDialog",{id:userDomDataUtil.getId(a),screen_name:userDomDataUtil.getScreenName(a),name:userDomDataUtil.getName(a)}),c},this.hideSuggestion=function(a,b,c){return utils.merge(c,{feedbackToken:a.data("feedback-token")})},this.followStateChange=function(a,b){this.updateFollowState(b.userId,b.newState),b.fromShortcut&&(b.newState==="not-following"?this.trigger("uiShowMessage",{message:_('{{username}}\u3055\u3093\u306e\u30d6\u30ed\u30c3\u30af\u3092\u89e3\u9664\u3057\u307e\u3057\u305f',{username:b.username})}):b.newState==="blocked"&&this.trigger("uiUpdateAfterBlock",{userId:b.userId}))},this.updateFollowState=function(a,b){var c=this.findInfoElementForUser(a),d=this.getFollowState(c);d&&c.removeClass(d),c.addClass(b)},this.follow=function(a,b){var c=this.findInfoElementForUser(b.userId),d=c.data("protected")?"pending":"following";this.updateFollowState(b.userId,d),c.addClass("including")},this.unfollow=function(a,b){var c=this.findInfoElementForUser(b.userId);this.updateFollowState(b.userId,"not-following"),c.removeClass("including notifying email-following")},this.cancel=function(a,b){var c=this.findInfoElementForUser(b.userId);this.updateFollowState(b.userId,"not-following")},this.block=function(a,b){var c=this.findInfoElementForUser(b.userId);this.updateFollowState(b.userId,"blocked"),c.removeClass("including notifying email-following")},this.unblock=function(a,b){this.updateFollowState(b.userId,"not-following")},this.retweetsOn=function(a,b){var c=this.findInfoElementForUser(b.userId);c.addClass("including")},this.retweetsOff=function(a,b){var c=this.findInfoElementForUser(b.userId);c.removeClass("including")},this.notificationsOn=function(a,b){var c=this.findInfoElementForUser(b.userId),d=c.find(this.attr.deviceFollowCheckboxSelector);c.addClass("notifying"),d.prop("checked",!0)},this.notificationsOff=function(a,b){var c=this.findInfoElementForUser(b.userId),d=c.find(this.attr.deviceFollowCheckboxSelector);c.removeClass("notifying"),d.prop("checked",!1)},this.blockUserConfirmed=function(a,b){a.stopImmediatePropagation(),this.trigger("uiBlockAction",b.sourceEventData)},this.emailFollow=function(a,b){var c=this.findInfoElementForUser(b.userId),d=c.find(this.attr.emailFollowCheckboxSelector);c.addClass("email-following"),d.prop("checked",!0)},this.emailUnfollow=function(a,b){var c=this.findInfoElementForUser(b.userId),d=c.find(this.attr.emailFollowCheckboxSelector);c.removeClass("email-following"),d.prop("checked",!1)},this.favoriteUser=function(a,b){var c=this.findInfoElementForUser(b.userId);c.addClass(this.attr.favoritedUserClass)},this.unfavoriteUser=function(a,b){var c=this.findInfoElementForUser(b.userId);c.removeClass(this.attr.favoritedUserClass)},this.preventFocus=function(a,b){a.preventDefault()},this.handleMuteButtonClick=function(a){return function(b,c){c=this.interactionData(b),c.scribeContext={element:"muted_button"},this.trigger(b.target,a,c)}},this.updateMuteButtonState=function(a,b){var c=this.$node.find(this.attr.userInfoSelector+"[data-user-id="+b.userId+"]"),d=c.find(this.attr.unmuteButtonSelector),e=c.find(this.attr.muteButtonSelector),f=c.find(this.attr.favoriteUserButtonSelector),g=d.is(":focus"),h=e.is(":focus");c[b.modOp](b.modClass),e.removeClass("first-load"),f.remove(),g?e.focus():h&&d.focus()},this.after("initialize",function(){UserActionsDropdown.attachTo(this.$node);if(!this.attr.loggedIn){this.on("click",{followButtonSelector:this.handleLoggedOutFollowButtonClick});return}this.on("click",{followButtonSelector:this.handleFollowButtonClick,topicLinkSelector:this.handleTopicLinkClick,deviceFollowCheckboxSelector:this.handleDeviceFollowCheckboxClick,emailFollowCheckboxSelector:this.handleEmailFollowCheckboxClick,favoriteUserButtonSelector:this.handleFavoriteUserButtonClick,dropdownItemSelector:this.handleUserAction,unmuteButtonSelector:this.handleMuteButtonClick("uiDidUnmuteUser"),muteButtonSelector:this.handleMuteButtonClick("uiDidMuteUser"),blockOrReportButtonSelector:this.handleBlockOrReportClick}),this.on("mousedown",{unmuteButtonSelector:this.preventFocus,muteButtonSelector:this.preventFocus}),this.on(document,"uiFollowStateChange dataFollowStateChange dataBulkFollowStateChange",this.followStateChange),this.on(document,"uiFollowAction",this.follow),this.on(document,"uiUnfollowAction",this.unfollow),this.on(document,"uiCancelFollowRequestAction",this.cancel),this.on(document,"uiUnblockAction",this.unblock),this.on(document,"uiRetweetOnAction dataRetweetOnAction",this.retweetsOn),this.on(document,"uiRetweetOffAction dataRetweetOffAction",this.retweetsOff),this.on(document,"uiDeviceNotificationsOnAction dataDeviceNotificationsOnAction",this.notificationsOn),this.on(document,"uiDeviceNotificationsOffAction dataDeviceNotificationsOffAction",this.notificationsOff),this.on(document,"uiShowMobileNotificationsConfirm",this.redirectToMobileNotifications),this.on(document,"uiShowPushTweetsNotificationsConfirm",this.redirectToPushNotificationsHelp),this.on(document,"uiEmailFollowAction dataEmailFollow",this.emailFollow),this.on(document,"uiEmailUnfollowAction dataEmailUnfollow",this.emailUnfollow),this.on(document,"uiUpdateMuteButtonState",this.updateMuteButtonState),this.on(document,"uiFavoriteUserAction dataFavoriteUser",this.favoriteUser),this.on(document,"uiUnfavoriteUserAction dataUnfavoriteUser",this.unfavoriteUser),this.on(document,"uiBlockAction",this.block),this.on(document,"uiDidBlockUser",this.blockUserConfirmed),this.on(document,"uiDidTriggerBlockingAction",this.block)})}var compose=require("core/compose"),_=require("core/i18n"),utils=require("core/utils"),withInteractionData=require("app/ui/with_interaction_data"),UserActionsDropdown=require("app/ui/user_actions_dropdown"),StringUtils=require("app/utils/string"),userDomDataUtil=require("app/utils/user_dom_data");module.exports=withUserActions
});
define("app/ui/with_dynamic_stylesheet",["module","require","exports"],function(module, require, exports) {
function withDynamicStylesheet(){this.createStyleSheet=function(a){var b=document.createElement("style");return b.type="text/css",a&&(b.id=a),document.getElementsByTagName("head")[0].appendChild(b),b.sheet||new ShimStyleSheet},this.rules=function(a){return a.cssRules?a.cssRules:a.rules},this.insertCSSRule=function(a,b){return a.insertRule(b,this.rules(a).length)},this.removeCSSRule=function(a,b){a.deleteRule(b)}}module.exports=withDynamicStylesheet;var ShimStyleSheet=function(){function a(){this.cssRules=[]}return a.prototype.insertRule=function(a,b){return this.cssRules[b]={cssText:a},b},a.prototype.deleteRule=function(a){delete this.cssRules[a],this.cssRules=this.cssRules.filter(function(a){a!=null})},a}()
});
define("app/ui/direct_message_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/with_timestamp_updating","app/utils/string","app/ui/with_item_actions","app/ui/with_tweetbox_initialization","app/ui/with_user_actions","app/ui/with_dynamic_stylesheet"],function(module, require, exports) {
function directMessageDialog(){this.defaultAttrs({itemType:"user",dialogSelector:"#dm_dialog",classConversationList:"dm-conversation-list",classConversation:"dm-conversation",classNew:"dm-new",classViewParticipants:"dm-view-participants",viewConversationList:"#dm_dialog_conversation_list",viewConversation:"#dm_dialog_conversation",viewNew:"#dm_dialog_new",viewConversationParticipants:"#dm_dialog_view_participants",linksForConversationListView:"#dm_dialog_new h3 a, #dm_dialog_conversation h3 a, #dm_dialog_view_participants h3 a",linksForConversationView:".dm-thread-item, .dm-view-participants-done",linksForNewView:".dm-new-button",contentSelector:".twttr-dialog-content",tweetBoxSelector:".dm-tweetbox",toFieldSelector:".dm-to-input",autocompleteImage:"img.selected-profile",autocompleteInput:"input.twttr-directmessage-input",newConversationEditor:"#tweet-box-dm-new-conversation",conversationActionsSelector:".dm-conversation-actions",viewParticipantsDoneSelector:".dm-view-participants-done",errorContainerSelector:".js-dm-error",errorTextSelector:".dm-error-text",errorCloseSelector:".js-dismiss",errorReloadSelector:".js-reload",markAllReadSelector:".mark-all-read",markReadConfirmSelector:".mark-read-confirm .js-prompt-ok",markReadCancelSelector:".mark-read-confirm .js-prompt-cancel",mediaPreviewSelector:".media-thumb"}),this.generateConversationId=function(a,b){if(this.attr.deciders&&this.attr.deciders.dm_convo&&a&&b){var c=[a,b];return(StringUtils.compare(c[0],c[1])<0?c:c.reverse()).join("-")}},this.openDialog=function(a,b){b&&b.fromInitData&&this.on("uiDialogClosed",function(){this.isDialogNavigation||this.trigger("uiNavigate",{href:"/"})}),this.trigger("dataRefreshDMs"),b&&b.screen_name?this.renderConversationView(null,b):this.renderConversationListView(),this.open()},this.before("openDialog",function(a,b){if(b&&b.id){var c=this.generateConversationId(this.attr.userId,b.id);c&&(b.conversation_id=c)}}),this.renderConversationListView=function(a,b){a&&a.preventDefault(),this.renderView(this.attr.classConversationList);var c=this.select("viewConversationList");if(c.hasClass("needs-refresh")){c.removeClass("needs-refresh"),this.trigger("uiNeedsDMConversationList",{since_id:0});return}this.trigger("uiDMDialogOpenedConversationList")},this.renderConversationView=function(a,b){if(a){var c=$(a.target);if(this.isProfileLink(c)){this.isDialogNavigation=!0,this.closeImmediately();return}if(c.hasClass("media-thumb"))return}this.trigger("uiDMDialogClearActions"),a&&a.preventDefault();var b=b||{},d=b.screen_name||$(b.el).attr("data-thread-id"),e=b.name||$(b.el).find(".fullname").html();this.lastMessageIdInConversation=$(b.el).attr("data-last-message-id"),this.isConversationUnread=!!$(b.el).find(".unread").length,this.$node.find(".dm_dialog_real_name").html(e),this.select("viewConversation").find(this.attr.contentSelector).empty(),b.preventDMBoxReset||this.renderView(this.attr.classConversation);var f=conversationCache[d]||{},g=f.data&&f.lastMessageId==this.lastMessageIdInConversation;g?this.updateConversation(null,f.data):this.trigger("uiNeedsDMConversation",{screen_name:d,conversation_id:b.conversation_id||d,fromInitData:b.fromInitData}),b.preventDMBoxReset||this.resetDMBox()},this.renderNewView=function(a,b){a&&a.preventDefault();var c=this.select("autocompleteImage").attr("data-default-img");this.renderView(this.attr.classNew),this.trigger("uiDMDialogOpenedNewConversation"),this.resetDMBox(),this.isOpen()||(this.trigger("dataRefreshDMs"),this.open()),this.select("autocompleteImage").attr("src",c),this.select("autocompleteInput").val("").focus(),b&&b.recipient&&this.selectAutocompleteUser(null,b.recipient)},this.renderViewParticipants=function(a,b){a&&a.preventDefault(),this.trigger("uiNeedsConversationParticipants",{conversation_id:b.conversation_id}),this.renderView(this.attr.classViewParticipants)},this.renderView=function(a){this.hideError(),this.markReadCancel(),this.$dialogContainer.removeClass(this.viewClasses).addClass(a),this.trigger(this.$dialog,"uiDialogContentChanged"),this.attr.eventData||(this.attr.eventData={});var b;switch(a){case this.attr.classNew:b="dm_new_conversation_dialog";break;case this.attr.classConversation:b="dm_existing_conversation_dialog";break;case this.attr.classConversationList:b="dm_conversation_list_dialog";break;case this.attr.classViewParticipants:b="dm_view_participants_dialog"}this.attr.eventData.scribeContext={component:b}},this.updateConversationList=function(a,b){var c=this.select("viewConversationList"),d=c.find("li");b.sourceEventData.since_id?d.filter(function(){return $.inArray($(this).attr("data-thread-id"),b.threads)>-1}).remove():d.remove();var e=b.html||"";c.find(this.attr.contentSelector+" ul").prepend(e);var f=c.find(".dm-no-messages");c.find("li").length==0?(f.addClass("show"),this.select("markAllReadSelector").addClass("disabled").attr("disabled",!0)):(f.removeClass("show"),this.select("markAllReadSelector").removeClass("disabled").attr("disabled",!1)),this.trigger("uiResetDMPoll"),this.latestMessageId=b.last_message_id||-1},this.updateViewParticipants=function(a,b){a&&a.preventDefault(),this.$dialogContainer.hasClass(this.attr.classViewParticipants)||this.renderViewParticipants(null,b);var c=this.select("viewConversationParticipants").find(this.attr.contentSelector);c.html(b.html),this.select("viewParticipantsDoneSelector").attr("data-thread-id",b.conversation_id),this.trigger("uiDMDialogOpenedViewParticipants")},this.updateConversation=function(a,b){a&&a.preventDefault();var c=a&&a.type,d=b.recipient.screen_name,e=(conversationCache[d]||{}).forceRetryMarkAsRead;conversationCache[d]={data:b,lastMessageId:-1,forceRetryMarkAsRead:!!e},this.$node.find(".dm_dialog_real_name").html(b.recipient&&b.recipient.name),b.conversation_actions&&this.select("conversationActionsSelector").html(b.conversation_actions.html),this.$dialogContainer.hasClass(this.attr.classConversation)||this.renderConversationView(null,{screen_name:d,conversation_id:b.conversation_id||d,name:b.recipient.name});var f=this.select("viewConversation").find(this.attr.contentSelector);f.html(b.html),b.sourceEventData&&b.sourceEventData.fromInitData&&this.resetDMBox(),this.trigger("uiResetDMPoll");if(b.is_oto&&b.is_empty){c==="dataDMDeleteSuccess"?(this.trigger("dataRefreshDMs"),this.renderConversationListView()):this.trigger("uiOpenNewDM",{recipient:b.recipient});return}this.trigger("uiDMDialogOpenedConversation",{recipient:d});var g=f.find(".dm-convo");if(g.length){var h=g.find(".dm").last().attr("data-message-id");conversationCache[d].lastMessageId=h;if(conversationCache[d].forceRetryMarkAsRead||c=="dataDMConversationResult"&&(!b.sourceEventData||!b.sourceEventData.msgAction))conversationCache[d].forceRetryMarkAsRead=!1,g.find(".dm[data-unread=true]").length&&(conversationCache[d].forceRetryMarkAsRead=e=!0),this.initMsgRead({messageId:h,recipientId:b.recipient.id_str,recipientName:d},e);g.scrollTop(g[0].scrollHeight)}},this.refreshConversation=function(a,b){var c=b&&b.id_str||this.select("viewConversation").find(".dm-convo .dm:last").attr("data-message-id"),d=b.tweetboxId||b.sourceEventData&&b.sourceEventData.tweetboxId,e=b.recipient&&b.recipient.screen_name;this.$dialogContainer.hasClass(this.attr.classConversation)&&(e=this.select("viewConversation").find(".dm-convo").attr("data-thread-id"));var f={screen_name:e,conversation_id:b.conversation_id||e,tweetboxId:d,msgAction:a.type=="dataDMSendSuccess"?"Send":"Delete",lastMsgId:c};typeof b.html!="undefined"?(this.updateConversation(a,b),this.retryRefresh<3&&b.sourceEventData&&b.sourceEventData.lastMsgId==this.select("viewConversation").find(".dm-convo .dm:last").attr("data-message-id")?(this.retryRefresh++,this.trigger("uiNeedsDMConversation",f)):this.trigger("dataDMSuccess",b)):(this.retryRefresh=0,this.trigger("uiNeedsDMConversation",f))},this.initMsgRead=function(a,b){var c=this.lastMessageIdInConversation&&StringUtils.compare(this.lastMessageIdInConversation,a.messageId)==-1;if(b||this.isConversationUnread||c)this.markMessages(null,a),this.select("viewConversationList").find(".dm-thread-item[data-last-message-id="+a.messageId+"] .dm-thread.unread").removeClass("unread"),this.unreadCount-=this.select("viewConversation").find(".js-dm-item[data-unread=true]").length,this.trigger("uiReadStateChanged",{msgCount:this.unreadCount})},this.sendMessage=function(a,b){var c=this.$dialogContainer.hasClass(this.attr.classConversation),d,e=b.recipient;if(!e&&c){e=this.select("viewConversation").find("div[data-thread-id]").attr("data-thread-id");if(!e){setTimeout(function(){this.sendMessage(a,b)}.bind(this),100);return}}else e||(e="",d=this.select("viewNew").find("input[type=text]").val().trim());var f={tweetboxId:b.tweetboxId,screen_name:(d||"").replace(/^@/,""),conversation_id:e,text:b.tweetData.status};c&&(this.retryRefresh=0,f.lastMsgId=this.select("viewConversation").find(".dm-convo .dm:last").attr("data-message-id")),b.media_id&&(f.media_id=b.media_id),this.trigger("uiDMDialogSendMessage",f),this.resetDMBox(),this.select("viewConversationList").addClass("needs-refresh")},this.selectAutocompleteUser=function(a,b){var c=b.item?b.item.id:b.id,d=b.item?b.item.screen_name:b.screen_name,e=b.conversation_id||d,f=b.item?b.item.name:b.name,g=this.select("viewConversationList").find("li[data-thread-id="+e+"]").length;g?this.renderConversationView(null,{conversation_id:e,id:c,screen_name:d,name:f}):(this.select("autocompleteInput").val(d),this.select("autocompleteImage").attr("src",this.getUserAvatar(b.item?b.item:b)),this.select("newConversationEditor").focus())},this.before("selectAutocompleteUser",function(a,b){var c=this.generateConversationId(this.attr.userId,b.item?b.item.id:b.id);c&&(b.conversation_id=c)}),this.getUserAvatar=function(a){return a.profile_image_url_https?a.profile_image_url_https.replace(/^https?:/,"").replace(/_normal(\..*)?$/i,"_mini$1"):null},this.markMessages=function(a,b){this.trigger("dataMarkDMsAsRead",{last_message_id:b.messageId||this.latestMessageId,recipient_id:b.recipientId,recipient_name:b.recipientName})},this.markAllMessages=function(a,b){this.markMessages(a,b),this.trigger("uiDMDialogMarkMessage"),this.trigger("uiReadStateChanged",{msgCount:0})},this.updateReadState=function(a,b){(!b||b.text!="success")&&this.handleReadStateFailure(a,b),this.select("viewConversationList").addClass("needs-refresh"),this.$dialogContainer.hasClass(this.attr.classConversationList)&&this.openDialog()},this.handleReadStateFailure=function(a,b){b&&b.sourceEventData&&b.sourceEventData.recipient_name&&(conversationCache[b.sourceEventData.recipient_name].forceRetryMarkAsRead=!0)},this.refreshDMList=function(a,b){b&&b.d&&b.d.status==="ok"&&b.d.response!=null&&(this.unreadCount!=b.d.response&&this.$dialogContainer.is(":visible")&&(this.$dialogContainer.hasClass(this.attr.classConversationList)?this.trigger("dataRefreshDMs"):this.$dialogContainer.hasClass(this.attr.classConversation)&&this.$dialogContainer.find(".dm-convo").length&&(this.lastMessageIdInConversation=-1,this.renderConversationView(null,{screen_name:this.$dialogContainer.find(".dm-convo").attr("data-thread-id"),name:this.$dialogContainer.find(".dm_dialog_real_name").html(),preventDMBoxReset:!0}))),this.unreadCount=b.d.response)},this.showMarkReadConfirm=function(a,b){a&&a.preventDefault();if(this.select("markAllReadSelector").hasClass("disabled"))return;this.select("viewConversationList").addClass("show-mark-read"),this.trigger(this.$dialog,"uiDialogContentChanged")},this.markReadCancel=function(a,b){this.select("viewConversationList").removeClass("show-mark-read"),this.trigger(this.$dialog,"uiDialogContentChanged")},this.showError=function(a,b){this.select("errorTextSelector").html(b.message||b.error),this.select("errorContainerSelector").show(),this.trigger(this.select("toFieldSelector"),"uiTypeaheadIgnoreNextFocus"),this.trigger(this.$dialog,"uiDialogContentChanged")},this.hideError=function(a,b){this.select("errorContainerSelector").hide()},this.resetDMBox=function(){this.select("tweetBoxSelector").trigger("uiDMBoxReset")},this.isProfileLink=function(a){return!!a.closest("a.js-user-profile-link").length},this.checkForInput=function(a){if(!$(a.target).val()){var b=this.select("autocompleteImage");b.attr("src",b.attr("data-default-img"))}},this.previewMedia=function(a,b){a.preventDefault();var c=$(a.target);this.trigger("uiDMDialogMediaPreview",{imgUrl:c.attr("data-full-img"),dmId:c.closest(".dm").attr("data-message-id")||c.closest(".dm-thread-item").attr("data-last-message-id")}),this.$dialogContainer.hide(),this.openState=!1},this.showDMDialog=function(a,b){this.$dialogContainer.show(),this.openState=!0},this.restoreDialog=function(){this.isDialogNavigation&&(this.isDialogNavigation=!1,this.openDialog())},this.dismissErrors=function(){this.trigger("uiHideMessage")},this.refreshPageHandler=function(){this.refreshPage()},this.refreshPage=function(){window.location.reload()},this.deleteConversation=function(a,b){this.deletedConversations=this.deletedConversations||{};var c=".dm-thread-item[data-thread-id='"+b.conversation_id+"'] {display: none !important;}";this.deletedConversations[b.conversation_id]=this.insertCSSRule(this.stylesheet,c)},this.deleteConversationFailure=function(a,b){this.deletedConversations=this.deletedConversations||{};var c=this.deletedConversations[b.conversation_id];c!=null&&this.removeCSSRule(this.stylesheet,c)},this.after("initialize",function(){this.$dialogContainer=this.select("dialogSelector"),this.viewClasses=[this.attr.classConversationList,this.attr.classConversation,this.attr.classNew,this.attr.classViewParticipants].join(" "),this.on(document,"uiNeedsDMDialog",this.openDialog),this.on(document,"uiOpenNewDM",this.renderNewView),this.on(document,"uiViewParticipants",this.renderViewParticipants),this.on(document,"dataDMConversationListResult",this.updateConversationList),this.on(document,"dataDMConversationResult",this.updateConversation),this.on(document,"dataConversationParticipantsResult",this.updateViewParticipants),this.on(document,"dataDMSendSuccess dataDMDeleteSuccess",this.refreshConversation),this.on(document,"uiSendDM dataDMMediaUploadSuccess",this.sendMessage),this.on(document,"dataDMError",this.showError),this.on("uiTypeaheadItemSelected uiTypeaheadItemComplete",this.selectAutocompleteUser),this.on(document,"dataDMReadSuccess",this.updateReadState),this.on(document,"dataDMReadError",this.handleReadStateFailure),this.on(document,"dataNotificationsReceived",this.refreshDMList),this.on(document,"uiDMDialogMediaPreviewClosed",this.showDMDialog),this.on(document,"uiCloseProfilePopup",this.restoreDialog),this.stylesheet=this.createStyleSheet("deleted-direct-messages"),this.on(document,"uiDeleteConversation","uiNeedsDMDialog"),this.on(document,"uiDeleteConversation",this.deleteConversation),this.on(document,"dataConversationDeleteFailed",this.deleteConversationFailure),this.on("uiDialogClosed",this.dismissErrors),this.on("click",{linksForConversationListView:this.renderConversationListView,linksForConversationView:this.renderConversationView,linksForNewView:this.renderNewView,errorCloseSelector:this.hideError,errorReloadSelector:this.refreshPageHandler,markAllReadSelector:this.showMarkReadConfirm,markReadConfirmSelector:this.markAllMessages,markReadCancelSelector:this.markReadCancel,mediaPreviewSelector:this.previewMedia}),this.on("keyup",{autocompleteInput:this.checkForInput}),this.unreadCount=0})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withTimestampUpdating=require("app/ui/with_timestamp_updating"),StringUtils=require("app/utils/string"),withItemActions=require("app/ui/with_item_actions"),withTweetboxInitialization=require("app/ui/with_tweetbox_initialization"),withUserActions=require("app/ui/with_user_actions"),withDynamicStylesheet=require("app/ui/with_dynamic_stylesheet"),DirectMessageDialog=defineComponent(directMessageDialog,withDialog,withTimestampUpdating,withItemActions,withTweetboxInitialization,withDynamicStylesheet,withUserActions),conversationCache={};module.exports=DirectMessageDialog
});
define("app/utils/image/image_resizer",["module","require","exports"],function(module, require, exports) {
var imageResizer=function(){var a=300,b=520,c=50;return{galleryWidth:function(a,b){var d=$(window).width()-2*c,e=Math.min(d,a.width());return Math.max(b.width(),e)},resetMinSize:function(c){this.galW=b,this.galH=a,c.width(this.galW),c.css("min-height",this.galH)},resizeMedia:function(a,b,d,e,f){var g=b.find(e).add(b.find(".modal-header")).map(function(){return $(this).outerHeight()}).get().reduce(function(a,b){return a+b}),h=$(window).height()-2*c,i=$(window).width()-2*c,j=this.galH,k=this.galW,l=h-g,m=i,n=a.height(),o=a.width();d&&(o+=130,n+=100),n>l&&(o=Math.ceil(o*(l/n)),n=l,a.width(o).height(n)),o>m&&(o=m,n=Math.ceil(n*(m/o)),a.width(o).height(n));var p=b.find(".GalleryNav").hasClass("enabled");if(!p||o>this.galW)this.galW=o,b.width(this.galW);n+g>this.galH?(this.galH=n+g,b.css("min-height",this.galH),a.css("margin-top",0)):f?b.css("min-height",0):(a.css("margin-top",(this.galH-g-n)/2),a.css("margin-bottom",(this.galH-g-n)/2))}}}();module.exports=imageResizer
});
define("app/ui/direct_message_media_preview",["module","require","exports","core/component","app/ui/with_dialog","app/ui/with_scrollbar_width","app/utils/image/image_resizer"],function(module, require, exports) {
function directMessageMediaPreview(){this.defaultAttrs({dmImagePreviewSelector:".dm-media-preview",dmPreviewSelector:".dm-media"}),this.loadImage=function(a,b){var c=$('<img class="dm-media-image"/>'),d=this.select("dmImagePreviewSelector");d.empty(),c.on("load",function(a){d.empty().append(c),c.attr({"data-height":c[0].height,"data-width":c[0].width}),imageResizer.resizeMedia(c,this.select("dmPreviewSelector")),this.position();var e=parseFloat(c.css("margin-top"));e&&c.css("margin-bottom",e),this.trigger("uiDMMediaLoaded",{url:c.attr("src"),id:b})}.bind(this)),c.on("error",function(a){this.trigger("uiDMMediaFailed",{url:c.attr("src"),id:b})}.bind(this)),c.attr("src",a)},this.openDialog=function(a,b){this.calculateScrollbarWidth(),imageResizer.resetMinSize(this.select("dmPreviewSelector")),this.loadImage(b.imgUrl,b.dmId),this.open()},this.renderConversation=function(a,b){this.trigger("uiDMDialogMediaPreviewClosed")},this.after("initialize",function(){this.on(document,"uiDMDialogMediaPreview",this.openDialog),this.on("uiDialogCloseRequested",this.renderConversation)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withScrollbarWidth=require("app/ui/with_scrollbar_width"),imageResizer=require("app/utils/image/image_resizer");module.exports=defineComponent(directMessageMediaPreview,withDialog,withScrollbarWidth)
});
define("app/ui/direct_message_actions",["module","require","exports","core/component","app/ui/with_dropdownmenu"],function(module, require, exports) {
function dmActionsDropdown(){this.defaultAttrs({itemType:"user",dialogSelector:"#dm_dialog",viewConversationList:"#dm_dialog_conversation_list",viewConversation:"#dm_dialog_conversation",tweetBoxSelector:".dm-tweetbox",deleteSelector:".dm-delete",deleteConfirmSelector:".dm-deleting .js-prompt-ok",deleteCancelSelector:".dm-deleting .js-prompt-cancel",reportSelector:".dm-report",spamSelector:".dm-spam",spamConfirmSelector:".dm-reporting-spam .js-prompt-ok",spamCancelSelector:".dm-reporting-spam .js-prompt-cancel",spamDialogSelector:".dm-spam-confirm",abuseSelector:".dm-abuse",abuseConfirmSelector:".dm-reporting-abuse .js-prompt-ok",abuseCancelSelector:".dm-reporting-abuse .js-prompt-cancel"}),this.deleteMessage=function(a,b){a.preventDefault(),this.clearActions(),this.select("tweetBoxSelector").addClass("dm-deleting"),$(a.target).closest(".dm").addClass("marked-for-deletion"),this.trigger(this.$dialog,"uiDialogContentChanged")},this.deleteConfirm=function(a,b){var c=this.select("viewConversation").find(".marked-for-deletion"),d=this.select("viewConversation").find("div[data-thread-id]").attr("data-thread-id");this.trigger("uiDMDialogDeleteMessage",{id:c.attr("data-message-id"),screen_name:d.replace(/^@/,"")}),this.select("viewConversationList").addClass("needs-refresh"),this.select("tweetBoxSelector").removeClass("dm-deleting")},this.deleteCancel=function(a,b){this.select("tweetBoxSelector").removeClass("dm-deleting"),this.select("viewConversation").find(".marked-for-deletion").removeClass("marked-for-deletion")},this.reportMenu=function(a,b){$(a.target).closest(".dm").addClass("active-menu")},this.reportMessage=function(a,b){this.trigger("uiForceDropdownClosed"),this.handleMenuClose(),this.clearActions();var c=$(a.target).hasClass("dm-spam")?"spam":"abuse";this.select("tweetBoxSelector").addClass("dm-reporting-"+c),$(a.target).closest(".dm").addClass("marked-for-"+c),this.trigger(this.$dialog,"uiDialogContentChanged")},this.reportConfirm=function(a,b){var c=this.select("viewConversation"),d=$(a.target).closest(this.attr.spamDialogSelector).length?"spam":"abuse";this.trigger("uiDMDialogReportDM",{id:c.find(".marked-for-"+d).attr("data-message-id"),screen_name:c.find(".dm-convo").attr("data-thread-id"),report_as:d}),this.select("viewConversationList").addClass("needs-refresh"),this.select("tweetBoxSelector").removeClass("dm-reporting-"+d)},this.reportCancel=function(a,b){this.select("tweetBoxSelector").removeClass("dm-reporting-spam").removeClass("dm-reporting-abuse"),this.select("viewConversation").find(".marked-for-spam").removeClass("marked-for-spam"),this.select("viewConversation").find(".marked-for-abuse").removeClass("marked-for-abuse")},this.handleMenuClose=function(a,b){var c=this.$node.find(".dm-convo .dm");c.length&&(c.removeClass("active-menu"),document.body.offsetHeight)},this.clearActions=function(a,b){this.deleteCancel(),this.reportCancel()},this.after("initialize",function(){this.$dialog=this.select("dialogSelector"),this.on(document,"uiDMDialogClearActions",this.clearActions),this.on(document,"uiDropdownCloseRequested",this.handleMenuClose),this.on("click",{deleteSelector:this.deleteMessage,deleteConfirmSelector:this.deleteConfirm,deleteCancelSelector:this.deleteCancel,reportSelector:this.reportMenu,spamSelector:this.reportMessage,abuseSelector:this.reportMessage,spamConfirmSelector:this.reportConfirm,spamCancelSelector:this.reportCancel,abuseConfirmSelector:this.reportConfirm,abuseCancelSelector:this.reportCancel})})}var defineComponent=require("core/component"),withDropdownMenu=require("app/ui/with_dropdownmenu"),DMActionsDropdown=defineComponent(dmActionsDropdown,withDropdownMenu);module.exports=DMActionsDropdown
});
define("app/ui/with_draft_tweets",["module","require","exports","app/utils/storage/custom"],function(module, require, exports) {
var customStorage=require("app/utils/storage/custom");module.exports=function(){this.defaultAttrs({draftTweetTTL:864e5}),this.getDraftTweet=function(){return this.attr.draftTweetId&&this.draftTweets().getItem(this.attr.draftTweetId)},this.hasDraftTweet=function(){return!!this.getDraftTweet()},this.loadDraftTweet=function(){var a=this.getDraftTweet();if(a)return this.val(a),!0},this.saveDraftTweet=function(a,b){if(this.attr.draftTweetId&&this.hasFocus()){var c=b.text.trim();!!this.attr.defaultText&&c===this.attr.defaultText.trim()||!!this.attr.condensedText&&c===this.attr.condensedText.trim()||!c?this.draftTweets().removeItem(this.attr.draftTweetId):this.draftTweets().setItem(this.attr.draftTweetId,c,this.attr.draftTweetTTL)}},this.clearDraftTweet=function(){this.attr.draftTweetId&&(this.draftTweets().removeItem(this.attr.draftTweetId),this.resetTweetText())},this.overrideDraftTweetId=function(a,b){this.attr.draftTweetId=b.draftTweetId,this.resetTweetText()},this.draftTweets=function(){if(!this.draftTweetsStore){var a=customStorage({withExpiry:!0});this.draftTweetsStore=new a("draft_tweets")}return this.draftTweetsStore},this.around("resetTweetText",function(a){this.loadDraftTweet()||a()}),this.initDraftTweets=function(){this.on("uiTextChanged",this.saveDraftTweet),this.on("ui{{type}}Sent",this.clearDraftTweet),this.attr.modal&&this.on(document,"uiOverride{{type}}BoxOptions",this.overrideDraftTweetId)}}
});
define("app/ui/with_rtl_tweet_box",["module","require","exports","lib/twitter-text","app/utils/caret"],function(module, require, exports) {
function replaceIndices(a,b,c){var d=0,e="";return b(a).forEach(function(b){e+=a.slice(d,b.indices[0])+c(a.slice(b.indices[0],b.indices[1])),d=b.indices[1]}),e+a.slice(d)}function withRTL(){this.defaultAttrs({isRTL:$("body").attr("dir")==="rtl",rtlCharRegex:/[\u0600-\u06FF]|[\u0750-\u077F]|[\u0590-\u05FF]|[\uFE70-\uFEFF]/gm,dirMarkRegex:/\u200e|\u200f/gm,rtlThreshold:.3}),this.shouldBeRTL=function(a,b,c){c===undefined&&(c=a.match(this.attr.rtlCharRegex));var d=a.trim();if(!d)return this.attr.isRTL;if(!c)return!1;var e=d.length-b;return e>0&&c.length/e>this.attr.rtlThreshold},this.removeMarkers=function(a){return a.replace(this.attr.dirMarkRegex,"")},this.setMarkersAndRTL=function(a,b){var c=b.match(this.attr.rtlCharRegex),d=0;if(c){a=b,a=replaceIndices(a,txt.extractMentionsWithIndices,function(a){return d+=a.length+1,"‎"+a+"‏"});var e=this.attr.rtlCharRegex;a=replaceIndices(a,txt.extractHashtagsWithIndices,function(a){return a[1].match(e)?a:"‎"+a}),a=replaceIndices(a,txt.extractUrlsWithIndices,function(a){return d+=a.length+2,a+"‎"})}var f=this.shouldBeRTL(b,d,c);return this.$text.attr("dir",f?"rtl":"ltr"),a},this.erasePastMarkers=function(a){if(a.which===8)var b=-1;else{if(a.which!==46)return;var b=0}var c=caret.getPosition(this.$text[0]),d=this.$text.val(),e=0;do{var f=d[c+b]||"";f&&(c+=b,e++,d=d.slice(0,c)+d.slice(c+1))}while(f.match(this.attr.dirMarkRegex));e>1&&(this.$text.val(d),caret.setPosition(this.$text[0],c),a.preventDefault(),this.detectUpdatedText())},this.cleanRtlText=function(a){var b=this.removeMarkers(a),c=this.setMarkersAndRTL(a,b);if(c!==a){var d=this.$text[0],e=caret.getPosition(d);this.$text.val(c),this.prevText=c,caret.setPosition(d,e+c.length-a.length)}return b},this.after("initTextNode",function(){this.on(this.$text,"keydown",this.erasePastMarkers)})}var txt=require("lib/twitter-text"),caret=require("app/utils/caret");module.exports=withRTL
});
define("app/ui/toolbar",["module","require","exports","core/component"],function(module, require, exports) {
function toolbar(){this.defaultAttrs({buttonsSelector:".btn:not([disabled])"}),this.current=-1,this.focusNext=function(a){var b=this.select("buttonsSelector");this.current==-1&&(this.current=$.inArray(document.activeElement,b));var c,d=this.current;switch(a.which){case 37:d--;break;case 39:d++}c=b[d],c&&(c.focus(),this.current=d)},this.clearCurrent=function(){this.current=-1},this.after("initialize",function(){this.$node.attr("role","toolbar"),this.on("keydown",{buttonsSelector:this.focusNext}),this.on("focusout",this.clearCurrent)})}var defineComponent=require("core/component"),Toolbar=defineComponent(toolbar);module.exports=Toolbar
});
define("app/utils/html_text",["module","require","exports"],function(module, require, exports) {
function isTextNode(a){return a.nodeType==3||a.nodeType==4}function isElementNode(a){return a.nodeType==1}function isBrNode(a){return isElementNode(a)&&a.nodeName.toLowerCase()=="br"}function isOutsideContainer(a,b){while(a!==b){if(!a)return!0;a=a.parentNode}}var useW3CRange=window.getSelection,useMsftTextRange=!useW3CRange&&document.selection,useIeHtmlFix=navigator.appName=="Microsoft Internet Explorer",NBSP_REGEX=/[\xa0\n\t]/g,CRLF_REGEX=/\r\n/g,LINES_REGEX=/(.*?)\n/g,SP_LEADING_OR_FOLLOWING_CLOSE_TAG_OR_PRECEDING_A_SP_REGEX=/^ |(<\/[^>]+>) | (?= )/g,SP_LEADING_OR_TRAILING_OR_FOLLOWING_A_SP_REGEX=/^ | $|( ) /g,MAX_OFFSET=Number.MAX_VALUE,htmlText=function(a,b){function c(a,c){function h(a){var i=d.length;if(isTextNode(a)){var j=a.nodeValue.replace(NBSP_REGEX," "),k=j.length;k&&(d+=j,e=!0),c(a,!0,0,i,i+k)}else if(isElementNode(a)){c(a,!1,0,i,i);if(isBrNode(a))a==f?g=!0:(d+="\n",e=!1);else{var l=a.currentStyle||window.getComputedStyle(a,""),m=l.display=="block";m&&b.msie&&(e=!0);for(var n=a.firstChild,o=1;n;n=n.nextSibling,o++){h(n);if(g)return;i=d.length,c(a,!1,o,i,i)}g||a==f?g=!0:m&&e&&(d+="\n",e=!1)}}}var d="",e,f,g;for(var i=a;i&&isElementNode(i);i=i.lastChild)f=i;return h(a),d}function d(a,b){var d=null,e=b.length-1;if(useW3CRange){var f=b.map(function(){return{}}),g;c(a,function(a,c,d,h,i){g||f.forEach(function(f,j){var k=b[j];h<=k&&!isBrNode(a)&&(f.node=a,f.offset=c?Math.min(k,i)-h:d,g=c&&j==e&&i>=k)})}),f[0].node&&f[e].node&&(d=document.createRange(),d.setStart(f[0].node,f[0].offset),d.setEnd(f[e].node,f[e].offset))}else if(useMsftTextRange){var h=document.body.createTextRange();h.moveToElementText(a),d=h.duplicate();if(b[0]==MAX_OFFSET)d.setEndPoint("StartToEnd",h);else{d.move("character",b[0]);var i=e&&b[1]-b[0];i>0&&d.moveEnd("character",i),h.inRange(d)||d.setEndPoint("EndToEnd",h)}}return d}function e(){return a.offsetWidth&&a.offsetHeight}function f(b){a.innerHTML=b;if(useIeHtmlFix)for(var c=a.firstChild;c;c=c.nextSibling)isElementNode(c)&&c.nodeName.toLowerCase()=="p"&&c.innerHTML==""&&(c.innerText="")}function g(a,b){return a.map(function(a){return Math.min(a,b.length)})}function h(){var b=getSelection();if(b.rangeCount!==1)return null;var d=b.getRangeAt(0);if(isOutsideContainer(d.commonAncestorContainer,a))return null;var e=[{node:d.startContainer,offset:d.startOffset}];d.collapsed||e.push({node:d.endContainer,offset:d.endOffset});var f=e.map(function(){return MAX_OFFSET}),h=c(a,function(a,b,c,d){e.forEach(function(e,g){f[g]==MAX_OFFSET&&a==e.node&&(b||c==e.offset)&&(f[g]=d+(b?e.offset:0))})});return g(f,h)}function i(){var b=document.selection.createRange();if(isOutsideContainer(b.parentElement(),a))return null;var d=["Start"];b.compareEndPoints("StartToEnd",b)&&d.push("End");var e=d.map(function(){return MAX_OFFSET}),f=document.body.createTextRange(),h=c(a,function(c,g,h,i){function j(a,c){if(e[c]<MAX_OFFSET)return;var d=f.compareEndPoints("StartTo"+a,b);if(d>0)return;var g=f.compareEndPoints("EndTo"+a,b);if(g<0)return;var h=f.duplicate();h.setEndPoint("EndTo"+a,b),e[c]=i+h.text.length,c&&!g&&e[c]++}!g&&!h&&c!=a&&(f.moveToElementText(c),d.forEach(j))});return g(e,h)}return{getHtml:function(){if(useIeHtmlFix){var b="",c=document.createElement("div");for(var d=a.firstChild;d;d=d.nextSibling)isTextNode(d)?(c.innerText=d.nodeValue,b+=c.innerHTML):b+=d.outerHTML.replace(CRLF_REGEX,"");return b}return a.innerHTML},setHtml:function(a){f(a)},getText:function(){return c(a,function(){})},setTextWithMarkup:function(a){f((a+"\n").replace(LINES_REGEX,function(a,c){return b.mozilla||b.msie?(c=c.replace(SP_LEADING_OR_FOLLOWING_CLOSE_TAG_OR_PRECEDING_A_SP_REGEX,"$1&nbsp;"),b.mozilla?c+"<BR>":"<P>"+c+"</P>"):(c=(c||"<br>").replace(SP_LEADING_OR_TRAILING_OR_FOLLOWING_A_SP_REGEX,"$1&nbsp;"),b.opera?"<p>"+c+"</p>":"<div>"+c+"</div>")}))},getSelectionOffsets:function(){var a=null;return e()&&(useW3CRange?a=h():useMsftTextRange&&(a=i())),a},setSelectionOffsets:function(b){if(b&&e()){var c=d(a,b);if(c)if(useW3CRange){var f=window.getSelection();f.removeAllRanges(),f.addRange(c)}else useMsftTextRange&&c.select()}},emphasizeText:function(b){var f=[];b&&b.length>1&&e()&&(c(a,function(a,c,d,e,g){if(c){var h=Math.max(e,b[0]),i=Math.min(g,b[1]);i>h&&f.push([h,i])}}),f.forEach(function(b){var c=d(a,b);c&&(useW3CRange?c.surroundContents(document.createElement("em")):useMsftTextRange&&c.execCommand("italic",!1,null))}))}}};module.exports=htmlText
});
define("app/ui/with_rich_editor",["module","require","exports","app/utils/tweet_helper","lib/twitter-text","app/utils/html_text"],function(module, require, exports) {
function withRichEditor(){this.defaultAttrs({richSelector:"div.rich-editor",linksSelector:"a",normalizerSelector:"div.rich-normalizer",immediatelyParseTweetText:!1}),this.linkify=function(a){var b={urlTarget:null,textWithSymbolTag:RENDER_URLS_AS_PRETTY_LINKS?"b":"",linkAttributeBlock:function(a,b){var c=a.screenName||a.url;c&&(this.urlAndMentionsCharCount+=c.length+2),delete b.title,delete b["data-screen-name"],b.dir=a.hashtag&&this.shouldBeRTL(a.hashtag,0)?"rtl":"ltr",b.role="presentation"}.bind(this)};return this.urlAndMentionsCharCount=0,tweetHelper.linkify(a,b)},this.around("setSelection",function(a,b){if(!this.isRich)return a(b);b&&this.setSelectionIfFocused(b)}),this.around("setCursorPosition",function(a,b){if(!this.isRich)return a(b);b===undefined&&(b=this.attr.cursorPosition),b===undefined&&(b=MAX_OFFSET),this.setSelectionIfFocused([b])}),this.around("detectUpdatedText",function(a,b,c){if(!this.isRich)return a(b,c);var d=this.htmlRich.getHtml(),e=this.htmlRich.getSelectionOffsets()||[MAX_OFFSET],f=c!==undefined;if(d===this.prevHtml&&e[0]===this.prevSelectionOffset&&!b&&!f)return;var g=f?c:this.htmlRich.getText(),h=g.replace(INVALID_CHARS_REGEX,"");(f||!this.$text.attr("data-in-composition"))&&this.reformatHtml(h,d,e,f);if(b||this.cleanedText!=h||this.prevSelectionOffset!=e[0])this.prevSelectionOffset=e[0],this.updateCleanedTextAndOffset(h,e[0])}),this.reformatHtml=function(a,b,c,d){this.htmlNormalizer.setTextWithMarkup(this.linkify(a));var e=this.shouldBeRTL(a,this.urlAndMentionsCharCount);this.$text.attr("dir",e?"rtl":"ltr"),this.$normalizer.find(e?"[dir=rtl]":"[dir=ltr]").removeAttr("dir"),RENDER_URLS_AS_PRETTY_LINKS&&this.$normalizer.find(".twitter-timeline-link").wrapInner("<b>").addClass("pretty-link");var f=this.getMaxLengthOffset(a);f>=0&&(this.htmlNormalizer.emphasizeText([f,MAX_OFFSET]),this.$normalizer.find("em").each(function(){this.innerHTML=this.innerHTML.replace(TRAILING_SINGLE_SPACE_REGEX," ")}));var g=this.htmlNormalizer.getHtml();if(g!==b){var h=d&&!this.isFocusing&&this.hasFocus();h&&this.$text.addClass("fake-focus").blur(),this.htmlRich.setHtml(g),h&&this.$text.focus().removeClass("fake-focus"),this.setSelectionIfFocused(c)}this.prevHtml=g},this.getMaxLengthOffset=function(a){var b=this.getLength(a),c=this.attr.maxLength;if(b<=c)return-1;c+=twitterText.getUnicodeTextLength(a)-b;var d=[{indices:[c,c]}];return twitterText.modifyIndicesFromUnicodeToUTF16(a,d),d[0].indices[0]},this.setSelectionIfFocused=function(a){this.hasFocus()&&this.htmlRich.setSelectionOffsets(a)},this.selectPrevCharOnBackspace=function(a){if(a.which==8&&!a.ctrlKey){var b=this.htmlRich.getSelectionOffsets();b&&b[0]!=MAX_OFFSET&&b.length==1&&(b[0]?this.setSelectionIfFocused([b[0]-1,b[0]]):this.stopEvent(a))}},this.emulateCommandArrow=function(a){if(a.metaKey&&!a.shiftKey&&(a.which==37||a.which==39)){var b=a.which==37;this.htmlRich.setSelectionOffsets([b?0:MAX_OFFSET]),this.$text.scrollTop(b?0:this.$text[0].scrollHeight),this.stopEvent(a)}},this.stopEvent=function(a){a.preventDefault(),a.stopPropagation()},this.saveUndoStateDeferred=function(a){a.type!="focusin"&&this.saveUndoState(),setTimeout(function(){this.detectUpdatedText(),this.saveUndoState()}.bind(this),0)},this.saveEmptyUndoState=function(){this.undoHistory=[["",[0]]],this.undoIndex=0},this.saveUndoState=function(){if(this.condensed)return;var a=this.htmlRich.getText(),b=this.htmlRich.getSelectionOffsets()||[a.length],c=this.undoHistory,d=c[this.undoIndex];(!d||d[0]!==a)&&c.splice(++this.undoIndex,c.length,[a,b])},this.isUndoKey=function(a){return this.isMac?a.which==90&&a.metaKey&&!a.shiftKey&&!a.ctrlKey&&!a.altKey:a.which==90&&a.ctrlKey&&!a.shiftKey&&!a.altKey},this.emulateUndo=function(a){this.isUndoKey(a)&&(this.stopEvent(a),this.saveUndoState(),this.undoIndex>0&&this.setUndoState(this.undoHistory[--this.undoIndex]))},this.isRedoKey=function(a){return this.isMac?a.which==90&&a.metaKey&&a.shiftKey&&!a.ctrlKey&&!a.altKey:this.isWin?a.which==89&&a.ctrlKey&&!a.shiftKey&&!a.altKey:a.which==90&&a.shiftKey&&a.ctrlKey&&!a.altKey},this.emulateRedo=function(a){var b=this.undoHistory,c=this.undoIndex;c<b.length-1&&this.htmlRich.getText()!==b[c][0]&&b.splice(c+1,b.length),this.isRedoKey(a)&&(this.stopEvent(a),c<b.length-1&&this.setUndoState(b[++this.undoIndex]))},this.setUndoState=function(a){this.detectUpdatedText(!1,a[0]),this.htmlRich.setSelectionOffsets(a[1]),this.trigger("uiHideAutocomplete")},this.handleKeyDown=function(a){$.browser.msie&&this.selectPrevCharOnBackspace(a),$.browser.mozilla&&this.emulateCommandArrow(a),this.emulateUndo(a),this.emulateRedo(a)},this.interceptPaste=function(a){if(a.originalEvent&&a.originalEvent.clipboardData){var b=a.originalEvent.clipboardData;(this.interceptImagePaste(b)||this.interceptTextPaste(b))&&a.preventDefault()}},this.interceptImagePaste=function(a){if(a.items&&a.items.length===1&&a.items[0].kind==="file"&&a.items[0].type.indexOf("image/")===0){var b=new FileReader;b.onload=function(a){var b=a.target.result;this.trigger("uiGotImageData",{name:"pasted",contents:b})}.bind(this);var c=a.items[0].getAsFile();return b.readAsDataURL(c),!0}return!1},this.interceptTextPaste=function(a){var b=a.getData("text");return b&&document.execCommand("insertHTML",!1,$("<div>").text(b).html().replace(LINE_FEEDS_REGEX,"<br>"))?!0:!1},this.setTypeaheadItemSelected=function(){this.typeaheadItemSelected=!0},this.clearSelectionOnBlur=function(){window.getSelection&&(this.previousSelection=this.htmlRich.getSelectionOffsets(),this.previousSelection&&getSelection().removeAllRanges())},this.restoreSelectionOnFocus=function(){this.previousSelection&&!this.typeaheadItemSelected?setTimeout(function(){this.htmlRich.setSelectionOffsets(this.previousSelection),this.previousSelection=null}.bind(this),0):(this.previousSelection=null,this.typeaheadItemSelected=!1)},this.setFocusingState=function(){this.isFocusing=!0,setTimeout(function(){this.isFocusing=!1}.bind(this),0)},this.around("initTextNode",function(a){this.$text=this.select("richSelector");if(!this.$text.length)return a();this.isRich=!0,this.undoIndex=-1,this.undoHistory=[],this.htmlRich=htmlText(this.$text[0],$.browser),this.$text.toggleClass("notie",!$.browser.msie),this.$normalizer=this.select("normalizerSelector"),this.htmlNormalizer=htmlText(this.$normalizer[0],$.browser);var b=navigator.platform;this.isMac=b.indexOf("Mac")!=-1,this.isWin=b.indexOf("Win")!=-1,this.on(this.$text,"click",{linksSelector:this.stopEvent}),this.on(this.$text,"focusin",this.setFocusingState),this.on(this.$text,"keydown",this.handleKeyDown),this.on(this.$text,"cut paste drop focusin",this.ignoreDuringFakeFocus(this.saveUndoStateDeferred)),this.on(this.$text,"paste",this.interceptPaste),this.on(this.$text,"focusout",this.ignoreDuringFakeFocus(this.clearSelectionOnBlur)),this.on(this.$text,"focusin",this.ignoreDuringFakeFocus(this.restoreSelectionOnFocus)),this.on("uiTypeaheadItemSelected",this.setTypeaheadItemSelected),this.attr.immediatelyParseTweetText&&this.detectUpdatedText()})}var tweetHelper=require("app/utils/tweet_helper"),twitterText=require("lib/twitter-text"),htmlText=require("app/utils/html_text");module.exports=withRichEditor;var INVALID_CHARS_REGEX=/[\uFFFE\uFEFF\uFFFF\u200E\u200F\u202A-\u202E\x00-\x09\x0B\x0C\x0E-\x1F]/g,RENDER_URLS_AS_PRETTY_LINKS=$.browser.mozilla&&parseInt($.browser.version,10)<2,TRAILING_SINGLE_SPACE_REGEX=/ $/,LINE_FEEDS_REGEX=/\r\n|\n\r|\n/g,MAX_OFFSET=Number.MAX_VALUE
});
define("app/ui/with_upload_photo_affordance",["module","require","exports"],function(module, require, exports) {
function uploadPhotoAffordance(){this.defaultAttrs({uploadPhotoHoverClass:"upload-photo-hover"}),this.uploadPhotoHoverOn=function(){this.$node.addClass(this.attr.uploadPhotoHoverClass)},this.uploadPhotoHoverOff=function(){this.$node.removeClass(this.attr.uploadPhotoHoverClass)},this.after("initialize",function(){this.attr.dmOnly||(this.attr.uploadPhotoSelector=this.attr.uploadPhotoSelector||".upload-photo",this.on("mouseover",{uploadPhotoSelector:this.uploadPhotoHoverOn}),this.on(document,"uiDragEnter",this.uploadPhotoHoverOff),this.on("mouseout",{uploadPhotoSelector:this.uploadPhotoHoverOff}),this.on("click",{uploadPhotoSelector:this.uploadPhotoHoverOff}))})}module.exports=uploadPhotoAffordance
});
deferred('$lib/jquery.swfobject.js', function() {
/*! jQuery SWFObject v1.1.1 MIT/GPL @jon_neal http://jquery.thewikies.com/swfobject */(function(a,b,c){function d(a,b){var c=(a[0]||0)-(b[0]||0);return c>0||!c&&a.length>0&&d(a.slice(1),b.slice(1))}function e(a){if(typeof a!=h)return a;var b=[],c="";for(var d in a)c=typeof a[d]==h?e(a[d]):[d,i?encodeURI(a[d]):a[d]].join("="),b.push(c);return b.join("&")}function f(a){var b=[];for(var c in a)a[c]&&b.push([c,'="',a[c],'"'].join(""));return b.join(" ")}function g(a){var b=[];for(var c in a)b.push(['<param name="',c,'" value="',e(a[c]),'" />'].join(""));return b.join("")}var h="object",i=!0;try{var j=c.description||function(){return(new c("ShockwaveFlash.ShockwaveFlash")).GetVariable("$version")}()}catch(k){j="Unavailable"}var l=j.match(/\d+/g)||[0];a[b]={available:l[0]>0,activeX:c&&!c.name,version:{original:j,array:l,string:l.join("."),major:parseInt(l[0],10)||0,minor:parseInt(l[1],10)||0,release:parseInt(l[2],10)||0},hasVersion:function(a){return a=/string|number/.test(typeof a)?a.toString().split("."):/object/.test(typeof a)?[a.major,a.minor]:a||[0,0],d(l,a)},encodeParams:!0,expressInstall:"expressInstall.swf",expressInstallIsActive:!1,create:function(a){if(!a.swf||this.expressInstallIsActive||!this.available&&!a.hasVersionFail)return!1;if(!this.hasVersion(a.hasVersion||1)){this.expressInstallIsActive=!0;if(typeof a.hasVersionFail=="function"&&!a.hasVersionFail.apply(a))return!1;a={swf:a.expressInstall||this.expressInstall,height:137,width:214,flashvars:{MMredirectURL:location.href,MMplayerType:this.activeX?"ActiveX":"PlugIn",MMdoctitle:document.title.slice(0,47)+" - Flash Player Installation"}}}attrs={data:a.swf,type:"application/x-shockwave-flash",id:a.id||"flash_"+Math.floor(Math.random()*999999999),width:a.width||320,height:a.height||180,style:a.style||""},i=typeof a.useEncode!="undefined"?a.useEncode:this.encodeParams,a.movie=a.swf,a.wmode=a.wmode||"opaque",delete a.fallback,delete a.hasVersion,delete a.hasVersionFail,delete a.height,delete a.id,delete a.swf,delete a.useEncode,delete a.width;var b=document.createElement("div");return b.innerHTML=["<object ",f(attrs),">",g(a),"</object>"].join(""),b.firstChild}},a.fn[b]=function(c){var d=this.find(h).andSelf().filter(h);return/string|object/.test(typeof c)&&this.each(function(){var d=a(this),e;c=typeof c==h?c:{swf:c},c.fallback=this;if(e=a[b].create(c))d.children().remove(),d.html(e)}),typeof c=="function"&&d.each(function(){var d=this;d.jsInteractionTimeoutMs=d.jsInteractionTimeoutMs||0,d.jsInteractionTimeoutMs<660&&(d.clientWidth||d.clientHeight?c.call(d):setTimeout(function(){a(d)[b](c)},d.jsInteractionTimeoutMs+66))}),d}})(jQuery,"flash",navigator.plugins["Shockwave Flash"]||window.ActiveXObject)
});
define("app/utils/image",["module","require","exports","$lib/jquery.swfobject.js"],function(module, require, exports) {
require("$lib/jquery.swfobject.js");var image={photoHelperSwfPath:"/t1/flash/PhotoHelper.swf",photoSelectorSwfPath:"/t1/flash/PhotoSelector.swf",MAX_FILE_SIZE:5242880,validateFileName:function(a){return/(.*)\.(jpg|jpeg|png|gif)$/i.test(a)},validateImageSize:function(a,b){var c=a.size||a.fileSize,b=b||this.MAX_FILE_SIZE;return!c||c<=b},getFileName:function(a){if(a.indexOf("/")==-1&&a.indexOf("\\")==-1)return a;var b=a.match(/(?:.*)[\/\\]([^\/\\]+(?:\.\w+)?)$/);return b[1]},isAnimatedGif:function(a){return/(.*)\.gif$/i.test(a)},loadPhotoHelperSwf:function(a,b,c,d,e){return a.flash({swf:this.photoHelperSwfPath,height:d,width:e,wmode:"transparent",AllowScriptAccess:"sameDomain",flashvars:{callbackName:b,errorCallbackName:c}}),a.find("object")},loadPhotoSelectorSwf:function(a,b,c,d,e,f){return a.flash({swf:this.photoSelectorSwfPath,height:d,width:e,wmode:"transparent",AllowScriptAccess:"sameDomain",flashvars:{callbackName:b,errorCallbackName:c,buttonWidth:e,buttonHeight:d,maxSizeInBytes:f}}),a.find("object")},hasFlash:function(){try{return $.flash.available&&$.flash.hasVersion(10)}catch(a){return!1}},hasFileReader:function(){return typeof FileReader=="function"||typeof FileReader=="object"?!0:!1},hasCanvas:function(){var a=document.createElement("canvas");return!!a.getContext&&!!a.getContext("2d")},supportsCropper:function(){return this.hasCanvas()&&(this.hasFileReader()||this.hasFlash())},getFileHandle:function(a){return a.files&&a.files[0]?a.files[0]:!1},shouldUseFlash:function(){return!this.hasFileReader()&&this.hasFlash()},mode:function(){return this.hasFileReader()?"html5":this.hasFlash()?"flash":"html4"},getDataUri:function(a,b){var c="data:image/jpeg;base64,"+a;return b&&(c="url("+c+")"),c},getFileData:function(a,b,c){var d=new FileReader;d.onload=function(b){var d=b.target.result;c(a,d)},d.readAsDataURL(b)}};module.exports=image
});
define("app/utils/drag_drop_helper",["module","require","exports"],function(module, require, exports) {
var dragDropHelper={hasFiles:function(a){var b=(a.originalEvent||a).dataTransfer;return b&&(b.types.contains?b.types.contains("Files"):b.types.indexOf("Files")>=0)},onlyHandleEventsWithFiles:function(a){return function(b,c){if(dragDropHelper.hasFiles(b))return a.call(this,b,c)}}};module.exports=dragDropHelper
});
define("app/ui/with_drop_events",["module","require","exports","app/utils/image","app/utils/drag_drop_helper"],function(module, require, exports) {
function withDropEvents(){this.drop=function(a){a.preventDefault(),a.stopImmediatePropagation();var b=image.getFileHandle(a.originalEvent.dataTransfer);this.trigger("uiDrop",{file:b}),this.trigger("uiDragEnd")},this.after("initialize",function(){this.on("drop",dragDropHelper.onlyHandleEventsWithFiles(this.drop))})}var image=require("app/utils/image"),dragDropHelper=require("app/utils/drag_drop_helper");module.exports=withDropEvents
});
define("app/ui/with_droppable_image",["module","require","exports","core/compose","app/ui/with_drop_events","app/utils/image"],function(module, require, exports) {
function withDroppableImage(){compose.mixin(this,[withDropEvents]),this.triggerGotImageData=function(a,b){this.trigger("uiGotImageData",{name:a,contents:b})},this.captureImageData=function(a,b){var c=b.file;image.getFileData(c.name,c,this.triggerGotImageData.bind(this))},this.after("initialize",function(){this.on("uiDrop",this.captureImageData)})}var compose=require("core/compose"),withDropEvents=require("app/ui/with_drop_events"),image=require("app/utils/image");module.exports=withDroppableImage
});
define("app/ui/select_users",["module","require","exports","core/component","app/ui/typeahead/typeahead_input","app/utils/caret","app/ui/typeahead/typeahead_dropdown"],function(module, require, exports) {
function selectUsers(){this.defaultAttrs({openDropdownButtonSelector:".js-open-user-select",selectUsersContainerSelector:".user-select-container",typeaheadContainerSelector:".typeahead-container",dropdownSelector:".user-select-container.dropdown-menu",inputSelector:".user-select-controls input",itemSelector:".typeahead-item",maxSelection:10,includePreviouslySelectedUsers:!1,controlsSelector:".user-select-controls",userBorderColorClass:"u-borderUserColorLight",taggingClass:"photo-tagging-container",cannotSelectClass:"cannot-select"}),this.showSelectDropdown=function(a){this.previouslyFocused=document.activeElement,a.stopPropagation(),a.preventDefault(),this.$node.show(),this.$input.focus(),this.trigger("uiTypeaheadResultsShown")},this.hideSelectDropdown=function(a){if(a.target!=this.$node.get(0)&&!$.contains(this.$node.get(0),a.target)&&$(a.target).closest(this.attr.openDropdownButtonSelector).length==0){if(this.previouslyFocused&&a.type=="focusin"){var b=this.previouslyFocused;this.previouslyFocused=null,b.focus()}else this.previouslyFocused=null;this.forceHide()}},this.forceHide=function(a){this.$node.hide(),this.trigger("uiTypeaheadSetPreventDefault",{preventDefault:!1,key:9}),this.trigger("uiTypeaheadResultsHidden")},this.selectUser=function(a,b){var c=this.shouldUpdateUserList(a,b),d=this.selectedUserIndex(b.item.id);d==-1&&!c&&a.stopImmediatePropagation(),d==-1&&c?this.selectedUsers.push(b.item):d!=-1&&(this.selectedUsers.splice(d,1),c=!0),c?(this.$input.val(""),this.trigger(this.$input,"uiTextChanged",{text:this.$input.val(),position:caret.getPosition(this.$input[0])}),this.trigger("uiUpdatedSelectedUsers",{items:this.selectedUsers})):this.trigger("uiCouldNotSelectUser"),this.$input.focus()},this.shouldUpdateUserList=function(a,b){return!$(a.target).find("[data-user-id="+b.item.id+"]").hasClass(this.attr.cannotSelectClass)&&this.selectedUsers.length<this.attr.maxSelection},this.selectedUserIndex=function(a){for(var b=0;b<this.selectedUsers.length;b++)if(this.selectedUsers[b].id==a)return b;return-1},this.hideAndManageEsc=function(a){a.preventDefault(),a.stopPropagation(),this.forceHide()},this.resetComposer=function(){this.selectedUsers=[],this.$input.val(""),this.trigger("uiUpdatedSelectedUsers",{items:this.selectedUsers}),this.trigger(this.$input,"uiTextChanged",{text:this.$input.val(),position:caret.getPosition(this.$input[0])})},this.focusInput=function(){this.select("controlsSelector").addClass(this.attr.userBorderColorClass)},this.blurInput=function(){this.select("controlsSelector").removeClass(this.attr.userBorderColorClass)},this.after("initialize",function(){var a={scribeContext:{element:"tweet_box"}};TypeaheadInput.attachTo(this.$node,{inputSelector:this.attr.inputSelector,eventData:a});var b=this.$node.hasClass(this.attr.taggingClass)?"mediaTagAccounts":"accounts",c=[b,"selectedUsers"];this.attr.includePreviouslySelectedUsers&&c.push("prefillUsers"),TypeaheadDropdown.attachTo(this.$node,{inputSelector:this.attr.inputSelector,datasourceRenders:[["selectedUsers",c]],blockLinkActions:!0,eventData:a,alwaysOpen:!0,deciders:{},typeaheadSrc:"COMPOSE_MEDIA_TAGGING"}),this.on("uiShowSelectDropdown",this.showSelectDropdown),this.on("uiTypeaheadItemSelected",this.selectUser),this.on("uiResetSelectedUsers",this.resetComposer),this.selectedUsers=[],this.$input=this.select("inputSelector"),this.on("uiShortcutEsc",this.hideAndManageEsc),this.on(document,"mousedown : focusin",this.hideSelectDropdown),this.on(this.$input,"focusin",this.focusInput),this.on(this.$input,"focusout",this.blurInput)})}var defineComponent=require("core/component"),TypeaheadInput=require("app/ui/typeahead/typeahead_input"),caret=require("app/utils/caret"),TypeaheadDropdown=require("app/ui/typeahead/typeahead_dropdown"),SelectUsers=defineComponent(selectUsers);module.exports=SelectUsers
});
define("app/data/media_tags_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function mediaTagsScribe(){this.scribeClickOnButton=function(a,b){this.scribe({page:"composition",element:"media_tag_prompt",action:"click"},b)},this.scribeUserSelected=function(a,b){this.scribe({page:"composition",component:"media_tag",element:"taggable_user",action:"click"},b)},this.scribeUserNotSelected=function(a,b){this.scribe({page:"composition",component:"media_tag",element:"nontaggable_user",action:"click"},b)},this.scribeTweet=function(a,b){b.tweetData.tagged_users&&b.tweetData.tagged_users.length&&b.tweetData.in_reply_to_status_id&&b.tweetData.in_reply_to_status_id.length?this.scribe({page:"composition",action:"reply_with_tags"},b):b.tweetData.tagged_users&&b.tweetData.tagged_users.length&&this.scribe({page:"composition",action:"tweet_with_tags"},b)},this.after("initialize",function(){this.on("uiShowSelectDropdown",this.scribeClickOnButton),this.on("uiUpdatedSelectedUsers",this.scribeUserSelected),this.on("uiSendTweetWithMedia",this.scribeTweet),this.on("uiCouldNotSelectUser",this.scribeUserNotSelected)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(mediaTagsScribe,withScribe)
});
define("app/ui/tweet_box",["module","require","exports","core/component","app/ui/with_character_counter","app/utils/with_event_params","app/utils/caret","core/utils","core/i18n","app/utils/scribe_item_types","app/ui/with_draft_tweets","app/ui/with_text_polling","app/ui/with_rtl_tweet_box","app/ui/toolbar","app/ui/with_rich_editor","app/ui/with_upload_photo_affordance","app/ui/with_droppable_image","app/utils/tweet_helper","app/data/user_info","app/ui/select_users","app/data/media_tags_scribe"],function(module, require, exports) {
function tweetBox(){var a=_('\u30c4\u30a4\u30fc\u30c8\u3059\u308b'),b="";this.defaultAttrs({textSelector:"textarea.tweet-box",shadowTextSelector:".tweet-box-shadow",counterSelector:"span.tweet-counter",toolbarSelector:".js-toolbar",imageSelector:".photo-selector",uploadPhotoSelector:".photo-selector",imageBtnSelector:".photo-selector .btn",focusClass:"focus",activeClass:"active",messagingClass:"messaging",fileInputSelector:".file-input",thumbContainerSelector:".thumbnail-container",taggingSelector:".photo-tagging-container",taggingButtonSelector:".js-open-user-select",taggedUsersSelector:".tagged-users",tweetActionSelector:".tweet-action",iframeSelector:".tweet-post-iframe",placeIdSelector:"input[name=place_id]",thumbSelector:".previews .preview",cursorPosition:undefined,inReplyToTweetData:{},inReplyToStatusId:undefined,impressionId:undefined,disclosureType:undefined,modal:!1,condensable:!1,suppressFlashMessage:!1,customData:{},position:undefined,itemType:"tweet",component:undefined,lifelineAlertSelector:".lifeline-alert-status",lifelineAlertBtnSelector:".lifeline-alert-status-btn",dmOnly:!1,multiPhoto:!1,geoStatusSelector:".geo-status",tooltipClass:"js-tooltip",tooltipSelector:".js-tooltip",visuallyHiddenClass:"u-hiddenVisually",eventParams:""}),this.dmRegex=/^\s*(?:d|m|dm)\s+[@＠]?(\S+)\s*(.*)/i,this.validUserRegex=/^(\w{1,20})$/,this.dmMode=!1,this.hasMedia=!1,this.condensed=!1,this.lifelineAlertMode=!1,this.lifelineAlertText=" #alert",this.taggedUsers=[],this.defaultTagText=_('\u8ab0\u304c\u5199\u3063\u3066\u3044\u307e\u3059\u304b?'),this.sendLifelineAlertTweet=function(){this.sendTweet(),this.trigger("uiLifelineAlertsTweet")},this.cancelLifelineAlertTweet=function(){this.trigger("uiLifelineAlertsCancel")},this.confirmAndSendTweet=function(a){this.lifelineAlertMode?(this.trigger("uiLifelineAlertsImpression"),this.trigger("uiOpenConfirmDialog",{titleText:_('Twitter\u30a2\u30e9\u30fc\u30c8\u3092\u9001\u4fe1'),bodyText:_('\u672c\u5f53\u306bTwitter\u30a2\u30e9\u30fc\u30c8\u3092\u30d5\u30a9\u30ed\u30ef\u30fc\u306b\u9001\u4fe1\u3057\u307e\u3059\u304b?'),cancelText:_('\u30ad\u30e3\u30f3\u30bb\u30eb'),submitText:_('\u9001\u4fe1'),action:"SendLifelineAlert"})):this.sendTweet(a)},this.sendTweet=function(a){a&&a.preventDefault(),this.detectUpdatedText(),this.$node.attr("id",this.getTweetboxId());var b=this.val();this.lifelineAlertMode&&(b+=this.lifelineAlertText);var c=this.taggedUsers.map(function(a){return a.id}),d={status:b,place_id:this.select("placeIdSelector").val(),in_reply_to_status_id:this.attr.inReplyToStatusId,impression_id:this.attr.impressionId,earned:this.attr.disclosureType?this.attr.disclosureType=="earned":undefined,tagged_users:c.join()};if(userInfo.getExperimentGroup("reply140")){var e=tweetHelper.separateRepliesAndText(b,this.attr.inReplyToTweetData.screenNames);d.replied_users=e.replyScreenNames.join(","),d.status=e.text}this.attr.inReplyToTweetData&&(d.tweet_stat_count=this.attr.inReplyToTweetData.tweetStatCount);var f=this.hasMedia?"uiSend{{type}}WithMedia":"uiSend{{type}}";this.trigger(f,{tweetboxId:this.getTweetboxId(),tweetData:d,customData:this.attr.customData}),this.trigger("uiUpdateRecentTags",{items:this.taggedUsers}),this.$node.addClass("tweeting"),this.disable()},this.getTweetboxId=function(){return this.tweetboxId||(this.tweetboxId="swift_tweetbox_"+ +(new Date)),this.tweetboxId},this.overrideTweetBoxOptions=function(a,b){this.attr.inReplyToTweetData=b,b.id&&(this.attr.inReplyToStatusId=b.id),b.impressionId&&(this.attr.impressionId=b.impressionId),b.disclosureType&&(this.attr.disclosureType=b.disclosureType),b.defaultText&&(this.attr.defaultText=b.defaultText),b.customData&&(this.attr.customData=b.customData),b.itemType&&(this.attr.itemType=b.itemType),b.scribeContext&&b.scribeContext.component&&(this.attr.component=b.scribeContext.component),b.position!==undefined&&(this.attr.position=b.position),b.cursorPosition!==undefined&&(this.attr.cursorPosition=b.cursorPosition)},this.resetOverriddenOptions=function(a,b){delete this.attr.defaultText,this.attr.inReplyToTweetData=this.defaults.inReplyToTweetData,this.attr.inReplyToStatusId=this.defaults.inReplyToStatusId,this.attr.impressionId=this.defaults.impressionId,this.attr.disclosureType=this.defaults.disclosureType,this.attr.defaultText=this.getDefaultText(),this.attr.cursorPosition=this.defaults.cursorPosition,this.attr.customData=this.defaults.customData,this.attr.position=this.defaults.position,this.attr.itemType=this.defaults.itemType,this.attr.component=this.attr.component},this.updateTweetTitleThenButton=function(){this.updateTitle(),this.updateTweetButton()},this.updateTweetButton=function(){var a=!1,b=this.val().trim();this.hasMedia?a=!0:a=b&&(this.attr.canTweetDefaultText||b!==this.attr.defaultText.trim());if(this.maxReached()||this.$node.hasClass("tweeting"))a=!1;this.dmMode&&(!this.dmText||!this.dmUsername.match(this.validUserRegex))&&(a=!1),a?this.enable():this.disable(),this.dmMode||this.attr.dmOnly?this.select("tweetActionSelector").addClass(this.attr.messagingClass):this.select("tweetActionSelector").removeClass(this.attr.messagingClass)},this.updateTitle=function(){var a=this.val().match(this.dmRegex),b=a&&a[1];this.dmText=a&&a[2],a&&(!this.dmMode||this.dmMode&&this.dmUsername!=b)?(this.dmMode=!0,this.dmUsername=b,this.trigger("uiDialogUpdateTitle",{title:_('@{{username}}\u3078\u306e\u30c0\u30a4\u30ec\u30af\u30c8\u30e1\u30c3\u30bb\u30fc\u30b8',{username:b})})):this.dmMode&&!a&&(this.dmMode=!1,this.dmUsername=undefined,this.trigger("uiDialogUpdateTitle",{title:_('\u30c4\u30a4\u30fc\u30c8\u3059\u308b')}))},this.tweetSent=function(a,b){var c=b.tweetboxId||b.sourceEventData.tweetboxId;if(c!=this.getTweetboxId())return;b.customData=this.attr.customData,b.message&&this.trigger(b.unusual?"uiShowError":"uiShowMessage",{message:b.message});if(this.attr.eventParams.type=="Tweet"){var d="uiTweetboxTweetSuccess",e={id:b.tweet_id,item_type:scribeItemTypes.tweet};if(this.attr.inReplyToStatusId||this.val().indexOf("@")==0){if((this.attr.inReplyToTweetData||{}).replyLinkClick){var f=utils.merge({},this.attr.inReplyToTweetData);f.scribeContext&&(f.scribeContext.element=""),this.trigger("uiReplyButtonTweetSuccess",f)}d="uiTweetboxReplySuccess"}else this.val().match(this.dmRegex)&&(d="uiTweetboxDMSuccess");this.trigger(d,{scribeData:{items:[e]}})}this.$node.removeClass("tweeting"),this.trigger("ui{{type}}Sent",b),this.reset(),this.condense(),this.lifelineAlertMode&&this.setLifelineAlertMode(!1)},this.scribeDataForReply=function(){var a={id:this.attr.inReplyToStatusId,item_type:scribeItemTypes.tweet},b={};this.attr.impressionId&&(a.token=this.attr.impressionId,b.promoted=!0);if(this.attr.position==0||this.attr.position)a.position=this.attr.position;return b.items=[a],{scribeData:b,scribeContext:{component:this.attr.component,element:""}}},this.tweetError=function(a,b){var c=b.tweetboxId||b.sourceEventData.tweetboxId;if(c!=this.getTweetboxId())return;!this.attr.suppressFlashMessage&&!b.spamChallenge&&this.trigger("uiShowError",{message:b.error||b.message}),this.$node.removeClass("tweeting"),this.enable(),this.attr.eventParams.type=="Tweet"&&this.trigger("uiTweetboxTweetError")},this.detectUpdatedText=function(a,b){b===undefined?b=this.$text.val():this.$text.val(b);if(b!==this.prevText||a)this.prevText=b,b=this.cleanRtlText(b),this.updateCleanedTextAndOffset(b,caret.getPosition(this.$text[0]))},this.updateCleanedTextAndOffset=function(a,b){this.cleanedText=a,this.select("shadowTextSelector").val(a),this.trigger("uiTextChanged",{text:a,position:b,condensed:this.condensed}),this.updateTweetTitleThenButton()},this.showPreview=function(a,b){this.$node.addClass("has-preview has-thumbnail"),this.hasMedia=!0,this.detectUpdatedText(!0),b.isGif?this.select("taggingButtonSelector").first().hide():(this.select("taggingButtonSelector").first().show(),this.select("taggingButtonSelector").first().prop("disabled",!1))},this.updateThumbnailCount=function(a){var b=this.select("thumbSelector").length;b>1?this.defaultTagText=_('\u8ab0\u304c\u5199\u3063\u3066\u3044\u307e\u3059\u304b?'):this.defaultTagText=_('\u8ab0\u304c\u5199\u3063\u3066\u3044\u307e\u3059\u304b?'),this.taggedUsers.length==0&&this.select("taggedUsersSelector").html(this.defaultTagText)},this.hidePreview=function(a,b){this.$node.removeClass("has-preview has-thumbnail"),this.hasMedia=!1,this.detectUpdatedText(!0),this.select("taggingButtonSelector").first().prop("disabled",!0)},this.enable=function(){this.select("tweetActionSelector").removeClass("disabled").attr("disabled",!1),this.$node.trigger("uiEnableTweetAction")},this.disable=function(){this.select("tweetActionSelector").addClass("disabled").attr("disabled",!0),this.$node.trigger("uiDisableTweetAction")},this.reset=function(){this.freezeTweetText||this.resetTweetText(),this.trigger("uiTweetBoxHidePreview"),this.trigger("uiTweetBoxRemoveAllThumbnail"),this.trigger(this.attr.taggingSelector,"uiResetSelectedUsers"),this.$text.css("height",""),this.$node.find("input[type=hidden]").val(""),this.condenseOnMouseUp=!1},this.resetAndFocus=function(a){this.reset(),this.focus(),this.setCursorPosition()},this.val=function(a){if(a==undefined)return this.cleanedText||"";this.detectUpdatedText(!1,a)},this.setSelection=function(a){},this.setCursorPosition=function(a){a===undefined&&(a=this.attr.cursorPosition),a===undefined&&(a=this.$text.val().length),caret.setPosition(this.$text.get(0),a)},this.focus=function(){this.hasFocus()||this.$text.focus()},this.expand=function(){this.$node.removeClass("condensed"),this.condensed&&(this.condensed=!1,this.trigger("uiTweetBoxExpanded"),this.trigger("uiPrepareTweetBox"))},this.onTweetBoxExpand=function(a,b){b&&this.overrideTweetBoxOptions(a,b),this.expand(),this.focus()},this.forceExpand=function(){this.condensed=!0,this.expand(),this.saveEmptyUndoState()},this.condense=function(){!this.condensed&&this.attr.condensable&&(this.$node.addClass("condensed"),this.condensed=!0,this.resetTweetText(),this.$text.blur(),this.trigger("uiTweetBoxCondensed"))},this.condenseEmptyTweet=function(){this.detectUpdatedText();var a=this.val().trim();this.trigger("uiHideAutocomplete"),(a==this.attr.defaultText.trim()||a=="")&&!this.hasMedia&&this.condense()},this.condenseOnMouseDown=function(a){this.condensed||($.contains(this.$condenseContainer[0],a.target)?this.blockCondense=!0:this.condenseOnMouseUp=!0)},this.condenseOnMouseUp=function(){this.condenseOnMouseUp&&(this.condenseOnMouseUp=!1,this.condenseEmptyTweet())},this.condenseOnBlur=function(){if(this.blockCondense||this.condenseOnMouseUp){this.blockCondense=!1;return}this.condenseEmptyTweet()},this.hasFocus=function(){return document.activeElement===this.$text[0]},this.prepareTweetBox=function(){this.resetAndFocus()},this.resetTweetText=function(){this.val(this.condensed?this.attr.condensedText:this.attr.defaultText)},this.getDefaultText=function(){return typeof this.attr.defaultText!="undefined"?this.attr.defaultText:this.getAttrOrElse("data-default-text",b)},this.getCondensedText=function(){return typeof this.attr.condensedText!="undefined"?this.attr.condensedText:this.getAttrOrElse("data-condensed-text",a)},this.changeTextAndPosition=function(a,b){this.val(b.text),this.setCursorPosition(b.position)},this.getAttrOrElse=function(a,b){return typeof this.$node.attr(a)=="undefined"?b:this.$node.attr(a)},this.applyFocusStyleImageButton=function(a){this.select("imageBtnSelector").addClass(this.attr.focusClass)},this.removeFocusStyleImageButton=function(a){this.select("imageBtnSelector").removeClass(this.attr.focusClass)},this.applyActiveStyleImageButton=function(a){this.select("imageBtnSelector").addClass(this.attr.activeClass)},this.removeActiveStyleImageButton=function(a){this.select("imageBtnSelector").removeClass(this.attr.activeClass)},this.initTextNode=function(){this.$text=this.select("textSelector")},this.setLifelineAlertMode=function(a){a?(this.select("lifelineAlertBtnSelector").addClass("active"),this.trigger("uiLifelineAlertsSelect")):this.select("lifelineAlertBtnSelector").removeClass("active"),this.lifelineAlertMode=a,this.detectUpdatedText(!0)},this.selectLifelineAlertAction=function(){this.setLifelineAlertMode(!this.lifelineAlertMode)},this.allowTeardown=function(a,b){this.attr.noTeardown=!1},this.ignoreDuringFakeFocus=function(a){var b=this;return function(){if(!b.$text.hasClass("fake-focus"))return a.apply(this,arguments)}},this.handleCmdEnterSubmit=function(a){this.select("tweetActionSelector").hasClass("disabled")||this.confirmAndSendTweet(a)},this.updateTaggedUsers=function(a,b){var c=this.select("taggedUsersSelector");if(b.items.length==0){c.text(this.defaultTagText),this.select("taggingButtonSelector").addClass("no-users");return}this.select("taggingButtonSelector").removeClass("no-users"),this.taggedUsers=b.items,c.html(this.getTaggedUsersString(b.items))},this.getTaggedUsersString=function(a){if(a.length==1)return _('{{name1}}\u3055\u3093',{name1:a[0].name});if(a.length==2)return _('<span class=\'user-name\'>{{name1}}</span>\u3055\u3093\u3068\u4ed61\u4eba',{name1:a[0].name});if(a.length>2)return _('<span class=\'user-name\'>{{name1}}</span>\u3055\u3093\u3068\u4ed6{{count}}\u4eba',{name1:a[0].name,count:a.length-1})},this.prepareToolbarButtons=function(){var a=this.select("toolbarSelector");a.outerWidth()>=490?a.find(this.attr.tooltipSelector).removeClass(this.attr.tooltipClass).removeAttr("title"):this.select("geoStatusSelector").addClass(this.attr.visuallyHiddenClass)},this.after("initialize",function(){this.attr.condenseContainer?this.$condenseContainer=$(this.attr.condenseContainer):this.$condenseContainer=this.$node,this.attr.defaultText=this.getDefaultText(),this.attr.condensedText=this.getCondensedText(),utils.push(this.attr,{eventData:{scribeContext:{element:"tweet_box"}}},!1),this.initTextNode(),this.on(this.select("tweetActionSelector"),"click",this.confirmAndSendTweet),this.on("uiShortcutCmdEnter",this.handleCmdEnterSubmit),this.on(document,"data{{type}}Success",this.tweetSent),this.on(document,"data{{type}}Error",this.tweetError),this.on(this.$text,"dragover",this.focus),this.on("uiAllowTeardown",this.allowTeardown),this.on("uiTweetBoxShowPreview",this.showPreview),this.on("uiTweetBoxHidePreview",this.hidePreview),this.on("ui{{type}}BoxReset",this.resetAndFocus),this.on("uiPrepare{{type}}Box",this.prepareTweetBox),this.on("uiExpandFocus uiTweetBoxRemoveThumbnail",this.focus),this.on("uiChangeTextAndPosition",this.changeTextAndPosition),this.on("uiTweetBoxExpand",this.onTweetBoxExpand),this.on("focusin",{fileInputSelector:this.applyFocusStyleImageButton}),this.on("focusout",{fileInputSelector:this.removeFocusStyleImageButton}),this.on("mousedown",{fileInputSelector:this.applyActiveStyleImageButton}),this.on("mouseup",{fileInputSelector:this.removeActiveStyleImageButton}),this.on("mouseleave",{fileInputSelector:this.removeActiveStyleImageButton}),this.on(this.attr.lifelineAlertSelector,"click",this.selectLifelineAlertAction),this.on("uiSendLifelineAlertConfirm",this.sendLifelineAlertTweet),this.on("uiSendLifelineAlertCancel",this.cancelLifelineAlertTweet),Toolbar.attachTo(this.select("toolbarSelector"),{buttonsSelector:".file-input, .lifeline-alert-status-btn, .geo-picker-btn, .tweet-action"}),taggingComposer.attachTo(this.select("taggingSelector"),{includePreviouslySelectedUsers:!0}),taggingScribe.attachTo(this.select("taggingSelector"),{}),this.on(this.select("taggingButtonSelector"),"click",function(){this.trigger(this.select("taggingSelector"),"uiShowSelectDropdown")}),this.on("uiUpdatedSelectedUsers",this.updateTaggedUsers),this.on("uiPrepareTweetBox",this.prepareToolbarButtons),this.attr.modal&&(this.on(document,"uiOverride{{type}}BoxOptions",this.overrideTweetBoxOptions),this.on(document,"uiDialogClosed",this.resetOverriddenOptions)),this.attr.multiPhoto&&this.select("thumbContainerSelector").addClass("multi-photo"),this.on("uiUpdatedThumbnails",this.updateThumbnailCount),this.initDraftTweets();var a=this.hasFocus();this.attr.condensable&&(this.on(this.$text,"focusin",this.ignoreDuringFakeFocus(this.expand)),this.on(this.$text,"focusout",this.ignoreDuringFakeFocus(this.condenseOnBlur)),this.on(document,"mousedown",this.condenseOnMouseDown),this.on(document,"mouseup",this.condenseOnMouseUp),a||(this.hasDraftTweet()?this.forceExpand():this.condense())),a&&(this.freezeTweetText=!0,this.forceExpand(),this.freezeTweetText=!1)})}var defineComponent=require("core/component"),withCounter=require("app/ui/with_character_counter"),withEventParams=require("app/utils/with_event_params"),caret=require("app/utils/caret"),utils=require("core/utils"),_=require("core/i18n"),scribeItemTypes=require("app/utils/scribe_item_types"),withDraftTweets=require("app/ui/with_draft_tweets"),withTextPolling=require("app/ui/with_text_polling"),withRTL=require("app/ui/with_rtl_tweet_box"),Toolbar=require("app/ui/toolbar"),withRichEditor=require("app/ui/with_rich_editor"),withUploadPhotoAffordance=require("app/ui/with_upload_photo_affordance"),withDroppableImage=require("app/ui/with_droppable_image"),tweetHelper=require("app/utils/tweet_helper"),userInfo=require("app/data/user_info"),taggingComposer=require("app/ui/select_users"),taggingScribe=require("app/data/media_tags_scribe"),TweetBox=defineComponent(tweetBox,withCounter,withEventParams,withTextPolling,withRTL,withDraftTweets,withRichEditor,withDroppableImage,withUploadPhotoAffordance);TweetBox.caret=caret,module.exports=TweetBox
});
define("app/utils/image_thumbnail",["module","require","exports","app/utils/image"],function(module, require, exports) {
var image=require("app/utils/image"),imageThumbnail={createThumbnail:function(a,b,c,d){var e=new Image;e.onload=function(){c(a,e,e.height,e.width,d)},e.src=image.getDataUri(b)},getThumbnailOffset:function(a,b,c){var d;if(b==a&&b>=c&&a>=c)return{position:"absolute",height:c,width:c,left:0,top:0};if(a<c||b<c)d={position:"absolute",height:a,width:b,top:(c-a)/2,left:(c-b)/2};else if(b>a){var e=c/a*b;d={position:"absolute",height:c,width:e,left:-(e-c)/2,top:0}}else if(a>b){var f=c/b*a;d={position:"absolute",height:f,width:c,top:-(f-c)/2,left:0}}return d}};module.exports=imageThumbnail
});
define("app/ui/tweet_box_thumbnails",["module","require","exports","core/component","core/utils","app/utils/image_thumbnail"],function(module, require, exports) {
function tweetBoxThumbnails(){this.defaults={thumbSelector:".previews .preview",thumbTemplateSelector:".preview.template",thumbsSelector:".previews",thumbImageSelector:".preview img",filenameSelector:".preview .filename",dismissSelector:".dismiss",tweetBoxSelector:".tweet-form",photoLimit:1,photoCount:0},this.addThumbnail=function(a,b){b.imageData&&imageThumbnail.createThumbnail(b.fileName,b.imageData,this.gotThumbnail.bind(this),b.uploadId),this.select("filenameSelector").text(b.fileName)},this.removeAllThumbnails=function(a,b){this.select("thumbsSelector").empty(),this.select("filenameSelector").empty()},this.gotThumbnail=function(a,b,c,d,e){var f=imageThumbnail.getThumbnailOffset(c,d,48);$(b).css(f);var g=$("<a>",{href:$(b).attr("src"),target:"_blank"}).append($(b)),h=this.select("thumbTemplateSelector").clone();h.removeClass("template"),h.append(g),e&&h.attr("data-upload-id",e),this.on(h.find(".dismiss"),"click",this.removeImage),this.select("thumbsSelector").append(h),this.trigger("uiUpdatedThumbnails")},this.removeImage=function(a){var b=$(a.target).closest(this.attr.thumbSelector),c=b.attr("data-upload-id");this.trigger("uiTweetBoxRemoveThumbnail",{uploadId:c}),b.remove(),this.trigger("uiImagePickerRemove"),this.trigger("uiUpdatedThumbnails")},this.after("initialize",function(){utils.push(this.attr,{eventData:{scribeContext:{element:"image_picker"}}},!1);var a=this.$node.closest(this.attr.tweetBoxSelector);this.on(a,"uiTweetBoxAddThumbnail",this.addThumbnail),this.on(a,"uiTweetBoxRemoveAllThumbnail",this.removeAllThumbnails)})}var defineComponent=require("core/component"),utils=require("core/utils"),imageThumbnail=require("app/utils/image_thumbnail"),TweetBoxThumbnails=defineComponent(tweetBoxThumbnails);module.exports=TweetBoxThumbnails
});
define("app/utils/image_resize",["module","require","exports","app/utils/image"],function(module, require, exports) {
var image=require("app/utils/image"),imageResize={resize:function(a,b,c,d){if(!image.hasCanvas())return d(a,b.split(";base64,")[1]);var e=new Image,f=document.createElement("canvas"),g=f.getContext("2d");e.onload=function(){if(e.width==0||e.height==0){d(a,!1);return}if(e.width<c&&e.height<c){d(a,b.split(";base64,")[1]);return}var h,i;e.width>e.height?(h=c,i=e.height/e.width*c):(i=c,h=e.width/e.height*c),f.width=h,f.height=i,g.drawImage(e,0,0,h,i);var j=f.toDataURL("image/jpeg");d(a,j.split("data:image/jpeg;base64,")[1])},e.onerror=function(){d(a,!1)},e.src=b}};module.exports=imageResize
});
define("app/ui/with_image_selection",["module","require","exports","app/utils/image","app/utils/image_resize"],function(module, require, exports) {
function withImageSelection(){this.resize=imageResize.resize.bind(image),this.getFileData=image.getFileData.bind(image),this.getFileHandle=image.getFileHandle.bind(image),this.getFileName=image.getFileName.bind(image),this.validateFileName=image.validateFileName.bind(image),this.validateImageSize=image.validateImageSize.bind(image),this.defaultAttrs({swfSelector:".swf-container",fileNameSelector:"input.file-name",fileDataSelector:"input.file-data",fileSelector:"input.file-input",buttonSelector:".btn",fileNameString:"media_file_name",fileDataString:"media_data[]",fileInputString:"media[]",uploadType:"",maxSizeInBytes:5242880,maxGifSizeInBytes:3145728}),this.validateImage=function(a,b){if(!this.validateFileName(a))return this.addFileError("notImage"),!1;if(b){var c=image.isAnimatedGif(a),d=c?this.validateImageSize(b,this.attr.maxGifSizeInBytes):this.validateImageSize(b,this.attr.maxSizeInBytes);if(!d)return c?this.addFileError("gifTooLarge"):this.addFileError("tooLarge"),!1}return!0},this.imageSelected=function(a){var b=this.select("fileSelector").get(0),c=this.getFileName(b.value),d=this.getFileHandle(b);if(!this.validateImage(c,d))return;this.gotFileHandle(c,d)},this.gotFileHandle=function(a,b){this.mode()=="html5"?this.getFileData(a,b,this.gotImageData.bind(this)):this.gotFileInput(a)},this.reset=function(){this.resetInput(),this.select("fileDataSelector").replaceWith('<input type="hidden" name="media_data_empty" class="file-data">'),this.trigger("uiTweetBoxHidePreview")},this.getUploadId=function(){return+(new Date)},this.gotFlashImageData=function(a,b,c){if(!this.validateFileName(a)){this.addFileError("notImage");return}var d=this.getUploadId();this.addThumbnail({imageData:c,fileName:a,uploadId:d}),this.trigger("uiImagePickerAdd",{message:"flash"}),this.readyFileData(b,d),this.trigger("uiImagePickerFileReady",{uploadType:this.attr.uploadType})},this.gotFlashImageError=function(a,b){this.addFileError(a)},this.gotResizedImageData=function(a,b,c){if(!b){this.addFileError("notImage");return}if(this.photoCount&&c){this.addFileError("gifLimit");return}var d=this.getUploadId();c&&(this.gifId=d),this.addThumbnail({imageData:b,fileName:a,uploadId:d}),this.select("fileNameSelector").attr("value",a),this.trigger("uiImagePickerAdd",{message:"html5"});var e=b.split(",");e.length>1&&(b=e[1]),this.readyFileData(b,d,c),this.trigger("uiImagePickerFileReady",{uploadType:this.attr.uploadType})},this.gotFileInput=function(a){var b=this.getUploadId();this.addThumbnail({fileName:a,uploadId:b}),this.trigger("uiImagePickerAdd",{message:"html4"}),this.readyFileInput(),this.trigger("uiImagePickerFileReady",{uploadType:this.attr.uploadType})},this.readyFileInput=function(){this.select("fileSelector").attr("name",this.attr.fileInputString)},this.readyFileData=function(a,b,c){if(this.attr.photoLimit==4){var d=$('<input type="hidden" class="multi-photo-data">');d.attr("value",a),d.attr("data-upload-id",b),this.select("multiPhotoDataContainerSelector").append(d)}else this.select("fileDataSelector").attr("value",a),this.select("fileDataSelector").attr("name",this.attr.fileDataString);this.resetInput()},this.resetInput=function(){this.select("fileSelector").replaceWith('<input type="file" name="media_empty" class="file-input" tabindex="-1">')},this.addThumbnail=function(a){this.trigger("uiTweetBoxAddThumbnail",a)},this.setupFlash=function(){var a="swift_tweetbox_callback_"+ +(new Date),b="swift_tweetbox_error_callback_"+ +(new Date);window[a]=this.gotFlashImageData.bind(this),window[b]=this.gotFlashImageError.bind(this),setTimeout(function(){this.loadSwf(a,b)}.bind(this),500)},this.mode=function(){return this.attr.forceHTML5FileUploader&&(this._mode="html5"),this._mode=this._mode||image.mode(),this._mode},this.setup=function(){this.mode()=="flash"&&this.setupFlash(),this.select("fileNameSelector").attr("name",this.attr.fileNameString),this.select("fileDataSelector").attr("name",this.attr.fileDataString),this.select("fileSelector").attr("name",this.attr.fileInputString)},this.after("initialize",function(){this.setup(),this.on("change",this.imageSelected)})}var image=require("app/utils/image"),imageResize=require("app/utils/image_resize");module.exports=withImageSelection
});
define("app/ui/image_selector",["module","require","exports","core/component","app/utils/image","app/ui/with_image_selection","app/data/user_info","core/i18n"],function(module, require, exports) {
function imageSelector(){this.defaults={swfHeight:30,swfWidth:42,tweetBoxSelector:".tweet-form",photoButtonSelector:".file-input",addPhotoLabelSelector:".add-photo-label",multiPhotoDataSelector:".multi-photo-data",multiPhotoDataContainerSelector:".multi-photo-data-container",interceptAvatarImageData:!1,photoLimit:1},this.disable=function(){this.$node.addClass("disabled"),this.select("buttonSelector").attr("disabled",!0).addClass("enabled")},this.enable=function(){this.$node.removeClass("disabled"),this.select("buttonSelector").attr("disabled",!1).removeClass("enabled")},this.thumbAdded=function(a,b){this.photoCount++,(this.photoCount>=this.attr.photoLimit||this.gifId)&&this.disable(),this.updateAddPhotoLabel();var c=b?{isGif:image.isAnimatedGif(b.fileName)}:{};this.trigger("uiTweetBoxShowPreview",c)},this.thumbRemoved=function(a,b){var c=b.uploadId;this.select("multiPhotoDataContainerSelector").find("[data-upload-id="+c+"]").remove(),this.photoCount=Math.max(--this.photoCount,0),this.gifId==c&&(this.gifId=0),this.photoCount<this.attr.photoLimit&&!this.gifId&&this.enable(),this.updateAddPhotoLabel(),this.photoCount==0&&this.trigger("uiTweetBoxHidePreview")},this.removeAllThumbs=function(){this.photoCount=0,this.gifId=0,this.updateAddPhotoLabel(),this.reset(),this.enable(),this.select("multiPhotoDataContainerSelector").empty()},this.gotImageData=function(a,b){image.isAnimatedGif(a)?this.gotResizedImageData(a,b.split(";base64,")[1],!0):this.resize(a,b,2048,this.gotResizedImageData.bind(this))},this.interceptGotImageData=function(a,b){this.gotImageData(b.name,b.contents)},this.interceptAvatarImageData=function(a,b){b.uploadType==="avatar"&&this.gotResizedImageData(b.fileName,b.fileData)},this.addFileError=function(a){a=="tooLarge"?this.trigger("uiShowError",{message:_('\u30d5\u30a1\u30a4\u30eb\u304c\u5927\u304d\u3059\u304e\u307e\u3059\u3002\u6700\u5927\u30b5\u30a4\u30ba\u306f5MB\u3067\u3059\u3002')}):a=="gifTooLarge"?this.trigger("uiShowError",{message:_('\u30d5\u30a1\u30a4\u30eb\u304c\u5927\u304d\u3059\u304e\u307e\u3059\u3002\u6700\u5927\u30b5\u30a4\u30ba\u306f3MB\u3067\u3059\u3002')}):a=="notImage"||a=="ioError"?this.trigger("uiShowError",{message:_('\u753b\u50cf\u30d5\u30a1\u30a4\u30eb\u3092\u9078\u629e\u3057\u3066\u304f\u3060\u3055\u3044\u3002')}):a=="gifLimit"&&this.trigger("uiShowError",{message:_('\u8907\u6570\u306eGIF\u3092\u30a2\u30c3\u30d7\u30ed\u30fc\u30c9\u3059\u308b\u3053\u3068\u306f\u3067\u304d\u307e\u305b\u3093')}),this.trigger("uiImagePickerError",{message:a})},this.loadSwf=function(a,b){image.loadPhotoHelperSwf(this.select("swfSelector"),a,b,this.attr.swfHeight,this.attr.swfWidth)},this.imageSelectorClicked=function(a,b){this.trigger("uiImagePickerClick")},this.updateAddPhotoLabel=function(){var a="";this.attr.photoLimit==1||this.attr.photoLimit==4&&this.photoCount==0?a=_('\u753b\u50cf\u3092\u8ffd\u52a0'):this.gifId?a=_('1\u4ef6\u8ffd\u52a0'):this.attr.photoLimit==4&&this.photoCount==4?a=_('4\u4ef6\u8ffd\u52a0\u3057\u307e\u3057\u305f'):a=_('\u3055\u3089\u306b\u8ffd\u52a0'),this.select("addPhotoLabelSelector").text(a)},this.after("initialize",function(){this.on(this.attr.photoButtonSelector,"click",this.imageSelectorClicked);var a=this.$node.closest(this.attr.tweetBoxSelector);this.on(a,"uiTweetBoxRemoveThumbnail",this.thumbRemoved),this.on(a,"uiTweetBoxAddThumbnail",this.thumbAdded),this.on(a,"uiTweetBoxRemoveAllThumbnail",this.removeAllThumbs),this.on(a,"uiGotImageData",this.interceptGotImageData),this.attr.interceptAvatarImageData&&this.on(document,"uiImageSave",this.interceptAvatarImageData),this.gifId=0,this.photoCount=0})}var defineComponent=require("core/component"),image=require("app/utils/image"),withImageSelection=require("app/ui/with_image_selection"),userInfo=require("app/data/user_info"),_=require("core/i18n"),ImageSelector=defineComponent(imageSelector,withImageSelection);module.exports=ImageSelector
});
define("app/ui/with_click_outside",["module","require","exports"],function(module, require, exports) {
function withClickOutside(){this.onClickOutside=function(a,b){b=b.bind(this),this.clickOutsideHandler=function(c,d){var e=!0;a.each(function(){if($(c.target).closest(this).length)return e=!1,!1}),e&&b(c,d)},$(document).on("click",this.clickOutsideHandler)},this.offClickOutside=function(){this.clickOutsideHandler&&($(document).off("click",this.clickOutsideHandler),this.clickOutsideHandler=null)},this.before("teardown",function(){this.offClickOutside()})}module.exports=withClickOutside
});
define("app/ui/geo_picker",["module","require","exports","core/component","core/i18n","app/ui/with_click_outside","core/utils"],function(module, require, exports) {
function geoPicker(){this.defaultAttrs({buttonSelector:"button.geo-picker-btn",placeIdSelector:"input[name=place_id]",statusSelector:"span.geo-status",dropdownContainerSelector:"span.dropdown-container",dropdownSelector:".dropdown-menu",dropdownDisabledSelector:"#geo-disabled-dropdown",enableButtonSelector:"button.geo-turn-on",notNowButtonSelector:"button.geo-not-now",dropdownEnabledSelector:"#geo-enabled-dropdown",querySelector:"li.geo-query-location input",geoSearchSelector:"li.geo-query-location .icon",dropdownStatusSelector:"li.geo-dropdown-status",searchResultsSelector:"li.geo-search-result",placeResultsSelector:"li.geo-place-result",changePlaceSelector:"li[data-place-id]",turnOffButtonSelector:"li.geo-turn-off-item",focusableSelector:"li.geo-focusable",firstFocusableSelector:"li.geo-focusable:first",focusedSelector:"li.geo-focused"}),this.selectGeoAction=function(a){if(this.dropdownIsOpen()){this.hideDropdownAndRestoreFocus();return}switch(this.geoState.state){case"disabled":this.disable(),this.trigger("uiGeoPickerOffer");break;case"enableIsUnavailable":this.trigger("uiGeoPickerOffer");break;case"locateIsUnavailable":case"enabledTurnedOn":this.requestGeoState();break;case"enabledTurnedOff":this.turnOn();break;case"changing":case"locating":case"located":case"locationUnknown":case"locateIsUnavailable":this.trigger("uiGeoPickerOpen")}},this.dropdownIsOpen=function(){return this.select("dropdownSelector").is(":visible")},this.hideDropdown=function(){this.offClickOutside(),this.select("dropdownSelector").hide(),this.select("buttonSelector").removeClass("open")},this.captureActiveEl=function(){this.activeEl=document.activeElement},this.hideDropdownAndRestoreFocus=function(){this.hideDropdown(),this.activeEl&&(this.activeEl.focus(),this.activeEl=null)},this.openDropdown=function(a,b){var c,d;a.type=="uiGeoPickerOpen"?(c=this.attr.dropdownEnabledSelector,d=1):(c=this.attr.dropdownDisabledSelector,d=0),this.captureActiveEl(),d!=this.dropdownState&&(this.select("dropdownContainerSelector").html($(c).html()),this.dropdownState=d);var e=this.select("dropdownSelector");this.showGeoState(),this.onClickOutside(e.add(this.select("buttonSelector")),this.hideDropdown),this.lastQuery="",this.geoQueryFieldChanged=!1,e.show();var f=this.select("enableButtonSelector");f.length||(f=this.select("querySelector")),this.select("buttonSelector").addClass("open"),f.focus()},this.enable=function(){this.hideDropdownAndRestoreFocus(),this.trigger("uiGeoPickerEnable")},this.setFocus=function(a){var b=$(a.target);this.select("focusedSelector").not(b).removeClass("geo-focused"),b.addClass("geo-focused")},this.clearFocus=function(a){$(a.target).removeClass("geo-focused")},this.turnOn=function(){this.trigger("uiGeoPickerTurnOn")},this.turnOff=function(a){this.hideDropdownAndRestoreFocus(),this.trigger("uiGeoPickerTurnOff")},this.changePlace=function(a){var b=$(a.target),c=b.attr("data-place-id");this.hideDropdownAndRestoreFocus();if(!c||c===this.lastPlaceId)return;var d={placeId:c,scribeData:{items:[{name:c}]}};this.lastPlaceId&&d.scribeData.items.push({name:this.lastPlaceId}),b.hasClass("geo-search-result")&&this.lastQueryData&&(d.scribeData.query=this.lastQueryData.query),this.trigger("uiGeoPickerChange",d)},this.updateState=function(a,b){this.geoState=b,this.showGeoState()},this.showGeoState=function(){var a="",b="",c=!1,d="",e=this.geoState;switch(e.state){case"enabling":this.select("buttonSelector").removeClass("disabled");case"locating":a=_('\u4f4d\u7f6e\u60c5\u5831\u3092\u53d6\u5f97\u4e2d...');break;case"enableIsUnavailable":case"locateIsUnavailable":a=_('\u4f4d\u7f6e\u60c5\u5831\u30b5\u30fc\u30d3\u30b9\u306f\u3054\u5229\u7528\u3067\u304d\u307e\u305b\u3093');break;case"changing":a=_('\u4f4d\u7f6e\u60c5\u5831\u3092\u5909\u66f4\u4e2d...');break;case"locationUnknown":a=_('\u4e0d\u660e\u306a\u5834\u6240');break;case"located":a=e.place_name,b=e.place_id,d=e.places_html,c=!0;break;case"enabledTurnedOff":a=_('\u4f4d\u7f6e\u60c5\u5831\u3092\u8ffd\u52a0');break;case"disabled":this.disable(),a=_('\u4f4d\u7f6e\u60c5\u5831\u306f\u4f7f\u7528\u3067\u304d\u307e\u305b\u3093')}this.$node.toggleClass("active",c),c?this.select("buttonSelector").addClass("enabled"):this.select("buttonSelector").removeClass("enabled"),this.select("statusSelector").text(a),this.select("buttonSelector").attr("title",a||_('\u4f4d\u7f6e\u60c5\u5831\u3092\u8ffd\u52a0')),this.select("placeResultsSelector").add(this.select("searchResultsSelector")).remove(),this.select("dropdownStatusSelector").text(a).toggle(!c).after(d),this.select("placeIdSelector").val(b),this.lastPlaceId=b},this.requestGeoState=function(){this.trigger("uiRequestGeoState")},this.queryKeyDown=function(a){switch(a.which){case 38:a.preventDefault(),this.moveFocus(-1);break;case 40:a.preventDefault(),this.moveFocus(1);break;case 13:a.preventDefault();var b=this.select("focusedSelector");if(b.length){a.stopPropagation(),b.trigger("uiGeoPickerSelect");return}this.searchExactMatch()}this.searchAutocomplete()},this.onEsc=function(a){if(!this.dropdownIsOpen())return;a.preventDefault(),a.stopPropagation(),this.hideDropdownAndRestoreFocus()},this.searchIfQueryChanged=function(a){var b=this.select("querySelector").val()||"";if(a&&this.lastQuery===b)return;this.lastIsPrefix=a,this.lastQuery=b,this.select("dropdownStatusSelector").text(_('\u5730\u540d\u3092\u691c\u7d22\u3057\u3066\u3044\u307e\u3059...')).show(),this.geoQueryFieldChanged||(this.geoQueryFieldChanged=!0,this.trigger("uiGeoPickerInteraction")),this.trigger("uiGeoPickerSearch",{placeId:this.lastPlaceId,query:b,isPrefix:a})},this.searchExactMatch=function(){this.searchIfQueryChanged(!1)},this.searchAutocomplete=function(){setTimeout(function(){this.searchIfQueryChanged(!0)}.bind(this),0)},this.moveFocus=function(a){var b=this.select("focusedSelector"),c=this.select("focusableSelector"),d=c.index(b)+a,e=c.length-1;d<0?d=e:d>e&&(d=0),b.removeClass("geo-focused"),c.eq(d).addClass("geo-focused")},this.searchResults=function(a,b){var c=b.sourceEventData;if(!c||c.placeId!==this.lastPlaceId||c.query!==this.select("querySelector").val()||c.isPrefix&&!this.lastIsPrefix)return;this.lastQueryData=c,this.select("searchResultsSelector").remove(),this.select("dropdownStatusSelector").hide().after(b.html)},this.searchUnavailable=function(a,b){this.select("dropdownStatusSelector").text(_('\u4f4d\u7f6e\u60c5\u5831\u30b5\u30fc\u30d3\u30b9\u306f\u3054\u5229\u7528\u3067\u304d\u307e\u305b\u3093')).show()},this.preventFocusLoss=function(a){var b;$.browser.msie&&parseInt($.browser.version,10)<9?(b=$(document.activeElement),b.is(this.select("buttonSelector"))?this.captureActiveEl():b.one("beforedeactivate",function(a){a.preventDefault()})):a.preventDefault()},this.disable=function(){this.select("buttonSelector").addClass("disabled"),this.select("statusSelector").text(_('\u4f4d\u7f6e\u60c5\u5831\u306f\u4f7f\u7528\u3067\u304d\u307e\u305b\u3093')),this.select("buttonSelector").attr("title",_('\u4f4d\u7f6e\u60c5\u5831\u306f\u4f7f\u7528\u3067\u304d\u307e\u305b\u3093'))},this.after("initialize",function(){utils.push(this.attr,{eventData:{scribeContext:{element:"geo_picker"}}},!1),this.geoState={},this.on(this.attr.parent,"uiPrepareTweetBox",this.requestGeoState),this.on(this.attr.parent,"uiPrepareGeoPicker",this.requestGeoState),this.on(document,"dataGeoState",this.updateState),this.on(document,"dataGeoSearchResults",this.searchResults),this.on(document,"dataGeoSearchResultsUnavailable",this.searchUnavailable),this.on("mousedown",{buttonSelector:this.preventFocusLoss}),this.on("click",{buttonSelector:this.selectGeoAction,enableButtonSelector:this.enable,notNowButtonSelector:this.hideDropdownAndRestoreFocus,turnOffButtonSelector:this.turnOff,geoSearchSelector:this.searchExactMatch,changePlaceSelector:this.changePlace}),this.on("uiGeoPickerSelect",{turnOffButtonSelector:this.turnOff,changePlaceSelector:this.changePlace}),this.on("mouseover",{focusableSelector:this.setFocus}),this.on("mouseout",{focusableSelector:this.clearFocus}),this.on("keydown",{querySelector:this.queryKeyDown}),this.on("uiShortcutEsc",this.onEsc),this.on("change paste",{querySelector:this.searchAutocomplete}),this.on("uiGeoPickerOpen uiGeoPickerOffer",this.openDropdown)}),this.before("teardown",function(){this.hideDropdown()})}var defineComponent=require("core/component"),_=require("core/i18n"),withClickOutside=require("app/ui/with_click_outside"),utils=require("core/utils");module.exports=defineComponent(geoPicker,withClickOutside)
});
define("app/ui/tweet_box_manager",["module","require","exports","core/utils","app/ui/tweet_box","app/ui/tweet_box_thumbnails","app/ui/image_selector","app/ui/typeahead/typeahead_dropdown","app/ui/typeahead/typeahead_input","app/ui/geo_picker","core/utils","app/utils/image","app/data/user_info","core/component"],function(module, require, exports) {
function tweetBoxManager(){this.createTweetBoxAtTarget=function(a,b){this.createTweetBox(a.target,b)},this.createTweetBox=function(a,b){var c=$(a);if(!((b.eventData||{}).scribeContext||{}).component)throw new Error("Please specify scribing component for tweet box.");c.find(".geo-picker").length>0&&GeoPicker.attachTo(c.find(".geo-picker"),utils.merge(b,{parent:c},!0)),TweetBox.attachTo(c,utils.merge({eventParams:{type:"Tweet"},multiPhoto:this.getPhotoLimit()>1},b));if(c.find(".photo-selector").length>0){TweetBoxThumbnails.attachTo(c.find(".thumbnail-container"),utils.merge(b,!0));var d=this.getPhotoLimit();ImageSelector.attachTo(c.find(".photo-selector"),utils.merge({photoLimit:c.hasClass("dm-tweetbox")?1:d},b))}if(b.hasTypeahead||b.hasTypeahead===undefined)TypeaheadInput.attachTo(c,utils.merge(b,{inputSelector:"div.rich-editor, textarea.tweet-box",completeAllEntities:this.attr.typeaheadData.hashtags&&this.attr.typeaheadData.hashtags.enabled,includeTweetContext:!0,allowAccountsWithoutAtSign:this.attr.typeaheadData.fullNameMatchingInCompose,inputIsTweetbox:!0})),TypeaheadDropdown.attachTo(c,utils.merge(b,{inputSelector:"div.rich-editor, textarea.tweet-box",blockLinkActions:!0,includeSearchGlass:!1,parseHashtags:!0,typeaheadSrc:"COMPOSE",datasourceRenders:[["accounts",["accounts"]],["topics",["hashtags"]]],datasourceOptions:{accountsWithoutAtSignLocalOnly:!0,topicsMustStartWithHashtag:!0},deciders:this.attr.typeaheadData}))},this.getPhotoLimit=function(){return userInfo.getDecider("async_upload")&&userInfo.getDecider("multi_compose")&&image.hasFileReader()&&image.hasCanvas()?4:1},this.after("initialize",function(){this.on("uiInitTweetbox",this.createTweetBoxAtTarget)})}var utils=require("core/utils"),TweetBox=require("app/ui/tweet_box"),TweetBoxThumbnails=require("app/ui/tweet_box_thumbnails"),ImageSelector=require("app/ui/image_selector"),TypeaheadDropdown=require("app/ui/typeahead/typeahead_dropdown"),TypeaheadInput=require("app/ui/typeahead/typeahead_input"),GeoPicker=require("app/ui/geo_picker"),utils=require("core/utils"),image=require("app/utils/image"),userInfo=require("app/data/user_info"),defineComponent=require("core/component"),TweetBoxManager=defineComponent(tweetBoxManager);module.exports=TweetBoxManager
});
define("app/ui/direct_message_conversation_actions",["module","require","exports","core/component"],function(module, require, exports) {
function conversationActions(){this.defaultAttrs({deleteSelector:".js-actionDeleteConversation",viewParticipantsSelector:".js-actionViewParticipants",conversationIdSelector:"[data-conversation-id]"}),this.getConversationId=function(){return this.select("conversationIdSelector").attr("data-conversation-id")},this.deleteConversation=function(a){a.preventDefault(),this.trigger("uiDeleteConversation",{conversation_id:this.getConversationId()})},this.viewParticipants=function(a){a.preventDefault(),this.trigger("uiViewParticipants",{conversation_id:this.getConversationId()})},this.after("initialize",function(){this.on("click",{deleteSelector:this.deleteConversation,viewParticipantsSelector:this.viewParticipants})})}var defineComponent=require("core/component"),ConversationActions=defineComponent(conversationActions);module.exports=ConversationActions
});
define("app/data/dm/delete_conversation",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function deleteConversation(){this.deleteConversation=function(a,b){this.destroy({url:"/messages/with/conversation",data:{id:b.conversation_id},eventData:b,success:this.success.bind(this,b.conversation_id),error:this.failure.bind(this,b.conversation_id)})},this.success=function(a,b){this.trigger("dataConversationDeleted",{conversation_id:a}),this.trigger("dataDMConversationListResult",b)},this.failure=function(a,b){this.trigger("dataConversationDeleteFailed",{conversation_id:a}),this.trigger("dataDMError",b)},this.after("initialize",function(){this.on("uiDeleteConversation",this.deleteConversation)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),DeleteConversation=defineComponent(deleteConversation,withData);module.exports=DeleteConversation
});
define("app/data/dm/view_participants",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function viewParticipants(){this.fetchParticipants=function(a,b){this.get({url:"/i/direct_messages/participants",data:{conversation_id:b.conversation_id},eventData:b,success:"dataConversationParticipantsResult",error:"dataDMError"})},this.after("initialize",function(){this.on("uiNeedsConversationParticipants",this.fetchParticipants)})}var defineComponent=require("core/component"),withData=require("app/data/with_data");module.exports=defineComponent(viewParticipants,withData)
});
define("app/boot/direct_messages",["module","require","exports","app/data/direct_messages","app/data/direct_messages_scribe","app/ui/direct_message_link_handler","app/ui/typeahead/typeahead_dropdown","app/ui/typeahead/typeahead_input","app/ui/direct_message_dialog","app/ui/direct_message_media_preview","app/ui/direct_message_actions","app/ui/tweet_box_manager","app/ui/direct_message_conversation_actions","app/data/dm/delete_conversation","app/data/dm/view_participants","core/utils"],function(module, require, exports) {
function initialize(a){DirectMessagesData.attachTo(document,a),DirectMessagesScribe.attachTo(document,a),DirectMessageLinkHandler.attachTo(document,a),DirectMessageDialog.attachTo("#dm_dialog",a),DirectMessageMediaPreview.attachTo(".dm-media-container"),DirectMessageActions.attachTo("#dm_dialog",{eventData:{scribeContext:{component:"dm_existing_conversation_dialog"}}});var b={scribeContext:{component:"tweet_box_dm"}};DeleteConversationData.attachTo(document),ViewParticipantsData.attachTo(document),ConversationActions.attachTo(".dm-conversation-actions"),TweetBoxManager.attachTo(document,a),$("#dm_dialog form.tweet-form").trigger("uiInitTweetbox",{defaultText:"",condensedText:"",hasTypeahead:!1,eventParams:{type:"DM"},suppressFlashMessage:!0,eventData:b,dmOnly:!0,fileDataString:"media",fileInputString:"media"}),TypeaheadInput.attachTo("#dm_dialog_new .dm-dialog-content",{inputSelector:"input.twttr-directmessage-input",eventData:b}),TypeaheadDropdown.attachTo("#dm_dialog_new .dm-dialog-content",{inputSelector:"input.twttr-directmessage-input",datasourceRenders:[["accounts",["dmAccounts"]]],blockLinkActions:!0,deciders:a.typeaheadData,eventData:b,typeaheadSrc:"COMPOSE_MESSAGE"})}var DirectMessagesData=require("app/data/direct_messages"),DirectMessagesScribe=require("app/data/direct_messages_scribe"),DirectMessageLinkHandler=require("app/ui/direct_message_link_handler"),TypeaheadDropdown=require("app/ui/typeahead/typeahead_dropdown"),TypeaheadInput=require("app/ui/typeahead/typeahead_input"),DirectMessageDialog=require("app/ui/direct_message_dialog"),DirectMessageMediaPreview=require("app/ui/direct_message_media_preview"),DirectMessageActions=require("app/ui/direct_message_actions"),TweetBoxManager=require("app/ui/tweet_box_manager"),ConversationActions=require("app/ui/direct_message_conversation_actions"),DeleteConversationData=require("app/data/dm/delete_conversation"),ViewParticipantsData=require("app/data/dm/view_participants"),utils=require("core/utils"),hasDialog=!!$("#dm_dialog").length;module.exports=hasDialog?initialize:$.noop
});
define("app/data/dm_poll",["module","require","exports","core/component","app/data/with_data","app/data/with_auth_token","app/data/notifications"],function(module, require, exports) {
function dmPoll(){this.defaultAttrs({noShowError:!0}),this.dispatch=function(a){a&&(notifications.updateNotificationState(a.note),this.trigger("dataNotificationsReceived",a.note))},this.makeRequest=function(a,b,c){this.get({url:"/i/toast_poll",data:c,eventData:b,success:this.dispatch.bind(this)})},this.requestConversationList=function(a,b){var c={};notifications.addDMData(c),this.makeRequest(a,b,c)},this.after("initialize",function(){this.on("uiDMPoll",this.requestConversationList)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),withAuthToken=require("app/data/with_auth_token"),notifications=require("app/data/notifications"),DMPoll=defineComponent(dmPoll,withData,withAuthToken);module.exports=DMPoll
});
define("app/ui/with_drag_events",["module","require","exports","app/utils/drag_drop_helper"],function(module, require, exports) {
function withDragEvents(){this.childHover=function(a){$.contains(this.$node.get(0),a.target)&&(a.stopImmediatePropagation(),this.inChild=a.type==="dragenter")},this.hover=function(a){a.preventDefault();if(this.inChild)return!1;this.trigger(a.type==="dragenter"?"uiDragEnter":"uiDragLeave")},this.finish=function(a){a.stopImmediatePropagation(),this.inChild=!1,this.trigger("uiDragLeave")},this.preventDefault=function(a){return a.preventDefault(),!1},this.detectDragEnd=function(a){this.detectingEnd||(this.detectingEnd=!0,$(document.body).one("mousemove",this.dragEnd.bind(this)))},this.dragEnd=function(){this.detectingEnd=!1,this.trigger("uiDragEnd")},this.outOfBounds=function(a){var b=a.originalEvent.pageX,c=a.originalEvent.pageY,d=document.body.clientWidth,e=document.body.clientHeight;(b<=0||c<=0||c>=e||b>=d)&&this.dragEnd()},this.after("initialize",function(){this.inChild=!1,this.on(document.body,"dragenter dragover",this.detectDragEnd),this.on(document.body,"dragleave",this.outOfBounds),this.on("dragenter dragleave",dragDropHelper.onlyHandleEventsWithFiles(this.hover)),this.on("dragover drop",dragDropHelper.onlyHandleEventsWithFiles(this.preventDefault)),this.on("dragenter dragleave",dragDropHelper.onlyHandleEventsWithFiles(this.childHover)),this.on(document,"uiDragEnd drop",this.finish)})}module.exports=withDragEvents;var dragDropHelper=require("app/utils/drag_drop_helper")
});
define("app/ui/drag_state",["module","require","exports","core/component","app/ui/with_drag_events"],function(module, require, exports) {
function dragState(){this.defaultAttrs({draggingClass:"currently-dragging",supportsDraggingClass:"supports-drag-and-drop"}),this.dragEnter=function(){this.$node.addClass(this.attr.draggingClass)},this.dragLeave=function(){this.$node.removeClass(this.attr.draggingClass)},this.addSupportsDraggingClass=function(){this.$node.addClass(this.attr.supportsDraggingClass)},this.hasSupport=function(){return"draggable"in document.createElement("span")&&!$.browser.msie},this.after("initialize",function(){this.hasSupport()&&(this.addSupportsDraggingClass(),this.on("uiDragEnter",this.dragEnter),this.on("uiDragLeave uiDrop",this.dragLeave))})}var defineComponent=require("core/component"),withDragEvents=require("app/ui/with_drag_events");module.exports=defineComponent(dragState,withDragEvents)
});
define("app/ui/banners/email_banner",["module","require","exports","core/component"],function(module, require, exports) {
function emailBanner(){this.defaultAttrs({emailSettingsLinkSelector:".email-settings-link",phoneSettingsLinkSelector:".phone-settings-link",resendConfirmationEmailLinkSelector:".resend-confirmation-email-link",resetBounceLinkSelector:".reset-bounce-link"}),this.emailSettingsLink=function(){this.trigger("uiClickEmailSettingsLink")},this.phoneSettingsLink=function(){this.trigger("uiClickPhoneSettingsLink")},this.resendConfirmationEmail=function(a,b){this.trigger("uiResendConfirmationEmail",{unsuspend:$(a.target).hasClass("unsuspend-confirmation")})},this.resetBounceLink=function(){this.trigger("uiResetBounceLink")},this.after("initialize",function(){this.on("click",{emailSettingsLinkSelector:this.emailSettingsLink,phoneSettingsLinkSelector:this.phoneSettingsLink,resendConfirmationEmailLinkSelector:this.resendConfirmationEmail,resetBounceLinkSelector:this.resetBounceLink})})}var defineComponent=require("core/component");module.exports=defineComponent(emailBanner)
});
define("app/data/email_banner",["module","require","exports","core/component","app/data/with_data","core/i18n"],function(module, require, exports) {
function emailBannerData(){this.resendConfirmationEmail=function(a,b){var c=function(a){this.trigger("uiShowMessage",{message:a.messageForFlash})},d=function(){this.trigger("uiShowMessage",{message:_('\u78ba\u8a8d\u30e1\u30fc\u30eb\u306e\u9001\u4fe1\u306b\u304a\u3044\u3066\u30a8\u30e9\u30fc\u304c\u767a\u751f\u3057\u307e\u3057\u305f\u3002')})};this.post({url:"/account/resend_confirmation_email",eventData:null,data:b&&b.unsuspend?{unsuspend:!0}:{},success:c.bind(this),error:d.bind(this)})},this.resetBounceScore=function(){var a=function(){this.trigger("uiShowMessage",{message:_('\u3057\u3070\u3089\u304f\u3057\u305f\u3089\u304a\u77e5\u3089\u305b\u30e1\u30fc\u30eb\u3092\u9001\u4fe1\u3057\u307e\u3059\u3002')})},b=function(){this.trigger("uiShowMessage",{message:_('\u901a\u77e5\u30e1\u30fc\u30eb\u306e\u9001\u4fe1\u306b\u304a\u3044\u3066\u30a8\u30e9\u30fc\u304b\u3099\u767a\u751f\u3057\u307e\u3057\u305f\u3002')})};this.post({url:"/bouncers/reset",eventData:null,data:null,success:a.bind(this),error:b.bind(this)})},this.after("initialize",function(){this.on("uiResendConfirmationEmail",this.resendConfirmationEmail),this.on("uiResetBounceLink",this.resetBounceScore)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),_=require("core/i18n");module.exports=defineComponent(emailBannerData,withData)
});
define("app/data/email_banner_scribe",["module","require","exports","core/component","app/data/with_scribe","core/utils"],function(module, require, exports) {
function emailBannerScribe(){this.scribeEmailSettingsClick=function(a,b){this.scribe({page:"self_unsuspend",section:"banner",component:"email_verification",element:"settings",action:"click"})},this.scribePhoneSettingsClick=function(a,b){this.scribe({page:"self_unsuspend",section:"banner",component:"phone_verification",action:"click"})},this.scribeResendConfirmationEmailClick=function(a,b){this.scribe({page:"self_unsuspend",section:"banner",component:"email_verification",element:"resend_confirmation_email",action:"click"})},this.after("initialize",function(){this.on("uiClickEmailSettingsLink",this.scribeEmailSettingsClick),this.on("uiClickPhoneSettingsLink",this.scribePhoneSettingsClick),this.on("uiResendConfirmationEmail",this.scribeResendConfirmationEmailClick)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),utils=require("core/utils");module.exports=defineComponent(emailBannerScribe,withScribe)
});
define("app/data/embed_scribe",["module","require","exports","core/component","app/data/with_scribe","app/data/with_interaction_data_scribe","core/utils"],function(module, require, exports) {
function embedScribe(){this.scribeOpen=function(a,b){this.scribeEmbedAction("open",b)},this.scribeOembedError=function(a,b){this.scribeEmbedAction("request_failed",b)},this.scribeEmbedCopy=function(a,b){this.scribeEmbedAction("copy",b)},this.scribeEmbedError=function(a,b){this.scribeEmbedAction("embed_request_failed")},this.scribeEmbedAction=function(a,b){this.scribeInteraction(a,utils.merge(b,{scribeContext:{component:"embed_tweet_dialog"}}))},this.after("initialize",function(){this.on("uiEmbedRequestFailed",this.scribeEmbedError),this.on("uiNeedsEmbedTweetDialog",this.scribeOpen),this.on("uiOembedError",this.scribeOembedError),this.on("uiUserCopiedEmbedCode",this.scribeEmbedCopy)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),withInteractionScribe=require("app/data/with_interaction_data_scribe"),utils=require("core/utils");module.exports=defineComponent(embedScribe,withScribe,withInteractionScribe)
});
define("app/data/with_widgets",["module","require","exports","core/component"],function(module, require, exports) {
function withWidgets(){this.widgetsAreLoaded=function(){return!!this.widgets&&!!this.widgets.init},this.getWidgets=function(){window.twttr||this.asyncWidgetsLoader(),this.widgets=window.twttr,window.twttr.ready(this._widgetsReady.bind(this))},this._widgetsReady=function(_){this.widgetsReady&&this.widgetsReady()},this.asyncWidgetsLoader=function(){window.twttr=function(a,b,c){var d,e,f=a.getElementsByTagName(b)[0];if(a.getElementById(c))return;return e=a.createElement(b),e.id=c,e.src="//platform.twitter.com/widgets.js",f.parentNode.insertBefore(e,f),window.twttr||(d={_e:[],ready:function(a){d._e.push(a)}})}(document,"script","twitter-wjs")}}var defineComponent=require("core/component"),WithWidgets=defineComponent(withWidgets);module.exports=withWidgets
});
define("app/ui/dialogs/embed_tweet",["module","require","exports","core/component","app/ui/with_dialog","app/data/with_card_metadata","app/data/with_widgets"],function(module, require, exports) {
function embedTweetDialog(){this.defaultAttrs({dialogSelector:"#embed-tweet-dialog",dialogContentSelector:"#embed-tweet-dialog .modal-content",previewContainerSelector:".embed-preview",embedFrameSelector:".embed-preview iframe",visibleEmbedFrameSelector:".embed-preview iframe:visible",embedCodeDestinationSelector:".embed-destination",triggerSelector:".js-embed-tweet",overlaySelector:".embed-overlay",spinnerOverlaySelector:".embed-overlay-spinner",errorOverlaySelector:".embed-overlay-error",tryAgainSelector:".embed-overlay-error .retry-embed",includeParentTweetContainerSelector:".embed-include-parent-tweet",includeParentTweetSelector:".include-parent-tweet",includeCardContainerSelector:".embed-include-card",includeCardSelector:".include-card",embedWidth:"469px",top:"90px"}),this.cacheKeyForOptions=function(a){return JSON.stringify(a.data)+a.tweetId},this.cacheKeyChanged=function(a){var b=this.cacheKeyForOptions(a);return b!=this.cacheKeyForOptions(this.getOptions())},this.didReceiveEmbedCode=function(a,b){if(this.cacheKeyChanged(b.options))return;this.select("overlaySelector").hide(),this.$embedCodeDestination.val(b.data.html),this.trigger(this.$dialog,"uiDialogContentChanged"),this.selectEmbedCode()},this.retryEmbedCode=function(a,b){if(this.cacheKeyChanged(b))return;this.select("overlaySelector").hide(),this.select("spinnerOverlaySelector").show(),this.trigger("uiOembedError",this.tweetData)},this.failedToReceiveEmbedCode=function(a,b){if(this.cacheKeyChanged(b))return;this.select("overlaySelector").hide(),this.select("embedCodeDestinationSelector").hide(),this.select("errorOverlaySelector").show(),this.clearOembed(),this.trigger(this.$dialog,"uiDialogContentChanged")},this.updateEmbedCode=function(){this.select("embedCodeDestinationSelector").show(),this.select("overlaySelector").hide(),this.trigger("uiNeedsOembed",this.getOptions()),this.trigger(this.$dialog,"uiDialogContentChanged")},this.requestTweetEmbed=function(){if(!this.widgetsAreLoaded())return;var a=this.getOptions(),b=this.cacheKeyForOptions(a);if(this.cachedTweetEmbeds[b]){this.displayCachedTweetEmbed(b);return}this.clearTweetEmbed(),this.widgets.widgets.createTweet(this.tweetId(),this.select("previewContainerSelector")[0],this.receivedTweetEmbed.bind(this,b),{width:this.attr.embedWidth,conversation:a.data.hide_thread?"none":"all",cards:a.data.hide_media?"hidden":"shown"})},this.clearTweetEmbed=function(){var a=this.select("visibleEmbedFrameSelector");this.stopPlayer(),a.hide()},this.clearOembed=function(){this.$embedCodeDestination.val("")},this.tearDown=function(){this.stopPlayer(),this.clearTweetEmbed(),this.clearOembed()},this.stopPlayer=function(){var a=this.select("embedFrameSelector");a.each(function(a,b){var c=$(b.contentWindow.document),d=c.find("div.media iframe")[0],e;if(!d||!d.src||d.src==document.location.href)return;e=d.src,d.setAttribute("src",""),d.setAttribute("src",e)})},this.displayCachedTweetEmbed=function(a){this.clearTweetEmbed(),$(this.cachedTweetEmbeds[a]).show()},this.receivedTweetEmbed=function(a,b){b?this.cachedTweetEmbeds[a]=b:this.trigger("uiEmbedRequestFailed")},this.embedCodeCopied=function(a){this.trigger("uiUserCopiedEmbedCode")},this.includeParentTweet=function(){return this.$includeParentTweet.attr("checked")=="checked"},this.showCard=function(){return this.$includeCard.attr("checked")=="checked"},this.getOptions=function(){return{data:{lang:this.lang,hide_thread:!this.includeParentTweet(),hide_media:!this.showCard()},retry:!0,tweetId:this.tweetId(),screenName:this.screenName()}},this.selectEmbedCode=function(){this.$embedCode.select()},this.setUpDialog=function(a,b){this.position(),this.eventData=a,this.tweetData=b,this.toggleIncludeParent(),this.toggleShowCard(),this.resetIncludeParent(),this.resetShowCard(),this.updateEmbedCode(),this.requestTweetEmbed(),this.open(),this.fixPosition(),this.widgetsAreLoaded()||this.getWidgets()},this.fixPosition=function(){this.$dialog.css({position:"relative",top:this.attr.top})},this.resetIncludeParent=function(){var a=this.cacheKeyForOptions(this.getOptions());if(this.cachedTweetEmbeds[a])return;this.$includeParentTweet.attr("checked","CHECKED")},this.resetShowCard=function(){var a=this.cacheKeyForOptions(this.getOptions());if(this.cachedTweetEmbeds[a])return;this.$includeCard.attr("checked","CHECKED")},this.toggleIncludeParent=function(){this.tweetHasParent()?this.$includeParentCheckboxContainer.show():this.$includeParentCheckboxContainer.hide()},this.toggleShowCard=function(){this.tweetHasCard()?this.$includeCardCheckboxContainer.show():this.$includeCardCheckboxContainer.hide()},this.tweetId=function(){return this.tweetData.tweetId},this.tweetHasParent=function(){return this.tweetData.hasParentTweet},this.tweetHasCard=function(){return this.getCardDataFromTweet($(this.eventData.target)).tweetHasCard},this.screenName=function(){return this.tweetData.screenName},this.widgetsReady=function(){this.$dialogContainer&&this.isOpen()&&this.requestTweetEmbed()},this.onOptionChange=function(){this.trigger("uiNeedsOembed",this.getOptions()),this.requestTweetEmbed()},this.restoreFocusToTweet=function(a){$(a.target).is(this.$dialog)&&this.activeEl&&this.trigger($(this.activeEl).closest(".tweet"),"uiShouldAddFocusStyle")},this.after("initialize",function(){this.$includeParentTweet=this.select("includeParentTweetSelector"),this.$embedCodeDestination=this.select("embedCodeDestinationSelector"),this.$includeParentCheckboxContainer=this.select("includeParentTweetContainerSelector"),this.$includeCard=this.select("includeCardSelector"),this.$includeCardCheckboxContainer=this.select("includeCardContainerSelector"),this.$embedCode=this.select("embedCodeDestinationSelector"),this.on(document,"uiNeedsEmbedTweetDialog",this.setUpDialog),this.on("uiDialogCloseRequested",this.tearDown),this.on(document,"uiDialogRestorePreviousFocus",this.restoreFocusToTweet),this.on(document,"dataOembedSuccess",this.didReceiveEmbedCode),this.on(document,"dataOembedError",this.failedToReceiveEmbedCode),this.on(document,"dataOembedRetry",this.retryEmbedCode),this.on(this.$embedCodeDestination,"copy cut",this.embedCodeCopied),this.on(this.$embedCode,"click",this.selectEmbedCode),this.on("click",{tryAgainSelector:this.updateEmbedCode}),this.on("change",{includeParentTweetSelector:this.onOptionChange,includeCardSelector:this.onOptionChange}),this.lang=document.documentElement.getAttribute("lang"),this.cachedTweetEmbeds={}})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withCardMetadata=require("app/data/with_card_metadata"),withWidgets=require("app/data/with_widgets"),EmbedTweetDialog=defineComponent(embedTweetDialog,withDialog,withCardMetadata,withWidgets);module.exports=EmbedTweetDialog
});
define("app/data/feedback/feedback",["module","require","exports","core/component","app/utils/cookie","app/data/with_data"],function(module, require, exports) {
function feedbackData(){var a=!0;this.defaultAttrs({feedbackCookie:"debug_data",data:{},reportEmail:undefined,reportBackendPingUrl:undefined,reportBackendPostUrl:undefined,reportBackendGetUrl:undefined}),this.isBackendAvailable=function(){return a},this.getFeedbackData=function(a,b){this.trigger("dataFeedback",this.attr.data)},this.toggleFeedbackCookie=function(a,b){var c=b.enabled?!0:null;cookie(this.attr.feedbackCookie,c),this.refreshPage(),this.checkDebugEnabled()},this.refreshPage=function(){document.location.reload(!0)},this.checkDebugEnabled=function(){this.trigger("dataDebugFeedbackChanged",{enabled:!!cookie(this.attr.feedbackCookie)})},this.addFeedbackData=function(a,b){var c=this.attr.data;for(var d in b)c[d]?c[d]=[].concat.apply(c[d],b[d]):c[d]=b[d]},this.pingBackend=function(b,c){if(this.attr.reportBackendPingUrl==null){a=!1;return}var d=function(b){a=!0},e=function(b){a=!1};this.get({url:this.attr.reportBackendPingUrl,success:d.bind(this),error:e.bind(this)})},this.backendPost=function(b,c){if(!this.isBackendAvailable()){this.fallbackToEmail(b,c);return}var d=function(a){var b=this.attr.reportBackendGetUrl+a.key;this.trigger("dataFeedbackBackendSuccess",{link:b,ticketId:a.key})},e=function(d){a=!1,this.fallbackToEmail(b,c)};this.post({url:this.attr.reportBackendPostUrl,data:c,isMutation:!1,success:d.bind(this),error:e.bind(this)})},this.fallbackToEmail=function(a,b){var c="mailto:"+this.attr.reportEmail+"?subject="+b.summary+"&body=",d=["summary","debug_data","debug_text","screenshotData"];for(var e in b)d.indexOf(e)<0&&(c+=e.toString()+": "+b[e].toString()+"%0D%0A");this.trigger("dataFeedbackBackendFailure",{link:c,data:b})},this.logNavigation=function(a,b){this.trigger("dataSetDebugData",{pushState:[{data:{href:b.href,module:b.module,title:b.title}}]})},this.after("initialize",function(){this.data=this.attr.data||{},this.on("uiNeedsFeedbackData",this.getFeedbackData),this.on("uiToggleDebugFeedback",this.toggleFeedbackCookie),this.on("dataSetDebugData",this.addFeedbackData),this.on("uiCheckFeedbackBackendAvailable",this.pingBackend),this.on("uiFeedbackBackendPost",this.backendPost),this.on("uiPageChanged",this.logNavigation),this.checkDebugEnabled()})}var defineComponent=require("core/component"),cookie=require("app/utils/cookie"),withData=require("app/data/with_data");module.exports=defineComponent(feedbackData,withData)
});
define("app/ui/feedback/with_feedback_tweet",["module","require","exports","core/compose","app/ui/dialogs/with_modal_tweet"],function(module, require, exports) {
function withFeedbackTweet(){compose.mixin(this,[withModalTweet]),this.defaultAttrs({tweetItemSelector:"div.tweet",streamSelector:"div.stream-container"}),this.insertTweetIntoDialog=function(){if(this.selectedKey.indexOf("stream_status_")==-1)return;var a=this.attr.tweetItemSelector.split(",").map(function(a){return a+"[data-feedback-key="+this.selectedKey+"]"}.bind(this)).join(","),b=$(this.attr.streamSelector).find(a);this.addTweet(b.clone().removeClass("retweeted favorited"))},this.after("initialize",function(){this.on(document,"uiInsertElementIntoFeedbackDialog",this.insertTweetIntoDialog)})}var compose=require("core/compose"),withModalTweet=require("app/ui/dialogs/with_modal_tweet");module.exports=withFeedbackTweet
});
define("app/ui/feedback/feedback_stories",["module","require","exports","core/component"],function(module, require, exports) {
function feedbackStories(){this.defaultAttrs({debugStringToggle:".toggle-debug",debugStringSelector:".debug-string",storyDataSelector:".story-data"}),this.toggleDebugData=function(a){this.select("storyDataSelector").toggleClass("expanded")},this.convertDebugToHTML=function(){var a=this.select("debugStringSelector").text(),b=a.replace(/\n/g,"<br>");this.select("debugStringSelector").html(b)},this.after("initialize",function(){this.convertDebugToHTML(),this.on("click",{debugStringToggle:this.toggleDebugData})})}var defineComponent=require("core/component");module.exports=defineComponent(feedbackStories)
});
define("app/ui/feedback/with_feedback_discover",["module","require","exports","app/ui/feedback/feedback_stories"],function(module, require, exports) {
function withFeedbackDiscover(){this.defaultAttrs({storyItemSelector:"div.tweet",storyStreamSelector:"div.stream-container",debugStorySelector:".debug-story.expanded",inlinedStorySelector:".debug-story.inlined"}),this.insertStoryIntoDialog=function(){if(this.selectedKey.indexOf("story_status_")==-1)return;var a=this.attr.storyItemSelector+'[data-feedback-key="'+this.selectedKey+'"]',b=$(this.attr.storyStreamSelector).find(a);this.select("debugStorySelector").append(b.clone().removeClass("retweeted favorited"))},this.insertFeedbackStories=function(){if(this.selectedKey!="discover_stories_debug")return;var a=$(this.attr.storyStreamSelector).find(this.attr.storyItemSelector),b=this.select("contentContainerSelector");b.empty(),a.each(function(a,c){var d=$(c).data("feedback-key");this.debugData[d]&&this.debugData[d].forEach(function(a){b.append(a.html)})}.bind(this)),this.select("inlinedStorySelector").show(),FeedbackStories.attachTo(this.attr.inlinedStorySelector)},this.after("initialize",function(){this.on(document,"uiInsertElementIntoFeedbackDialog",this.insertStoryIntoDialog),this.on(document,"uiInsertElementIntoFeedbackDialog",this.insertFeedbackStories)})}var FeedbackStories=require("app/ui/feedback/feedback_stories");module.exports=withFeedbackDiscover
});
define("app/ui/feedback/feedback_dialog",["module","require","exports","core/component","app/utils/cookie","app/ui/with_dialog","app/ui/feedback/with_feedback_tweet","app/ui/feedback/with_feedback_discover","core/i18n"],function(module, require, exports) {
function feedbackDialog(){this.defaultAttrs({contentContainerSelector:".sample-content",debugContainerSelector:".modal-inner.debug",cancelSelector:".cancel",reportLinkSelector:".report-link",spinnerSelector:".loading-spinner",pastedContentSelector:".feedback-json-output",selectPasteSelector:"#select-paste-text",formSelector:"form",navBarSelector:".nav-tabs",navBarTabSelector:".nav-tabs li:not(.tab-disabled):not(.active)",debugKeySelectorSelector:"select[name=debug-key]",summaryInputSelector:"input[name=summary]",descriptionInputSelector:"textarea[name=comments]",screenshotInputSelector:"input[name=includeScreenshot]",screenshotPreviewLink:"#feedback-preview-screenshot",summaryErrorSelector:".summary-error",descriptionErrorSelector:".description-error",lastTabCookie:"last_feedback_tab",reportEmail:null,reportScreenshotProxyUrl:null,debugDataText:"",debugDataKey:"",feedbackSuccessText:"",dialogToggleSelector:".feedback-dialog .feedback-data-toggle"}),this.takeScreenshot=function(){using("$lib/html2canvas.js",function(){var a=function(a){this.imageCanvas||(this.imageCanvas=a,this.select("screenshotPreviewLink").attr("href",this.imageCanvas.toDataURL()),this.trigger("uiNeedsFeedbackData"))};html2canvas($("body"),{proxy:null,onrendered:a.bind(this),timeout:1e3})}.bind(this))},this.setErrorState=function(a,b){b?this.select(a).show():this.select(a).hide()},this.resetParams=function(a){this.selectedKey=this.debugKey,this.selectedProject=this.projectKey,this.debugKey=null,this.projectKey=null,this.debugData=a},this.toggleDebugEnabled=function(a,b){this.trigger("uiToggleDebugFeedback",{enabled:$(b.el).is(".off")})},this.prepareDialog=function(a,b){this.debugKey=b.debugKey,this.projectKey=b.projectKey,this.imageCanvas=null,this.takeScreenshot()},this.openDialog=function(a,b){this.showTabFromName(cookie(this.attr.lastTabCookie)||"report");var c="";this.debugKey&&b[this.debugKey]&&b[this.debugKey].length>0&&b[this.debugKey].forEach(function(a){a.html&&(c+=a.html)}),this.select("contentContainerSelector").html(c),this.select("screenshotInputSelector").attr("checked",!0),this.select("reportLinkSelector").find("button").removeClass("disabled"),this.select("spinnerSelector").css("visibility","hidden"),this.trigger("uiCheckFeedbackBackendAvailable"),this.resetParams(b),this.resetErrorStatus(),this.selectedKey&&this.trigger("uiInsertElementIntoFeedbackDialog"),this.refreshAvailableDataKeys(),this.reportToConsole(b),this.open()},this.showTabFromName=function(a){this.select("navBarSelector").find("li").removeClass("active"),this.select("navBarSelector").find("li[data-tab-name="+a+"]").addClass("active"),this.$node.find(".modal-inner").hide(),this.$node.find(".modal-inner."+a).show(),cookie(this.attr.lastTabCookie,a)},this.refreshAvailableDataKeys=function(){var a=this.select("debugKeySelectorSelector");a.empty();var b=this.selectedKey;Object.keys(this.debugData).forEach(function(c){var d=$("<option>"+c+"</option>");b==c&&(d=$("<option value="+c+">"+c+" (selected)</option>")),a.append(d)}),a.val(this.selectedKey),this.refreshDebugJSON()},this.refreshDebugJSON=function(a){var b=this.select("debugKeySelectorSelector").val()||this.selectedKey;if(!b||!this.debugData[b])return;var c=this.debugData[b].map(function(a){return a.data});this.select("pastedContentSelector").html(JSON.stringify(c,undefined,2))},this.resetErrorStatus=function(){this.setErrorState("summaryErrorSelector",!1),this.setErrorState("descriptionErrorSelector",!1)},this.reportToConsole=function(a){if(!window.console||!Object.keys(a).length)return;console.log&&console.log(this.attr.debugDataText),console.dir&&console.dir(this.debugData)},this.reportFeedback=function(a,b){a.preventDefault(),this.resetErrorStatus();var c={};this.select("formSelector").serializeArray().map(function(a){c[a.name]&&$.isArray(c[a.name])?c[a.name].push(a.value):c[a.name]?c[a.name]=[c[a.name],a.value]:c[a.name]=a.value});var d=this.select("summaryInputSelector").val(),e=this.select("descriptionInputSelector").val();if(!d||!e){d||this.setErrorState("summaryErrorSelector",!0),e||this.setErrorState("descriptionErrorSelector",!0);return}this.imageCanvas&&c.includeScreenshot&&(c.screenshotData=this.imageCanvas.toDataURL()),this.selectedProject&&(c.project=this.selectedProject),this.selectedKey&&(c.key=this.selectedKey),$.isEmptyObject(this.debugData)||(c.debug_text=JSON.stringify(this.debugData,undefined,2),this.debugData.initial_pageload&&(basicData=this.debugData.initial_pageload[0].data,c.basic_info="Screen Name: "+basicData.screen_name+"\n"+"URL: "+basicData.url+"\n"+"User Agent: "+basicData.userAgent)),this.select("reportLinkSelector").find("button").addClass("disabled"),this.select("spinnerSelector").css("visibility","visible"),this.trigger("uiFeedbackBackendPost",c)},this.handleBackendSuccess=function(a,b){this.close(),this.select("formSelector")[0].reset(),this.trigger("uiShowError",{message:_('Successfully created Jira ticket: {{ticketId}}',{ticketId:"<a target='_blank' href='"+b.link+"'>"+b.ticketId+"</a>"})})},this.triggerEmail=function(a,b){this.close(),this.select("formSelector")[0].reset(),window.open(b.link,"_blank"),this.trigger("uiShowError",{message:_('Failed to create Jira ticket. Please see the popup to send an email instead.')})},this.switchTab=function(a,b){a.preventDefault(),this.showTabFromName($(a.target).closest("li").data("tab-name"))},this.selectText=function(a,b){this.select("debugContainerSelector").find("textarea")[0].select()},this.after("initialize",function(){this.on(document,"dataFeedback",this.openDialog),this.on(document,"dataFeedbackBackendSuccess",this.handleBackendSuccess),this.on(document,"dataFeedbackBackendFailure",this.triggerEmail),this.on(document,"uiPrepareFeedbackDialog",this.prepareDialog),this.on("change",{debugKeySelectorSelector:this.refreshDebugJSON}),this.on("click",{dialogToggleSelector:this.toggleDebugEnabled,navBarTabSelector:this.switchTab,cancelSelector:this.close,reportLinkSelector:this.reportFeedback,selectPasteSelector:this.selectText})})}var defineComponent=require("core/component"),cookie=require("app/utils/cookie"),withDialog=require("app/ui/with_dialog"),withFeedbackTweet=require("app/ui/feedback/with_feedback_tweet"),withFeedbackDiscover=require("app/ui/feedback/with_feedback_discover"),_=require("core/i18n");module.exports=defineComponent(feedbackDialog,withDialog,withFeedbackTweet,withFeedbackDiscover)
});
define("app/ui/feedback/feedback_report_link_handler",["module","require","exports","core/component"],function(module, require, exports) {
function feedbackReportLinkHandler(){this.defaultAttrs({reportElementLinkSelector:".feedback-btn[data-feedback-key]"}),this.openDialog=function(a,b){a.preventDefault();var c=$(b.el);b={},b.debugKey=c.data("feedback-key"),b.projectKey=c.data("team-key"),this.trigger("uiPrepareFeedbackDialog",b)},this.after("initialize",function(){this.on(document,"click",{reportElementLinkSelector:this.openDialog})})}var defineComponent=require("core/component");module.exports=defineComponent(feedbackReportLinkHandler)
});
define("app/utils/image/image_loader",["module","require","exports"],function(module, require, exports) {
var imageLoader={load:function(a,b,c){var d=$("<img/>");d.on("load",function(a){b(d)}),d.on("error",function(a){c()}),d.attr("src",a)}};module.exports=imageLoader
});
define("app/ui/media/with_flag_action",["module","require","exports"],function(module, require, exports) {
module.exports=function(){this.defaultAttrs({flagContainerSelector:".flag-container",flaggableSelector:".flaggable",flaggedSelector:".flagged",tweetWithIdSelector:".tweet[data-tweet-id]"}),this.flagMedia=function(a){var b=$(a.target).closest(this.attr.flagContainerSelector),c=b.find(this.attr.flaggableSelector);if(!c.hasClass("hidden")){var d=b.closest(this.attr.tweetWithIdSelector);d.attr("data-possibly-sensitive")?this.trigger("uiFlagConfirmation",{id:d.attr("data-tweet-id")}):(this.trigger("uiFlagMedia",{id:d.attr("data-tweet-id")}),b.find(this.attr.flaggableSelector).addClass("hidden"),b.find(this.attr.flaggedSelector).removeClass("hidden"))}},this.after("initialize",function(){this.on("click",{flagContainerSelector:this.flagMedia})})}
});
define("app/ui/with_tweet_translation",["module","require","exports","core/compose","app/utils/tweet_helper","app/ui/with_interaction_data","app/utils/rtl_text","core/i18n"],function(module, require, exports) {
function withTweetTranslation(){compose.mixin(this,[withInteractionData]),this.defaultAttrs({tweetSelector:"div.tweet",tweetTranslationSelector:".tweet-translation",tweetTranslationTextSelector:".tweet-translation-text",translateTweetSelector:".js-translate-tweet",translateAndExpandTweetSelector:".js-translate-tweet.expand-stream-item",autoTranslatedTweetSelector:"div.auto-translatable-tweet",needsTranslationClass:"needs-translation",translateLabelSelector:".translate-label",permalinkContainerSelector:".permalink-tweet-container",permalinkClass:".permalink-tweet",languageSelector:".tweet-language",galleryTranslateButtonSelector:".Gallery .GalleryTweet .tweet .translate-button"}),this.translateTweet=function(a){var b=this.tweetFromEvent(a);if(b.find(this.attr.tweetTranslationSelector).hasClass(this.attr.needsTranslationClass)){var c=this.interactionData(b);c.dest=b.find(this.attr.tweetTranslationSelector).data("destLang"),this.trigger(b,"uiNeedsTweetTranslation",c)}},this.expandTweet=function(a){this.trigger(this.tweetFromEvent(a),"uiExpandTweet")},this.autoTranslationEnabled=function(){return!!$(this.attr.autoTranslatedTweetSelector).length},this.tweetFromEvent=function(a){return $(a.target).closest(this.attr.tweetSelector)},this.showTweetTranslation=function(a,b){var c,d;if(b.item_html){d=this.findTweetById($(a.target),b.id_str),c=d.find(this.attr.tweetTranslationSelector);if(!b.translated_lang){d.find(this.attr.translateTweetSelector).hide();return}c.find(this.attr.languageSelector).html(b.translated_lang),c.find(this.attr.tweetTranslationTextSelector).html(b.item_html),c.removeClass(this.attr.needsTranslationClass),d.find(this.attr.translateTweetSelector).toArray().forEach(function(a){var b=$(a);(!b.is(this.attr.translateAndExpandTweetSelector)||b.is(this.attr.galleryTranslateButtonSelector))&&b.hide()},this)}},this.findTweetById=function(a,b){var c=this.tweetSelectorById(b);return a.is(c)?a:a.find(c)},this.tweetSelectorById=function(a){return this.attr.tweetSelector+"[data-tweet-id="+a.replace(/\D/g,"")+"]"},this.showError=function(a,b){this.trigger("uiShowMessage",{message:_('\u30c4\u30a4\u30fc\u30c8\u3092\u7ffb\u8a33\u3067\u304d\u307e\u305b\u3093\u3067\u3057\u305f\u3002\u3057\u3070\u3089\u304f\u3057\u3066\u304b\u3089\u3082\u3046\u4e00\u5ea6\u304a\u8a66\u3057\u304f\u3060\u3055\u3044\u3002')})},this.after("initialize",function(){this.on("dataTweetTranslationSuccess",this.showTweetTranslation),this.on("dataTweetTranslationError",this.showError);var a={translateAndExpandTweetSelector:this.expandTweet};this.autoTranslationEnabled()?this.on("uiTimelineNeedsTranslation",this.translateTweet):a.translateTweetSelector=this.translateTweet,this.on("click",a)})}var compose=require("core/compose"),tweetHelper=require("app/utils/tweet_helper"),withInteractionData=require("app/ui/with_interaction_data"),RTLText=require("app/utils/rtl_text"),_=require("core/i18n");module.exports=withTweetTranslation
});
define("app/ui/gallery/gallery",["module","require","exports","core/component","core/utils","core/i18n","app/utils/image/image_loader","app/utils/image/image_resizer","app/ui/media/with_flag_action","app/ui/with_item_actions","app/ui/with_tweet_translation","app/ui/with_scrollbar_width"],function(module, require, exports) {
function gallery(){this.tweetHtml={},this.defaultAttrs({profileUser:!1,defaultGalleryTitle:_('\u30d5\u30a9\u30c8\u30ae\u30e3\u30e9\u30ea\u30fc'),mediaSelector:".media-thumbnail",galleryParentSelector:".Gallery",galleryMediaSelector:".Gallery-media",galleryTweetSelector:".GalleryTweet",closeSelector:".js-close, .Gallery-closeTarget",gridSelector:".grid-action",gallerySelector:".Gallery-content",galleryTitleSelector:".modal-title",imageSelector:".media-image",navSelector:".GalleryNav",prevSelector:".GalleryNav--prev",nextSelector:".GalleryNav--next",itemType:"tweet",modalHeaderSelector:".modal-header",tweetlessGalleryClass:"is-tweetless",inOverlayGalleryClass:"Gallery--inOverlay"}),this.isOpen=function(){return this.$node.is(":visible")},this.open=function(a,b){this.calculateScrollbarWidth(),this.fromGrid=b&&!!b.fromGrid,this.title=b&&b.title?b.title:this.attr.defaultGalleryTitle,this.select("galleryTitleSelector").text(this.title),b&&b.inOverlay?this.$node.addClass(this.attr.inOverlayGalleryClass):this.$node.removeClass(this.attr.inOverlayGalleryClass),b&&b.showGrid&&b.profileUser?(this.select("gallerySelector").removeClass("no-grid"),this.select("gridSelector").attr("href","/"+b.profileUser.screen_name+"/media"),this.select("gridSelector").find(".visuallyhidden").text(b.profileUser.name),this.select("gridSelector").addClass("js-nav")):(this.select("gallerySelector").addClass("no-grid"),this.select("gridSelector").removeClass("js-nav"));var c=$(a.target).closest(this.attr.mediaSelector);if(this.isOpen()||c.length==0)return;b&&b.timelineSelector?this.$timeline=c.closest(b.timelineSelector):this.$timeline=c.parent(),imageResizer.resetMinSize(this.select("gallerySelector")),this.render(c),$("body").addClass("gallery-enabled"),this.select("gallerySelector").addClass("show-controls"),this.on("mousemove",function(){this.select("gallerySelector").removeClass("show-controls")}.bind(this)),this.trigger("uiGalleryOpened")},this.handleClose=function(a){if(!this.isOpen())return;this.fromGrid?this.returnToGrid(!0):this.closeGallery()},this.returnToGrid=function(a){this.trigger(this.$current,"uiOpenGrid",{title:this.title,fromGallery:a}),this.closeGallery()},this.closeGallery=function(){$("body").hasClass("gallery-enabled")&&($("body").removeClass("gallery-enabled"),this.select("galleryMediaSelector").empty(),this.hideNav(),this.enableNav(!1,!1),this.off(window,"resize",this.debouncedResize),this.off("mousemove"),delete this.$timeline,delete this.$current,this.trigger("uiGalleryClosed"),this.trigger("uiDialogClosed"))},this.render=function(a){this.clearTweet(),this.$current=a,this.renderNav(),this.trigger(a,"uiGalleryMediaLoad"),this.renderMedia(!0,a)},this.renderNav=function(){if(!this.$current)return;var a,b,c,d;a=this.$timeline.find(this.attr.mediaSelector),d=a.index(this.$current),b=a.slice(0,d),c=a.slice(d+1);var e=c.length>0,f=b.length>0;this.enableNav(e,f),e||f?this.showNav():this.hideNav()},this.preloadNeighbors=function(a){this.preloadRecursive(a,"next",2),this.preloadRecursive(a,"prev",2)},this.clearTweet=function(){this.select("galleryTweetSelector").empty()},this.getTweet=function(a){if(!a)return;this.tweetHtml[a]?this.renderTweet(a,this.tweetHtml[a]):(this.$current&&this.getTweetId(this.$current)==a&&this.select("galleryMediaSelector").find(".media-image,iframe").hide(),this.trigger("uiGetTweet",{id:a,modal:"gallery"}))},this.gotTweet=function(a,b){b.id&&b.tweet_html&&(this.tweetHtml[b.id]=b.tweet_html,this.renderTweet(b.id,b.tweet_html))},this.renderTweet=function(a,b){if(this.$current&&this.getTweetId(this.$current)==a){var c=this.select("galleryTweetSelector"),d=this.select("gallerySelector"),e=this.select("galleryMediaSelector").find(".media-image,iframe");c.html(b),this.trigger(c.find(".tweet"),"uiTimelineNeedsTranslation"),e.length&&(e.show(),imageResizer.resizeMedia(e,d,!1,this.attr.galleryTweetSelector))}},this.getTweetId=function(a){return a.attr("data-status-id")?a.attr("data-status-id"):a.closest("[data-tweet-id]").attr("data-tweet-id")},this.getAllInDir=function(a,b){var c,d,e;d=b=="prev"?-1:1,e=this.$timeline.find(this.attr.mediaSelector);var f=e.index(a)+d;return f>-1&&(c=e.slice(f)),c||$()},this.getInDir=function(a,b){return this.getAllInDir(a,b).first()},this.preloadRecursive=function(a,b,c){if(c==0)return;if(this.$timeline.find(this.attr.mediaSelector).length==1)return;if(b=="next"&&this.getAllInDir(a,b).length<c&&!this.$timeline.hasClass("dashboard")){this.trigger("uiNearTheBottom");return}var d=this.getInDir(a,b);if(!d||!d.length)return;d.attr("data-preloading",!0);var e=function(a){d.attr("data-preloaded",!0),this.getTweet(this.getTweetId(d)),this.preloadRecursive(d,b,--c)}.bind(this),f=function(){d.remove(),this.preloadRecursive(d,b,c)}.bind(this);imageLoader.load(d.attr("data-resolved-url-large"),e,f)},this.renderMedia=function(a,b){a?(b.attr("data-source-url")?this.loadVideo(b):this.loadImage(b),this.preloadNeighbors(b)):(b.remove(),this.next())},this.loadImage=function(a){var b=$('<img class="media-image"/>');b.on("load",function(c){var d=this.getTweetId(a),e=this.select("gallerySelector");a.attr("loaded",!0),this.select("galleryMediaSelector").empty().append(b),b[0].height==0?b.height(a.data("img-height")).width(a.data("img-width")):(a.data("img-height",b[0].height),a.data("img-width",b[0].width)),b.attr({"data-height":b[0].height,"data-width":b[0].width}),imageResizer.resizeMedia(b,e,!1,this.attr.galleryTweetSelector,!0),this.$current=a,d?(this.getTweet(d),e.closest(this.attr.galleryParentSelector).removeClass(this.attr.tweetlessGalleryClass)):e.closest(this.attr.galleryParentSelector).addClass(this.attr.tweetlessGalleryClass),this.trigger("uiGalleryMediaLoaded",{url:b.attr("src"),id:a.attr("data-status-id")})}.bind(this)),b.on("error",function(c){this.trigger("uiGalleryMediaFailed",{url:b.attr("src"),id:a.attr("data-status-id")}),a.remove(),this.next()}.bind(this)),b.attr("src",a.attr("data-resolved-url-large")),this.select("gallerySelector").removeClass("video")},this.fixSnappyUrl=function(a){var b=a.attr("data-source-url"),c=/https:\/\/www.snappytv.com\/tc\/(\d+)\?autoplay=true&h=(\d+)&w=(\d+)/;if(!c.test(b))return;var d=a.attr("data-height")*2,e=a.attr("data-width")*2;b=b.replace(c,"https://www.snappytv.com/tc/$1?autoplay=true&h="+d+"&w="+e),a.attr("data-source-url",b)},this.loadVideo=function(a){var b=$("<iframe>");this.fixSnappyUrl(a),b.height(a.attr("data-height")*2).width(a.attr("data-width")*2).attr("data-height",a.attr("data-height")*2).attr("data-width",a.attr("data-width")*2).attr("src",a.attr("data-source-url")),a.attr("loaded",!0),this.select("galleryMediaSelector").empty().append(b),this.$current=a,this.getTweet(a.attr("data-status-id")),this.select("gallerySelector").addClass("video")},this.prev=function(){this.gotoMedia("prev"),this.trigger("uiGalleryNavigatePrev")},this.next=function(){this.gotoMedia("next"),this.trigger("uiGalleryNavigateNext")},this.gotoMedia=function(a){if(this.$current){var b=this.getInDir(this.$current,a);b.length&&this.render(b)}},this.showNav=function(){this.select("navSelector").show()},this.hideNav=function(){this.select("navSelector").hide()},this.enableNav=function(a,b){a?this.select("nextSelector").addClass("enabled"):this.select("nextSelector").removeClass("enabled"),b?this.select("prevSelector").addClass("enabled"):this.select("prevSelector").removeClass("enabled")},this.throttle=function(a,b,c){var d=!1;return function(){d||(a.apply(c,arguments),d=!0,setTimeout(function(){d=!1},b))}},this.after("initialize",function(){this.on("uiReplyToTweet","uiOpenReplyDialog"),this.on(document,"dataDidDeleteTweet",this.closeGallery),this.on(document,"dataGotMoreMediaTimelineItems",this.renderNav),this.on(document,"uiOpenGallery",this.open),this.on(document,"uiCloseGallery",this.closeGallery),this.on(document,"uiShortcutEsc",this.handleClose),this.on(window,"popstate",this.closeGallery),this.on(document,"uiShortcutLeft",this.throttle(this.prev,200,this)),this.on(document,"uiShortcutRight",this.throttle(this.next,200,this)),this.on(document,"dataGotTweet",this.gotTweet),this.on("click",{prevSelector:this.prev,nextSelector:this.next,closeSelector:this.handleClose,gridSelector:this.closeGallery})})}var defineComponent=require("core/component"),utils=require("core/utils"),_=require("core/i18n"),imageLoader=require("app/utils/image/image_loader"),imageResizer=require("app/utils/image/image_resizer"),withFlagAction=require("app/ui/media/with_flag_action"),withItemActions=require("app/ui/with_item_actions"),withTweetTranslation=require("app/ui/with_tweet_translation"),withScrollbarWidth=require("app/ui/with_scrollbar_width"),Gallery=defineComponent(gallery,withItemActions,withFlagAction,withScrollbarWidth,withTweetTranslation);module.exports=Gallery
});
define("app/data/gallery_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function galleryScribe(){this.scribeGalleryOpened=function(a,b){this.scribe({element:"gallery",action:"open"},b)},this.scribeGalleryClosed=function(a,b){this.scribe({element:"gallery",action:"close"},b)},this.scribeGalleryMediaLoaded=function(a,b){var c={url:b.url,item_ids:[b.id]};this.scribe({element:"photo",action:"impression"},b,c)},this.scribeGalleryMediaFailed=function(a,b){var c={url:b.url,item_ids:[b.id]};this.scribe({element:"photo",action:"error"},b,c)},this.scribeGalleryNavigateNext=function(a,b){this.scribe({element:"next",action:"click"},b)},this.scribeGalleryNavigatePrev=function(a,b){this.scribe({element:"prev",action:"click"},b)},this.scribeGridPaged=function(a,b){this.scribe({element:"grid",action:"page"},b)},this.scribeGridOpened=function(a,b){this.scribe({element:"grid",action:"impression"},b)},this.after("initialize",function(){this.on(document,"uiGalleryOpened",this.scribeGalleryOpened),this.on(document,"uiGalleryClosed",this.scribeGalleryClosed),this.on(document,"uiGalleryMediaLoaded",this.scribeGalleryMediaLoaded),this.on(document,"uiGalleryMediaFailed",this.scribeGalleryMediaFailed),this.on(document,"uiGalleryNavigateNext",this.scribeGalleryNavigateNext),this.on(document,"uiGalleryNavigatePrev",this.scribeGalleryNavigatePrev),this.on(document,"uiGridPaged",this.scribeGridPaged),this.on(document,"uiGridOpened",this.scribeGridOpened)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(galleryScribe,withScribe)
});
define("app/ui/global_loading_indicator",["module","require","exports","core/component"],function(module, require, exports) {
function globalLoadingIndicator(){this.defaultAttrs({birdSelector:"h1.bird-topbar-etched",spinnerContainer:"body",globalHeadingSelector:".global-nav h1",spinnerClass:"pushing-state",spinnerSelector:".pushstate-spinner"}),this.showSpinner=function(a,b){this.select("birdSelector").removeAttr("style"),this.select("spinnerContainer").addClass(this.attr.spinnerClass)},this.hideSpinner=function(a,b){this.select("spinnerContainer").removeClass(this.attr.spinnerClass)},this.addSpinner=function(){this.select("spinnerSelector").length||$('<div class="pushstate-spinner"></div>').insertAfter(this.select("globalHeadingSelector"))},this.after("initialize",function(){this.on("uiSwiftLoaded",this.addSpinner),this.on("uiShowGlobalLoadingIndicator",this.showSpinner),this.on("uiHideGlobalLoadingIndicator",this.hideSpinner)})}var defineComponent=require("core/component"),GlobalLoadingIndicator=defineComponent(globalLoadingIndicator);module.exports=GlobalLoadingIndicator
});
define("app/ui/dialogs/goto_user_dialog",["module","require","exports","core/component","app/ui/typeahead/typeahead_dropdown","app/ui/typeahead/typeahead_input","app/ui/with_dialog"],function(module, require, exports) {
function gotoUserDialog(){this.defaultAttrs({dropdownId:"swift_autocomplete_dropdown_goto_user",inputSelector:"input.username-input",usernameFormSelector:"form.goto-user-form"}),this.focus=function(){this.select("inputSelector").focus()},this.gotoUser=function(a,b){if(b&&b.dropdownId&&b.dropdownId!=this.attr.dropdownId)return;a.preventDefault();if(b&&b.item){this.select("inputSelector").val(b.item.screen_name),this.trigger("uiNavigate",{href:b.href});return}var c=this.select("inputSelector").val().trim();c.substr(0,1)=="@"&&(c=c.substr(1)),this.trigger("uiNavigate",{href:"/"+c})},this.reset=function(){this.select("inputSelector").val(""),this.select("inputSelector").blur(),this.trigger(this.select("inputSelector"),"uiHideAutocomplete")},this.after("initialize",function(){this.on(document,"uiShortcutShowGotoUser",this.open),this.on("uiDialogOpened",this.focus),this.on("uiDialogClosed",this.reset),this.on(this.select("usernameFormSelector"),"submit",this.gotoUser),this.on("uiTypeaheadItemSelected uiTypeaheadSubmitQuery",this.gotoUser),TypeaheadInput.attachTo(this.$node,{inputSelector:this.attr.inputSelector}),TypeaheadDropdown.attachTo(this.$node,{inputSelector:this.attr.inputSelector,autocompleteAccounts:!1,datasourceRenders:[["accounts",["accounts"]]],deciders:this.attr.typeaheadData,eventData:{scribeContext:{component:"goto_user_dialog"}}})})}var defineComponent=require("core/component"),TypeaheadDropdown=require("app/ui/typeahead/typeahead_dropdown"),TypeaheadInput=require("app/ui/typeahead/typeahead_input"),withDialog=require("app/ui/with_dialog"),GotoUserDialog=defineComponent(gotoUserDialog,withDialog);module.exports=GotoUserDialog
});
define("app/ui/dialogs/keyboard_shortcuts_dialog",["module","require","exports","core/component","app/ui/with_dialog","core/i18n","app/utils/cookie","template"],function(module, require, exports) {
function keyboardShortcutsDialog(){this.defaultAttrs({showShortcutsBtnSelector:"#show-shortcuts-btn",dismissShortcutsBtnSelector:"#dismiss-shortcuts-btn",suppressSRMsgCookie:"suppress_sr_shortcuts_msg",enableActivity:!1,loggedIn:!1}),this.renderSRMessage=function(){if($("#kb-shortcuts-msg").length)return;var a=template.screen_reader_kb_shortcuts_message.render({},template);$(a).insertBefore(document.body.firstChild)},this.addMessage=function(){if(cookie(this.attr.suppressSRMsgCookie))return;this.renderSRMessage()},this.removeMessage=function(){$("#kb-shortcuts-msg").remove(),cookie(this.attr.suppressSRMsgCookie,"1")},this.renderShortcutsDialog=function(){if($("#keyboard-shortcut-dialog").length)return;var a={is_mac:isMac,enable_activity:this.attr.enableActivity,logged_in:this.attr.loggedIn};$("body").append(template["dialogs/keyboard_shortcuts_dialog"].render(a,template)),this.$dialogContainer=$("#keyboard-shortcut-dialog"),this.$dialog=this.$dialogContainer.find(this.attr.modalSelector)},this.showShortcutsDialog=function(){this.renderShortcutsDialog(),this.open()},this.after("initialize",function(){this.on(document,"click",{showShortcutsBtnSelector:this.showShortcutsDialog,dismissShortcutsBtnSelector:this.removeMessage}),this.on(document,"uiSwiftLoaded",this.addMessage),this.on(document,"uiOpenKeyboardShortcutsDialog",this.showShortcutsDialog)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),_=require("core/i18n"),cookie=require("app/utils/cookie"),template=require("template"),KeyboardShortcutsDialog=defineComponent(keyboardShortcutsDialog,withDialog),isMac=navigator.platform.toLowerCase().indexOf("mac")!=-1;module.exports=KeyboardShortcutsDialog
});
define("app/ui/dialogs/leadgen_confirm_dialog",["module","require","exports","core/component","app/ui/with_dialog"],function(module, require, exports) {
function leadGenConfirmDialog(){this.defaultAttrs({promoCTASelector:".stream-items .leadgen-card-forward .promotion-cta",leadgenDialogIframeSelector:".cards2-promotion-iframe",tweetSelector:".leadgen-card-forward"}),this.setUpDialog=function(a,b){this.$tweet=$(b.el).closest(this.attr.tweetSelector),this.trigger(this.$tweet,"uiHasExpandedTweet",{organicExpansion:!0,impressionId:this.$tweet.closest("[data-impression-id]").attr("data-impression-id"),disclosureType:this.$tweet.closest("[data-impression-id]").attr("data-disclosure-type")}),this.leadgenDialogIframe.attr("src",$(b.el).data("card-url")),a.preventDefault(),this.open()},this.scribeClose=function(a,b){this.trigger(this.$tweet,"uiHasCollapsedTweet")},this.after("initialize",function(){this.leadgenDialogIframe=this.select("leadgenDialogIframeSelector"),this.on(document,"click",{promoCTASelector:this.setUpDialog}),this.on("uiDialogClosed",this.scribeClose)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),LeadGenConfirmDialog=defineComponent(leadGenConfirmDialog,withDialog);module.exports=LeadGenConfirmDialog
});
define("app/ui/dialogs/list_membership_dialog",["module","require","exports","core/component","app/ui/with_dialog"],function(module, require, exports) {
function listMembershipDialog(){this.defaultAttrs({top:90,contentSelector:".list-membership-content",createListSelector:".create-a-list",membershipSelector:".list-membership-container li"}),this.openListMembershipDialog=function(a,b){this.userId=b.userId,this.userId&&this.trigger("uiNeedsListMembershipContent",{userId:this.userId}),this.$content.empty(),this.$node.removeClass("has-content"),this.open()},this.addListMembershipContent=function(a,b){this.$node.addClass("has-content"),this.$content.html(b.html)},this.handleNoListMembershipContent=function(a,b){this.close(),this.trigger("uiShowError",b)},this.toggleListMembership=function(a,b){var c=$(a.target),d={userId:c.closest("[data-user-id]").attr("data-user-id"),listId:c.closest("[data-list-id]").attr("data-list-id")},e=$("#list_"+d.listId);if(!e.is(":visible"))return;e.closest(this.attr.membershipSelector).addClass("pending"),e.data("is-checked")?this.trigger("uiRemoveUserFromList",d):this.trigger("uiAddUserToList",d)},this.updateMembershipState=function(a){return function(b,c){var d=$("#list_"+c.sourceEventData.listId);d.closest(this.attr.membershipSelector).removeClass("pending"),d.attr("checked",a?"checked":null),d.data("is-checked",a),d.attr("data-is-checked",a)}.bind(this)},this.openListCreateDialog=function(){this.close(),this.trigger("uiOpenCreateListDialog",{userId:this.userId})},this.after("initialize",function(){this.$content=this.select("contentSelector"),this.on("click",{createListSelector:this.openListCreateDialog,membershipSelector:this.toggleListMembership}),this.on(document,"uiListAction uiOpenListMembershipDialog",this.openListMembershipDialog),this.on(document,"dataGotListMembershipContent",this.addListMembershipContent),this.on(document,"dataFailedToGetListMembershipContent",this.handleNoListMembershipContent),this.on(document,"dataDidAddUserToList dataFailedToRemoveUserFromList",this.updateMembershipState(!0)),this.on(document,"dataDidRemoveUserFromList dataFailedToAddUserToList",this.updateMembershipState(!1))})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),ListMembershipDialog=defineComponent(listMembershipDialog,withDialog);module.exports=ListMembershipDialog
});
define("app/ui/dialogs/list_operations_dialog",["module","require","exports","core/component","app/ui/with_dialog","core/i18n","core/utils"],function(module, require, exports) {
function listOperationsDialog(){this.defaultAttrs({top:90,win:window,saveListSelector:".update-list-button",editorSelector:".list-editor",currentNameSelector:".js-list-details .js-list-name",currentDescSelector:".js-list-details .js-list-desc",nameInputSelector:".list-editor input[name='name']",descriptionSelector:".list-editor textarea[name='description']",privacySelector:".list-editor input[name='mode']"}),this.openListOperationsDialog=function(a,b){b=b||{},this.userId=b.userId,a.type=="uiOpenUpdateListDialog"&&this.modifyDialog(),this.open(),this.$nameInput.focus()},this.modifyDialog=function(){this.$modalTitle=this.select("modalTitleSelector"),this.originalTitle=this.originalTitle||this.$modalTitle.text(),this.$modalTitle.text(_('\u30ea\u30b9\u30c8\u306e\u8a73\u7d30\u3092\u7de8\u96c6')),this.$nameInput.val($(this.attr.currentNameSelector).text().trim()),this.$descriptionInput.val($(this.attr.currentDescSelector).text().trim()),this.isPublic||(this.$privacyInput[1].checked=!0),this.$saveButton.attr("data-list-id",this.listId).attr("data-operation","update"),this.toggleSaveButtonDisabled(),this.modified=!0,this.$descriptionInput.on("keyup",this.toggleSaveButtonDisabled.bind(this)),this.$privacyInput.on("change",this.toggleSaveButtonDisabled.bind(this))},this.revertModifications=function(){this.modified&&(this.revertDialog(),this.$editor.find("input,textarea").val(""),this.$descriptionInput.off("keyup"),this.$privacyInput.off("change"),this.modified=!1)},this.revertDialog=function(){this.$modalTitle.text(this.originalTitle),this.$saveButton.removeAttr("data-list-id").removeAttr("data-operation"),this.isPublic||(this.$privacyInput[0].checked=!0)},this.saveList=function(a,b){if(this.requestInProgress)return;this.requestInProgress=!0;var c=$(b.el),d=c.attr("data-operation")=="update"?"uiUpdateList":"uiCreateList",e={name:this.formValue("name"),description:this.formValue("description",{type:"textarea"}),mode:this.formValue("mode",{conditions:":checked"})};c.attr("data-operation")=="update"&&(e=utils.merge(e,{list_id:c.attr("data-list-id")})),this.trigger(d,e),this.$saveButton.attr("disabled",!0)},this.saveListSuccess=function(a,b){this.close();var c=_('\u30ea\u30b9\u30c8\u304c\u4fdd\u5b58\u3055\u308c\u307e\u3057\u305f');a.type=="dataDidCreateList"?(c=_('\u30ea\u30b9\u30c8\u3092\u4f5c\u6210\u3057\u307e\u3057\u305f\u3002'),this.userId?this.trigger("uiOpenListMembershipDialog",{userId:this.userId}):b&&b.slug&&(this.attr.win.location="/"+this.attr.screenName+"/lists/"+b.slug)):this.revertDialog(),this.$editor.find("input,textarea").val(""),this.trigger("uiShowMessage",{message:c})},this.saveListComplete=function(a,b){this.requestInProgress=!1,this.toggleSaveButtonDisabled()},this.toggleSaveButtonDisabled=function(a,b){this.$saveButton.attr("disabled",this.$nameInput.val()=="")},this.formValue=function(a,b){return b=b||{},b.type=b.type||"input",b.conditions=b.conditions||"",this.$editor.find(b.type+"[name='"+a+"']"+b.conditions).val()},this.disableSaveButton=function(){this.$saveButton.attr("disabled",!0)},this.updateState=function(a,b){this.listId=b.init_data.list_id,this.isPublic=b.init_data.is_public},this.after("initialize",function(){this.listId=this.attr.list_id,this.isPublic=this.attr.is_public,this.$editor=this.select("editorSelector"),this.$nameInput=this.select("nameInputSelector"),this.$descriptionInput=this.select("descriptionSelector"),this.$privacyInput=this.select("privacySelector"),this.$saveButton=this.select("saveListSelector"),this.on("click",{saveListSelector:this.saveList}),this.on("focus blur keyup",{nameInputSelector:this.toggleSaveButtonDisabled}),this.on("uiDialogOpened",this.disableSaveButton),this.on("uiDialogClosed",this.revertModifications),this.on(document,"uiOpenCreateListDialog uiOpenUpdateListDialog",this.openListOperationsDialog),this.on(document,"dataDidCreateList dataDidUpdateList",this.saveListSuccess),this.on(document,"dataDidCreateList dataDidUpdateList dataFailedToCreateList dataFailedToUpdateList",this.saveListComplete),this.on(document,"uiPageChanged",this.updateState)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),_=require("core/i18n"),utils=require("core/utils"),ListOperationsDialog=defineComponent(listOperationsDialog,withDialog);module.exports=ListOperationsDialog
});
define("app/data/sms/sms_download_scribe",["module","require","exports","core/component","core/utils","app/data/with_scribe"],function(module, require, exports) {
function smsDownloadScribe(){this.defaultAttrs({scribeContext:{component:"sms_download"}}),this.dismissScribe=function(a,b){this.scribe(utils.merge(this.attr.scribeContext,{action:"dismiss"}))},this.scribeImpression=function(a,b){this.scribe(utils.merge(this.attr.scribeContext,{action:"impression"}))},this.submitVerificationScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"device_verification",action:"submit"});this.scribe(c)},this.submitDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link",action:"submit"});this.scribe(c)},this.resendDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link_resend",action:"submit"});this.scribe(c)},this.failedToVerifyDeviceScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"device_verification",action:"failure"});this.scribe(c)},this.failedToSubmitDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link",action:"failure"});this.scribe(c)},this.failedToResendDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link_resend",action:"failure"});this.scribe(c)},this.succeededToVerifyDeviceScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"device_verification",action:"success"});this.scribe(c)},this.succeededToSubmitDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link",action:"success"});this.scribe(c)},this.succeededToResendDownloadLinkScribe=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"download_link_resend",action:"success"});this.scribe(c)},this.after("initialize",function(){this.on("uiDismissMobileDownloadPrompt",this.dismissScribe),this.on("uiMobileDownloadPromptLoaded",this.scribeImpression),this.on("uiDidSubmitDeviceVerification",this.submitVerificationScribe),this.on("uiDidSubmitDownloadLinkRequest",this.submitDownloadLinkScribe),this.on("uiDidResendDownloadLinkRequest",this.resendDownloadLinkScribe),this.on("dataFailedToVerifyDevice",this.failedToVerifyDeviceScribe),this.on("dataFailedToSubmitDownloadLinkRequest",this.failedToSubmitDownloadLinkScribe),this.on("dataFailedToResendDownloadLinkRequest",this.failedToResendDownloadLinkScribe),this.on("dataDidVerifyDevice",this.succeededToVerifyDeviceScribe),this.on("dataDidSubmitDownloadLinkRequest",this.succeededToSubmitDownloadLinkScribe),this.on("dataDidResendDownloadLinkRequest",this.succeededToResendDownloadLinkScribe)})}var defineComponent=require("core/component"),utils=require("core/utils"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(smsDownloadScribe,withScribe)
});
define("app/ui/with_tweet_actions_helper",["module","require","exports","core/utils"],function(module, require, exports) {
function withTweetActionsHelper(){this.preventDefault=function(a,b,c){a.preventDefault()},this.composeHandler=function(){var a=arguments,b={};return function(c,d){for(var e=0,f=a.length;e<f;e++)if(a[e].call(this,c,d,b)==0)break}},this.getTweetForEvent=function(a,b){var c=$(a.target),d;return c.is(this.attr.tweetItemSelector)&&(d=c),d||(d=c[b](this.attr.tweetItemSelector)),d},this.getClosestTweet=function(a,b,c){var d=this.getTweetForEvent(a,"closest"),e=!!d.length;return e&&(c.$tweet=d),e},this.getDataForTweet=function(a){return{id:a.attr("data-tweet-id"),screenName:a.attr("data-screen-name"),isTweetProof:a.attr("data-is-tweet-proof")==="true",viewerFollowsAuthor:a.attr("data-you-follow")==="true",viewerBlocksAuthor:a.attr("data-you-block")==="true",featureContext:a.attr("data-feature-context")}},this.mkTweetDataCollector=function(){var a=arguments;return function(b){var c={};for(var d=0,e=a.length;d<e;d++)c=utils.merge(c,a[d].call(this,b));return c=utils.merge(c,this.getDataForTweet(b)),c}.bind(this)},this.mkTweetDataCollectorForAction=function(){var a=this.mkTweetDataCollector.apply(this,arguments);return function(b,c,d){return d.tweetData=a(d.$tweet),!0}.bind(this)},this.triggerTweetAction=function(a){return function(b,c,d){var e=typeof a=="function"?a.call(this,b,c,d):a;this.trigger(d.$tweet,e,d.tweetData)}}}var utils=require("core/utils");module.exports=withTweetActionsHelper
});
define("app/utils/find_tweet",["module","require","exports"],function(module, require, exports) {
function findTweet(a,b,c){var d=b.split(",").map(function(a){return a+"[data-tweet-id="+c+"]"}).join();return a.find(d)}module.exports=findTweet
});
define("app/ui/more_tweet_actions_dropdown",["module","require","exports","core/component","app/ui/with_dropdownmenu","app/ui/with_tweet_actions_helper","app/ui/with_interaction_data","core/i18n","app/utils/find_tweet"],function(module, require, exports) {
function moreTweetActionsDropdown(){this.defaultAttrs({tweetItemSelector:".tweet",deleteSelector:".js-actionDelete",shareViaEmailSelector:".js-actionShareViaEmail",embedTweetSelector:".js-actionEmbedTweet",blockOrReportTweetSelector:".js-actionBlockOrReport",userTogglePinTweetSelector:".js-actionPinTweet",curateTweetSelector:".js-actionCurateTweet",curateToOtherSelector:".js-actionCurateTweetOther",curateToNewTimelineSelector:".js-actionCurateTweetNewTimeline",removeMediaTagSelector:".js-actionRemoveTag",tweetContainerSelector:".js-stream-item",mediaTagContainerSelector:".media-tags-container",pinnedTweetClass:"user-pinned",hasTimelinesClass:"has-timelines"}),this.renderCustomTimelinesList=function(a,b){var c=this.select("curateToOtherSelector");this.select("curateTweetSelector").remove(),c.before(b.html),this.select("curateTweetSelector").length>0&&c.addClass(this.attr.hasTimelinesClass)},this.curateTweet=function(a,b,c){var d=$(b.el),e=d.attr("data-timeline-id"),f=d.data("is-member"),g=c.tweetData;g.timelineId=e,f?this.trigger("uiCurateRemoveTweet",g):this.trigger("uiCurateAddTweet",g),this.trigger("uiCloseDropdowns")},this.getCustomTimelines=function(a,b,c){var d=c.$tweet.attr("data-tweet-id");this.trigger("uiNeedsCustomTimelines",{tweetId:d})},this.confirmRemoveMediaTag=function(a){this.trigger(a.target,"uiOpenConfirmDialog",{titleText:_('\u30c4\u30a4\u30fc\u30c8\u304b\u3089\u753b\u50cf\u30bf\u30b0\u3092\u524a\u9664\u3057\u307e\u3059\u304b?'),bodyText:_('\u672c\u5f53\u306b\u30c4\u30a4\u30fc\u30c8\u304b\u3089\u753b\u50cf\u30bf\u30b0\u3092\u524a\u9664\u3057\u3066\u3088\u308d\u3057\u3044\u3067\u3059\u304b?'),cancelText:_('\u30ad\u30e3\u30f3\u30bb\u30eb'),submitText:_('\u8a31\u53ef\u3059\u308b'),action:"MediaTagRemove"})},this.removeMediaTag=function(a,b,c){this.trigger(document,"uiDidRemoveMediaTag",c.tweetData)},this.handleRemoveMediaTagSuccess=function(a,b){var c=findTweet(this.$node,this.attr.tweetItemSelector,b.id_str);c.find(this.attr.mediaTagContainerSelector).html(b.item_html),this.trigger("uiShowMessage",{message:_('\u753b\u50cf\u30bf\u30b0\u3092\u524a\u9664\u3057\u307e\u3057\u305f')})},this.handleRemoveMediaTagFailure=function(a){this.trigger("uiShowMessage",{message:_('\u30bf\u30b0\u3092\u524a\u9664\u3067\u304d\u307e\u305b\u3093\u3002\u3057\u3070\u3089\u304f\u3057\u3066\u304b\u3089\u3082\u3046\u4e00\u5ea6\u304a\u8a66\u3057\u304f\u3060\u3055\u3044\u3002')})},this.showConfirmPinDialog=function(a){a.stopImmediatePropagation(),this.trigger(a.target,"uiOpenConfirmDialog",{titleText:_('\u30d7\u30ed\u30d5\u30a3\u30fc\u30eb\u306e\u5148\u982d\u306b\u3053\u306e\u30c4\u30a4\u30fc\u30c8\u3092 \u56fa\u5b9a\u3059\u308b\u3002'),bodyText:_('\u672c\u5f53\u306b\u4ee5\u524d\u306e\u56fa\u5b9a\u30c4\u30a4\u30fc\u30c8\u306b\u7f6e\u304d\u63db\u3048\u307e\u3059\u304b?'),cancelText:_('\u30ad\u30e3\u30f3\u30bb\u30eb'),submitText:_('\u56fa\u5b9a\u3059\u308b'),action:"UserPinTweetToggle"})},this.showConfirmUnPinDialog=function(a){a.stopImmediatePropagation(),this.trigger(a.target,"uiOpenConfirmDialog",{titleText:_('\u30d7\u30ed\u30d5\u30a3\u30fc\u30eb\u304b\u3089\u56fa\u5b9a\u3092\u89e3\u9664\u3059\u308b'),bodyText:_('\u672c\u5f53\u306b\u3088\u308d\u3057\u3044\u3067\u3059\u304b?'),cancelText:_('\u30ad\u30e3\u30f3\u30bb\u30eb'),submitText:_('\u56fa\u5b9a\u3092\u89e3\u9664\u3059\u308b'),action:"UserPinTweetToggle"})},this.showUserPinToggledMessage=function(a,b){this.trigger("uiShowStickyMessage",b)},this.unpinOtherTweets=function(a,b){this.select("tweetItemSelector").removeClass(this.attr.pinnedTweetClass),this.handleTransition("addClass",this.attr.pinnedTweetClass).call(this,a,b)},this.handleTransition=function(a,b){return function(c,d){var e=d.id||d.sourceEventData.id,f=findTweet(this.$node,this.attr.tweetItemSelector,e);f[a](b)}},this.confirmPinToggle=function(a,b,c){var d=c.$tweet.hasClass(this.attr.pinnedTweetClass)?"uiNeedUserUnpinTweetConfirm":"uiNeedUserPinTweetConfirm";this.trigger(c.$tweet,d)},this.togglePinnedTweet=function(a,b,c){return c.$tweet.hasClass(this.attr.pinnedTweetClass)?"uiDidUserUnpinTweet":"uiDidUserPinTweet"},this.after("initialize",function(){var a=this.mkTweetDataCollectorForAction(this.interactionDataWithCard);this.on("click",{embedTweetSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiNeedsEmbedTweetDialog"))});if(!this.attr.loggedIn)return;this.on("click",{deleteSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiOpenDeleteDialog")),userTogglePinTweetSelector:this.composeHandler(this.getClosestTweet,this.confirmPinToggle),shareViaEmailSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiNeedsShareViaEmailDialog")),curateTweetSelector:this.composeHandler(this.getClosestTweet,a,this.curateTweet),curateToOtherSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiOpenCurateDialog")),curateToNewTimelineSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiOpenCreateCustomTimelineDialog")),removeMediaTagSelector:this.confirmRemoveMediaTag,blockOrReportTweetSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiNeedsBlockOrReportDialog"))}),this.on("uiDropdownOpened",this.composeHandler(this.getClosestTweet,this.getCustomTimelines)),this.on("uiUserPinTweetToggleConfirm",this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction(this.togglePinnedTweet))),this.on("uiMediaTagRemoveConfirm",this.composeHandler(this.getClosestTweet,a,this.removeMediaTag)),this.on(document,"uiHasInjectedNewTimeline uiHasInjectedOldTimelineItems uiHasInjectedRangeTimelineItems",this.applyARIAAttrs),this.on(document,"dataGotCustomTimelines",this.renderCustomTimelinesList),this.on(document,"uiNeedUserPinTweetConfirm",this.showConfirmPinDialog),this.on(document,"uiNeedUserUnpinTweetConfirm",this.showConfirmUnPinDialog),this.on(document,"dataDidUserPinTweet dataDidUserUnpinTweet",this.showUserPinToggledMessage),this.on(document,"dataDidUserPinTweet",this.unpinOtherTweets),this.on(document,"uiDidUserPinTweet dataFailedToUserUnpinTweet",this.handleTransition("addClass",this.attr.pinnedTweetClass)),this.on(document,"uiDidUserUnpinTweet dataFailedToUserPinTweet",this.handleTransition("removeClass",this.attr.pinnedTweetClass)),this.on(document,"dataMediaTagRemoveSuccess",this.handleRemoveMediaTagSuccess),this.on(document,"dataMediaTagRemoveFailure",this.handleRemoveMediaTagFailure)})}var defineComponent=require("core/component"),withDropdownMenu=require("app/ui/with_dropdownmenu"),withTweetActionsHelper=require("app/ui/with_tweet_actions_helper"),withInteractionData=require("app/ui/with_interaction_data"),_=require("core/i18n"),findTweet=require("app/utils/find_tweet"),MoreTweetActionsDropdown=defineComponent(moreTweetActionsDropdown,withDropdownMenu,withTweetActionsHelper,withInteractionData);module.exports=MoreTweetActionsDropdown
});
define("app/utils/multiline_text_range",["module","require","exports"],function(module, require, exports) {
function MultilineTextRange(a){function c(){var b=document.createRange(),c=a.contents(),d=a.contents().last()[0];return c.length>0&&(b.setStart(c[0],0),b.setEnd(d,g(d))),b}function d(a){return a.nodeType==3||a.nodeType==4}function e(){var a=f(),b=null,c=null,d=null,e=null;for(var g=0;g<a.length;g++){var h=a[g];if(c===null||h.bottom>c)c=h.bottom;if(b===null||h.top<b)b=h.top;if(d===null||h.left<d)d=h.left;if(e===null||h.right>e)e=h.right}return{top:b,bottom:c,left:d,right:e,width:Math.abs(e-d),height:Math.abs(c-b)}}function f(){var a=b.getClientRects(),c=[];for(var d=0;d<a.length;d++)c.push(a[d]);return c.filter(function(a){return a.width>0})}function g(a){return d(a)?a.nodeValue.length:a.childNodes.length}function h(){return a.width()-i()}function i(){var a=e(),b=f(),c=b[b.length-1];return b.length==0?0:c.right-a.left}function j(a){var b=a.match(WORD_BREAKS_REGEX);if(b!==null){var c=b[b.length-1],d=a.lastIndexOf(c);return{startIndex:d,endIndex:d+c.length}}return null}function k(a){return!!a.match(WORD_BREAK_REGEX)}function l(a){return(a.match(CHARS_REGEX)||[]).length}var b=c();this.shortenToVisibleContent=function(){var c=a.contents();for(var e=c.length-1;e>=0;e--){var f=c[e];if(d(f))for(var g=f.nodeValue.length;g>=0;g--){b.setEnd(f,g);if(!this.hasOverflow())return}else{b.setEnd(f,f.childNodes.length);if(!this.hasOverflow())return}}},this.shortenToNearestWordBreak=function(a){var c=b.endContainer,e=a.maxCharsToRemove;if(!d(c)||!c.nodeValue.match(NEW_LINE_ONLY_REGEX)&&(b.endOffset===c.nodeValue.length||k(c.nodeValue[b.endOffset])))return;var f=c.nodeValue.slice(0,b.endOffset),g=j(f);if(g===null)return;if(e!==undefined&&l(f.substring(g.endIndex))>e)return;b.setEnd(c,g.startIndex)},this.ensureLastLineAvailableWidth=function(a){while(h(b)<=a){var c=b.endContainer;if(d(c)&&b.endOffset>1)b.setEnd(c,b.endOffset-1);else{var e=c.previousSibling;if(e===null)break;b.setEnd(e,g(e))}}},this.hasOverflow=function(){var b=e(),c=parseFloat(a.css("line-height"));return Math.round(b.height/c)>Math.round(a.height()/c)},this.toDocumentFragment=function(){return b.cloneContents()},this.setEnd=function(a,c){b.setEnd(a,c)}}var CHARS_REGEX=/([\uD800-\uDBFF][\uDC00-\uDFFF]|[\S\s])/g,WORD_BREAK_REGEX=/\s/,WORD_BREAKS_REGEX=/\s+/g,NEW_LINE_ONLY_REGEX=/^\n$/;module.exports=MultilineTextRange
});
define("app/ui/multiline_ellipses",["module","require","exports","core/component","app/utils/multiline_text_range"],function(module, require, exports) {
function multilineEllipses(){this.defaultAttrs({unEllipsifiedTextClass:"js-ellipsis",unEllipsifiedTextSelector:".js-ellipsis",maxCharsRemoveEnsureEndOnWordBreak:5}),this.after("initialize",function(){if(typeof document.createRange=="undefined")return;this.on(document,"uiSwiftLoaded uiPageChanged uiHasInjectedNewTimeline uiHasInjectedOldTimelineItems uiHasInjectedRangeTimelineItems dataTweetConversationResult uiOverlayUpdate uiTrendsDisplayed uiShowMoreTrends",this.addEllipses)}),this.addEllipses=function(){var a=this.select("unEllipsifiedTextSelector").filter(":visible");a.removeClass(this.attr.unEllipsifiedTextClass),a.each(this.addEllipsis.bind(this))},this.addEllipsis=function(a,b){var c=$(b),d=this.createRange(c);if(!d.hasOverflow())return;d.shortenToVisibleContent(),d.ensureLastLineAvailableWidth(this.maxEllipsisWidth(c)),d.shortenToNearestWordBreak({maxCharsToRemove:this.attr.maxCharsRemoveEnsureEndOnWordBreak});var e=d.toDocumentFragment();e.appendChild(document.createTextNode("…")),c.html(e)},this.maxEllipsisWidth=function(a){var b=parseInt(a.css("font-size"));return b*2},this.createRange=function(a){return new MultilineTextRange(a)}}var defineComponent=require("core/component"),MultilineTextRange=require("app/utils/multiline_text_range");module.exports=defineComponent(multilineEllipses)
});
define("app/ui/navigation_links",["module","require","exports","core/component"],function(module, require, exports) {
function navigationLinks(){this.defaultAttrs({navSelector:"a[data-nav]:not(.js-nonNavigable)"}),this.navEvent=function(a){var b=$(a.target).closest(this.attr.navSelector);this.trigger("uiNavigationLinkClick",{scribeContext:{element:b.attr("data-nav")},url:b.attr("href")})},this.after("initialize",function(a){this.on("click",{navSelector:this.navEvent})})}var defineComponent=require("core/component");module.exports=defineComponent(navigationLinks)
});
define("app/utils/setup_polling_with_backoff",["module","require","exports","core/clock","core/utils"],function(module, require, exports) {
function setupPollingWithBackoff(a,b,c){var d={focusedInterval:3e4,blurredInterval:9e4,backoffFactor:2};c=utils.merge(d,c);var e=clock.setIntervalEvent(a,c.focusedInterval,c.eventData);return $(document).on("uiPageHidden",e.backoff.bind(e,c.blurredInterval,c.backoffFactor)),$(document).on("uiPageVisible",e.cancelBackoff.bind(e)),e}var clock=require("core/clock"),utils=require("core/utils");module.exports=setupPollingWithBackoff
});
define("app/data/notification_listener",["module","require","exports","core/component","app/utils/setup_polling_with_backoff","app/data/notifications"],function(module, require, exports) {
function notificationListener(){this.pollForNotifications=function(a,b){notifications.shouldPoll()&&this.trigger("uiDMPoll")},this.resetDMs=function(a,b){notifications.resetDMState(a,b)},this.notifications=notifications,this.after("initialize",function(){notifications.init(this.attr),this.on(document,"uiResetDMPoll",this.resetDMs),this.on(document,"uiPollForNotifications",this.pollForNotifications),this.timer=setupPollingWithBackoff("uiPollForNotifications")})}var defineComponent=require("core/component"),setupPollingWithBackoff=require("app/utils/setup_polling_with_backoff"),notifications=require("app/data/notifications"),NotificationListener=defineComponent(notificationListener);module.exports=NotificationListener
});
define("app/data/oembed",["module","require","exports","core/component","app/data/with_data","app/data/user_info","core/utils"],function(module, require, exports) {
function OembedData(){this.requestEmbedCode=function(a,b){var c=this.cacheKeyForOptions(b),d=this.cachedEmbedCodes[c],e=this.receivedEmbedCode.bind(this,b),f=this.failedToReceiveEmbedCode.bind(this,b);if(d){this.receivedEmbedCode(b,d);return}this.get({dataType:"jsonp",url:this.embedCodeUrl(),data:utils.merge({id:b.tweetId},b.data),eventData:{},success:e,error:f})},this.embedCodeUrl=function(){return"//api.twitter.com/1/statuses/oembed.json"},this.receivedEmbedCode=function(a,b){var c=this.cacheKeyForOptions(a);this.cachedEmbedCodes[c]=b,this.trigger("dataOembedSuccess",{options:a,data:b})},this.failedToReceiveEmbedCode=function(a){a.retry?(a.retry=!1,this.trigger("dataOembedRetry",a),this.requestEmbedCode({},a)):this.trigger("dataOembedError",a)},this.cacheKeyForOptions=function(a){return JSON.stringify(a.data)+a.tweetId},this.after("initialize",function(){this.on("uiNeedsOembed",this.requestEmbedCode),this.cachedEmbedCodes={}})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),userInfo=require("app/data/user_info"),utils=require("core/utils");module.exports=defineComponent(OembedData,withData)
});
define("app/data/oembed_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function oembedScribe(){this.scribeError=function(a,b){this.scribe({component:"oembed",action:"request_failed"})},this.scribeRetry=function(a,b){this.scribe({component:"oembed",action:"retry"})},this.scribeRequest=function(a,b){this.scribe({component:"oembed",action:"request"},b)},this.scribeSuccess=function(a,b){this.scribe({component:"oembed",action:"success"},b)},this.after("initialize",function(){this.on("dataOembedError",this.scribeError),this.on("dataOembedRetry",this.scribeRetry),this.on("dataOembedRequest",this.scribeRequest),this.on("dataOembedSuccess",this.scribeSuccess)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(oembedScribe,withScribe)
});
define("app/data/with_boot_with_teardown_context",["module","require","exports","core/registry"],function(module, require, exports) {
function withBootWithTeardownContext(){this.bootWithTeardownContext=function(a,b,c){var d=registry.addInstance;c&&(registry.addInstance=function(a){a.teardownContext=c,d.call(registry,a)}),a(b),registry.addInstance=d}}var registry=require("core/registry");module.exports=withBootWithTeardownContext
});
define("app/ui/overlay_navigation",["module","require","exports","core/component","app/data/with_boot_with_teardown_context","app/utils/full_path","app/utils/push_state_enabled"],function(module, require, exports) {
function overlayNavigation(){this.defaultAttrs({pushState:!0}),this.overlayNavigate=function(a,b){b&&b.impressionCookie&&this.trigger("uiSendImpressionCookie",b),this.trigger("uiOverlayOpen"),this.trigger("uiOverlayNeedsPage",b),this.teardownOverlay()},this.updateOverlay=function(a,b){this.trigger("uiOverlayUpdate",{html:b.page}),this.loadModule(b)},this.updateOverlayAndTitle=function(a,b){this.updateOverlay(a,b),this.trigger("uiUpdatePageTitle",{title:b.title}),b.canonical_url&&$('link[rel="canonical"]').attr("href",b.canonical_url)},this.loadModule=function(a){using(a.module,function(b){var c="overlay";a.init_data.inOverlay=!0,this.bootWithTeardownContext(b,a.init_data,c),this.trigger("uiOverlayPageChanged",a)}.bind(this))},this.rollback=function(a,b){b.rollbackCount>0?(this.isRollback=!0,history.go(-b.rollbackCount)):delete this.isRollback},this.handlePopstate=function(a,b){var c=b.state&&b.state.inOverlay;this.isRollback?(a.preventDefault(),this.trigger("uiDidRollback",b),delete this.isRollback):c&&(a.preventDefault(),this.trigger("uiOverlayNavigate",{isPopState:!0,href:fullPath()}))},this.updatePageTitle=function(){this.trigger("uiUpdatePageTitle",{title:history.state&&history.state.title}),this.trigger("uiPageNeedsCount")},this.handleUpdatePageCount=function(a,b){history.state&&history.state.inOverlay&&a.preventDefault()},this.teardownOverlay=function(){this.trigger("uiTeardown",{teardownContext:"overlay"})},this.after("initialize",function(){this.on("uiOverlayNavigate",this.overlayNavigate),this.on("uiOverlayClosedByRequest",this.teardownOverlay),pushStateEnabled(this.attr.pushState)?(this.on("dataOverlayPageSuccess",this.updateOverlayAndTitle),this.on("dataNeedsRollback",this.rollback),this.on(document,"uiPopStateNavigate",this.handlePopstate),this.on("uiDidRollback",this.updatePageTitle),this.on(document,"uiUpdatePageCount",this.handleUpdatePageCount)):this.on("dataOverlayPageSuccess",this.updateOverlay)})}var defineComponent=require("core/component"),withBootWithTeardownContext=require("app/data/with_boot_with_teardown_context"),fullPath=require("app/utils/full_path"),pushStateEnabled=require("app/utils/push_state_enabled");module.exports=defineComponent(overlayNavigation,withBootWithTeardownContext)
});
define("app/data/overlay_navigation",["module","require","exports","core/component","app/data/with_data","app/utils/full_path","app/data/with_rollback_count","core/utils","app/utils/push_state_enabled"],function(module, require, exports) {
function overlayNavigation(){this.defaultAttrs({pushState:!0,currentPageName:"",underlyingSectionName:""}),this.pushState=function(a,b){var c={inOverlay:!0,rollbackCount:this.rollbackCount()+1};b.href!=fullPath()&&history.pushState(c,b.title,b.href)},this.handlePageSuccess=function(a){a.init_data&&a.page&&a.module?(a.href=a.init_data.href,a.init_data.overlayCapable?(this.trigger("dataOverlayDoPushState",a),this.trigger("dataOverlayPageSuccess",a)):this.trigger("uiNavigate",{href:a.href})):this.handlePageError(a)},this.handlePageError=function(a){this.trigger("dataOverlayPageFailure",a)},this.getHeaders=function(){return{"X-Overlay-Request":!0,"X-Previous-Page-Name":this.currentPageName}},this.currentPageChanged=function(a,b){this.currentPageName=b.init_data.pageName,this.underlyingSectionName=b.init_data.sectionName},this.getPage=function(a,b){this.get({headers:this.getHeaders(),url:b.href,success:function(a){this.handlePageSuccess(utils.merge(a,{autoplay:b&&b.autoplay}))}.bind(this),error:this.handlePageError.bind(this)})},this.rollback=function(){this.trigger("dataNeedsRollback",{rollbackCount:this.rollbackCount()})},this.updateScribeSection=function(){this.trigger("dataUpdateScribeSection",{sectionName:this.underlyingSectionName})},this.after("initialize",function(){this.currentPageName=this.attr.currentPageName,this.underlyingSectionName=this.attr.underlyingSectionName,this.on("uiPageChanged",this.currentPageChanged),this.on("uiOverlayNeedsPage",this.getPage),pushStateEnabled(this.attr.pushState)&&(this.on("uiOverlayClosedByRequest",this.rollback),this.on("dataOverlayDoPushState",this.pushState)),this.on("uiOverlayClosed",this.updateScribeSection)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),fullPath=require("app/utils/full_path"),withRollbackCount=require("app/data/with_rollback_count"),utils=require("core/utils"),pushStateEnabled=require("app/utils/push_state_enabled");module.exports=defineComponent(overlayNavigation,withData,withRollbackCount)
});
define("app/ui/page_title",["module","require","exports","core/component"],function(module, require, exports) {
function pageTitle(){this.addCount=function(a,b){this.trigger(document,{type:"uiUpdatePageCount",defaultBehavior:this.updateCount.bind(this,b)})},this.updateCount=function(a){a.count&&(document.title="("+a.count+") "+this.title)},this.removeCount=function(a,b){document.title=this.title},this.setTitle=function(a,b){var c=b||a.originalEvent.state;c&&c.title&&(document.title=this.title=c.title)},this.after("initialize",function(){this.title=document.title,this.on("uiAddPageCount",this.addCount),this.on("uiHasInjectedNewTimeline",this.removeCount),this.on(document,"uiBeforePageChanged uiUpdatePageTitle",this.setTitle)})}var defineComponent=require("core/component"),PageTitle=defineComponent(pageTitle);module.exports=PageTitle
});
define("app/ui/page_visibility",["module","require","exports","core/clock","core/component"],function(module, require, exports) {
function PageVisibility(){this.defaultAttrs({heartBeat:0,doc:document,isIe:$.browser.msie});var a,b=!1;this.visibilityChange=function(c){var d;switch(c.type){case"focus":case"focusin":d=!1;break;case"blur":case"focusout":d=!0;break;case"beforeunload":this.trigger("uiPageUnload");break;default:a&&(d=this.attr.doc[a])}d===!0?(b=!0,this.trigger("uiPageHidden")):d===!1&&(b=!1,this.trigger("uiPageVisible"))},this.focusTick=function(){b||this.trigger("uiPageVisible")},this.after("initialize",function(){var b={hidden:"visibilitychange",mozHidden:"mozvisibilitychange",webkitHidden:"webkitvisibilitychange",msHidden:"msvisibilitychange"},c=!1;for(var d in b)d in this.attr.doc&&(a=d,this.on(this.attr.doc,b[a],this.visibilityChange),c=!0);c||(this.attr.isIe?(this.on(this.attr.doc,"focusin",this.visibilityChange),this.on(this.attr.doc,"focusout",this.visibilityChange)):(this.on(window,"focus",this.visibilityChange),this.on(window,"blur",this.visibilityChange))),this.on(window,"beforeunload",this.visibilityChange),this.attr.heartBeat&&(this.timer=clock.setIntervalEvent("uiPageFocusTick",this.attr.heartBeat),this.on("uiPageFocusTick",this.focusTick))})}var clock=require("core/clock"),defineComponent=require("core/component");module.exports=defineComponent(PageVisibility)
});
define("app/ui/dialogs/payment_order_dialog",["module","require","exports","core/component","app/ui/with_dialog"],function(module, require, exports) {
function paymentsOrderDialog(){this.defaultAttrs({isLoadingClass:"PaymentOrderDialog-isLoading",isLoadedClass:"PaymentOrderDialog-isLoaded",isFailedClass:"PaymentOrderDialog-isFailed",containerSelector:".PaymentOrderDialog-orderDetails",spinnerSelector:".spinner-bigger",errorAlertSelector:".alert"}),this.setLoading=function(){this.select("modalBodySelector").addClass(this.attr.isLoadingClass).removeClass(this.attr.isLoadedClass).removeClass(this.attr.isFailedClass)},this.setLoaded=function(){this.select("modalBodySelector").removeClass(this.attr.isLoadingClass).addClass(this.attr.isLoadedClass).removeClass(this.attr.isFailedClass)},this.setFailed=function(){this.select("modalBodySelector").removeClass(this.attr.isLoadingClass).removeClass(this.attr.isLoadedClass).addClass(this.attr.isFailedClass)},this.openDialog=function(a,b){this.setLoading(),this.open(),this.trigger("uiShowPaymentOrderDetail",{orderId:b.orderId})},this.populateDialog=function(a,b){this.setLoaded(),this.select("modalBodySelector").addClass(this.attr.isLoadedClass),this.select("containerSelector").html(b.html),this.position()},this.after("initialize",function(){this.on(document,"uiRequestPaymentOrderDetail",this.openDialog),this.on(document,"dataCommercePaymentOrderDetailFetched",this.populateDialog),this.on(document,"dataCommercePaymentOrderDetailFetchFailed",this.setFailed)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),PaymentsOrderDialog=defineComponent(paymentsOrderDialog,withDialog);module.exports=PaymentsOrderDialog
});
define("app/ui/dialogs/permalink_overlay",["module","require","exports","core/component","app/ui/with_dialog","core/utils"],function(module, require, exports) {
function PermalinkOverlay(){this.defaultAttrs({spinnerSelector:".PermalinkOverlay-spinnerContainer",overlayEnabledClass:"overlay-enabled",overlayCloseButtonSelector:".PermalinkOverlay-close",overlayModalContainerSelector:".PermalinkOverlay",overlayModalClass:".PermalinkOverlay-modal",overlayModalContentSelector:".PermalinkOverlay-content",overlayModalBodySelector:".PermalinkOverlay-body"}),this.openOverlay=function(a,b){this.isOpen()||(this.showSpinner(),this.select("overlayModalBodySelector").empty(),this.open())},this.updateOverlay=function(a,b){this.hideSpinner(),this.select("overlayModalBodySelector").html(b.html),this.open()},this.possiblyCloseOverlay=function(a){this.$node.is(a.target)&&this.close()},this.empty=function(){this.select("overlayModalBodySelector").empty()},this.hideSpinner=function(){this.select("spinnerSelector").addClass("u-hidden")},this.showSpinner=function(){this.select("spinnerSelector").removeClass("u-hidden")},this.after("initialize",function(){this.attr.modalEnabledClass=this.attr.overlayEnabledClass,this.attr.closeButtonSelector=this.attr.overlayCloseButtonSelector,this.attr.modalSelector=this.attr.overlayModalClass,this.attr.modalContainerSelector=this.attr.overlayModalContainerSelector,this.attr.modalContentSelector=this.attr.overlayModalContentSelector,this.attr.modalBodySelector=this.attr.overlayModalBodySelector,this.on("click",this.possiblyCloseOverlay),this.on("uiDialogClosed",this.empty),this.on("uiDialogClosed","uiOverlayClosed"),this.on("uiDialogClosedByRequest","uiOverlayClosedByRequest"),this.on(document,"uiOverlayOpen",this.openOverlay),this.on(document,"uiOverlayClose",this.close),this.on(document,"uiOverlayUpdate",this.updateOverlay)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),utils=require("core/utils");module.exports=defineComponent(PermalinkOverlay,withDialog)
});
define("app/data/profile_popup",["module","require","exports","core/component","core/utils","app/data/with_data"],function(module, require, exports) {
function profilePopupData(){this.defaultAttrs({profileHoversEnabled:!1,hoverFetchDelay:100,noShowError:!0}),this.userCache={screenNames:Object.create(null),ids:Object.create(null)},this.socialProofCache={screenNames:Object.create(null),ids:Object.create(null)},this.saveToCache=function(a,b){a.ids[b.user_id]=b,a.screenNames[b.screen_name]=b},this.retrieveFromCache=function(a,b){var c;return b.userId?c=a.ids[b.userId]:b.user_id?c=a.ids[b.user_id]:b.screenName?c=a.screenNames[b.screenName]:b.screen_name&&(c=a.screenNames[b.screen_name]),c},this.invalidateCaches=function(a,b){var c,d,e;b.userId?(c=b.userId,e=this.userCache.ids[c],d=e&&e.screen_name):(d=b.screenName,e=this.userCache.screenNames[d],c=e&&e.user_id),c&&delete this.userCache.ids[c],c&&delete this.socialProofCache.ids[c],d&&delete this.userCache.screenNames[d],d&&delete this.socialProofCache.screenNames[d]},this.getSocialProof=function(a,b){if(!this.attr.asyncSocialProof||!this.attr.loggedIn)return;var c=function(a){this.saveToCache(this.socialProofCache,a);var b=this.retrieveFromCache(this.userCache,a);b&&this.trigger("dataSocialProofSuccess",a)}.bind(this),d=function(a){this.trigger("dataSocialProofFailure",a)}.bind(this),e=this.retrieveFromCache(this.socialProofCache,a);if(e){e.sourceEventData=a,c(e);return}this.get({url:"/i/profiles/social_proof",data:b,eventData:a,cache:!1,success:c,error:d})},this.getProfilePopupMain=function(a,b){var c=function(a){this.saveToCache(this.userCache,a),this.trigger("dataProfilePopupSuccess",a);var b=this.retrieveFromCache(this.socialProofCache,a);b&&this.trigger("dataSocialProofSuccess",b)}.bind(this),d=function(a){this.trigger("dataProfilePopupFailure",a)}.bind(this),e=this.retrieveFromCache(this.userCache,a);if(e){e.sourceEventData=a,c(e);return}this.attr.profileHoversEnabled&&(b.wants_hovercard=!0);var f=function(){this.pendingRemoteRequest=null,this.get({url:"/i/profiles/popup",data:b,eventData:a,cache:!1,success:c,error:d})}.bind(this);this.attr.profileHoversEnabled?this.pendingRemoteRequest=setTimeout(f,this.attr.hoverFetchDelay):f()},this.getProfilePopup=function(a,b){var c={};b.screenName?c.screen_name=b.screenName:b.userId&&(c.user_id=b.userId),this.attr.asyncSocialProof&&(c.async_social_proof=!0),this.attr.profileHoversEnabled||this.getSocialProof(b,c),b.simple_profile&&(c.simple_profile=b.simple_profile),this.getProfilePopupMain(b,c)},this.hideProfileHover=function(){this.pendingRemoteRequest&&(clearTimeout(this.pendingRemoteRequest),this.pendingRemoteRequest=null)},this.after("initialize",function(){this.on("uiWantsProfilePopup",this.getProfilePopup),this.on("uiHideProfileHover",this.hideProfileHover),this.on(document,"dataFollowStateChange dataUserActionSuccess",this.invalidateCaches)})}var defineComponent=require("core/component"),utils=require("core/utils"),withData=require("app/data/with_data"),ProfilePopupData=defineComponent(profilePopupData,withData);module.exports=ProfilePopupData
});
define("app/data/profile_popup_scribe",["module","require","exports","core/component","core/utils","app/data/with_interaction_data_scribe","app/data/client_event"],function(module, require, exports) {
function profilePopupScribe(){this.defaultAttrs({scribeContext:{component:"profile_dialog"},profileHoversEnabled:!1}),this.scribeProfilePopupOpen=function(a,b){if(this.attr.profileHoversEnabled){if(a.target.id!="profile-hover-container")return;b.user_id=$(a.target).attr("data-user-id")}if(this.clientEvent.scribeContext.page!="profile"||!this.clientEvent.scribeData.profile_id)this.clientEvent.scribeData.profile_id=b.user_id;var c=utils.merge(this.attr.scribeContext,{action:"open"});this.scribe(c,b)},this.cleanupProfilePopupScribing=function(a,b){this.clientEvent.scribeData.profile_id&&this.clientEvent.scribeContext.page!="profile"&&delete this.clientEvent.scribeData.profile_id},this.scribePopupSocialProof=function(a,b){var c=utils.merge(this.attr.scribeContext,{element:"social_proof",action:"impression"});this.scribe(c,b)},this.after("initialize",function(){this.clientEvent=clientEvent,this.attr.profileHoversEnabled?(this.attr.scribeContext={component:"profile_hover"},this.on(document,"uiHoverShown",this.scribeProfilePopupOpen)):(this.on(document,"uiCloseProfilePopup",this.cleanupProfilePopupScribing),this.on(document,"uiHasPopupSocialProof",this.scribePopupSocialProof),this.on(document,"dataProfilePopupSuccess",this.scribeProfilePopupOpen))})}var defineComponent=require("core/component"),utils=require("core/utils"),withInteractionDataScribe=require("app/data/with_interaction_data_scribe"),clientEvent=require("app/data/client_event");module.exports=defineComponent(profilePopupScribe,withInteractionDataScribe)
});
define("app/ui/with_profile_stats",["module","require","exports"],function(module, require, exports) {
function withProfileStats(){this.defaultAttrs({}),this.updateProfileStats=function(a,b){if(!b.stats||!b.stats.length)return;$.each(b.stats,function(a,b){var c=this.statNode(b.user_id,b.stat);this.isCompact(c)||c.html(b.html)}.bind(this))},this.statSelector=function(a,b){return'.stats[data-user-id="'+a+'"] a[data-element-term="'+b+'_stats"]'},this.statNode=function(a,b){return this.$node.find(this.statSelector(a,b))},this.isCompact=function(a){return a.data("is-compact")===!0},this.after("initialize",function(){this.on(document,"dataGotProfileStats",this.updateProfileStats)})}module.exports=withProfileStats
});
define("app/ui/with_handle_overflow",["module","require","exports"],function(module, require, exports) {
function withHandleOverflow(){this.defaultAttrs({heightOverflowClassName:"height-overflow"}),this.checkForOverflow=function(a){a=a||this.$node;if(!a||!a.length)return;a[0].scrollHeight>a.height()?a.addClass(this.attr.heightOverflowClassName):a.removeClass(this.attr.heightOverflowClassName)}}module.exports=withHandleOverflow
});
define("app/ui/profile_popup",["module","require","exports","core/component","app/ui/with_dialog","app/ui/with_user_actions","app/ui/with_item_actions","app/ui/with_profile_stats","app/ui/with_handle_overflow"],function(module, require, exports) {
function profilePopup(){this.defaultAttrs({dialogContentSelector:".profile-modal",profileHeaderInnerSelector:".profile-header-inner",socialProofSelector:".social-proof",tweetSelector:".simple-tweet",slideDuration:100,top:47,bottom:10,tweetMinimum:2,itemType:"user"}),this.slideInContent=function(a){var b=this.$dialog.height(),c=$(a);this.addHeaderImage(c),this.$contentContainer.html(c),this.$node.addClass("has-content"),this.removeTweets();var d=this.$dialog.height();this.$dialog.height(b),this.$dialog.animate({height:d},this.attr.slideDuration,this.slideInComplete.bind(this))},this.removeTweets=function(){var a=this.select("tweetSelector");for(var b=a.length-1;b>this.attr.tweetMinimum-1;b--){if(!this.isTooTall())return;a.eq(b).remove()}},this.getWindowHeight=function(){return $(window).height()},this.isTooTall=function(){return this.$dialog.height()+this.attr.top+this.attr.bottom>this.getWindowHeight()},this.addHeaderImage=function(a){var b=a.find(this.attr.profileHeaderInnerSelector);b.hasClass("no-image")?b.css("background-color",b.attr("data-background-color")):b.css("background-image",b.attr("data-background-image"))},this.slideInComplete=function(){this.checkForOverflow(this.select("profileHeaderInnerSelector")),this.trigger(this.$dialog,"uiDialogContentChanged")},this.clearPopup=function(){this.$dialog.height("auto"),this.$contentContainer.empty()},this.openProfilePopup=function(a,b){b.screenName&&delete b.userId;if(b.userId&&b.userId===this.currentUserId()||b.screenName&&b.screenName===this.currentScreenName())return;this.open(),this.clearPopup(),this.$node.removeClass("has-content"),this.$node.attr("data-associated-tweet-id",b.tweetId||null),this.$node.attr("data-impression-id",b.impressionId||null),this.$node.attr("data-disclosure-type",b.disclosureType||null),this.$node.attr("data-impression-cookie",b.impressionCookie||null),this.trigger("uiWantsProfilePopup",b)},this.closeProfilePopup=function(a){this.clearPopup(),this.trigger("uiCloseProfilePopup",{userId:this.currentUserId(),screenName:this.currentScreenName()})},this.fillProfile=function(a,b){this.$node.attr("data-screen-name",b.screen_name||null),this.$node.attr("data-user-id",b.user_id||null),this.slideInContent(b.html)},this.removeSocialProof=function(a,b){this.select("socialProofSelector").remove()},this.addSocialProof=function(a,b){b.html?(this.select("socialProofSelector").html(b.html),this.trigger("uiHasPopupSocialProof")):this.removeSocialProof()},this.showError=function(a,b){var c=['<div class="profile-modal-header error"><p>',b.message,"</p></div>"].join("");this.slideInContent(c)},this.getPopupData=function(a){return!this.isOpen()||!this.$node.hasClass("has-content")?null:this.$node.attr(a)},this.currentScreenName=function(){return this.getPopupData("data-screen-name")},this.currentUserId=function(){return this.getPopupData("data-user-id")},this.after("initialize",function(){this.$contentContainer=this.select("dialogContentSelector"),this.on(document,"uiShowProfilePopup",this.openProfilePopup),this.on(document,"dataProfilePopupSuccess",this.fillProfile),this.on(document,"dataProfilePopupFailure",this.showError),this.on(document,"dataSocialProofSuccess",this.addSocialProof),this.on(document,"dataSocialProofFailure",this.removeSocialProof),this.on(document,"uiOpenConfirmDialog uiNeedsBlockOrReportDialog uiOpenTweetDialog uiNeedsDMDialog uiListAction uiOpenSigninOrSignupDialog uiEmbedProfileAction",this.close),this.on("uiDialogClosed",this.closeProfilePopup)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withUserActions=require("app/ui/with_user_actions"),withItemActions=require("app/ui/with_item_actions"),withProfileStats=require("app/ui/with_profile_stats"),withHandleOverflow=require("app/ui/with_handle_overflow"),ProfilePopup=defineComponent(profilePopup,withDialog,withUserActions,withItemActions,withProfileStats,withHandleOverflow);module.exports=ProfilePopup
});
define("app/data/profile_edit_btn_scribe",["module","require","exports","core/component","core/utils","app/data/with_scribe"],function(module, require, exports) {
function profileEditBtnScribe(){this.defaultAttrs({editButtonSelector:".edit-profile-btn",scribeContext:{}}),this.scribeAction=function(a){var b=utils.merge(this.attr.scribeContext,{action:a});return function(a,c){b.element=$(a.target).attr("data-scribe-element"),this.scribe(b)}},this.after("initialize",function(){this.on("click",{editButtonSelector:this.scribeAction("click")})})}var defineComponent=require("core/component"),utils=require("core/utils"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(profileEditBtnScribe,withScribe)
});
define("app/ui/with_hover_card",["module","require","exports","core/utils","core/compose","app/ui/with_position"],function(module, require, exports) {
function withHoverCard(){compose.mixin(this,[withPosition]),this.defaultAttrs({hoverContentSelector:".hovercard",hoverContainerClasses:"hovercard",showDelay:400,hideDelay:50}),this.prepareHover=function(a){this.currentKey!==a&&this.forceHide(),this.openTimer=setTimeout(this.timerSaysOK.bind(this),this.attr.showDelay)},this.timerSaysOK=function(){this.okToOpen=!0,this.queuedOpen&&this.queuedOpen()},this.showHTML=function(a,b,c,d){d=d||{},d.id=a;if(this.currentKey==a&&this.timeout){clearTimeout(this.timeout),this.timeout=null;return}if(!this.okToOpen){this.queuedOpen=function(){this.showHTML(a,b,c,d)};return}this.queuedOpen=null,this.forceHide(),this.currentKey=a,this.$hoverContent=$(b),this.$hoverContent.addClass(this.attr.hoverContainerClasses),this.$node.html(this.$hoverContent),this.pos=this.adjacent(this.$node,$(c),{gravity:"vertical-north"}),this.$hoverContent.addClass("gravity-"+this.pos.gravity),this.pos.gravity=="south"&&(this.pos.top-=5),this.$node.css({top:this.pos.top,left:this.pos.left});var e=this.$hoverContent.find("img.banner");e.length>0?e.load(function(){this.$node.show(),this.trigger("uiHoverShown",d)}.bind(this)):(this.$node.show(),this.trigger("uiHoverShown",d))},this.forceHide=function(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null),this.openTimer&&(clearTimeout(this.openTimer),this.openTimer=null),this.currentKey=null,this.$hoverContent&&(this.$node.hide(),this.$hoverContent.remove(),this.$hoverContent=null)},this.hide=function(){this.okToOpen=!1,this.queuedOpen=null,clearTimeout(this.openTimer),this.openTimer=null,this.timeout=setTimeout(this.forceHide.bind(this),this.attr.hideDelay)},this.mouseOverContent=function(){if(this.timeout){clearTimeout(this.timeout),this.timeout=null;return}},this.after("initialize",function(){this.on(document,"uiBeforePageChanged uiShortcutEsc",this.forceHide),this.on(document,"mouseover",{hoverContentSelector:this.mouseOverContent}),this.on(document,"mouseout",{hoverContentSelector:this.hide})})}var utils=require("core/utils"),compose=require("core/compose"),withPosition=require("app/ui/with_position");module.exports=withHoverCard
});
define("app/ui/profile_hovercard",["module","require","exports","core/component","app/ui/with_hover_card","app/ui/with_user_actions","app/ui/navigation_links"],function(module, require, exports) {
function profileHovercard(){this.defaultAttrs({modalContainerSelector:".modal-container",profileLinkSelector:"a.profile-picture, .fullname a",itemType:"user"}),this.openProfileHover=function(a,b){b.screenName&&delete b.userId;if(this.skipScreenName&&b.screenName&&b.screenName.toLowerCase()==this.skipScreenName.toLowerCase()||this.skipUserId&&b.userId==this.skipUserId)return;if(a.target&&$(a.target).closest(this.attr.modalContainerSelector).length>0)return;this.refEventData=b,this.refEl=a.target,this.lastRequested=b.screenName?b.screenName.toLowerCase():b.userId,this.prepareHover(this.lastRequested),this.$node.attr("data-associated-tweet-id",b.tweetId||null),this.$node.attr("data-impression-id",b.impressionId||null),this.$node.attr("data-disclosure-type",b.disclosureType||null),this.$node.attr("data-impression-cookie",b.impressionCookie||null),this.trigger("uiWantsProfilePopup",b)},this.dataAvailable=function(a,b){if((!b.screen_name||this.lastRequested!=b.screen_name.toLowerCase())&&this.lastRequested!=b.user_id)return;this.$node.attr("data-screen-name",b.screen_name||null),this.$node.attr("data-user-id",b.user_id||null),this.showHTML(b.user_id,b.html,$(this.refEl),this.refEventData)},this.after("initialize",function(a,b){NavigationLinks.attachTo(this.$node,{eventData:{scribeContext:{component:"profile_hover"}}}),b.profile_user&&(this.skipScreenName=b.profile_user.screen_name,this.skipUserId=b.profile_user.id_str),this.on(document,"dataProfilePopupSuccess",this.dataAvailable),this.on(document,"uiShowProfileHover",this.openProfileHover),this.on(document,"uiHideProfileHover",this.hide)})}var defineComponent=require("core/component"),withHoverCard=require("app/ui/with_hover_card"),withUserActions=require("app/ui/with_user_actions"),NavigationLinks=require("app/ui/navigation_links"),ProfileHovercard=defineComponent(profileHovercard,withHoverCard,withUserActions);module.exports=ProfileHovercard
});
define("app/data/with_email_follow_data",["module","require","exports"],function(module, require, exports) {
function withEmailFollowData(){this.reversibleEmailFollowAjaxCall=function(a,b,c){function d(c){this.trigger("dataUserActionSuccess",$.extend({},c,{userId:a.userId,requestUrl:b})),c.message&&this.trigger("uiShowMessage",c)}function e(b){typeof c!="undefined"&&this.trigger(c,a)}this.post({url:b,data:{user_id:a.userId},eventData:a,success:d.bind(this),error:e.bind(this)})},this.emailFollowAction=function(a,b){this.reversibleEmailFollowAjaxCall(b,"/i/user/email_notifications_on","dataEmailUnfollow")},this.emailUnfollowAction=function(a,b){this.reversibleEmailFollowAjaxCall(b,"/i/user/email_notifications_off","dataEmailFollow")},this.enableEmailFollowAction=function(a,b){this.reversibleEmailFollowAjaxCall(b,"/i/email_follow/enable","dataDisableEmailFollow")},this.disableEmailFollowAction=function(a,b){this.reversibleEmailFollowAjaxCall(b,"/i/email_follow/disable","dataEnableEmailFollow")},this.after("initialize",function(){this.on(document,"uiEmailFollowAction",this.emailFollowAction),this.on(document,"uiEmailUnfollowAction",this.emailUnfollowAction),this.on(document,"uiEnableEmailFollowAction",this.enableEmailFollowAction),this.on(document,"uiDisableEmailFollowAction",this.disableEmailFollowAction)})}module.exports=withEmailFollowData
});
define("app/data/user",["module","require","exports","core/component","core/utils","app/utils/cookie","app/data/with_data","app/data/with_email_follow_data"],function(module, require, exports) {
function userData(){this.defaultAttrs({millisecInDay:864e5,ageGateingErrorCode:250,ageGateCookieKey:"age-gated",injectTweetOnFollow:!1}),this.hasBeenAgeGatedWithin24Hr=function(){var a=cookie(this.attr.ageGateCookieKey);return a?(new Date).getTime()-parseInt(a,10)<this.attr.millisecInDay:!1},this.updateFollowStatus=function(a,b){function c(c){this.trigger("dataFollowStateChange",utils.merge(c,a,{userId:a.userId,newState:c.new_state,requestUrl:b,isFollowBack:c.is_follow_back})),this.trigger(document,"dataGotProfileStats",{stats:c.profile_stats})}function d(b){var c=a.userId,d=a.originalFollowState,e=b&&b.data&&b.data.code==this.attr.ageGateingErrorCode;b.new_state&&(d=b.new_state),this.trigger("dataFollowStateChange",utils.merge(b,{userId:c,newState:d})),e&&this.trigger("uiNeedsAgeGateDialog",{originalData:a,newState:d,ageGated:this.hasBeenAgeGatedWithin24Hr(),minBirthDate:parseInt(b.data.timestamp,10)})}var e=a.disclosureType?a.disclosureType=="earned":undefined,f={user_id:a.userId,impression_id:a.impressionId,earned:e,fromShortcut:a.fromShortcut,handles_challenges:1,inject_tweet:this.attr.injectTweetOnFollow&&a.inject_tweet};a.lifeline&&(f.lifeline=1),f.challenges_passed=!!a.passedAgeGating,this.post({url:b,data:f,eventData:a,success:c.bind(this),error:d.bind(this),retryIfUnavailable:!0})},this.reversibleAjaxCall=function(a,b,c){function d(c){this.trigger("dataUserActionSuccess",$.extend({},c,{userId:a.userId,requestUrl:b})),c.message&&this.trigger("uiShowMessage",c)}function e(b){this.trigger(c,a)}this.post({url:b,data:{user_id:a.userId,impression_id:a.impressionId},eventData:a,success:d.bind(this),error:e.bind(this)})},this.normalAjaxCall=function(a,b,c){function d(c){this.trigger("dataUserActionSuccess",$.extend({},c,{userId:a.userId,requestUrl:b})),c.message&&this.trigger("uiShowMessage",c)}var e=$.extend({user_id:a.userId,token:a.feedbackToken,impression_id:a.impressionId},c);this.post({url:b,data:e,eventData:a,success:d.bind(this),error:"dataUserActionError"})},this.followAction=function(a,b){var c="/i/user/follow";this.updateFollowStatus(b,c)},this.unfollowAction=function(a,b){var c="/i/user/unfollow";this.updateFollowStatus(b,c)},this.cancelAction=function(a,b){var c="/i/user/cancel";this.updateFollowStatus(b,c)},this.blockAction=function(a,b){var c="/i/user/block";this.updateFollowStatus(b,c)},this.unblockAction=function(a,b){var c="/i/user/unblock";this.updateFollowStatus(b,c)},this.reportSpamAction=function(a,b){this.normalAjaxCall(b,"/i/user/report_spam",{screen_name:b.screenName,report_type:b.reportType,block_user:b.blockUser,impression_id:b.impressionId})},this.hideSuggestionAction=function(a,b){this.normalAjaxCall(b,"/i/user/hide")},this.retweetOnAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/retweets_on","dataRetweetOffAction")},this.retweetOffAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/retweets_off","dataRetweetOnAction")},this.deviceNotificationsOnAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/device_notifications_on","dataDeviceNotificationsOffAction")},this.deviceNotificationsOffAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/device_notifications_off","dataDeviceNotificationsOnAction")},this.favoriteUserAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/favorite","dataUnfavoriteUser")},this.unfavoriteUserAction=function(a,b){this.reversibleAjaxCall(b,"/i/user/unfavorite","dataFavoriteUser")},this.after("initialize",function(){this.on(document,"uiFollowAction",this.followAction),this.on(document,"uiUnfollowAction",this.unfollowAction),this.on(document,"uiCancelFollowRequestAction",this.cancelAction),this.on(document,"uiBlockAction",this.blockAction),this.on(document,"uiUnblockAction",this.unblockAction),this.on(document,"uiReportSpamAction uiReportUserAction",this.reportSpamAction),this.on(document,"uiHideSuggestionAction",this.hideSuggestionAction),this.on(document,"uiRetweetOnAction",this.retweetOnAction),this.on(document,"uiRetweetOffAction",this.retweetOffAction),this.on(document,"uiDeviceNotificationsOnAction",this.deviceNotificationsOnAction),this.on(document,"uiDeviceNotificationsOffAction",this.deviceNotificationsOffAction),this.on(document,"uiAgeGatePassed",this.followAction),this.on(document,"uiFavoriteUserAction",this.favoriteUserAction),this.on(document,"uiUnfavoriteUserAction",this.unfavoriteUserAction)})}var defineComponent=require("core/component"),utils=require("core/utils"),cookie=require("app/utils/cookie"),withData=require("app/data/with_data"),withEmailFollowData=require("app/data/with_email_follow_data"),UserData=defineComponent(userData,withData,withEmailFollowData);module.exports=UserData
});
define("app/data/lists",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function listsData(){this.listMembershipContent=function(a,b){this.get({url:"/i/"+b.userId+"/lists",dataType:"json",data:{},eventData:b,success:"dataGotListMembershipContent",error:"dataFailedToGetListMembershipContent"})},this.addUserToList=function(a,b){this.post({url:"/i/"+b.userId+"/lists/"+b.listId+"/members",dataType:"json",data:{},eventData:b,success:"dataDidAddUserToList",error:"dataFailedToAddUserToList"})},this.removeUserFromList=function(a,b){this.destroy({url:"/i/"+b.userId+"/lists/"+b.listId+"/members",dataType:"json",data:{},eventData:b,success:"dataDidRemoveUserFromList",error:"dataFailedToRemoveUserFromList"})},this.createList=function(a,b){this.post({url:"/i/lists/create",dataType:"json",data:b,eventData:b,success:"dataDidCreateList",error:"dataFailedToCreateList"})},this.after("initialize",function(){this.on("uiNeedsListMembershipContent",this.listMembershipContent),this.on("uiAddUserToList",this.addUserToList),this.on("uiRemoveUserFromList",this.removeUserFromList),this.on("uiCreateList",this.createList)})}var defineComponent=require("core/component"),withData=require("app/data/with_data");module.exports=defineComponent(listsData,withData)
});
define("app/boot/profile_popup",["module","require","exports","core/utils","app/data/profile_popup","app/data/profile_popup_scribe","app/ui/profile_popup","app/data/profile_edit_btn_scribe","app/ui/profile_hovercard","app/data/user","app/data/lists"],function(module, require, exports) {
function initialize(a){ProfileHovercard.attachTo("#profile-hover-container",utils.merge(a,{eventData:{scribeContext:{component:"profile_hover"}}})),ProfilePopupData.attachTo(document,utils.merge(a,{eventData:{scribeContext:{component:"profile_dialog"}}})),UserData.attachTo(document,a),Lists.attachTo(document,a),ProfilePopup.attachTo("#profile_popup",utils.merge(a,{eventData:{scribeContext:{component:"profile_dialog"}}})),ProfileEditBtnScribe.attachTo("#profile_popup",{scribeContext:{component:"profile_dialog"}}),ProfilePopupScribe.attachTo(document,a)}var utils=require("core/utils"),ProfilePopupData=require("app/data/profile_popup"),ProfilePopupScribe=require("app/data/profile_popup_scribe"),ProfilePopup=require("app/ui/profile_popup"),ProfileEditBtnScribe=require("app/data/profile_edit_btn_scribe"),ProfileHovercard=require("app/ui/profile_hovercard"),UserData=require("app/data/user"),Lists=require("app/data/lists"),hasPopup=$("#profile_popup").length>0;module.exports=hasPopup?initialize:$.noop
});
define("app/ui/responsive_dashboard_width",["module","require","exports","core/component","core/utils","core/clock"],function(module, require, exports) {
function responsiveDashboardWidth(){this.defaultAttrs({leftDashboardSelector:".dashboard-left",rightDashboardSelector:".dashboard-right",roamingSelector:".roaming-module",threeColWidth:1236}),this.setWindowWidth=function(a){this.windowWidth=this.$window.width();if(this.windowWidth<this.attr.threeColWidth){if(this.threeCol||a)this.$dashboardLeft.append(this.$dashboardRight.find(this.attr.roamingSelector)),this.$body.removeClass("three-col"),this.threeCol=!1}else if(!this.threeCol||a)this.$dashboardRight.append(this.$dashboardLeft.find(this.attr.roamingSelector)),this.$body.addClass("three-col"),this.threeCol=!0},this.after("initialize",function(){this.$dashboardRight=this.select("rightDashboardSelector"),this.$dashboardRight.length&&(this.$window=$(window),this.$body=$(document.body),this.$dashboardLeft=this.select("leftDashboardSelector"),this.threeCol=!1,this.setWindowWidth(!0),this.on(window,"resize",utils.debounce(this.setWindowWidth.bind(this),100)))})}var defineComponent=require("core/component"),utils=require("core/utils"),clock=require("core/clock");module.exports=defineComponent(responsiveDashboardWidth)
});
define("app/ui/dialogs/retweet_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/ui/dialogs/with_modal_tweet"],function(module, require, exports) {
function retweetDialog(){this.defaults={cancelSelector:".cancel-action",retweetSelector:".retweet-action"},this.openRetweet=function(a,b){var c=$(a.target).clone();this.sourceEventData=b,this.displayTweet(b.tweetId,c,{modal:"retweet"}),this.open()},this.retweet=function(){this.trigger("uiDidRetweet",this.sourceEventData)},this.retweetSuccess=function(a,b){this.sourceEventData!=undefined&&this.trigger("uiDidRetweetSuccess",this.sourceEventData),this.close(),this.sourceEventData=undefined},this.restoreFocusToTweet=function(a){$(a.target).is(this.$dialog)&&this.activeEl&&(a.preventDefault(),this.trigger($(this.activeEl).closest(".tweet"),"uiShouldAddFocusStyle"),this.activeEl.focus())},this.after("initialize",function(){this.on("click",{cancelSelector:this.close,retweetSelector:this.retweet}),this.on(document,"uiOpenRetweetDialog",this.openRetweet),this.on(document,"dataDidRetweet",this.retweetSuccess),this.on(document,"uiDialogRestorePreviousFocus",this.restoreFocusToTweet)})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withModalTweet=require("app/ui/dialogs/with_modal_tweet"),RetweetDialog=defineComponent(retweetDialog,withDialog,withModalTweet);module.exports=RetweetDialog
});
define("app/data/saved_searches",["module","require","exports","core/component","app/data/with_data","app/data/with_auth_token"],function(module, require, exports) {
function savedSearches(){this.saveSearch=function(a,b){this.post({url:"/i/saved_searches/create.json",data:b,headers:{"X-PHX":!0},eventData:"",success:"dataAddedSavedSearch",error:"dataSavedSearchError"})},this.removeSavedSearch=function(a,b){this.post({url:"/i/saved_searches/destroy/"+encodeURIComponent(b.id)+".json",data:"",headers:{"X-PHX":!0},eventData:{component:b.component},success:"dataRemovedSavedSearch",error:"dataSavedSearchError"})},this.after("initialize",function(){this.on("uiAddSavedSearch",this.saveSearch),this.on("uiRemoveSavedSearch",this.removeSavedSearch)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),withAuthToken=require("app/data/with_auth_token");module.exports=defineComponent(savedSearches,withData,withAuthToken)
});
define("app/data/saved_searches_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function savedSearchesScribe(){this.scribeRemovedSavedSearch=function(a,b){var c="stream";b&&b.sourceEventData&&b.sourceEventData.component&&(c=b.sourceEventData.component),this.scribe({action:"remove",component:c,element:"saved_search"})},this.after("initialize",function(){this.scribeOnEvent("dataAddedSavedSearch",{action:"add",component:"stream",element:"saved_search"}),this.on("dataRemovedSavedSearch",this.scribeRemovedSavedSearch)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(savedSearchesScribe,withScribe)
});
define("app/ui/search_query_source",["module","require","exports","core/component","app/utils/storage/custom"],function(module, require, exports) {
function searchQuerySource(){this.defaultAttrs({querySourceLinkSelector:"a[data-query-source]",querySourceDataAttr:"data-query-source",storageExpiration:6e4}),this.saveQuerySource=function(a){this.storage.setItem("source",{source:{value:a,expire:Date.now()+this.attr.storageExpiration}},this.attr.storageExpiration)},this.catchLinkClick=function(a,b){var c=$(b.el).attr(this.attr.querySourceDataAttr);c&&this.saveQuerySource(c)},this.saveTypedQuery=function(a,b){if(b.source!=="search")return;this.saveQuerySource("typed_query")},this.after("initialize",function(){var a=customStorage({withExpiry:!0});this.storage=new a("searchQuerySource"),this.on("click",{querySourceLinkSelector:this.catchLinkClick}),this.on("uiSearchQuery",this.saveTypedQuery)})}var defineComponent=require("core/component"),customStorage=require("app/utils/storage/custom");module.exports=defineComponent(searchQuerySource)
});
define("app/data/share_via_email_dialog_data",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function shareViaEmailDialogData(){this.getDialogData=function(a,b){var c=function(a){this.trigger("dataShareViaEmailDialogSuccess",{tweets:a.items_html,name:b.name})},d=function(){this.trigger("dataShareViaEmailDialogError")},e=b.screenName,f=b.tweetId;this.get({url:"/i/"+e+"/conversation/"+f,success:c.bind(this),error:d.bind(this)})},this.after("initialize",function(){this.on("uiNeedsShareViaDialogData",this.getDialogData)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),ShareViaEmailDialogData=defineComponent(shareViaEmailDialogData,withData);module.exports=ShareViaEmailDialogData
});
define("app/ui/dialogs/share_via_email_dialog",["module","require","exports","core/component","app/ui/with_dialog","app/data/with_data","app/ui/dialogs/with_modal_tweet","app/data/share_via_email_dialog_data","core/i18n","core/utils"],function(module, require, exports) {
function shareViaEmailDialog(){this.defaultAttrs({contentSelector:".share-via-email-form .js-share-tweet-container",buttonSelector:".share-via-email-form .primary-btn",emailSelector:".share-via-email-form .js-share-tweet-emails",commentSelector:".share-via-email-form .js-share-comment",replyToUserSelector:".share-via-email-form .js-reply-to-user",tweetSelector:".share-via-email-form .tweet",socialProofSelector:".share-via-email-form .comment-box .social-proof"}),this.openDialog=function(a,b){var c=$(a.target).clone().removeClass("retweeted favorited"),d=c.attr("data-tweet-id");this.sourceEventData=b,this.displayTweet(d,c,{modal:"share"}),this.select("emailSelector").val(""),this.select("commentSelector").val(""),this.select("socialProofSelector").html(""),this.open(),this.trigger("uiNeedsShareViaDialogData",{tweetId:d,screenName:$(a.target).attr("data-screen-name"),name:$(a.target).attr("data-name")}),this.trigger("uiShareViaEmailDialogOpened",utils.merge(b,{scribeContext:{component:"share_via_email_dialog"}}))},this.fillDialog=function(a,b){var c=$(b.tweets).find(".tweet"),d=b.name;this.select("socialProofSelector").html("");var e=[];$.each(c,function(a,b){e.push($(b).attr("data-name"))}),e=jQuery.unique(e),e=jQuery.grep(e,function(a){return a!=d});var f=$(c[0]).attr("data-name"),g=$(c[0]).attr("data-protected"),h=$(c[c.length-1]).attr("data-name"),i=$(c[c.length-1]).attr("data-protected"),j="",k=e.length-2,l={inReplyToTweetAuthor:h,rootTweetAuthor:f,othersLeft:k};f!=d&&!g?f!=h&&!i?e.length>3?j=_('{{rootTweetAuthor}}\u3055\u3093\u3001{{inReplyToTweetAuthor}}\u3055\u3093\u3068\u4ed6{{othersLeft}}\u4eba\u3078\u306e\u8fd4\u4fe1',l):e.length>0&&(j=_('{{rootTweetAuthor}}\u3055\u3093\u3068{{inReplyToTweetAuthor}}\u3055\u3093\u3078\u306e\u8fd4\u4fe1',l)):i||(e.length>3?j=_('{{rootTweetAuthor}}\u3055\u3093\u3068\u4ed6{{othersLeft}}\u4eba\u3078\u306e\u8fd4\u4fe1',l):e.length>0&&(j=_('{{rootTweetAuthor}}\u3055\u3093\u3078\u306e\u8fd4\u4fe1',l))):h!=d&&!i&&(e.length>3?j=_('{{inReplyToTweetAuthor}}\u3055\u3093\u3068\u4ed6{{othersLeft}}\u4eba\u3078\u306e\u8fd4\u4fe1',l):e.length>0&&(j=_('{{inReplyToTweetAuthor}}\u3055\u3093\u3078\u306e\u8fd4\u4fe1',l))),this.select("socialProofSelector").html(j)},this.submitForm=function(a){var b={id:this.select("tweetSelector").attr("data-tweet-id"),emails:this.select("emailSelector").val(),comment:this.select("commentSelector").val(),reply_to_user:this.select("replyToUserSelector").is(":checked")};this.post({url:"/i/tweet/share_via_email",data:b,eventData:null,success:"dataShareViaEmailSuccess",error:"dataShareViaEmailError"}),this.trigger("uiCloseDialog"),a.preventDefault()},this.shareSuccess=function(a,b){this.trigger("uiShowMessage",{message:b.message}),this.trigger("uiDidShareViaEmailSuccess",this.sourceEventData)},this.restoreFocusToTweet=function(a){$(a.target).is(this.$dialog)&&this.activeEl&&this.trigger($(this.activeEl).closest(".tweet"),"uiShouldAddFocusStyle")},this.after("initialize",function(){this.on(document,"uiNeedsShareViaEmailDialog",this.openDialog),this.on(document,"dataShareViaEmailDialogSuccess",this.fillDialog),this.on(document,"dataShareViaEmailSuccess",this.shareSuccess),this.on(document,"uiDialogRestorePreviousFocus",this.restoreFocusToTweet),this.on("click",{buttonSelector:this.submitForm}),DialogData.attachTo(this.$node,{noTeardown:!0})})}var defineComponent=require("core/component"),withDialog=require("app/ui/with_dialog"),withData=require("app/data/with_data"),withModalTweet=require("app/ui/dialogs/with_modal_tweet"),DialogData=require("app/data/share_via_email_dialog_data"),_=require("core/i18n"),utils=require("core/utils"),ShareViaEmailDialog=defineComponent(shareViaEmailDialog,withDialog,withData,withModalTweet);module.exports=ShareViaEmailDialog
});
define("app/data/spam_challenge",["module","require","exports","core/component","core/i18n","app/data/with_data"],function(module, require, exports) {
function spamChallenge(){this.defaultAttrs({supportedChallengeTypes:["Captcha"],captchaName:"Captcha",defaultCompletionMessage:_('\u64cd\u4f5c\u304c\u5b8c\u4e86\u3057\u307e\u3057\u305f\u3002'),recaptchaLoadTime:100,maxCaptchaLoadRetries:3}),this.hitChallengeEndpoint=function(a){this.get({url:"/account/challenge",data:{challenge:a.challenge,response:a.response,challenge_name:a.challengeName},success:this.handleSuccessResponse.bind(this),error:this.handleErrorResponse.bind(this)})},this.handleErrorResponse=function(a){this.closeCurrentChallenge(),this.resetChallengeParams()},this.closeCurrentChallenge=function(){this.currentChallenge&&this.trigger("uiCloseSpam"+this.currentChallenge+"Challenge")},this.allChallengesCompleted=function(a){return!a.challengeName},this.isValidChallengeType=function(a){return this.attr.supportedChallengeTypes.indexOf(a.challengeName)!==-1},this.needToRefreshCaptchaChallenge=function(a){return this.currentChallenge===this.attr.captchaName&&a.challengeName===this.attr.captchaName},this.handleSuccessResponse=function(a){this.allChallengesCompleted(a)?(this.closeCurrentChallenge(),this.sendCompletionMessage(),this.resetChallengeParams()):this.needToRefreshCaptchaChallenge(a)?this.trigger("uiRefreshSpamCaptchaChallenge"):this.isValidChallengeType(a)?(this.closeCurrentChallenge(),this.setAndOpenNewChallenge(a)):(this.closeCurrentChallenge(),this.resetChallengeParams())},this.setAndOpenNewChallenge=function(a){this.setChallengeParams(a.challengeName,a.completionMessage),this.trigger("uiOpenSpam"+this.currentChallenge+"Challenge",a)},this.sendCompletionMessage=function(){this.trigger("uiShowMessage",{message:this.getCompletionMessage()})},this.getCompletionMessage=function(){return this.completionMessage||this.attr.defaultCompletionMessage},this.createInitialChallenge=function(a,b){this.needToCreateRecaptchaWidget(b)?this.fetchRecaptchaScript(a,b):this.setAndOpenNewChallenge(b)},this.needToCreateRecaptchaWidget=function(a){return a.challengeName===this.attr.captchaName&&!this.isRecaptchaObjectDefined()},this.isRecaptchaObjectDefined=function(){return typeof Recaptcha!="undefined"},this.fetchScriptDone=function(a,b,c){c=="success"?this.ensureRecaptchaCreatedAndLoadChallenge(a):this.trigger(document,"uiShowError",{message:"Internal server error."})},this.fetchScriptFailure=function(a,b,c){this.trigger(document,"uiShowError",{message:"Internal server error."})},this.fetchRecaptchaScript=function(a,b){$.getScript(this.attr.recaptchaApiUrl).done(this.fetchScriptDone.bind(this,b)).fail(this.fetchScriptFailure.bind(this))},this.ensureRecaptchaCreatedAndLoadChallenge=function(a){if(this.isRecaptchaObjectDefined()){this.setAndOpenNewChallenge(a);return}this.loadAttempts=this.attr.maxCaptchaLoadRetries,this.recaptchaLoadInterval=setInterval(this.checkIfRecaptchaCreated.bind(this,a),this.attr.recaptchaLoadTime)},this.clearRecaptchLoadInterval=function(){clearInterval(this.recaptchaLoadInterval)},this.clearLoadAttempts=function(){this.loadAttempts=undefined},this.isLoadAttemptsDefined=function(){return typeof this.loadAttempts!="undefined"},this.checkIfRecaptchaCreated=function(a){this.isLoadAttemptsDefined()&&this.loadAttempts--,this.isRecaptchaObjectDefined()&&(this.clearRecaptchLoadInterval(),this.setAndOpenNewChallenge(a),this.clearLoadAttempts());if(!this.isLoadAttemptsDefined()||this.loadAttempts<=0)this.clearRecaptchLoadInterval(),this.clearLoadAttempts(),this.trigger(document,"uiShowError",{message:"Internal server error."})},this.submitChallenge=function(a,b){this.hitChallengeEndpoint(b)},this.resetChallengeParams=function(){this.setChallengeParams()},this.setChallengeParams=function(a,b){this.currentChallenge=a,this.completionMessage=b},this.after("initialize",function(){this.on("uiSubmitSpamChallenge",this.submitChallenge),this.on("dataInitialChallengeNeeded",this.createInitialChallenge)})}var defineComponent=require("core/component"),_=require("core/i18n"),withData=require("app/data/with_data");module.exports=defineComponent(spamChallenge,withData)
});
define("app/ui/spoonbill",["module","require","exports","core/component","template","app/ui/with_user_actions","app/ui/with_item_actions","app/ui/with_interaction_data","app/data/with_interaction_data_scribe","app/utils/tweet_helper"],function(module, require, exports) {
function Spoonbill(){this.defaultAttrs({eventData:{scribeContext:{component:"spoonbill"}},toastClass:"WebToast",toastSelector:".WebToast",closeButtonSelector:".WebToast-closeButton",headerSelector:".WebToast-header",toastfollowButtonSelector:".WebToast-followButton",fullnameSelector:".WebToast-fullname",usernameSelector:".WebToast-username",avatarSelector:".WebToast-avatar",excerptSelector:".WebToast-tweetExcerpt",actionBarSelector:".WebToast-actionBar",tweetTextSelector:".tweet-text",inlineReplySelector:".js-inlineReply",tweetFormSelector:".WebToast-box .tweet-form",redirectToNotificationsSelector:'.WebToast[data-redirect-to="notifications"]'}),this.elementIsClickableTarget=function(a){var b=["a","b","button","strong"];return a&&a.tagName&&b.indexOf(a.tagName.toLowerCase())>-1},this.hasAncestorWithClickableTarget=function(a,b){var c=!1;while(a){this.elementIsClickableTarget(a)&&(c=!0);if(c||a==b)break;a=a.parentElement}return c},this.redirectToNotifications=function(a,b){if(this.hasAncestorWithClickableTarget(a.target,a.currentTarget))return;this.trigger("uiNavigate",{href:"/i/notifications"})},this.renderSpoonbillNotification=function(a,b){var c="spoonbill_"+(new Date).getTime(),d=$(template["spoonbill/"+b.type].render(b,template));this.$node.empty(),this.$node.append(d),d.fadeIn(),this.setupUIElementsForSpoonbill(d,b),d.attr("id",c),b.elementId=c,this.trigger("uiSpoonbillDidShow",b),this.scribeInteraction({action:"impression"},this.interactionData(d))},this.spoonbillDismiss=function(a,b){this.markDMRead(),this.scribeInteraction({action:"dismiss"},this.interactionData(a)),this.trigger("uiNotificationDismissed",{}),a.stopPropagation()},this.replyClick=function(){this.select("tweetFormSelector").trigger("uiTweetBoxExpand")},this.setupMentionUIForSpoonbill=function(a,b){var c=b.mentions;c.unshift(b.user_screen_name),b.screen_names_for_tweet_box=c.map(function(a){return"@"+a}).join(" "),b.tweet_box_id="spoonbill_tweet_box",b.include_image_picker=!0,b.upload_domain=this.attr.uploadDomain,$(template.swift_tweet_box.render(b,template)).appendTo(this.select("inlineReplySelector")),this.select("tweetFormSelector").trigger("uiInitTweetbox",{noTeardown:!0,condensable:!0,condenseContainer:this.attr.toastSelector,preventTweetingDefaultText:!1,inReplyToStatusId:b.tweet_id,impressionId:b.impression_id,accountsShortcutShow:!1,renderLimit:2,eventData:{scribeContext:{component:"spoonbill"}}}),this.attr.itemType="tweet"},this.markDMRead=function(){this.dmData&&this.dmData.tweet_id&&this.trigger("dataMarkDMsAsRead",{last_message_id:this.dmData.tweet_id,recipient_id:this.dmData.user_id,recipient_name:this.dmData.user_screen_name,from_notification:!0}),this.dmData=null},this.setupDMUIForSpoonbill=function(a,b){this.dmData=b,b.media_upload_domain=this.attr.uploadDomain,$(template.swift_dm_box.render(b,template)).appendTo(this.select("inlineReplySelector")),this.select("tweetFormSelector").trigger("uiInitTweetbox",{noTeardown:!0,eventParams:{type:"DM"},suppressFlashMessage:!0,hasTypeahead:!1,eventData:{scribeContext:{component:"spoonbill"}},dmOnly:!0,fileDataString:"media",fileInputString:"media"}),this.attr.itemType="tweet"},this.setupFollowUIForSpoonbill=function(a,b){this.attr.itemType="user"},this.setupFavoriteUIForSpoonbill=function(a,b){this.attr.itemType="activity"},this.setupRetweetUIForSpoonbill=function(a,b){this.attr.itemType="activity"},this.setupUIElementsForSpoonbill=function(a,b){b.type=="mention"?this.setupMentionUIForSpoonbill(a,b):b.type=="dm"?this.setupDMUIForSpoonbill(a,b):b.type=="follow"?this.setupFollowUIForSpoonbill(a,b):b.type=="favorite"?this.setupFavoriteUIForSpoonbill(a,b):b.type=="retweet"&&this.setupRetweetUIForSpoonbill(a,b)},this.dmScreenName=function(){return this.select("toastSelector").data("screen-name")},this.sendDM=function(a,b){this.markDMRead(),this.attr.sentTweetboxId=b.tweetboxId,a.stopPropagation(),a.preventDefault(),this.trigger("uiDMDialogSendMessage",{tweetboxId:b.tweetboxId,screen_name:this.dmScreenName(),text:b.tweetData.status,source:"spoonbill"}),this.trigger("uiNotificationComposeActive",b)},this.sendDMWithMedia=function(a,b){this.markDMRead(),b.recipient=this.dmScreenName(),this.attr.sentTweetboxId=b.tweetboxId,this.trigger("uiNotificationComposeActive",b)},this.sendTweet=function(a,b){this.attr.sentTweetboxId=b.tweetboxId,this.trigger("uiNotificationComposeActive",b)},this.resetOnSend=function(){this.attr.sentTweetboxId=undefined,this.trigger("uiNotificationComposeComplete")},this.sendDMSuccess=function(a,b){b.sourceEventData.tweetboxId==this.attr.sentTweetboxId&&this.resetOnSend()},this.sendTweetSuccess=function(a,b){b.tweetboxId==this.attr.sentTweetboxId&&this.resetOnSend()},this.resumeRotation=function(a,b){this.trigger("uiResumeSpoonbillRotation")},this.after("initialize",function(){this.on(document,"uiRequestSpoonbillRender",this.renderSpoonbillNotification),this.on("uiReplyToTweet",this.replyClick),this.on("uiSendDM",this.sendDM),this.on("uiSendDMWithMedia",this.sendDMWithMedia),this.on("uiSendTweet",this.sendTweet),this.on(document,"dataDMSuccess",this.sendDMSuccess),this.on(document,"dataTweetSuccess",this.sendTweetSuccess),this.on(document,"dataTweetError dataDMError",this.resumeRotation),this.on("click",{closeButtonSelector:this.spoonbillDismiss,redirectToNotificationsSelector:this.redirectToNotifications})})}var defineComponent=require("core/component"),template=require("template"),withUserActions=require("app/ui/with_user_actions"),withItemActions=require("app/ui/with_item_actions"),withInteractionData=require("app/ui/with_interaction_data"),withInteractionDataScribe=require("app/data/with_interaction_data_scribe"),tweetHelper=require("app/utils/tweet_helper");module.exports=defineComponent(Spoonbill,withUserActions,withItemActions,withInteractionData,withInteractionDataScribe)
});
define("app/ui/spoonbill_producer",["module","require","exports","core/component","app/utils/storage/core","core/clock"],function(module, require, exports) {
function SpoonbillProducer(){this.defaultAttrs({spoonbillDuration:{mention:8e3,dm:8e3,follow:8e3,normal:5e3},betweenInterval:2e3,eventTypeMapper:{direct_message:"dm",favorited:"favorite",favorited_mention:"favorite",favorited_retweet:"favorite",followed:"follow",followed_request:"follow",retweeted:"retweet",retweeted_mention:"retweet",retweeted_retweet:"retweet"},acceptEventTypes:["dm","favorite","follow","retweet","mention"],queue:[],toastClass:"WebToast",toastSelector:".WebToast",tweetFormSelector:".WebToast-box .tweet-form",closeButtonSelector:".WebToast-close",displayState:undefined}),this.incomingSpoonbills=function(a,b){if(!b||typeof b!="object"||!Array.isArray(b.toasts))return;b.force&&(this.latestNotificationTimestamp=0),this.normalizeSpoonbills(b.toasts).forEach(function(a){this.attr.eventTypeMapper.hasOwnProperty(a.type)&&(a.type=this.attr.eventTypeMapper[a.type]);if(this.attr.acceptEventTypes.indexOf(a.type)<0)return;this.addSpoonbill(a)},this),this.latestNotificationTimestamp=++b.latest,storage.setItem("latestNotificationTimestamp",this.latestNotificationTimestamp)},this.addSpoonbill=function(a){if(!a.timestamp||a.timestamp<this.latestNotificationTimestamp)return;this.attr.queue.push(a),this.displayState==DisplayState.None&&this.showSpoonbill()},this.showSpoonbill=function(){var a=this.getNext();if(!a){this.displayState=DisplayState.None;return}this.displayState=DisplayState.Visible,this.removeMouseBindings(),this.trigger("uiRequestSpoonbillRender",a)},this.getPath=function(){return location.pathname},this.getNext=function(){var a=this.attr.queue.shift();if(this.getPath()=="/i/notifications")while(a&&(a.type=="retweet"||a.type=="favorite"))a=this.attr.queue.shift();return a&&a.type=="follow"&&(a.with_block_username=!0),a},this.normalizeSpoonbills=function(a){return a.filter(function(a){return a.timestamp}).sort(function(a,b){return a.timestamp-b.timestamp})},this.removeMouseBindings=function(){this.select("toastSelector").unbind("mouseenter",this.notificationMouseEnterHandler),this.select("toastSelector").unbind("mouseleave",this.notificationMouseLeaveHandler)},this.clearTimers=function(a){a.forEach(function(a){this[a]&&(clearTimeout(this[a]),delete this[a])}.bind(this))},this.purgeNotifications=function(a){this.removeMouseBindings(),this.clearTimers(["rotateTimer","updateTimer"]),this.attr.queue=[],this.fadeOut()},this.fadeOut=function(){this.select("toastSelector").animate({opacity:0},function(){this.select("tweetFormSelector").trigger("uiAllowTeardown",{}),this.select("toastSelector").remove(),this.displayState=DisplayState.Between,this.clearTimers(["rotateTimer"]),this.rotateTimer=setTimeout(this.showSpoonbill.bind(this),this.attr.betweenInterval)}.bind(this))},this.updateNotificationDisplay=function(a){this.checkForUserData(),this.displayState>DisplayState.Visible?this.monitorVisibleSpoonbill(a):this.displayState==DisplayState.Visible&&this.fadeOut()},this.monitorVisibleSpoonbill=function(a){this.clearTimers(["updateTimer"]),this.updateTimer=setTimeout(this.updateNotificationDisplay.bind(this,a),this.getRotateInterval(a.type))},this.getRotateInterval=function(a){return this.attr.spoonbillDuration.hasOwnProperty(a)?this.attr.spoonbillDuration[a]:this.attr.spoonbillDuration.normal},this.checkForUserData=function(){if(this.displayState>DisplayState.Composing)return;var a=this.$node.find(".tweet-button"),b=a.is(":visible")&&a.find("button.primary-btn").attr("disabled")!="disabled"&&a.find("button.primary-btn.disabled").length==0,c=$.contains(this.$node[0],document.activeElement);b||c?this.displayState=DisplayState.Composing:this.displayState>DisplayState.Visible&&(this.displayState=DisplayState.Visible)},this.spoonbillDidShow=function(a,b){var c=$("#"+b.elementId);this.notificationMouseEnterHandler=this.handleMouseEnterForNotifications.bind(this),this.notificationMouseLeaveHandler=this.handleMouseLeaveForNotifications.bind(this),c.bind("mouseenter",this.notificationMouseEnterHandler),c.bind("mouseleave",this.notificationMouseLeaveHandler),this.monitorVisibleSpoonbill(b)},this.processNewNotifications=function(a,b){b&&b.n&&b.n.status=="ok"&&b.n.response&&typeof b.n.response=="object"&&this.trigger("uiNewSpoonbillsArrived",b.n.response)},this.composeActive=function(a,b){this.displayState=DisplayState.Composing},this.composeComplete=function(a,b){this.fadeOut()},this.handleMouseEnterForNotifications=function(a,b){this.displayState=DisplayState.Focused},this.handleMouseLeaveForNotifications=function(a,b){this.displayState=DisplayState.Visible},this.handleImagePickerClick=function(a,b){this.displayState=DisplayState.Attaching},this.after("initialize",function(){this.displayState=DisplayState.None,this.on(document,"uiNotificationComposeActive",this.composeActive),this.on(document,"uiNotificationComposeComplete",this.composeComplete),this.on(document,"uiNewSpoonbillsArrived",this.incomingSpoonbills),this.on(document,"uiSpoonbillDidShow",this.spoonbillDidShow),this.on(document,"uiNotificationRotate",this.showSpoonbill),this.on(document,"dataNotificationsReceived",this.processNewNotifications),this.on("uiImagePickerClick",this.handleImagePickerClick),this.on("uiNotificationDismissed",this.purgeNotifications),this.on("mouseenter",this.handleMouseEnterForNotifications),this.on("mouseleave",this.handleMouseLeaveForNotifications)})}var defineComponent=require("core/component"),Storage=require("app/utils/storage/core"),clock=require("core/clock");module.exports=defineComponent(SpoonbillProducer);var storage=new Storage("DM"),DisplayState={None:1,Between:2,Visible:3,Composing:4,Focused:5,Attaching:6}
});
define("app/data/geo",["module","require","exports","core/component","app/utils/cookie","app/data/with_data"],function(module, require, exports) {
function geo(){this.isInState=function(a){return a.split(" ").indexOf(this.state)>=0},this.isEnabled=function(a){return!this.isInState("disabled enabling enableIsUnavailable")},this.setInitialState=function(){this.attr.geoEnabled?this.state=Geo.webclientCookie()==="1"?"enabledTurnedOn":"enabledTurnedOff":this.state="disabled"},this.requestState=function(a,b){this.shouldLocate()?this.locate():this.sendState(this.state)},this.shouldLocate=function(){return this.isInState("enabledTurnedOn locateIsUnavailable")||this.isInState("located locationUnknown")&&(!this.lastLocationTime||this.now()-this.lastLocationTime>MIN_TIME_BETWEEN_LOCATES_IN_MS)},this.locate=function(a){this.sendState(a?"changing":"locating");var b=function(a){this.sendState(this.locateOrEnableState(a)||"locateIsUnavailable")}.bind(this),c=function(){this.sendState("locateIsUnavailable")}.bind(this),d={override_place_id:a};this.post({url:"/account/geo_locate",data:d,echoParams:{spoof_ip:!0},eventData:d,success:b,error:c})},this.locateOrEnableState=function(a){switch(a.status){case"ok":return this.place_id=a.place_id,this.place_name=a.place_name,this.places_html=a.html,this.lastLocationTime=this.now(),"located";case"unknown":return this.lastLocationTime=this.now(),"locationUnknown"}},this.now=function(){return(new Date).getTime()},this.sendState=function(a){a&&(this.state=a);var b={state:this.state};this.state==="located"&&(b.place_id=this.place_id,b.place_name=this.place_name,b.places_html=this.places_html),this.trigger("dataGeoState",b)},this.turnOn=function(){this.isEnabled()&&(Geo.webclientCookie("1"),this.locate())},this.turnOff=function(){this.isEnabled()&&(Geo.webclientCookie(null),this.sendState("enabledTurnedOff"))},this.enable=function(a,b){if(!this.isInState("disabled enableIsUnavailable"))return;this.sendState("enabling");var c=function(a){Geo.webclientCookie("1"),this.sendState(this.locateOrEnableState(a)||"enableIsUnavailable")}.bind(this),d=function(){this.sendState("enableIsUnavailable")}.bind(this);this.post({url:"/account/geo_locate",data:{enable:"1"},echoParams:{spoof_ip:!0},eventData:b,success:c,error:d})},this.change=function(a,b){this.isEnabled()&&this.locate(b.placeId)},this.search=function(a,b){if(this.searching){this.pendingSearchData=b;return}this.pendingSearchData=null;var c=function(){this.searching=!1;if(this.pendingSearchData)return this.search(a,this.pendingSearchData),!0}.bind(this),d=b.query.trim(),e=[d,b.placeId,b.isPrefix].join(","),f=function(a){this.searchCache[e]=a,a=$.extend({},a,{sourceEventData:b}),c()||this.trigger("dataGeoSearchResults",a)}.bind(this),g=function(){c()||this.trigger("dataGeoSearchResultsUnavailable")}.bind(this);if(!d){f({html:""});return}var h=this.searchCache[e];if(h){f(h);return}this.searching=!0,this.get({url:"/account/geo_search",data:{query:d,place_id:b.placeId,is_prefix:b.isPrefix?"1":"0"},eventData:b,success:f,error:g})},this.after("initialize",function(){this.searchCache={},this.setInitialState(),this.on("uiRequestGeoState",this.requestState),this.on("uiGeoPickerEnable",this.enable),this.on("uiGeoPickerTurnOn",this.turnOn),this.on("uiGeoPickerTurnOff",this.turnOff),this.on("uiGeoPickerChange",this.change),this.on("uiGeoPickerSearch",this.search)})}var defineComponent=require("core/component"),cookie=require("app/utils/cookie"),withData=require("app/data/with_data"),Geo=defineComponent(geo,withData),MIN_TIME_BETWEEN_LOCATES_IN_MS=9e5;module.exports=Geo,Geo.webclientCookie=function(a){return a===undefined?cookie("geo_webclient"):cookie("geo_webclient",a,{expires:3650,path:"/"})}
});
define("app/data/with_media_upload",["module","require","exports"],function(module, require, exports) {
function withMediaUpload(){function b(a,b){var c;a.originalEvent&&(a=a.originalEvent);try{c=JSON.parse(a.data)}catch(d){return console.log("Failed to JSON.parse: "+a.data),!1}return c.media_id_string&&c.upload_id==b?c.media_id_string:!1}var a="https://upload.twitter.com/i/media/upload.iframe";this.UPLOAD_TIMEOUT=12e4,this.$hiddenContent=$("#hidden-content"),this.$formTemplate=$(".media-upload-form"),this.getOnMessage=function(a,c){return function(d){var e=b(d,c);e&&a.resolveWith(this,[e,c])}.bind(this)},this.uploadMedia=function(a){var b=a.mediaData,c=a.tweetboxId,d=a.uploadId,e=this.createMediaUploadForm(this.$hiddenContent,this.$formTemplate,d,b),f=$.Deferred(),g=setTimeout(function(){f.reject()},this.UPLOAD_TIMEOUT),h=this.getOnMessage(f,d),i=function(){e.form.remove(),e.iframe.remove(),this.off(window,"message",h),clearTimeout(g)}.bind(this);return this.on(window,"message",h),f.always(i),e.form.submit(),f},this.createMediaUploadForm=function(b,c,d,e){var f=$("<iframe>");f.attr("name","media-upload-iframe-"+d),b.append(f);var g=c.clone(),h=location.protocol+"//"+location.hostname+(location.port?":"+location.port:"");return g.attr("target","media-upload-iframe-"+d),g.attr("action",a+"?origin="+encodeURIComponent(h)),g.find(".auth-token").val(this.getAuthToken()),g.find(".media").val(e),g.find(".upload-id").val(d),g.find(".origin").val(h),b.append(g),{form:g,iframe:f}}}module.exports=withMediaUpload
});
define("app/data/tweet",["module","require","exports","core/component","app/data/with_auth_token","core/i18n","app/data/with_data","app/data/with_media_upload","app/data/user_info"],function(module, require, exports) {
function tweet(){this.IFRAME_TIMEOUT=12e4,this.defaultAttrs({includePageContext:!0,asyncMediaUpload:!1}),this.sendTweet=function(a,b){var c=b.tweetboxId,d=function(a){a.tweetboxId=c,this.trigger("dataTweetSuccess",a),this.trigger("dataGotProfileStats",{stats:a.profile_stats}),a.tweet_stats&&this.trigger("dataGotTweetStats",{stats:a.tweet_stats})},e=function(a){var b;try{b={message:a.message,spamChallenge:a.challengeName}}catch(d){b={error:_('\u7533\u3057\u8a33\u3042\u308a\u307e\u305b\u3093\u304c\u3001Twitter\u306b\u4f55\u304b\u554f\u984c\u304c\u3042\u308b\u3088\u3046\u3067\u3059\u3002')}}b.tweetboxId=c,this.trigger("dataTweetError",b)};this.post({url:"/i/tweet/create",isMutation:!1,data:b.tweetData,success:d.bind(this),error:e.bind(this),retryIfUnavailable:!0})},this.sendTweetWithMedia=function(a,b){if(this.attr.asyncMediaUpload){this.sendTweetWithMediaAsync(a,b);return}var c=b.tweetboxId,d=b.tweetData,e=this,f,g=function(a){a.tweetboxId=c,clearTimeout(f),a.error?e.trigger("dataTweetError",a):e.trigger("dataTweetSuccess",a)};window[c]=g.bind(this),f=setTimeout(function(){window[c]=function(){},g({error:_('\u5199\u771f\u3064\u304d\u306e\u6295\u7a3f\u304c\u30bf\u30a4\u30e0\u30a2\u30a6\u30c8\u3057\u307e\u3057\u305f')})},this.IFRAME_TIMEOUT);var h=$("#"+b.tweetboxId),i=this.getAuthToken();h.find(".auth-token").val(i),h.find(".iframe-callback").val("window.top."+c),h.find(".in-reply-to-status-id").val(d.in_reply_to_status_id),h.find(".impression-id").val(d.impression_id),h.find(".earned").val(d.earned),h.find('[name="status"]').val(d.status),this.attr.includePageContext&&this.attr.pageContext&&h.find(".page-context").val(this.attr.pageContext),h.find(".tagged-users").val(d.tagged_users),h.submit()},this.getMediaData=function(a){var b={},c=$("#"+a),d=c.find(".multi-photo-data");if(d.length)$.each(d,function(a,c){var d=$(c).attr("data-upload-id");b[d]=$(c).val()});else{var e=+(new Date);b[e]=c.find(".file-data").val()}return b},this.sendTweetWithMediaAsync=function(a,b){var c=b.tweetboxId,d=b.tweetData,e=this.getMediaData(c),f=$.map(e,function(a,b){var d=this.uploadMedia({mediaData:a,tweetboxId:c,uploadId:b});return d.done(function(a,b){e[b]=a}.bind(this)),d.fail(function(){this.trigger("dataTweetError",{tweetboxId:c})}.bind(this)),d}.bind(this));$.when.apply($,f).then(function(){d.media_ids=$.map(e,function(a,b){return a}).join(","),this.sendTweet(a,{tweetboxId:c,tweetData:d})}.bind(this),function(){this.trigger("dataTweetError",{tweetboxId:c})}.bind(this))},this.sendDirectMessage=function(a,b){this.trigger("dataDirectMessageSuccess",b)},this.after("initialize",function(){this.attr.asyncMediaUpload=userInfo.getDecider("async_upload"),this.on("uiSendTweet",this.sendTweet),this.on("uiSendTweetWithMedia",this.sendTweetWithMedia),this.on("uiSendDirectMessage",this.sendDirectMessage)})}var defineComponent=require("core/component"),withAuthToken=require("app/data/with_auth_token"),_=require("core/i18n"),withData=require("app/data/with_data"),withMediaUpload=require("app/data/with_media_upload"),userInfo=require("app/data/user_info"),Tweet=defineComponent(tweet,withAuthToken,withData,withMediaUpload);module.exports=Tweet
});
define("app/ui/tweet_dialog",["module","require","exports","core/component","core/utils","app/ui/with_dialog","app/ui/dialogs/with_modal_tweet","app/data/user_info","core/i18n"],function(module, require, exports) {
function tweetDialog(){this.defaultAttrs({tweetBoxSelector:"form.tweet-form",profileTweetGradeSelectors:".ProfileTweet--low, .ProfileTweet--medium, .ProfileTweet--high",defaultProfileTweetGradeClass:"ProfileTweet--low",globalTweetBoxSelector:"#global-tweet-dialog form.tweet-form"}),this.sanitizeTweet=function(a){return a.is(this.attr.profileTweetGradeSelectors)&&a.removeClass(this.attr.profileTweetGradeSelectors.replace(/[.,]/g,"")).addClass(this.attr.defaultProfileTweetGradeClass),a},this.openShareTrendsDialog=function(a,b){this.openTweetDialog(a,utils.merge(b,{title:_('\u30c8\u30ec\u30f3\u30c9\u3092\u5171\u6709\u3059\u308b'),setCursorToBeginning:!0,canTweetDefaultText:!0,customData:{shareTrends:!0}}))},this.openReply=function(a,b){this.displayTweet(b.id,this.sanitizeTweet($(a.target).clone()),{modal:"reply"});var c=b.screenNames[0];this.openTweetDialog(a,utils.merge(b,{title:_('{{screenName}}\u3055\u3093\u3078\u8fd4\u4fe1',{screenName:"@"+c})}))},this.openGlobalTweetDialog=function(a,b){if(this.isModalOpen())return;this.openTweetDialog(a,utils.merge(b,{draftTweetId:"global"}))},this.openTweetDialog=function(a,b){var c=$(this.attr.globalTweetBoxSelector);this.setTitle(b&&b.title||_('\u30c4\u30a4\u30fc\u30c8\u3059\u308b')),this.tweetBoxReady||(this.trigger(c,"uiInitTweetbox",{eventData:{scribeContext:{component:"tweet_box_dialog"}},modal:!0,canTweetDefaultText:b&&b.canTweetDefaultText}),this.tweetBoxReady=!0);if(b){var d=null;b.screenNames?d=b.screenNames:b.screenName&&(d=[b.screenName]),d&&(b.defaultText="@"+d.join(" @")+" ",b.condensedText=_('{{screenNames}}\u3055\u3093\u3078\u8fd4\u4fe1',{screenNames:b.defaultText})),b.text&&(b.defaultText=" "+b.text),b.setCursorToBeginning&&(b.cursorPosition=0),b.imageUrl&&this.trigger(c,"uiGotImageData",{contents:b.imageUrl,name:b.imageName}),this.trigger(document,"uiOverrideTweetBoxOptions",b)}this.open()},this.setTitle=function(a){this.select("modalTitleSelector").text(a)},this.updateTitle=function(a,b){b&&b.title&&this.setTitle(b.title)},this.prepareTweetBox=function(){this.select("tweetBoxSelector").trigger("uiPrepareTweetBox")},this.preventDefaultDialogFocus=function(a){this.isOpen()&&this.$dialog.is(a.target)&&a.preventDefault()},this.triggerTweetDialogClosedEvent=function(){this.trigger(document,"uiTweetDialogClosed")},this.after("initialize",function(){this.on(document,"uiDialogInitialFocus",this.preventDefaultDialogFocus),this.on(document,"uiShortcutShowTweetbox",this.openGlobalTweetDialog),this.on(document,"uiOpenTweetDialog",this.openTweetDialog),this.on(document,"uiOpenReplyDialog",this.openReply),this.on(document,"uiOpenShareTrendsDialog",this.openShareTrendsDialog),this.on("uiTweetSent",this.close),this.on("uiDialogOpened",this.prepareTweetBox),this.on("uiDialogClosed",this.removeTweet),this.on("uiDialogClosed",this.triggerTweetDialogClosedEvent),this.on("uiDialogUpdateTitle",this.updateTitle)})}var defineComponent=require("core/component"),utils=require("core/utils"),withDialog=require("app/ui/with_dialog"),withModalTweet=require("app/ui/dialogs/with_modal_tweet"),userInfo=require("app/data/user_info"),_=require("core/i18n"),TweetDialog=defineComponent(tweetDialog,withDialog,withModalTweet);module.exports=TweetDialog
});
define("app/ui/new_tweet_button",["module","require","exports","core/component","app/data/with_scribe","app/utils/user_dom_data"],function(module, require, exports) {
function newTweetButton(){this.defaultAttrs({draftTweetIdAttr:"draft-tweet-id",dialogTitleAttr:"dialog-title",defaultTextAttr:"default-text",setCursorToBeginningAttr:"cursor-beginning"}),this.openTweetDialog=function(){this.scribe({element:"tweet_button",action:"click"},this.attr.eventData),this.trigger("uiOpenTweetDialog",this.tweetDialogData())},this.tweetDialogData=function(){return{draftTweetId:this.$node.data(this.attr.draftTweetIdAttr)||"global",screenName:userDomDataUtil.getScreenName(this.$node),title:this.$node.data(this.attr.dialogTitleAttr),text:this.$node.data(this.attr.defaultTextAttr),setCursorToBeginning:this.$node.data(this.attr.setCursorToBeginningAttr)}},this.after("initialize",function(){this.on("click",this.openTweetDialog)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),userDomDataUtil=require("app/utils/user_dom_data");module.exports=defineComponent(newTweetButton,withScribe)
});
define("app/data/tweet_box_scribe",["module","require","exports","core/component","app/data/with_scribe"],function(module, require, exports) {
function tweetBoxScribe(){var a={tweetBox:{uiTweetboxTweetError:"failure",uiTweetboxTweetSuccess:"send_tweet",uiTweetboxReplySuccess:"send_reply",uiTweetboxDMSuccess:"send_dm",uiOpenTweetDialog:"compose_tweet"},imagePicker:{uiImagePickerClick:"click",uiImagePickerAdd:"add",uiImagePickerRemove:"remove",uiImagePickerError:"error",uiDrop:"drag_and_drop"},geoPicker:{uiGeoPickerOffer:"offer",uiGeoPickerEnable:"enable",uiGeoPickerOpen:"open",uiGeoPickerTurnOn:"on",uiGeoPickerTurnOff:"off",uiGeoPickerChange:"select",uiGeoPickerInteraction:"focus_field"},lifelineAlerts:{uiLifelineAlertsSelect:"select",uiLifelineAlertsImpression:"impression",uiLifelineAlertsTweet:"tweet",uiLifelineAlertsCancel:"cancel"}};this.after("initialize",function(){Object.keys(a.tweetBox).forEach(function(b){this.scribeOnEvent(b,{element:"tweet_box",action:a.tweetBox[b]})},this),Object.keys(a.imagePicker).forEach(function(b){this.scribeOnEvent(b,{element:"image_picker",action:a.imagePicker[b]})},this),Object.keys(a.geoPicker).forEach(function(b){this.scribeOnEvent(b,{element:"geo_picker",action:a.geoPicker[b]})},this),Object.keys(a.lifelineAlerts).forEach(function(b){this.scribeOnEvent(b,{element:"lifeline_alerts",action:a.lifelineAlerts[b]})},this)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(tweetBoxScribe,withScribe)
});
define("app/boot/tweet_boxes",["module","require","exports","app/data/geo","app/data/tweet","app/ui/tweet_dialog","app/ui/new_tweet_button","app/data/tweet_box_scribe","app/ui/tweet_box_manager"],function(module, require, exports) {
function initialize(a){GeoData.attachTo(document,a),TweetData.attachTo(document,a),TweetDialog.attachTo("#global-tweet-dialog"),NewTweetButton.attachTo("#global-new-tweet-button",{eventData:{scribeContext:{component:"top_bar",element:"tweet_button"}}}),TweetBoxScribe.attachTo(document,a),TweetBoxManager.attachTo(document,a)}var GeoData=require("app/data/geo"),TweetData=require("app/data/tweet"),TweetDialog=require("app/ui/tweet_dialog"),NewTweetButton=require("app/ui/new_tweet_button"),TweetBoxScribe=require("app/data/tweet_box_scribe"),TweetBoxManager=require("app/ui/tweet_box_manager");module.exports=initialize
});
define("app/ui/user_dropdown",["module","require","exports","core/component","app/ui/with_dropdownmenu","app/utils/storage/core"],function(module, require, exports) {
function userDropdown(){this.defaultAttrs({feedbackLinkSelector:".feedback-callout-link"}),this.signout=function(){storage.clearAll(),this.$signoutForm.submit()},this.showKeyboardShortcutsDialog=function(a,b){this.trigger(document,"uiOpenKeyboardShortcutsDialog"),a.preventDefault()},this.showConversationNotification=function(a,b){this.unreadThreads=b.threads,this.$node.addClass(this.attr.glowClass),this.$dmCount.addClass(this.attr.glowClass).text(b.threads.length)},this.openFeedbackDialog=function(a,b){this.closeDropdown(),this.trigger("uiPrepareFeedbackDialog",{})},this.updateConversationNotication=function(a,b){var c=$.inArray(b.recipient,this.unreadThreads);if(c===-1)return;this.unreadThreads.splice(c,1);var d=parseInt(this.$dmCount.text(),10)-1;d?this.$dmCount.text(d):(this.$node.removeClass(this.attr.glowClass),this.$dmCount.removeClass(this.attr.glowClass).text(""))},this.after("initialize",function(){this.unreadThreads=[],this.$signoutForm=this.select("signoutForm"),this.on(this.attr.keyboardShortcuts,"click",this.showKeyboardShortcutsDialog),this.on(this.attr.feedbackLinkSelector,"click",this.openFeedbackDialog),this.$dmCount=this.select("dmCount"),this.on(this.attr.signout,"click",this.signout),this.on(document,"uiDMDialogOpenedConversation",this.updateConversationNotication),this.on(document,"uiDMDialogHasNewConversations",this.showConversationNotification),this.on(document,"click",this.close),this.on(document,"uiNavigate",this.close)})}var defineComponent=require("core/component"),withDropdownMenu=require("app/ui/with_dropdownmenu"),storage=require("app/utils/storage/core"),UserDropdown=defineComponent(userDropdown,withDropdownMenu);module.exports=UserDropdown
});
define("app/ui/signin_dropdown",["module","require","exports","core/component","app/ui/with_dropdown"],function(module, require, exports) {
function signinDropdown(){this.defaultAttrs({usernameSelector:".email-input",dialogContainerSelector:".signin-dialog-body"}),this.focusUsername=function(){this.applyARIADialogAttrs(),this.select("usernameSelector").focus()},this.applyARIADialogAttrs=function(){this.select("dropDownMenuSelector").attr({role:"dialog","aria-hidden":!1,"aria-labelledby":"signin-form-legend"})},this.toggleARIAHiddenRole=function(){this.select("dropDownMenuSelector").attr("aria-hidden",!0)},this.after("initialize",function(){this.on("uiDropdownOpened",this.focusUsername),this.on("uiDropdownClosed",this.toggleARIAHiddenRole)})}var defineComponent=require("core/component"),withDropdown=require("app/ui/with_dropdown"),SigninDropdown=defineComponent(signinDropdown,withDropdown);module.exports=SigninDropdown
});
define("app/utils/animate_window_scrolltop",["module","require","exports"],function(module, require, exports) {
function getScrollEl(){return $("body").hasClass("overlay-enabled")?$(".PermalinkOverlay"):scrollEl?scrollEl:([document.body,document.documentElement].forEach(function(a){var b=a.scrollTop,c=b>0?b-1:b+1;a.scrollTop=c,a.scrollTop==c&&(scrollEl=a.tagName.toLowerCase(),a.scrollTop=b)}),scrollEl)}var scrollEl;module.exports=function(a,b,c){$(getScrollEl()).animate({scrollTop:a},b,c)}
});
define("app/ui/global_nav",["module","require","exports","core/component","app/utils/full_path","app/utils/animate_window_scrolltop"],function(module, require, exports) {
function globalNav(){this.defaultAttrs({activeClass:"active",newClass:"new",newCountClass:"new-count",maxCountClass:"max",nav:"li",notificationsNav:"li.notifications",meNav:"li.profile",navLinkSelector:"li > a",linkSelector:"a",notificationsCountSelector:"li.people .count",notificationsCountInnerSelector:"li.people .count .count-inner",maxCountValue:99,dynamicTooltipSelector:".js-dynamic-tooltip"}),this.updateActive=function(a,b){b&&(this.select("nav").removeClass(this.attr.activeClass),this.select("nav").filter("[data-global-action="+b.section+"]").addClass(this.attr.activeClass),this.removeGlowFromActive())},this.isNotificationsActive=function(){return this.select("notificationsNav").hasClass(this.attr.activeClass)},this.updateNotificationsCount=function(a,b){b&&typeof b=="number"&&b>0&&!this.isNotificationsActive()?this.setNotificationsCount(b):this.clearBadgeAndNotificationsCount()},this.setNotificationsCount=function(a){var b=this.select("notificationsCountSelector"),c=this.select("notificationsCountInnerSelector"),d=a>this.attr.maxCountValue;d&&(a=this.attr.maxCountValue+"+"),b.toggleClass(this.attr.maxCountClass,d),c.text(a),b.addClass(this.attr.newCountClass)},this.clearBadgeAndNotificationsCount=function(){var a=this.select("notificationsCountSelector");a.removeClass(this.attr.newCountClass),a.removeClass(this.attr.maxCountClass)},this.addGlowToActive=function(){this.$node.find("."+this.attr.activeClass).addClass(this.attr.newClass)},this.addGlowToMe=function(){this.select("meNav").addClass(this.attr.newClass)},this.removeGlowFromActive=function(){this.$node.find("."+this.attr.activeClass).not(this.attr.meNav).removeClass(this.attr.newClass)},this.removeGlowFromMe=function(){this.select("meNav").removeClass(this.attr.newClass)},this.scrollToTopLink=function(a){var b=$(a.target).closest(this.attr.linkSelector);b.attr("href")==fullPath()&&(a.preventDefault(),b.blur(),this.scrollToTop())},this.topBarBirdClick=function(){this.scrollToTop({wasTopBarBirdClick:!0})},this.scrollToTop=function(a){animateWinScrollTop(0,"fast"),this.trigger(document,"uiGotoTopOfScreen",a||{})},this.addTooltip=function(a,b){var c=$(b.el),d=c.find(".text");d.width()==1&&!c.attr("data-original-title")&&(d.addClass("u-hiddenVisually"),c.attr({"data-original-title":d.text().trim()}))},this.removeTooltip=function(a,b){var c=$(b.el),d=c.find(".text");c.attr("data-original-title")&&(d.removeClass("u-hiddenVisually"),c.removeAttr("data-original-title"))},this.after("initialize",function(){this.on(document,"uiAddPageCount",this.addGlowToActive),this.on(document,"uiHasInjectedNewTimeline",this.removeGlowFromActive),this.on(document,"uiUpdateConnectBadge",this.updateNotificationsCount),this.on(document,"dataPageRefresh",this.updateActive),this.on(".bird-topbar-etched","click",this.topBarBirdClick),this.on("click",{navLinkSelector:this.scrollToTopLink}),this.on("mouseover focusin",{dynamicTooltipSelector:this.addTooltip}),this.on("mouseout focusout",{dynamicTooltipSelector:this.removeTooltip})})}var defineComponent=require("core/component"),fullPath=require("app/utils/full_path"),animateWinScrollTop=require("app/utils/animate_window_scrolltop"),GlobalNav=defineComponent(globalNav);module.exports=GlobalNav
});
define("app/ui/dm_envelope",["module","require","exports","core/component"],function(module, require, exports) {
function dmEnvelope(){this.defaultAttrs({directMessagesSelector:".global-dm-nav",msgCounterSelector:".dm-new .count-inner",newMsgClass:"new",singleCount:"with-count",doubleCount:"with-count-2",tripleCount:"with-count-3"}),this.addGlowToEnvelope=function(a,b){this.select("directMessagesSelector").addClass(this.attr.newMsgClass)},this.removeGlowFromEnvelope=function(a,b){this.select("directMessagesSelector").removeClass(this.attr.newMsgClass)},this.addCountToEnvelope=function(a,b){var c=parseInt(b.msgCount,10);if(isNaN(c))return;var d=[this.attr.singleCount];c>9&&d.push(this.attr.doubleCount),c>99&&d.push(this.attr.tripleCount),this.removeCountFromEnvelope(a,c),this.select("directMessagesSelector").addClass(d.join(" ")),this.select("directMessagesSelector").find(this.attr.msgCounterSelector).text(c)},this.removeCountFromEnvelope=function(a,b){this.select("directMessagesSelector").removeClass(this.attr.singleCount+" "+this.attr.doubleCount+" "+this.attr.tripleCount)},this.after("initialize",function(){this.on(document,"dataUserHasUnreadDMs dataUserHasUnreadDMsWithCount",this.addGlowToEnvelope),this.on(document,"dataUserHasNoUnreadDMs dataUserHasNoUnreadDMsWithCount",this.removeGlowFromEnvelope),this.on(document,"dataUserHasUnreadDMsWithCount",this.addCountToEnvelope),this.on(document,"dataUserHasNoUnreadDMsWithCount",this.removeCountFromEnvelope)})}var defineComponent=require("core/component"),DMEnvelope=defineComponent(dmEnvelope);module.exports=DMEnvelope
});
define("app/ui/search_input",["module","require","exports","core/component"],function(module, require, exports) {
function searchInput(){this.defaultAttrs({magnifyingGlassSelector:".js-search-action",inputFieldSelector:"#search-query",query:"",searchPathWithQuery:"/search?q=query&src=typd",focusClass:"focus"}),this.addFocusStyles=function(a){this.$node.addClass(this.attr.focusClass),this.$input.addClass(this.attr.focusClass),this.trigger("uiSearchInputFocused")},this.removeFocusStyles=function(a){this.$node.removeClass(this.attr.focusClass),this.$input.removeClass(this.attr.focusClass)},this.executeTypeaheadSelection=function(a,b){b.source!="account"&&this.$input.val(b.display);if(b.isClick)return;this.trigger("uiNavigate",{href:b.href})},this.submitQuery=function(a,b){this.trigger("uiSearchQuery",{query:b.query,source:"search"}),this.trigger("uiNavigate",{href:this.attr.searchPathWithQuery.replace("query",encodeURIComponent(b.query))})},this.searchFormSubmit=function(a,b){a.preventDefault(),this.trigger(this.$input,"uiTypeaheadInputSubmit")},this.after("initialize",function(){this.$input=this.select("inputFieldSelector"),this.$input.val(this.attr.query),this.on("uiTypeaheadItemSelected",this.executeTypeaheadSelection),this.on("uiTypeaheadSubmitQuery",this.submitQuery),this.on(this.$input,"focus",this.addFocusStyles),this.on(this.$input,"blur",this.removeFocusStyles),this.on("submit",this.searchFormSubmit),this.on(this.select("magnifyingGlassSelector"),"click",this.searchFormSubmit)})}var defineComponent=require("core/component");module.exports=defineComponent(searchInput)
});
define("app/data/search_input_scribe",["module","require","exports","core/component","app/data/with_scribe","app/utils/scribe_item_types"],function(module, require, exports) {
function searchInputScribe(){var a={account:function(a){var b={message:a.input,items:[{id:a.query,item_type:itemTypes.user,position:a.index}],format_version:2,event_info:a.item?a.item.origin:undefined};this.scribe("profile_click",a,b)},search:function(b){if(this.lastCompletion&&b.query===this.lastCompletion.query)a.topics.call(this,this.lastCompletion);else{var c={items:[{item_query:b.query,item_type:itemTypes.search}],format_version:2};this.scribe("search",b,c)}},topics:function(a){var b={message:a.input,items:[{item_query:a.query,item_type:itemTypes.search,position:a.index}],format_version:2};this.scribe("search",a,b)},account_search:function(a){this.scribe("people_search",a,{query:a.input})},saved_search:function(a){var b={message:a.input,items:[{item_query:a.query,item_type:itemTypes.savedSearch,position:a.index}],format_version:2};this.scribe({element:"saved_search",action:"search"},a,b)},recent_search:function(a){var b={message:a.input,items:[{item_query:a.query,item_type:itemTypes.search,position:a.index}],format_version:2};this.scribe({element:"recent_search",action:"search"},a,b)},concierge:function(a){var b={message:a.input,items:[{item_query:a.query,item_type:itemTypes.search,position:a.index}],format_version:2};this.scribe({element:"typeahead_concierge",action:"search"},a,b)}};this.storeCompletionData=function(a,b){a.type=="uiTypeaheadItemSelected"||a.type=="uiSearchQuery"?this.scribeSelection(a,b):b.fromSelectionEvent||(this.lastCompletion=b)},this.scribeSelection=function(b,c){a[c.source]&&a[c.source].call(this,c)},this.after("initialize",function(){this.scribeOnEvent("uiSearchInputFocused","focus_field"),this.on("uiTypeaheadItemComplete uiTypeaheadItemSelected uiSearchQuery",this.storeCompletionData)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),itemTypes=require("app/utils/scribe_item_types");module.exports=defineComponent(searchInputScribe,withScribe)
});
define("app/ui/login_form",["module","require","exports","core/component"],function(module, require, exports) {
function loginForm(){this.defaultAttrs({forgotPasswordLinkSelector:".forgot",accountIdentifierInputSelector:'[name="session[username_or_email]"]'}),this.navigateToPasswordReset=function(a){a.stopPropagation(),a.preventDefault();var b=this.$accountIdentifierInput.val(),c=b?"?account_identifier="+encodeURIComponent(b):"";this.trigger("uiNavigate",{href:this.forgotPasswordHref+c})},this.after("initialize",function(){this.$accountIdentifierInput=this.select("accountIdentifierInputSelector"),this.forgotPasswordHref=this.select("forgotPasswordLinkSelector").attr("href"),this.on("click",{forgotPasswordLinkSelector:this.navigateToPasswordReset})})}var defineComponent=require("core/component");module.exports=defineComponent(loginForm)
});
define("app/ui/track_ga_events",["module","require","exports","core/component"],function(module, require, exports) {
function trackGAEvent(){this.defaultAttrs({signinSelector:".signin-wrapper, .js-front-signin, .signin-dialog-body",incompleteNUXSelector:".StartPreviewLinks .js-skip-step"}),this.trackIncompleteNUX=function(){this.trigger("GATrackEvent",{gaEvent:"NUX-not-complete"})},this.trackExistingUserSignin=function(){this.trigger("GATrackEvent",{gaEvent:"existing-user-signin"})},this.after("initialize",function(){this.on("submit",{signinSelector:this.trackExistingUserSignin}),this.on("click",{incompleteNUXSelector:this.trackIncompleteNUX})})}var defineComponent=require("core/component"),TrackGAEvent=defineComponent(trackGAEvent);module.exports=TrackGAEvent
});
define("app/ui/macaw_nymizer_signin_conversion",["module","require","exports","core/component"],function(module, require, exports) {
function macawNymizerSigninConversion(){this.defaultAttrs({signinSelector:".signin-wrapper, .js-front-signin, .signin-dialog-body"}),this.signinConversion=function(){this.trigger("MNConversion",{mnType:"signin"})},this.after("initialize",function(){this.on("submit",{signinSelector:this.signinConversion})})}var defineComponent=require("core/component"),MacawNymizerSigninConversion=defineComponent(macawNymizerSigninConversion);module.exports=MacawNymizerSigninConversion
});
define("app/boot/top_bar",["module","require","exports","app/boot/tweet_boxes","app/ui/user_dropdown","app/ui/signin_dropdown","app/ui/global_nav","app/ui/dm_envelope","app/ui/navigation_links","app/ui/typeahead/typeahead_dropdown","app/ui/typeahead/typeahead_input","app/ui/search_input","app/data/search_input_scribe","app/ui/login_form","core/utils","app/ui/track_ga_events","app/ui/macaw_nymizer_signin_conversion"],function(module, require, exports) {
function initialize(a){GlobalNav.attachTo(".global-nav",{noTeardown:!0}),DMEnvelope.attachTo(".dm-nav",{noTeardown:!0}),SearchInput.attachTo("#global-nav-search",utils.merge(a,{eventData:{scribeContext:{component:"top_bar_searchbox",element:""}}})),SearchInputScribe.attachTo("#global-nav-search",{noTeardown:!0});var b=[["recentSearches",["recentSearches"]],["savedSearches",["savedSearches"]],["topics",["topics"]],["accounts",["accounts"]]];a.typeaheadData.accountsOnTop&&(b=[["recentSearches",["recentSearches"]],["savedSearches",["savedSearches"]],["accounts",["accounts"]],["topics",["topics"]]]),TypeaheadInput.attachTo("#global-nav-search"),TypeaheadDropdown.attachTo("#global-nav-search",{datasourceRenders:b,accountsShortcutShow:!0,autocompleteAccounts:!1,typeaheadSrc:"SEARCH_BOX",deciders:utils.merge(a.typeaheadData,{showSocialContext:a.typeaheadData.showSearchAccountSocialContext}),eventData:{scribeContext:{component:"top_bar_searchbox",element:"typeahead"}}}),a.loggedIn?(tweetBoxes(a),UserDropdown.attachTo("#user-dropdown",{noTeardown:!0,signout:"#signout-button",signoutForm:"#signout-form",keyboardShortcuts:".js-keyboard-shortcut-trigger",dmCount:".js-direct-message-count",glowClass:"new"})):(a.passwordResetAdvancedLoginForm&&LoginForm.attachTo(".signin-dialog-body"),SigninDropdown.attachTo(".js-session")),NavigationLinks.attachTo(".global-nav",{noTeardown:!0,eventData:{scribeContext:{component:"top_bar"}}}),GATrackEvent.attachTo(".signin-dialog-body"),MacawNymizerSigninConversion.attachTo(".signin-dialog-body")}var tweetBoxes=require("app/boot/tweet_boxes"),UserDropdown=require("app/ui/user_dropdown"),SigninDropdown=require("app/ui/signin_dropdown"),GlobalNav=require("app/ui/global_nav"),DMEnvelope=require("app/ui/dm_envelope"),NavigationLinks=require("app/ui/navigation_links"),TypeaheadDropdown=require("app/ui/typeahead/typeahead_dropdown"),TypeaheadInput=require("app/ui/typeahead/typeahead_input"),SearchInput=require("app/ui/search_input"),SearchInputScribe=require("app/data/search_input_scribe"),LoginForm=require("app/ui/login_form"),utils=require("core/utils"),GATrackEvent=require("app/ui/track_ga_events"),MacawNymizerSigninConversion=require("app/ui/macaw_nymizer_signin_conversion");module.exports=initialize
});
define("app/data/typeahead/with_cache",["module","require","exports"],function(module, require, exports) {
function WithCache(){this.defaultAttrs({cache_limit:10}),this.getCachedSuggestions=function(a){return this.cache[a]?this.cache[a].value:null},this.clearCache=function(){this.cache={NEWEST:null,OLDEST:null,COUNT:0,LIMIT:this.attr.cache_limit}},this.deleteCachedSuggestions=function(a){return this.cache[a]?(this.cache.COUNT>1&&(a==this.cache.NEWEST.query?(this.cache.NEWEST=this.cache.NEWEST.before,this.cache.NEWEST.after=null):a==this.cache.OLDEST.query?(this.cache.OLDEST=this.cache.OLDEST.after,this.cache.OLDEST.before=null):(this.cache[a].after.before=this.cache[a].before,this.cache[a].before.after=this.cache[a].after)),delete this.cache[a],this.cache.COUNT-=1,!0):!1},this.setCachedSuggestions=function(a,b){if(this.cache.LIMIT===0)return;this.deleteCachedSuggestions(a),this.cache.COUNT>=this.cache.LIMIT&&this.deleteCachedSuggestions(this.cache.OLDEST.query),this.cache.COUNT==0?(this.cache[a]={query:a,value:b,before:null,after:null},this.cache.NEWEST=this.cache[a],this.cache.OLDEST=this.cache[a]):(this.cache[a]={query:a,value:b,before:this.cache.NEWEST,after:null},this.cache.NEWEST.after=this.cache[a],this.cache.NEWEST=this.cache[a]),this.cache.COUNT+=1},this.aroundGetSuggestions=function(a,b,c){var d=c.id+":"+c.query,e=this.getCachedSuggestions(d);if(e){this.triggerSuggestionsEvent(c.id,c.query,e);return}a(b,c)},this.afterTriggerSuggestionsEvent=function(a,b,c,d){if(d)return;var e=a+":"+b;this.setCachedSuggestions(e,c)},this.after("triggerSuggestionsEvent",this.afterTriggerSuggestionsEvent),this.around("getSuggestions",this.aroundGetSuggestions),this.after("initialize",function(){this.clearCache(),this.on("uiTypeaheadDeleteRecentSearch",this.clearCache)})}module.exports=WithCache
});
define("app/data/with_datasource_helpers",["module","require","exports","app/data/user_info"],function(module, require, exports) {
function withDatasourceHelpers(){this.prefetch=function(a,b){var c={prefetch:!0,result_type:b,count:this.getPrefetchCount(),media_tagging_in_prefetch:this.shouldIncludeCanMediaTag(),experiments:!!this.attr.typeaheadExperiments&&this.attr.typeaheadExperiments.join(",")};c[b+"_cache_age"]=this.storage.getCacheAge(this.attr.storageHash,this.attr.ttl_ms),this.get({url:a,headers:{"X-Phx":!0},data:c,eventData:{},success:this.processResults.bind(this),error:this.useStaleData.bind(this)})},this.useStaleData=function(){this.extendTTL(),this.getDataFromLocalStorage()},this.extendTTL=function(){var a=this.getStorageKeys();for(var b=0;b<a.length;b++)this.storage.updateTTL(a[b],this.attr.ttl_ms)},this.loadData=function(a,b){var c=this.getStorageKeys().some(function(a){return this.storage.isExpired(a)},this);c||this.isMetadataExpired()?this.prefetch(a,b):this.getDataFromLocalStorage()},this.isIE8=function(){return $.browser.msie&&parseInt($.browser.version,10)===8},this.getProtocol=function(){return window.location.protocol},this.shouldIncludeCanMediaTag=function(){return userInfo.getDecider("enable_media_tag_prefetch")}}var userInfo=require("app/data/user_info");module.exports=withDatasourceHelpers
});
define("app/data/typeahead/accounts_datasource",["module","require","exports","app/utils/typeahead_helpers","app/utils/storage/custom","app/data/with_data","core/compose","core/utils","app/data/with_datasource_helpers"],function(module, require, exports) {
function accountsDatasource(a){this.attr={id:null,ttl_ms:1728e5,localStorageCount:1200,ie8LocalStorageCount:1e3,limit:6,version:4,localQueriesEnabled:!1,remoteQueriesEnabled:!1,onlyDMable:!1,onlyShowUsersWithCanMediaTag:!1,currentUserId:null,storageAdjacencyList:"userAdjacencyList",storageHash:"userHash",storageProtocol:"protocol",storageVersion:"userVersion",remotePath:"/i/search/typeahead.json",remoteType:"users",prefetchPath:"/i/search/typeahead.json",prefetchType:"users",storageBlackList:"userBlackList",maxLengthBlacklist:100,typeaheadExperiments:[]},this.attr=util.merge(this.attr,a),this.after=$.noop,this.defaultAttrs=$.noop,compose.mixin(this,[withData,withDatasourceHelpers]),this.getPrefetchCount=function(){return this.isIE8()&&this.attr.localStorageCount>this.attr.ie8LocalStorageCount?this.attr.ie8LocalStorageCount:this.attr.localStorageCount},this.isMetadataExpired=function(){var a=this.storage.getItem(this.attr.storageVersion),b=this.storage.getItem(this.attr.storageProtocol);return a==this.attr.version&&b==this.getProtocol()?!1:!0},this.getStorageKeys=function(){return[this.attr.storageVersion,this.attr.storageHash,this.attr.storageAdjacencyList,this.attr.storageProtocol]},this.getDataFromLocalStorage=function(){this.userHash=this.storage.getItem(this.attr.storageHash)||this.userHash,this.adjacencyList=this.storage.getItem(this.attr.storageAdjacencyList)||this.adjacencyList},this.processResults=function(a){if(!a||!a[this.attr.prefetchType]){this.useStaleData();return}a[this.attr.prefetchType].forEach(function(a){a.tokens=a.tokens.map(function(a){return typeof a=="string"?a:a.token}),a.prefetched=!0,this.userHash[a.id]=a,a.tokens.forEach(function(b){var c=helpers.getFirstChar(b);c.trim().length&&(this.adjacencyList[c]===undefined&&(this.adjacencyList[c]=[]),this.adjacencyList[c].indexOf(a.id)===-1&&this.adjacencyList[c].push(a.id))},this)},this),this.storage.setItem(this.attr.storageHash,this.userHash,this.attr.ttl_ms),this.storage.setItem(this.attr.storageAdjacencyList,this.adjacencyList,this.attr.ttl_ms),this.storage.setItem(this.attr.storageVersion,this.attr.version,this.attr.ttl_ms),this.storage.setItem(this.attr.storageProtocol,this.getProtocol(),this.attr.ttl_ms)},this.getLocalSuggestions=function(a){if(!this.attr.localQueriesEnabled)return[];var b=helpers.tokenizeText(a.query.replace("@","")),c=this.getPotentiallyMatchingIds(b),d=this.getAccountsFromIds(c),e=d.filter(this.matcher(b));return e.sort(this.sorter),e=e.slice(0,this.attr.limit),e},this.getPotentiallyMatchingIds=function(a){var b=[];return a.map(function(a){var c=this.adjacencyList[helpers.getFirstChar(a)];c&&(b=b.concat(c))},this),b=util.uniqueArray(b),b},this.getAccountsFromIds=function(a){var b=[];return a.forEach(function(a){var c=this.userHash[a];c&&b.push(c)},this),b},this.matcher=function(a){return function(b){var c=b.tokens,d=[];if(this.attr.onlyDMable&&!b.is_dm_able)return!1;if(!this.isEligibleForMediaTagSuggestion(b))return!1;var e=a.every(function(a){var b=c.filter(function(b){return b.indexOf(a)===0});return b.length});if(e)return b}.bind(this)},this.sorter=function(a,b){function e(a,b){var c=a.score_boost?a.score_boost:0,d=b.score_boost?b.score_boost:0,e=a.rounded_score?a.rounded_score:0,f=b.rounded_score?b.rounded_score:0;return f+d-(e+c)}var c=a.prefetched,d=b.prefetched;return c&&!d?-1:d&&!c?1:e(a,b)},this.processRemoteSuggestions=function(a,b,c){var d=c[this.attr.id]||[],e={};return d.forEach(function(a){e[a.id]=!0},this),this.requiresRemoteSuggestions(a.queryData)&&b[this.attr.remoteType]&&b[this.attr.remoteType].forEach(function(a){!e[a.id]&&(!this.attr.onlyDMable||a.is_dm_able)&&this.isEligibleForMediaTagSuggestion(a)&&d.push(a)},this),c[this.attr.id]=d.slice(0,this.attr.limit),c[this.attr.id].forEach(function(a){this.removeBlacklistSocialContext(a)},this),c},this.removeBlacklistSocialContext=function(a){a.first_connecting_user_id in this.socialContextBlackList&&(a.first_connecting_user_name=undefined,a.first_connecting_user_id=undefined)},this.requiresRemoteSuggestions=function(a){return!a||!a.query?!1:a.accountsWithoutAtSignLocalOnly?this.attr.remoteQueriesEnabled&&(helpers.getFirstChar(a.query)=="@"||a.atSignRemoved):this.attr.remoteQueriesEnabled},this.isEligibleForMediaTagSuggestion=function(a){return!this.attr.onlyShowUsersWithCanMediaTag||a.can_media_tag||a.id==this.attr.currentUserId},this.initialize=function(){var a=customStorage({withExpiry:!0});this.storage=new a("typeahead"),this.adjacencyList={},this.userHash={},this.attr.localQueriesEnabled&&this.loadData(this.attr.prefetchPath,this.attr.prefetchType),this.socialContextBlackList=this.storage.getItem(this.attr.storageBlackList)||{}},this.initialize()}var helpers=require("app/utils/typeahead_helpers"),customStorage=require("app/utils/storage/custom"),withData=require("app/data/with_data"),compose=require("core/compose"),util=require("core/utils"),withDatasourceHelpers=require("app/data/with_datasource_helpers");module.exports=accountsDatasource
});
define("app/data/typeahead/saved_searches_datasource",["module","require","exports","core/utils"],function(module, require, exports) {
function savedSearchesDatasource(a){this.attr={id:null,items:[],limit:0,searchPathWithQuery:"/search?src=savs&q=",querySource:"saved_search_click"},this.attr=util.merge(this.attr,a),this.getRemoteSuggestions=function(a,b,c){return c},this.requiresRemoteSuggestions=function(a){return!1},this.getLocalSuggestions=function(a){return!a||!a.query?this.attr.items:this.attr.items.filter(function(b){return b.name.indexOf(a.query)==0}).slice(0,this.attr.limit)},this.addSavedSearch=function(a){if(!a||!a.query)return;this.attr.items.push({id:a.id,id_str:a.id_str,name:a.name,query:a.query,saved_search_path:this.attr.searchPathWithQuery+encodeURIComponent(a.query),search_query_source:this.attr.querySource})},this.removeSavedSearch=function(a){if(!a||!a.query)return;var b=this.attr.items;for(var c=0;c<b.length;c++)if(b[c].query===a.query||b[c].name===a.query){b.splice(c,1);return}}}var util=require("core/utils");module.exports=savedSearchesDatasource
});
define("app/data/typeahead/recent_searches_datasource",["module","require","exports","core/utils","app/utils/storage/custom","app/data/with_datasource_helpers"],function(module, require, exports) {
function recentSearchesDatasource(a){this.attr={id:null,limit:4,storageList:"recentSearchesList",maxLength:100,ttl_ms:12096e5,searchPathWithQuery:"/search?src=typd&q=",querySource:"typed_query"},this.attr=util.merge(this.attr,a),this.getRemoteSuggestions=function(a,b,c){return c},this.requiresRemoteSuggestions=function(){return!1},this.removeAllRecentSearches=function(){this.items=[],this.updateStorage()},this.getLocalSuggestions=function(a){return!a||a.query===""?this.items.slice(0,this.attr.limit):this.items.filter(function(b){return b.name.indexOf(a.query)==0}).slice(0,this.attr.limit)},this.updateStorage=function(){this.storage.setItem(this.attr.storageList,this.items,this.attr.ttl_ms)},this.removeOneRecentSearch=function(a){this.removeRecentSearchFromList(a.query),this.updateStorage()},this.addRecentSearch=function(a){if(!a||!a.query)return;a.query=a.query.trim(),this.updateRecentSearchList(a),this.updateStorage()},this.updateRecentSearchList=function(a){var b=this.items,c={normalized_name:a.query.toLowerCase(),name:a.query,recent_search_path:this.attr.searchPathWithQuery+encodeURIComponent(a.query),search_query_source:this.attr.querySource};this.removeRecentSearchFromList(a.query),b.unshift(c),b.length>this.attr.maxLength&&b.pop()},this.removeRecentSearchFromList=function(a){var b=this.items,c=-1,d=a.toLowerCase();for(var e=0;e<b.length;e++)if(b[e].normalized_name===d){c=e;break}c!==-1&&b.splice(c,1)},this.initialize=function(){var a=customStorage({withExpiry:!0});this.storage=new a("typeahead"),this.items=this.storage.getItem(this.attr.storageList)||[]},this.initialize()}var util=require("core/utils"),customStorage=require("app/utils/storage/custom"),withDatasourceHelpers=require("app/data/with_datasource_helpers");module.exports=recentSearchesDatasource
});
define("app/data/typeahead/with_external_event_listeners",["module","require","exports","app/utils/typeahead_helpers"],function(module, require, exports) {
function WithExternalEventListeners(){this.defaultAttrs({weights:{CACHED_PROFILE_VISIT:10,UNCACHED_PROFILE_VISIT:75,FOLLOW:100}}),this.cleanupUserData=function(a){this.removeAccount(a),this.addToUserBlacklist(a)},this.onFollowStateChange=function(a,b){if(!b.userId)return;switch(b.newState){case"blocked":this.cleanupUserData(b.userId);break;case"not-following":this.cleanupUserData(b.userId);break;case"following":b.user&&(this.adjustScoreBoost(b.user,this.attr.weights.FOLLOW),this.addAccount(b.user,"following"),this.removeUserFromBlacklist(b.userId))}this.updateLocalStorage()},this.onProfileVisit=function(a,b){var c=this.datasources.accounts.userHash[b.id];c?this.adjustScoreBoost(c,this.attr.weights.CACHED_PROFILE_VISIT):(this.adjustScoreBoost(b,this.attr.weights.UNCACHED_PROFILE_VISIT),this.addAccount(b,"visit")),this.updateLocalStorage()},this.updateLocalStorage=function(){this.datasources.accounts.storage.setItem("userHash",this.datasources.accounts.userHash,this.datasources.accounts.attr.ttl),this.datasources.accounts.storage.setItem("adjacencyList",this.datasources.accounts.adjacencyList,this.datasources.accounts.attr.ttl),this.datasources.accounts.storage.setItem("version",this.datasources.accounts.attr.version,this.datasources.accounts.attr.ttl)},this.removeAccount=function(a){if(!this.datasources.accounts.userHash[a])return;var b=this.datasources.accounts.userHash[a].tokens;b.forEach(function(b){var c=this.datasources.accounts.adjacencyList[b.charAt(0)];if(!c)return;var d=c.indexOf(a);if(d===-1)return;c.splice(d,1)},this),delete this.datasources.accounts.userHash[a]},this.adjustScoreBoost=function(a,b){a.score_boost?a.score_boost+=b:a.score_boost=b},this.addAccount=function(a,b){this.datasources.accounts.userHash[a.id]=a,a.tokens=["@"+a.screen_name,a.screen_name].concat(helpers.tokenizeText(a.name)),a.social_proof=b==="following"?1:0,a.tokens.forEach(function(b){var c=b.charAt(0);if(!b.trim().length)return;if(!this.datasources.accounts.adjacencyList[c]){this.datasources.accounts.adjacencyList[c]=[a.id];return}this.datasources.accounts.adjacencyList[c].indexOf(a.id)===-1&&this.datasources.accounts.adjacencyList[c].push(a.id)},this)},this.removeOldAccountsInBlackList=function(){var a,b,c=0,d=this.datasources.accounts.attr.maxLengthBlacklist||100,e=this.datasources.accounts.socialContextBlackList,f=(new Date).getTime(),g=this.datasources.accounts.attr.ttl_ms;for(b in e){var h=e[b]+g;h<f?delete e[b]:(a=a||b,a=e[a]>e[b]?b:a,c+=1)}d<c&&delete e[a]},this.updateBlacklistLocalStorage=function(a){this.datasources.accounts.storage.setItem("userBlackList",a,this.attr.ttl)},this.addToUserBlacklist=function(a){var b=this.datasources.accounts.socialContextBlackList;b[a]=(new Date).getTime(),this.removeOldAccountsInBlackList(),this.updateBlacklistLocalStorage(b)},this.removeUserFromBlacklist=function(a){var b=this.datasources.accounts.socialContextBlackList;this.removeOldAccountsInBlackList(),b[a]&&(delete b[a],this.updateBlacklistLocalStorage(b))},this.checkItemTypeForRecentSearch=function(a){return a==="saved_search"||a==="topics"||a==="recent_search"?!0:!1},this.addSavedSearch=function(a,b){this.datasources.savedSearches.addSavedSearch(b)},this.removeSavedSearch=function(a,b){this.datasources.savedSearches.removeSavedSearch(b)},this.addRecentSearch=function(a,b){b.source==="search"?this.datasources.recentSearches.addRecentSearch({query:b.query}):this.checkItemTypeForRecentSearch(b.source)&&b.isSearchInput&&this.datasources.recentSearches.addRecentSearch({query:b.query})},this.removeRecentSearch=function(a,b){b.deleteAll?this.datasources.recentSearches.removeAllRecentSearches():this.datasources.recentSearches.removeOneRecentSearch(b),$(a.target).trigger("dataTypeaheadRecentSearchDeleted")},this.updateSelectedUsers=function(a,b){this.datasources.selectedUsers.updateSelectedUsers(b)},this.setTrendLocations=function(a,b){this.datasources.trendLocations.setTrendLocations(b)},this.updatePrefill=function(a,b){this.datasources.prefillUsers.updateRecentlySelectedUsers(b)},this.setupEventListeners=function(a){switch(a){case"accounts":this.on("dataFollowStateChange",this.onFollowStateChange),this.on("profileVisit",this.onProfileVisit);break;case"savedSearches":this.on(document,"dataAddedSavedSearch",this.addSavedSearch),this.on(document,"dataRemovedSavedSearch",this.removeSavedSearch);break;case"recentSearches":this.on("uiSearchQuery uiTypeaheadItemSelected",this.addRecentSearch),this.on("uiTypeaheadDeleteRecentSearch",this.removeRecentSearch);break;case"trendLocations":this.on(document,"dataLoadedTrendLocations",this.setTrendLocations);break;case"selectedUsers":this.on("uiUpdatedSelectedUsers",this.updateSelectedUsers);break;case"prefillUsers":this.on("uiUpdateRecentTags",this.updatePrefill)}}}var helpers=require("app/utils/typeahead_helpers");module.exports=WithExternalEventListeners
});
define("app/data/typeahead/topics_datasource",["module","require","exports","app/utils/typeahead_helpers","app/utils/storage/custom","app/data/with_data","core/compose","core/utils","app/data/with_datasource_helpers","core/i18n"],function(module, require, exports) {
function topicsDatasource(a){this.attr={id:null,ttl_ms:216e5,limit:4,version:4,storageAdjacencyList:"topicsAdjacencyList",storageHash:"topicsHash",storageVersion:"topicsVersion",prefetchLimit:500,localQueriesEnabled:!1,remoteQueriesEnabled:!1,remotePath:"/i/search/typeahead.json",remoteType:"topics",prefetchPath:"/i/search/typeahead.json",prefetchType:"topics",basePath:"/search?",modePathMap:{images:"mode=photos",videos:"mode=videos",news:"mode=news",users:"mode=users"},querySourcePathTypeahead:"src=tyah"},this.attr=util.merge(this.attr,a),this.after=$.noop,this.defaultAttrs=$.noop,compose.mixin(this,[withData,withDatasourceHelpers]),this.getStorageKeys=function(){return[this.attr.storageVersion,this.attr.storageHash,this.attr.storageAdjacencyList]},this.getPrefetchCount=function(){return this.attr.prefetchLimit},this.isMetadataExpired=function(){var a=this.storage.getItem(this.attr.storageVersion);return a!==this.attr.version},this.getDataFromLocalStorage=function(){this.topicsHash=this.storage.getItem(this.attr.storageHash)||this.topicsHash,this.adjacencyList=this.storage.getItem(this.attr.storageAdjacencyList)||this.adjacencyList},this.processResults=function(a){if(!a||!a[this.attr.prefetchType]){this.useStaleData();return}a[this.attr.prefetchType].forEach(function(a){var b=a.topic;a.searchPath=this.constructSearchPath(b,null),this.topicsHash[b]=a,a.tokens.forEach(function(a){var c=helpers.getFirstChar(a.token);this.adjacencyList[c]===undefined&&(this.adjacencyList[c]=[]),this.adjacencyList[c].indexOf(b)===-1&&this.adjacencyList[c].push(b)},this)},this),this.storage.setItem(this.attr.storageHash,this.topicsHash,this.attr.ttl_ms),this.storage.setItem(this.attr.storageAdjacencyList,this.adjacencyList,this.attr.ttl_ms),this.storage.setItem(this.attr.storageVersion,this.attr.version,this.attr.ttl_ms)},this.getLocalSuggestions=function(a){if(!this.attr.localQueriesEnabled)return[];var b=a.query.toLowerCase(),c=helpers.getFirstChar(b);if(this.attr.remoteType=="hashtags"&&HASHTAG_CHARS.indexOf(c)===-1)return[];var d=this.adjacencyList[c]||[];d=this.getTopicObjectsFromStrings(d);var e=d.filter(function(a){return a.topic.toLowerCase().indexOf(b)===0},this);return e.sort(function(a,b){return b.rounded_score-a.rounded_score}.bind(this)),e=e.slice(0,this.attr.limit),e},this.getTopicObjectsFromStrings=function(a){var b=[];return a.forEach(function(a){var c=this.topicsHash[a];c&&b.push(c)},this),b},this.requiresRemoteSuggestions=function(a){var b=helpers.getFirstChar(a.query),c=a.topicsMustStartWithHashtag&&HASHTAG_CHARS.indexOf(b)===-1;return!a||!a.query||c?!1:this.attr.remoteQueriesEnabled},this.processRemoteSuggestions=function(a,b,c){var d=c[this.attr.id]||[],e={};return d.forEach(function(a){var b=a.topic||a.hashtag;e[b.toLowerCase()]=!0},this),b[this.attr.remoteType]&&b[this.attr.remoteType].forEach(function(a){var b=a.topic||a.hashtag,c=a.filter;c&&(a.name=this.constructName(b,c)),a.searchPath=this.constructSearchPath(b,c),e[b.toLowerCase()]||d.push(a)},this),c[this.attr.id]=d.slice(0,this.attr.limit),c},this.constructName=function(a,b){var c={images:_('<strong>{{topic}}</strong>\u306e\u753b\u50cf',{topic:a}),videos:_('<strong>{{topic}}</strong>\u306e\u52d5\u753b',{topic:a}),news:_('<strong>{{topic}}</strong>\u306b\u3064\u3044\u3066\u306e\u30cb\u30e5\u30fc\u30b9',{topic:a}),users:_('<strong>{{topic}}</strong>\u306b\u95a2\u9023\u3059\u308b\u30e6\u30fc\u30b6\u30fc',{topic:a})};return c[b]},this.constructSearchPath=function(a,b){var c=["q="+encodeURIComponent(a)],d=b?this.attr.modePathMap[b]:"";return d&&c.push(d),c.push(this.attr.querySourcePathTypeahead),this.attr.basePath+c.join("&")},this.initialize=function(){var a=customStorage({withExpiry:!0});this.storage=new a("typeahead"),this.topicsHash={},this.adjacencyList={},this.attr.localQueriesEnabled&&this.loadData(this.attr.prefetchPath,this.attr.prefetchType)},this.initialize()}var helpers=require("app/utils/typeahead_helpers"),customStorage=require("app/utils/storage/custom"),withData=require("app/data/with_data"),compose=require("core/compose"),util=require("core/utils"),withDatasourceHelpers=require("app/data/with_datasource_helpers"),_=require("core/i18n"),HASHTAG_CHARS=["$","#","＃"];module.exports=topicsDatasource
});
define("app/data/typeahead/trend_locations_datasource",["module","require","exports","core/utils","core/i18n"],function(module, require, exports) {
function trendLocationsDatasource(a){var b={woeid:-1,placeTypeCode:-1,name:_('\u691c\u7d22\u7d50\u679c\u304c\u898b\u3064\u304b\u308a\u307e\u305b\u3093\u3067\u3057\u305f\u3002\u30ea\u30b9\u30c8\u304b\u3089\u9078\u629e\u3057\u3066\u304f\u3060\u3055\u3044\u3002')};this.attr={id:null,items:[],limit:10},this.attr=util.merge(this.attr,a),this.getRemoteSuggestions=function(a,b,c){return c},this.requiresRemoteSuggestions=function(a){return!1},this.getLocalSuggestions=function(a){var c=this.attr.items,d=function(a){return a.replace(/\s+/g,"").toLowerCase()};if(a&&a.query){var e=d(a.query);c=this.attr.items.filter(function(a){return d(a.name).indexOf(e)==0})}return c.length?c.slice(0,this.attr.limit):[b]},this.setTrendLocations=function(a){this.attr.items=a.trendLocations}}var util=require("core/utils"),_=require("core/i18n");module.exports=trendLocationsDatasource
});
define("app/data/typeahead/concierge_datasource",["module","require","exports","core/compose","core/utils","core/i18n","app/utils/storage/custom","app/data/with_data","app/data/with_datasource_helpers"],function(module, require, exports) {
function conciergeDatasource(a){this.attr={id:null,ttl_ms:216e5,limit:3,version:1,storageList:"conciergeList",storageVersion:"conciergeVersion",prefetchLimit:3,localQueriesEnabled:!1,remoteQueriesEnabled:!1,prefetchPath:"/i/search/typeahead.json",prefetchType:"oneclick",remotePath:"/i/search/typeahead.json",remoteType:"oneclick",basePath:"/search?",scribeMap:{images:"photos",videos:"video",news:"news",users:"people"},nameMap:{"images near":_('\u8fd1\u304f\u306e\u5199\u771f'),"images follow":_('\u30d5\u30a9\u30ed\u30fc\u3057\u3066\u3044\u308b\u30e6\u30fc\u30b6\u30fc\u306e\u5199\u771f'),"videos near":_('\u8fd1\u304f\u306e\u52d5\u753b'),"videos follow":_('\u30d5\u30a9\u30ed\u30fc\u3057\u3066\u3044\u308b\u30e6\u30fc\u30b6\u30fc\u306e\u52d5\u753b'),"news near":_('\u8fd1\u304f\u306e\u30cb\u30e5\u30fc\u30b9'),"news follow":_('\u30d5\u30a9\u30ed\u30fc\u3057\u3066\u3044\u308b\u30e6\u30fc\u30b6\u30fc\u304c\u5171\u6709\u3057\u305f\u30cb\u30e5\u30fc\u30b9'),"users near":_('\u8fd1\u304f\u306e\u30e6\u30fc\u30b6\u30fc')},modePathMap:{images:"mode=photos",videos:"mode=videos",news:"mode=news",users:"mode=users"},locationFilterPath:"near=me",followFilterPath:"f=follows",querySourcePath:"src=taoc",querySource:"typeahead_oneclick",typeaheadExperiments:[]},this.attr=util.merge(this.attr,a),this.after=$.noop,this.defaultAttrs=$.noop,compose.mixin(this,[withData,withDatasourceHelpers]),this.getStorageKeys=function(){return[this.attr.storageVersion,this.attr.storageList]},this.getPrefetchCount=function(){return this.attr.prefetchLimit},this.isMetadataExpired=function(){var a=this.storage.getItem(this.attr.storageVersion);return a!==this.attr.version},this.getDataFromLocalStorage=function(){this.conciergeList=this.storage.getItem(this.attr.storageList)||this.conciergeList},this.processResults=function(a){if(!a||!a[this.attr.prefetchType]){this.useStaleData();return}a[this.attr.prefetchType].forEach(function(a){var b=this.constructConciergeSuggestion(a);b&&this.conciergeList.push(b)},this),this.storage.setItem(this.attr.storageList,this.conciergeList,this.attr.ttl_ms),this.storage.setItem(this.attr.storageVersion,this.attr.version,this.attr.ttl_ms)},this.getLocalSuggestions=function(a){return!a||a.query===""?this.conciergeList.slice(0,this.attr.limit):[]},this.requiresRemoteSuggestions=function(a){return a&&a.query===""?this.attr.remoteQueriesEnabled:!1},this.processRemoteSuggestions=function(a,b,c){var d=c[this.attr.id]||[];if(b[this.attr.remoteType]){var e=b[this.attr.remoteType];for(var f=0;f<e.length;f++){var g=this.constructConciergeSuggestion(e[f]);if(g){var h=d.push(g);if(h>=this.attr.limit)break}}}return c[this.attr.id]=d.slice(0,this.attr.limit),c},this.constructConciergeSuggestion=function(a){var b=a.filter,c=!!a.location,d=!!a.follow,e=a.topic,f=this.constructName(b,c,d,e);return f?{topic:e,searchPath:this.constructSearchPath(b,c,d,e),name:f,querySource:this.attr.querySource,searchDetails:this.constructScribeDetails(b,c,d,e)}:null},this.constructName=function(a,b,c,d){var e=b?" near":"",f=c?" follow":"",g=d||this.attr.nameMap[a+e+f];return g},this.constructSearchPath=function(a,b,c,d){var e=[this.attr.querySourcePath],f=a?this.attr.modePathMap[a]:"";return f&&e.push(f),b&&e.push(this.attr.locationFilterPath),c&&e.push(this.attr.followFilterPath),d&&e.push("q="+encodeURIComponent(d)),this.attr.basePath+e.join("&")},this.constructScribeDetails=function(a,b,c,d){var e={result_type:this.attr.scribeMap[a]||"everything",social_filter:c?"following":"all"};return d&&(e.query=d),b&&(e.near="me"),e},this.initialize=function(){var a=customStorage({withExpiry:!0});this.storage=new a("typeahead"),this.conciergeList=[],this.attr.localQueriesEnabled&&this.loadData(this.attr.prefetchPath,this.attr.prefetchType)},this.initialize()}var compose=require("core/compose"),util=require("core/utils"),_=require("core/i18n"),customStorage=require("app/utils/storage/custom"),withData=require("app/data/with_data"),withDatasourceHelpers=require("app/data/with_datasource_helpers");module.exports=conciergeDatasource
});
define("app/data/typeahead/selected_users_datasource",["module","require","exports","core/utils"],function(module, require, exports) {
function selectedUsersDatasource(a){this.attr={id:null,maxLength:100,querySource:"typed_query",items:[]},this.attr=util.merge(this.attr,a),this.getRemoteSuggestions=function(a,b,c){return c},this.requiresRemoteSuggestions=function(){return!1},this.removeAllSelectedUsers=function(){this.attr.items=[]},this.getLocalSuggestions=function(a){return this.attr.items.slice(0,this.attr.maxLength)},this.updateSelectedUsers=function(a){this.attr.items=a.items}}var util=require("core/utils");module.exports=selectedUsersDatasource
});
define("app/data/typeahead/prefill_users_datasource",["module","require","exports","core/utils","app/utils/storage/custom","app/data/with_datasource_helpers"],function(module, require, exports) {
function prefillUsersDatasource(a){this.attr={id:null,maxLength:10,querySource:"typed_query",customItems:[],ttl_ms:12096e5,storageList:"recentlySelectedList"},this.attr=util.merge(this.attr,a),this.getRemoteSuggestions=function(a,b,c){return c},this.requiresRemoteSuggestions=function(){return!1},this.updateStorage=function(){this.storage.setItem(this.attr.storageList,this.storageItems,this.attr.ttl_ms)},this.updateRecentlySelectedUsers=function(a){var b=this.storageItems;a.items.forEach(function(a){this.removeRecentUserFromList(a),b.unshift(a),b.length>this.attr.maxLength&&(this.storageItems=b.slice(0,this.attr.maxLength))},this),this.updateStorage()},this.removeRecentUserFromList=function(a){var b=this.storageItems,c=this.getSuggestionIndexById(a,b);c!=-1&&b.splice(c,1)},this.getSuggestionIndexById=function(a,b){for(var c=0;c<b.length;c++)if(b[c].id==a.id)return c;return-1},this.getLocalSuggestions=function(a){var b=this.storageItems.slice(0,this.attr.maxLength);for(var c=0;b.length<this.attr.maxLength&&c<this.attr.customItems.length;c++){var d=this.attr.customItems[c];this.getSuggestionIndexById(b,d)==-1&&b.push(d)}return b},this.updateCustomItems=function(a){this.attr.customItems=a.items},this.initialize=function(){var a=customStorage({withExpiry:!0});this.storage=new a("typeahead"),this.storageItems=this.storage.getItem(this.attr.storageList)||[]},this.initialize()}var util=require("core/utils"),customStorage=require("app/utils/storage/custom"),withDatasourceHelpers=require("app/data/with_datasource_helpers");module.exports=prefillUsersDatasource
});
define("app/data/typeahead/typeahead",["module","require","exports","core/component","core/utils","app/data/with_data","app/data/typeahead/with_cache","app/data/typeahead/accounts_datasource","app/data/typeahead/saved_searches_datasource","app/data/typeahead/recent_searches_datasource","app/data/typeahead/with_external_event_listeners","app/data/typeahead/topics_datasource","app/data/typeahead/trend_locations_datasource","app/data/typeahead/concierge_datasource","app/data/typeahead/selected_users_datasource","app/data/typeahead/prefill_users_datasource"],function(module, require, exports) {
function typeahead(){this.defaultAttrs({limit:10,remoteDebounceInterval:300,remoteThrottleInterval:300,outstandingRemoteRequestCount:0,queuedRequestData:!1,outstandingRemoteRequestMax:6,useThrottle:!1,tweetContextEnabled:!1,topicsWithFiltersEnabled:!1,typeaheadExperiments:[]}),this.triggerSuggestionsEvent=function(a,b,c){this.trigger("dataTypeaheadSuggestionsResults",{suggestions:c,queryData:b,id:a})},this.hasAnySuggestions=function(a,b){return b.some(function(b){return a[b]&&a[b].length})},this.needsRemoteRequest=function(a,b){return b.some(function(b){return this.datasources[b]&&this.datasources[b].requiresRemoteSuggestions&&this.datasources[b].requiresRemoteSuggestions(a)},this)},this.getLocalSuggestions=function(a,b){var c={};return b.forEach(function(b){if(!this.datasources[b])return;var d=this.datasources[b].getLocalSuggestions(a);d.length&&(d.forEach(function(a){a.origin="prefetched"}),c[b]=d)},this),c},this.processRemoteSuggestions=function(a){this.adjustRequestCount(-1);var b=a.sourceEventData,c=b.suggestions||{};b.datasources.forEach(function(d){var e=d.processRemoteSuggestions(b,a,c);if(e[d.attr.id]&&e[d.attr.id].length){for(var f in e)e[f].forEach(function(a){a.origin=a.origin||"remote"});b.suggestions[d.attr.id]=e[d.attr.id]}},this),this.processSuggestionsByDataset(c),this.triggerSuggestionsEvent(b.id,b.queryData,c),this.makeQueuedRemoteRequestIfPossible()},this.getRemoteSuggestions=function(a,b,c,d){if(!b||!this.needsRemoteRequest(b,d))return;this.request[a]||(this.attr.useThrottle?this.request[a]=utils.throttle(this.splitRemoteRequests.bind(this),this.attr.remoteThrottleInterval):this.request[a]=utils.debounce(this.splitRemoteRequests.bind(this),this.attr.remoteDebounceInterval)),b.query.indexOf("@")===0&&(b.query=b.query.substring(1),b.atSignRemoved=!0),this.request[a](a,b,c,d)},this.makeQueuedRemoteRequestIfPossible=function(){if(this.attr.outstandingRemoteRequestCount===this.attr.outstandingRemoteRequestMax-1&&this.attr.queuedRequestData){var a=this.attr.queuedRequestData;this.getRemoteSuggestions(a.id,a.queryData,a.suggestions,a.datasources),this.attr.queuedRequestData=!1}},this.adjustRequestCount=function(a){this.attr.outstandingRemoteRequestCount+=a},this.canMakeRemoteRequest=function(a){return this.attr.outstandingRemoteRequestCount<this.attr.outstandingRemoteRequestMax?!0:(this.attr.queuedRequestData=a,!1)},this.processRemoteRequestError=function(){this.adjustRequestCount(-1),this.makeQueuedRemoteRequestIfPossible()},this.splitRemoteRequests=function(a,b,c,d){var e={};d.forEach(function(a){if(this[a]&&this[a].requiresRemoteSuggestions&&this[a].requiresRemoteSuggestions(b)){var c=this[a];e[c.attr.remotePath]?e[c.attr.remotePath].push(c):e[c.attr.remotePath]=[c]}},this.datasources);for(var f in e){this.executeRemoteRequest(a,b,c,e[f]);break}},this.executeRemoteRequest=function(a,b,c,d){var e={id:a,queryData:b,suggestions:c,datasources:d};if(!this.canMakeRemoteRequest(e))return;if(!this.attr.tweetContextEnabled||b.tweetContext&&b.tweetContext.length>1e3)b.tweetContext=undefined;this.adjustRequestCount(1),this.get({url:d[0].attr.remotePath,headers:{"X-Phx":!0},data:{q:b.query,tweet_context:b.tweetContext,count:this.attr.limit,result_type:d.map(function(a){return a.attr.remoteType}).join(","),filters:this.attr.topicsWithFiltersEnabled,src:b.typeaheadSrc,experiments:this.attr.typeaheadExperiments.join(",")},eventData:e,success:this.processRemoteSuggestions.bind(this),error:this.processRemoteRequestError.bind(this)})},this.truncateTopicsWithRecentSearches=function(a){if(!a.topics||!a.recentSearches)return;var b=a.recentSearches.length,c=4-b;a.topics=a.topics.slice(0,c)},this.dedupSuggestions=function(a,b,c){function e(){return b.some(function(a){return a in c})}function f(a){var b=a.topic||a.name;return!d[b.toLowerCase()]}if(!c[a]||!e())return;var d={};c[a].forEach(function(a){var b=a.name||a.topic;d[b.toLowerCase()]=!0}),b.forEach(function(a){a in c&&(c[a]=c[a].filter(f))})},this.processSuggestionsByDataset=function(a){this.dedupSuggestions("recentSearches",["topics"],a),this.truncateTopicsWithRecentSearches(a)},this.getSuggestions=function(a,b){if(typeof b=="undefined")throw"No parameters specified";if(!b.datasources)throw"No datasources specified";if(typeof b.queryData=="undefined")throw"No query data specified";if(typeof b.queryData.query=="undefined")throw"No query specified";if(!b.id)throw"No id specified";var c=this.getLocalSuggestions(b.queryData,b.datasources);this.processSuggestionsByDataset(c);var d=b.queryData.query!=="@"&&this.needsRemoteRequest(b.queryData,b.datasources);(this.hasAnySuggestions(c,b.datasources)||!d)&&this.triggerSuggestionsEvent(b.id,b.queryData,c),d&&this.getRemoteSuggestions(b.id,b.queryData,c,b.datasources)},this.addDatasource=function(a,b,c){var d=c[b]||{};if(!d.enabled)return;globalDataSources.hasOwnProperty(b)?this.datasources[b]=globalDataSources[b]:globalDataSources[b]=this.datasources[b]=new a(utils.merge(d,{id:b})),this.setupEventListeners(b)},this.after("initialize",function(a,b){this.datasources={},this.request={},this.addDatasource(accountsDatasource,"accounts",b),this.addDatasource(accountsDatasource,"dmAccounts",b),this.addDatasource(accountsDatasource,"mediaTagAccounts",b),this.addDatasource(savedSearchesDatasource,"savedSearches",b),this.addDatasource(recentSearchesDatasource,"recentSearches",b),this.addDatasource(topicsDatasource,"topics",b),this.addDatasource(topicsDatasource,"hashtags",utils.merge(b,{hashtags:{remoteType:"hashtags"}},!0)),this.addDatasource(trendLocationsDatasource,"trendLocations",b),this.addDatasource(conciergeDatasource,"concierge",b),this.addDatasource(selectedUsersDatasource,"selectedUsers",b),this.addDatasource(prefillUsersDatasource,"prefillUsers",b),this.on("uiNeedsTypeaheadSuggestions",this.getSuggestions)})}var defineComponent=require("core/component"),utils=require("core/utils"),withData=require("app/data/with_data"),withCache=require("app/data/typeahead/with_cache"),accountsDatasource=require("app/data/typeahead/accounts_datasource"),savedSearchesDatasource=require("app/data/typeahead/saved_searches_datasource"),recentSearchesDatasource=require("app/data/typeahead/recent_searches_datasource"),withExternalEventListeners=require("app/data/typeahead/with_external_event_listeners"),topicsDatasource=require("app/data/typeahead/topics_datasource"),trendLocationsDatasource=require("app/data/typeahead/trend_locations_datasource"),conciergeDatasource=require("app/data/typeahead/concierge_datasource"),selectedUsersDatasource=require("app/data/typeahead/selected_users_datasource"),prefillUsersDatasource=require("app/data/typeahead/prefill_users_datasource");module.exports=defineComponent(typeahead,withData,withCache,withExternalEventListeners);var globalDataSources={}
});
define("app/data/typeahead/typeahead_scribe",["module","require","exports","core/component","app/data/with_scribe","lib/twitter-text","app/utils/scribe_item_types"],function(module, require, exports) {
function typeaheadScribe(){this.defaultAttrs({tweetboxSelector:".tweet-box-shadow"}),this.storeCompletionData=function(a,b){if(b.scribeContext&&b.scribeContext.component=="tweet_box"){var c=b.source=="account"?"@"+b.display:b.display;this.completions.push(c)}},this.handleTweetCompletion=function(a,b){if(b.scribeContext.component!="tweet_box")return;var c=$(a.target).find(this.attr.tweetboxSelector).val(),d=twitterText.extractEntitiesWithIndices(c).filter(function(a){return a.screenName||a.cashtag||a.hashtag});d=d.map(function(a){return c.slice(a.indices[0],a.indices[1])});var e=d.filter(function(a){return this.completions.indexOf(a)>=0},this);this.completions=[];if(d.length==0)return;var f={query:b.query,message:d.length,event_info:e.length,format_version:2};this.scribe("entities",b,f)},this.scribeSelection=function(a,b){if(b.fromSelectionEvent&&a.type=="uiTypeaheadItemComplete")return;var c={element:"typeahead_"+b.source,action:"select"},d;a.type=="uiTypeaheadItemComplete"?d="autocomplete":b.isClick?d="click":a.type=="uiTypeaheadItemSelected"&&(d="key_select");var e={position:b.index,description:d};b.source=="account"?(e.item_type=itemTypes.user,e.id=b.query):b.source=="topics"?(e.item_type=itemTypes.search,e.item_query=b.query):b.source=="saved_search"?(e.item_type=itemTypes.savedSearch,e.item_query=b.query):b.source=="recent_search"?(e.item_type=itemTypes.search,e.item_query=b.query):b.source=="trend_location"?(e.item_type=itemTypes.trend,e.item_query=b.item.woeid,b.item.woeid==-1&&(c.action="no_results")):b.source=="concierge"&&(e.item_type=itemTypes.search,e.item_query=b.query||b.item.name);var f={message:b.input,items:[e],format_version:2,event_info:b.item?b.item.origin:null,search_details:b.item?b.item.searchDetails:null};this.scribe(c,b,f)},this.after("initialize",function(){this.completions=[],this.on("uiTypeaheadItemComplete uiTypeaheadItemSelected",this.storeCompletionData),this.on("uiTypeaheadItemComplete uiTypeaheadItemSelected",this.scribeSelection),this.on("uiTweetboxTweetSuccess uiTweetboxReplySuccess",this.handleTweetCompletion)})}var defineComponent=require("core/component"),withScribe=require("app/data/with_scribe"),twitterText=require("lib/twitter-text"),itemTypes=require("app/utils/scribe_item_types");module.exports=defineComponent(typeaheadScribe,withScribe)
});
define("app/ui/tweet_actions",["module","require","exports","core/component","app/utils/find_tweet","app/utils/tweet_helper","app/ui/with_tweet_actions_helper","app/ui/with_interaction_data"],function(module, require, exports) {
function tweetActions(){this.defaultAttrs({favoriteSelector:".js-toggle-fav a",replySelector:".js-action-reply",shareViaEmailSelector:".js-action-share-via-email",retweetSelector:".js-toggle-rt a:not([aria-disabled=true])",deleteSelector:".js-action-del",permalinkSelector:".tweet .js-permalink",tweetItemSelector:".tweet",retweetInlineSelector:".js-actionInlineRetweet",togglableTweetActionsSelector:"a:visible",toggleContainerSelector:".js-toggle-state",anyLoggedInActionSelector:".js-action-reply, .js-toggle-rt a:not([aria-disabled=true]), .js-toggle-fav a",favoritedTweetClass:"favorited",retweetedTweetClass:"retweeted"}),this.handleTransition=function(a,b){return function(c,d){var e=d.id||d.sourceEventData.id,f=findTweet(this.$node,this.attr.tweetItemSelector,e),g=f[0],h=document.activeElement,i;g&&$.contains(g,h)&&(i=$(h).closest(this.attr.toggleContainerSelector)),f[a](b),i&&i.find(this.attr.togglableTweetActionsSelector).focus()}},this.getDataForReply=function(a){return{screenNames:tweetHelper.extractMentionsForReply(a,this.attr.screenName),replyLinkClick:!0}},this.toggleFavorite=function(a,b,c){var d=c.$tweet.hasClass(this.attr.favoritedTweetClass)?"uiDidUnfavoriteTweet":"uiDidFavoriteTweet";this.trigger(c.$tweet,d,c.tweetData)},this.toggleRetweet=function(a,b,c){var d=c.$tweet.hasClass(this.attr.retweetedTweetClass)?"uiDidUnretweet":"uiOpenRetweetDialog";this.trigger(c.$tweet,d,c.tweetData)},this.openSigninOrSignupDialog=function(a,b,c){this.trigger("uiOpenSigninOrSignupDialog")},this.handleLoggedOutFavoriteClick=function(a,b){this.trigger("uiLoggedOutActionAttempt",{action:"favorite_attempt"})},this.handleLoggedOutRetweetClick=function(a,b){this.trigger("uiLoggedOutActionAttempt",{action:"retweet_attempt"})},this.handleLoggedOutReplyClick=function(a,b){this.trigger("uiLoggedOutActionAttempt",{action:"reply_attempt"})},this.after("initialize",function(){if(!this.attr.loggedIn){this.on("click",{anyLoggedInActionSelector:this.composeHandler(this.preventDefault,this.openSigninOrSignupDialog),favoriteSelector:this.handleLoggedOutFavoriteClick,retweetSelector:this.handleLoggedOutRetweetClick,replySelector:this.handleLoggedOutReplyClick});return}var a=this.mkTweetDataCollectorForAction(this.interactionDataWithCard),b=this.mkTweetDataCollectorForAction(this.interactionDataWithCard,this.getDataForReply);this.on("click",{favoriteSelector:this.composeHandler(this.preventDefault,this.getClosestTweet,a,this.toggleFavorite),retweetSelector:this.composeHandler(this.preventDefault,this.getClosestTweet,a,this.toggleRetweet),replySelector:this.composeHandler(this.preventDefault,this.getClosestTweet,b,this.triggerTweetAction("uiReplyToTweet")),shareViaEmailSelector:this.composeHandler(this.preventDefault,this.getClosestTweet,a,this.triggerTweetAction("uiNeedsShareViaEmailDialog")),deleteSelector:this.composeHandler(this.preventDefault,this.getClosestTweet,a,this.triggerTweetAction("uiOpenDeleteDialog")),permalinkSelector:this.composeHandler(this.getClosestTweet,a,this.triggerTweetAction("uiPermalinkClick"))}),this.on(document,"uiDidFavoriteTweet dataFailedToUnfavoriteTweet",this.handleTransition("addClass",this.attr.favoritedTweetClass)),this.on(document,"uiDidUnfavoriteTweet dataFailedToFavoriteTweet",this.handleTransition("removeClass",this.attr.favoritedTweetClass)),this.on(document,"uiDidRetweet dataFailedToUnretweet",this.handleTransition("addClass",this.attr.retweetedTweetClass)),this.on(document,"uiDidUnretweet dataFailedToRetweet",this.handleTransition("removeClass",this.attr.retweetedTweetClass))})}var defineComponent=require("core/component"),findTweet=require("app/utils/find_tweet"),tweetHelper=require("app/utils/tweet_helper"),withTweetActionsHelper=require("app/ui/with_tweet_actions_helper"),withInteractionData=require("app/ui/with_interaction_data"),TweetActions=defineComponent(tweetActions,withTweetActionsHelper,withInteractionData);module.exports=TweetActions
});
define("app/ui/tweet_state_updater",["module","require","exports","core/component"],function(module, require, exports) {
function tweetStateUpdater(){this.updateRetweetState=function(a,b){var c=this.$node.find('[data-tweet-id="'+b.tweet_id+'"]');c.each(function(){$(this).attr("data-my-retweet-id",b.retweet_id)})},this.updateUnRetweetState=function(a,b){var c=this.$node.find('[data-tweet-id="'+b.tweet_id+'"]');c.each(function(){$(this).removeAttr("data-my-retweet-id")})},this.after("initialize",function(){if(!this.attr.loggedIn)return;this.on(document,"dataDidRetweet",this.updateRetweetState),this.on(document,"dataDidUnretweet",this.updateUnRetweetState)})}var defineComponent=require("core/component"),TweetStateUpdater=defineComponent(tweetStateUpdater);module.exports=TweetStateUpdater
});
define("app/ui/dialogs/uz_survey",["module","require","exports","core/component"],function(module, require, exports) {
function uzSurvey(){this.defaultAttrs({backgroundSelector:"#uz_bg",containerSelector:"#uz_popup_container",backgroundParentSelector:"body",blockUserSurveyClass:"uz_block_user_survey"}),this.fadeoutSurvey=function(a){$(this.attr.containerSelector).fadeOut(500)},this.openSurvey=function(){window._uzactions=window._uzactions||[];var a=this.overrideCookie?this.overrideCookie:"twittersurvey"+this.surveyId;_uzactions.push(["_setCookie",a]);var b=document.getElementsByTagName("script")[0];b.parentNode.insertBefore($.extend(document.createElement("script"),{type:"text/javascript",async:!0,id:"injected_uz_survey_script",charset:"utf-8",src:"//cdn4.userzoom.com/files/js/"+this.surveyId+".js?t=uz_til&cuid=2BA733EB49F6DF1188490022196C4538"}),b)},this.onBlockAction=function(){this.$node.hasClass(this.attr.blockUserSurveyClass)&&this.openSurvey()},this.after("initialize",function(){this.surveyId=this.$node.attr("data-survey-id"),this.overrideCookie=this.$node.attr("data-override-cookie"),this.$node.attr("data-show")&&this.openSurvey(),this.on(document,"uiOpenSurvey",this.openSurvey),this.on(this.attr.backgroundParentSelector,"click",{backgroundSelector:this.fadeoutSurvey}),this.on(document,"uiBlockAction",this.onBlockAction)})}var defineComponent=require("core/component");module.exports=defineComponent(uzSurvey)
});
define("app/data/with_scribe_data_from_dom",["module","require","exports"],function(module, require, exports) {
function withScribeDataFromDom(){this.defaultAttrs({itemType:"",eventData:{scribeContext:{component:""}}}),this.setItemType=function(a){if(this.attr.itemType)return;var b=a.closest("[data-item-type]"),c=b.closest("[data-component-term]");this.attr.itemType=b.data("item-type")||this.attr.itemType,this.attr.eventData.scribeContext.component=c.data("component-term")||this.attr.eventData.scribeContext.component,this.attr.eventData.scribeContext.component||console.warn('You must configure your component with a "data-item-type" attribute in the DOM, with the value of activity, story, user, tweet, list, or trend in order for it to scribe properly.')},this.getItemPosition=function(a){var b=$(this.attr.genericInteractionItemSelector).index(a.closest(this.attr.genericInteractionItemSelector));if(b!=-1)return b}}module.exports=withScribeDataFromDom
});
define("app/ui/with_inline_retweet",["module","require","exports","core/i18n"],function(module, require, exports) {
function withInlineRetweet(){this.handleSuccessfulRetweet=function(a,b){this.retweetEventInfo!==undefined&&this.trigger("uiDidRetweetSuccess",this.retweetEventInfo),delete this.retweetEventInfo},this.around("toggleRetweet",function(a,b,c,d){var e=d.$tweet.hasClass(this.attr.retweetedTweetClass),f=e?"uiDidUnretweet":"uiDidRetweet",g=e?_('\u30ea\u30c4\u30a4\u30fc\u30c8'):_('\u30ea\u30c4\u30a4\u30fc\u30c8\u6e08\u307f');e||(this.retweetEventInfo=d.tweetData),this.trigger(d.$tweet,f,d.tweetData),this.select("retweetSelector").find(".u-hiddenVisually").text(g)}),this.after("initialize",function(){if(!this.attr.loggedIn)return;this.on(document,"dataDidRetweet",this.handleSuccessfulRetweet)})}var _=require("core/i18n");module.exports=withInlineRetweet
});
define("app/data/sms_confirmation_data",["module","require","exports","core/component","app/data/with_data"],function(module, require, exports) {
function smsConfirmationData(){this.smsConfirmationAjaxCall=function(a,b,c){function d(a){a.error?this.trigger("uiAlertBanner",a):this.trigger(c,{message:a.message})}var e=$.extend({user_id:a.userId},a);this.post({url:b,data:e,success:d.bind(this),error:"dataUserActionError"})},this.sendPinAction=function(a,b){var c={phone_number:b.phone_number,country_code:b.country_code};this.smsConfirmationAjaxCall(c,"/i/devices/sms_confirmation_begin","dataSendPinSuccess")},this.resendPinAction=function(a,b){var c={phone_number:b.phone_number,country_code:b.country_code,resend:!0};this.smsConfirmationAjaxCall(c,"/i/devices/sms_confirmation_begin","dataResendPinSuccess")},this.verifyPinAction=function(a,b){var c={numeric_pin:b.numeric_pin,phone_number:b.phone_number,country_code:b.country_code};this.smsConfirmationAjaxCall(c,"/i/devices/sms_confirmation_complete","dataVerifyPinSuccess")},this.after("initialize",function(){this.on(document,"uiSendPinAction",this.sendPinAction),this.on(document,"uiResendPinAction",this.resendPinAction),this.on(document,"uiVerifyPinAction",this.verifyPinAction)})}var defineComponent=require("core/component"),withData=require("app/data/with_data"),SmsConfirmationData=defineComponent(smsConfirmationData,withData);module.exports=SmsConfirmationData
});
define("app/ui/forms/select_box",["module","require","exports","core/component"],function(module, require, exports) {
function selectBox(){this.clickItems=function(a,b){this.trigger("uiItemClick")},this.itemSelect=function(){var a,b={index:this.node.selectedIndex},c,d;if(this.node.selectedIndex>=0){d=this.node.options[this.node.selectedIndex];for(c=0;c<d.attributes.length;c++)a=d.attributes[c].name,b[a]=d.attributes[c].value;b.text=d.innerHTML}this.trigger("uiItemSelect",b)},this.setItems=function(a,b){this.$node.empty(),b.items&&b.items.forEach(function(a){var b=$("<option />"),c;for(c in a)c=="text"?b.html(a[c]):b.attr(c,a[c]);b.appendTo(this.$node)}.bind(this)),this.itemSelect()},this.after("initialize",function(){this.node.jquery&&(this.node=this.node[0]),this.attr.items&&this.node.trigger("setItems",{items:this.attr.items}),this.on("setItems",this.setItems),this.on("change",this.itemSelect),this.on("mousedown",this.clickItems)})}var defineComponent=require("core/component");module.exports=defineComponent(selectBox)
});
define("app/ui/with_phone_pin_verification",["module","require","exports","core/i18n","app/ui/forms/select_box"],function(module, require, exports) {
function withPhonePinVerification(){this.defaultAttrs({countryCodeDisplaySelector:"#country_code_display",countryCodeSelector:"#country_code",countryNameSelector:"#device_country_code",phoneNumberSelector:"#phone_number",pinCodeSelector:"#numeric_pin",pinCodeSelectorRaw:"#numeric_pin_raw",submitRegisterButtonSelector:"#send_verification_pin",submitVerifyButtonSelector:"#device_verify"}),this.updateCountryCode=function(a,b){countryCode=b.value,this.select("countryCodeDisplaySelector").html("+"+countryCode),this.select("countryCodeSelector").val(countryCode),this.select("phoneNumberSelector").val()!=""&&this.callbackIfValidPhoneNumber(this.clearInvalidPhoneMessage)},this.callbackIfValidPhoneNumber=function(a){var b=this.select("countryCodeSelector").val(),c=this.select("phoneNumberSelector").val(),d=this.validatePhoneNumber(b,c);d?a.call(this):this.showInvalidPhoneMessage(b)},this.showInvalidPhoneMessage=function(a){var b=_('\u7c73\u56fd\u304a\u3088\u3073\u30ab\u30ca\u30c0\u306e\u96fb\u8a71\u756a\u53f7\u306f11\u6841\u3067\u3042\u308b\u5fc5\u8981\u304c\u3042\u308a\u307e\u3059\u3002'),c=_('\u3053\u306e\u96fb\u8a71\u756a\u53f7\u306f\u7121\u52b9\u306a\u3088\u3046\u3067\u3059\u3002'),d=a==="1"?b:c;d+=_('\u6709\u52b9\u306a\u96fb\u8a71\u756a\u53f7\u3092\u5165\u529b\u3057\u3066\u304f\u3060\u3055\u3044\u3002'),this.trigger("uiAlertBanner",{message:d})},this.clearInvalidPhoneMessage=function(){this.trigger("uiAlertBannerClose")},this.validatePhoneNumber=function(a,b){var c=/\(*\)*\+*-*#* */g,d=b.replace(c,""),e=/^\d{11}$/;return a!="1"&&(e=/^\d{10,15}$/),e.test(a+d)},this.enableIfValue=function(a){return function(b,c){var d=b.target||b.srcElement;this.select(a).attr("disabled",d.value==="")}},this.stripPin=function(a){return a.replace(/[^a-zA-Z0-9]/g,"")},this.after("initialize",function(){SelectBox.attachTo(this.attr.countryNameSelector),this.on(this.attr.countryNameSelector,"uiItemSelect",this.updateCountryCode),this.on("input",{phoneNumberSelector:this.enableIfValue("submitRegisterButtonSelector"),pinCodeSelectorRaw:this.enableIfValue("submitVerifyButtonSelector")})})}var _=require("core/i18n"),SelectBox=require("app/ui/forms/select_box");module.exports=withPhonePinVerification
});
define("app/ui/dialogs/sms_confirmation_dialog",["module","require","exports","core/component","core/i18n","app/ui/with_dialog","app/ui/with_phone_pin_verification"],function(module, require, exports) {
function smsConfirmationDialog(){this.defaultAttrs({phoneNumberInputModalSelector:"#sms-confirmation-begin-modal",pinVerificationModalSelector:"#sms-confirmation-complete-modal",alertBoxSelector:"#sms-alert-box",alertMessageSelector:"#sms-alert-message",alertBoxCloseSelector:"#sms-alert-close",authenticityTokenSelector:"#authenticity_token",resendCodeSelector:"#resend_code"}),this.setUpDialog=function(a,b){this.reset(),this.open()},this.reset=function(){this.select("pinVerificationModalSelector").hide(),this.select("phoneNumberSelector").val(""),this.savedPhoneNumber="",this.savedCountryCode=""},this.afterOpen=function(){this.position(),this.select("alertBoxSelector").hide()},this.alertBannerHandler=function(a,b){this.showAlert(b.message)},this.showAlert=function(a){this.select("alertBoxSelector").show(),this.select("alertMessageSelector").text(a)},this.hideAlert=function(){this.select("alertBoxSelector").hide(),this.select("alertMessageSelector").text("")},this.sendPinCode=function(a,b){a.preventDefault(),this.callbackIfValidPhoneNumber(function(){var a=this.select("phoneNumberSelector").val(),b=this.select("countryCodeSelector").val();this.savedPhoneNumber=a,this.savedCountryCode=b,this.trigger("uiSendPinAction",{phone_number:a,country_code:b})})},this.resendPinCode=function(){this.trigger("uiResendPinAction",{phone_number:this.savedPhoneNumber,country_code:this.savedCountryCode})},this.verifyPinCode=function(a,b){a.preventDefault();var c=this.stripPin(this.select("pinCodeSelectorRaw").val());if(!c){this.showAlert(_('\u30b3\u30fc\u30c9\u304c\u9593\u9055\u3063\u3066\u3044\u307e\u3059\u3002\u518d\u5ea6\u304a\u8a66\u3057\u306b\u306a\u308b\u304b\u3001\u65b0\u3057\u3044\u30b3\u30fc\u30c9\u3092\u30ea\u30af\u30a8\u30b9\u30c8\u3057\u3066\u304f\u3060\u3055\u3044\u3002'));return}this.trigger("uiVerifyPinAction",{numeric_pin:c,phone_number:this.savedPhoneNumber,country_code:this.savedCountryCode})},this.sendPinSuccess=function(a,b){this.select("phoneNumberInputModalSelector").remove(),this.hideAlert();var c=this.trimSavedPhoneNumber();this.select("pinVerificationModalSelector").find("#phone_number_to_verify").html(c),this.select("pinVerificationModalSelector").show(),this.trigger("uiVerifyPinFormImpression")},this.trimSavedPhoneNumber=function(){var a=/\(*\)*\+*-*#* */g,b=this.savedPhoneNumber.replace(a,"");return this.savedCountryCode+b},this.verifyPinSuccess=function(a,b){this.isCompleted=!0,this.close(),this.trigger("uiShowMessage",{message:_('\u30a2\u30ab\u30a6\u30f3\u30c8\u306e\u30ed\u30c3\u30af\u306f\u89e3\u9664\u3055\u308c\u3066\u3044\u307e\u3059\u3002')})},this.resendPinSuccess=function(a,b){this.showAlert(b.message)},this.updateSmsConfirmationCountryCode=function(a,b){this.trigger("uiSmsConfirmationCountryChange")},this.phoneNumberInput=function(a,b){this.startedPhoneInput||(this.trigger("uiSmsConfirmationPhoneNumberInput"),this.startedPhoneInput=!0)},this.pinInput=function(a,b){this.startedPinInput||(this.trigger("uiSmsConfirmationPinCodeInput"),this.startedPinInput=!0)},this.around("close",function(a){this.isOpen()&&!this.isCompleted&&this.trigger("uiCancelSmsConfirmationDialog"),a()}),this.after("initialize",function(){this.on(document,"uiNeedsSmsConfirmationDialog",this.setUpDialog),this.on("uiDialogOpened",this.afterOpen),this.on(document,"dataSendPinSuccess",this.sendPinSuccess),this.on(document,"dataResendPinSuccess",this.resendPinSuccess),this.on(document,"dataVerifyPinSuccess",this.verifyPinSuccess);var a=this.attr.show_sms_confirmation_dialog;a&&this.trigger("uiNeedsSmsConfirmationDialog"),this.on("click",{submitRegisterButtonSelector:this.sendPinCode,submitVerifyButtonSelector:this.verifyPinCode,alertBoxCloseSelector:this.clearInvalidPhoneMessage,resendCodeSelector:this.resendPinCode}),this.on("uiAlertBanner",this.alertBannerHandler),this.on("uiAlertBannerClose",this.hideAlert),this.on("submit",{phoneNumberInputModalSelector:this.sendPinCode,pinVerificationModalSelector:this.verifyPinCode}),this.on("change",{countryNameSelector:this.updateSmsConfirmationCountryCode}),this.on("input",{phoneNumberSelector:this.phoneNumberInput,pinCodeSelectorRaw:this.pinInput}),this.startedPhoneInput=!1,this.startedPinInput=!1,this.isCompleted=!1})}var defineComponent=require("core/component"),_=require("core/i18n"),withDialog=require("app/ui/with_dialog"),withPhonePinVerification=require("app/ui/with_phone_pin_verification"),SmsConfirmationDialog=defineComponent(withDialog,withPhonePinVerification,smsConfirmationDialog);module.exports=SmsConfirmationDialog
});
define("app/data/sms_confirmation_scribe",["module","require","exports","core/component","app/data/client_event","app/data/with_scribe"],function(module, require, exports) {
function smsConfirmationScribe(){this.scribeDialogImpression=function(a,b){this.scribe({component:"sms_confirmation_dialog",action:"impression"},b)},this.scribeCountryChange=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"mobile_country_code",action:"change"},b)},this.scribePhoneNumberInput=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"phone_number",action:"change"},b)},this.scribeSendPinClick=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"activate_mobile",action:"click"},b)},this.scribeVerifyPinFormImpression=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"verify_pin",action:"impression"},b)},this.scribePinCodeInput=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"verify_pin",action:"input"},b)},this.scribeVerifyButtonClick=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"verify_pin",action:"click"},b)},this.scribeResendPinCodeButtonClick=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"resend_pin",action:"click"},b)},this.scribeDialogCancelClick=function(a,b){this.scribe({component:"sms_confirmation_dialog",action:"cancel"},b)},this.scribeUnlockSuccessImpression=function(a,b){this.scribe({component:"sms_confirmation_dialog",element:"verify_pin",action:"success"},b)},this.after("initialize",function(){this.on("dataVerifyPinSuccess",this.scribeUnlockSuccessImpression),this.on("uiCancelSmsConfirmationDialog",this.scribeDialogCancelClick),this.on("uiNeedsSmsConfirmationDialog",this.scribeDialogImpression),this.on("uiResendPinAction",this.scribeResendPinCodeButtonClick),this.on("uiSendPinAction",this.scribeSendPinClick),this.on("uiSmsConfirmationCountryChange",this.scribeCountryChange),this.on("uiSmsConfirmationPhoneNumberInput",this.scribePhoneNumberInput),this.on("uiSmsConfirmationPinCodeInput",this.scribePinCodeInput),this.on("uiVerifyPinAction",this.scribeVerifyButtonClick),this.on("uiVerifyPinFormImpression",this.scribeVerifyPinFormImpression)})}var defineComponent=require("core/component"),clientEvent=require("app/data/client_event"),withScribe=require("app/data/with_scribe");module.exports=defineComponent(smsConfirmationScribe,withScribe)
});
define("app/boot/app",["module","require","exports","app/ui/dialogs/age_gate_dialog","app/ui/dialogs/block_or_report","app/ui/dialogs/block_user_dialog","app/boot/common","app/ui/dialogs/buy_now_dialog","app/ui/dialogs/captcha_challenge_dialog","app/ui/dialogs/confirm_dialog","app/ui/connect_badge","app/ui/dialogs/create_custom_timeline_dialog","app/ui/dialogs/curate_dialog","app/ui/dashboard","app/ui/dialogs/delete_tweet_dialog","app/data/sms/device_verification","app/ui/sms/device_verification_banner","app/boot/direct_messages","app/data/dm_poll","app/ui/drag_state","app/ui/banners/email_banner","app/data/email_banner","app/data/email_banner_scribe","app/data/embed_scribe","app/ui/dialogs/embed_tweet","app/data/feedback/feedback","app/ui/feedback/feedback_dialog","app/ui/feedback/feedback_report_link_handler","app/ui/gallery/gallery","app/data/gallery_scribe","app/ui/global_loading_indicator","app/ui/dialogs/goto_user_dialog","app/ui/dialogs/keyboard_shortcuts_dialog","app/ui/dialogs/leadgen_confirm_dialog","app/ui/dialogs/list_membership_dialog","app/ui/dialogs/list_operations_dialog","app/data/sms/sms_download_scribe","app/ui/more_tweet_actions_dropdown","app/ui/multiline_ellipses","app/ui/navigation_links","app/data/notification_listener","app/data/oembed","app/data/oembed_scribe","app/ui/overlay_navigation","app/data/overlay_navigation","app/ui/page_title","app/ui/page_visibility","app/ui/dialogs/payment_order_dialog","app/ui/dialogs/permalink_overlay","app/boot/profile_popup","app/ui/responsive_dashboard_width","app/ui/dialogs/retweet_dialog","app/data/saved_searches","app/data/saved_searches_scribe","app/ui/search_query_source","app/utils/setup_polling_with_backoff","app/ui/dialogs/share_via_email_dialog","app/data/spam_challenge","app/ui/spoonbill","app/ui/spoonbill_producer","app/boot/top_bar","app/data/typeahead/typeahead","app/data/typeahead/typeahead_scribe","app/ui/tweet_actions","app/ui/tweet_state_updater","app/ui/dialogs/uz_survey","app/data/with_scribe_data_from_dom","app/ui/with_inline_retweet","app/data/sms_confirmation_data","app/ui/dialogs/sms_confirmation_dialog","app/data/sms_confirmation_scribe"],function(module, require, exports) {
var AgeGateDialog=require("app/ui/dialogs/age_gate_dialog"),BlockOrReportDialog=require("app/ui/dialogs/block_or_report"),BlockUserDialog=require("app/ui/dialogs/block_user_dialog"),bootCommon=require("app/boot/common"),BuyNowConfirmDialog=require("app/ui/dialogs/buy_now_dialog"),CaptchaChallengeDialog=require("app/ui/dialogs/captcha_challenge_dialog"),ConfirmDialog=require("app/ui/dialogs/confirm_dialog"),ConnectBadge=require("app/ui/connect_badge"),CreateCustomTimelineDialog=require("app/ui/dialogs/create_custom_timeline_dialog"),CurateDialog=require("app/ui/dialogs/curate_dialog"),Dashboard=require("app/ui/dashboard"),DeleteTweetDialog=require("app/ui/dialogs/delete_tweet_dialog"),DeviceVerification=require("app/data/sms/device_verification"),DeviceVerificationBanner=require("app/ui/sms/device_verification_banner"),directMessages=require("app/boot/direct_messages"),DMPoll=require("app/data/dm_poll"),DragState=require("app/ui/drag_state"),EmailBanner=require("app/ui/banners/email_banner"),EmailBannerData=require("app/data/email_banner"),EmailBannerScribe=require("app/data/email_banner_scribe"),EmbedScribe=require("app/data/embed_scribe"),EmbedTweetDialog=require("app/ui/dialogs/embed_tweet"),Feedback=require("app/data/feedback/feedback"),FeedbackDialog=require("app/ui/feedback/feedback_dialog"),FeedbackReportLinkHandler=require("app/ui/feedback/feedback_report_link_handler"),Gallery=require("app/ui/gallery/gallery"),GalleryScribe=require("app/data/gallery_scribe"),GlobalLoadingIndicator=require("app/ui/global_loading_indicator"),GotoUserDialog=require("app/ui/dialogs/goto_user_dialog"),KeyboardShortcutsDialog=require("app/ui/dialogs/keyboard_shortcuts_dialog"),LeadGenConfirmDialog=require("app/ui/dialogs/leadgen_confirm_dialog"),ListMembershipDialog=require("app/ui/dialogs/list_membership_dialog"),ListOperationsDialog=require("app/ui/dialogs/list_operations_dialog"),MobileDownloadScribe=require("app/data/sms/sms_download_scribe"),MoreTweetActionsDropdown=require("app/ui/more_tweet_actions_dropdown"),MultilineEllipses=require("app/ui/multiline_ellipses"),NavigationLinks=require("app/ui/navigation_links"),NotificationListener=require("app/data/notification_listener"),OembedData=require("app/data/oembed"),OembedScribe=require("app/data/oembed_scribe"),OverlayNavigationUI=require("app/ui/overlay_navigation"),OverlayNavigationData=require("app/data/overlay_navigation"),PageTitle=require("app/ui/page_title"),PageVisibility=require("app/ui/page_visibility"),PaymentOrderDialog=require("app/ui/dialogs/payment_order_dialog"),PermalinkOverlay=require("app/ui/dialogs/permalink_overlay"),profilePopup=require("app/boot/profile_popup"),ResponsiveDashboardWidth=require("app/ui/responsive_dashboard_width"),RetweetDialog=require("app/ui/dialogs/retweet_dialog"),SavedSearchesData=require("app/data/saved_searches"),SavedSearchesScribe=require("app/data/saved_searches_scribe"),SearchQuerySource=require("app/ui/search_query_source"),setupPollingWithBackoff=require("app/utils/setup_polling_with_backoff"),ShareViaEmailDialog=require("app/ui/dialogs/share_via_email_dialog"),SpamChallengeData=require("app/data/spam_challenge"),Spoonbill=require("app/ui/spoonbill"),SpoonbillProducer=require("app/ui/spoonbill_producer"),topBar=require("app/boot/top_bar"),TypeaheadData=require("app/data/typeahead/typeahead"),TypeaheadScribe=require("app/data/typeahead/typeahead_scribe"),TweetActionsUI=require("app/ui/tweet_actions"),TweetStateUpdater=require("app/ui/tweet_state_updater"),uzSurvey=require("app/ui/dialogs/uz_survey"),withScribeDataFromDom=require("app/data/with_scribe_data_from_dom"),withInlineRetweet=require("app/ui/with_inline_retweet"),SmsConfirmationData=require("app/data/sms_confirmation_data"),SmsConfirmationDialog=require("app/ui/dialogs/sms_confirmation_dialog"),SmsConfirmationScribe=require("app/data/sms_confirmation_scribe");module.exports=function(b){bootCommon(b),topBar(b),PageTitle.attachTo(document,{noTeardown:!0}),Dashboard.attachTo(".dashboard",b),ResponsiveDashboardWidth.attachTo(document),b.dragAndDropPhotoUpload&&DragState.attachTo("body"),b.permalinkOverlayEnabled&&(PermalinkOverlay.attachTo(".PermalinkOverlay",{noTeardown:!0}),OverlayNavigationUI.attachTo(document,{pushState:b.pushState,noTeardown:!0}),OverlayNavigationData.attachTo(document,{currentPageName:b.pageName,underlyingSectionName:b.sectionName,pushState:b.pushState,noTeardown:!0})),SearchQuerySource.attachTo("body",{noTeardown:!0}),ConfirmDialog.attachTo(document,{noTeardown:!0}),CaptchaChallengeDialog.attachTo("#spam_challenge_dialog",{noTeardown:!0}),SpamChallengeData.attachTo(document,b,{noTeardown:!0}),b.loggedIn&&(NotificationListener.attachTo(document,b,{noTeardown:!0}),DMPoll.attachTo(document,b,{noTeardown:!0}),ListMembershipDialog.attachTo("#list-membership-dialog",b,{noTeardown:!0}),ListOperationsDialog.attachTo("#list-operations-dialog",b,{noTeardown:!0}),CreateCustomTimelineDialog.attachTo("#create-custom-timeline-dialog",b),CurateDialog.attachTo("#curate-dialog",b),directMessages(b),EmailBanner.attachTo(document,{noTeardown:!0}),EmailBannerScribe.attachTo(document,{noTeardown:!0}),EmailBannerData.attachTo(document,{noTeardown:!0}),b.skipDeviceVerificationBanner||DeviceVerificationBanner.attachTo("#page-container"),DeviceVerification.attachTo(document),MobileDownloadScribe.attachTo(document)),TypeaheadScribe.attachTo(document,{noTeardown:!0}),TypeaheadData.attachTo(document,b.typeaheadData,{noTeardown:!0}),SavedSearchesScribe.attachTo(document,{noTeardown:!0}),SavedSearchesData.attachTo(document,{noTeardown:!0}),GotoUserDialog.attachTo("#goto-user-dialog",b),profilePopup({profileHoversEnabled:b.profileHoversEnabled,profile_user:b.profile_user,deviceEnabled:b.deviceEnabled,deviceVerified:b.deviceVerified,formAuthenticityToken:b.formAuthenticityToken,loggedIn:b.loggedIn,asyncSocialProof:b.asyncSocialProof,injectTweetOnFollow:b.injectTweetOnFollow}),GalleryScribe.attachTo(document,{noTeardown:!0});var c={itemType:"tweet",noTeardown:!0,loggedIn:b.loggedIn,eventData:{scribeContext:{component:"gallery"}}};Gallery.attachTo(".Gallery",b,c),TweetActionsUI.attachTo(".Gallery",b,c),MoreTweetActionsDropdown.attachTo(".Gallery",b,c),OembedScribe.attachTo(document,{noTeardown:!0}),OembedData.attachTo(document,b),KeyboardShortcutsDialog.attachTo(document,{noTeardown:!0,loggedIn:b.loggedIn,enableActivity:b.enableActivity}),RetweetDialog.attachTo("#retweet-tweet-dialog",b,{noTeardown:!0}),DeleteTweetDialog.attachTo("#delete-tweet-dialog",b,{noTeardown:!0}),BlockUserDialog.attachTo("#block-user-dialog",b,{noTeardown:!0}),ShareViaEmailDialog.attachTo("#share-via-email-dialog",b,{noTeardown:!0}),EmbedScribe.attachTo(document,{noTeardown:!0}),EmbedTweetDialog.attachTo("#embed-tweet-dialog",b,{noTeardown:!0}),BlockOrReportDialog.attachTo("#block-or-report-dialog",b,{noTeardown:!0}),AgeGateDialog.attachTo("#age-gate-dialog",b,{noTeardown:!0}),LeadGenConfirmDialog.attachTo("#leadgen-confirm-dialog",b),setupPollingWithBackoff("uiWantsToRefreshTimestamps"),PageVisibility.attachTo(document),NavigationLinks.attachTo(".dashboard",{eventData:{scribeContext:{component:"dashboard_nav"}}}),FeedbackDialog.attachTo("#feedback_dialog",b.debugData,{noTeardown:!0}),Feedback.attachTo(document,b.debugData,{noTeardown:!0}),$(".uz_block_user_survey")[0]&&uzSurvey.attachTo(".uz_block_user_survey"),FeedbackReportLinkHandler.attachTo(document,b.debugData,{noTeardown:!0}),Spoonbill.attachTo("#spoonbill-outer",b,{noTeardown:!0}),TweetActionsUI.mixin(withScribeDataFromDom,withInlineRetweet).attachTo("#spoonbill-outer",b,{eventData:{scribeContext:{component:"spoonbill"}},tweetItemSelector:".WebToast",favoriteSelector:".js-actionFavorite",replySelector:".js-actionReply",retweetSelector:".js-actionInlineRetweet",noTeardown:!0}),SpoonbillProducer.attachTo("#spoonbill-outer",b,{noTeardown:!0}),GlobalLoadingIndicator.attachTo(document,b,{noTeardown:!0}),ConnectBadge.attachTo(document,b,{noTeardown:!0}),BuyNowConfirmDialog.attachTo("#buy-now-dialog",b,{noTeardown:!0}),PaymentOrderDialog.attachTo("#payment-order-detail-dialog",b,{noTeardown:!0}),MultilineEllipses.attachTo(document),TweetStateUpdater.attachTo(document,b,{noTeardown:!0}),SmsConfirmationData.attachTo("#sms-confirmation-dialog"),SmsConfirmationDialog.attachTo("#sms-confirmation-dialog",b,{noTeardown:!0}),SmsConfirmationScribe.attachTo(document)}
});define("lib/twitter_cldr",["module","require","exports"],function(a,b,c){(function(){var a,b,d,e;a={};a.is_rtl=!1;a.Utilities=function(){function a(){}a.from_char_code=function(a){if(a>65535){a-=65536;return String.fromCharCode(55296+(a>>10),56320+(a&1023)
)}return String.fromCharCode(a)};a.char_code_at=function(a,b){var c,d,e,f,g,i;a+="";d=a.length;i=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g;while(i.exec(a)!==null){f=i.lastIndex;if(!(f-2<b))break;b+=1}if(b>=d||b<0)return NaN;c=a.charCodeAt(b);if(55296<=c&&c<=56319)
{e=c;g=a.charCodeAt(b+1);return(e-55296)*1024+(g-56320)+65536}return c};a.unpack_string=function(a){var b,c,d,e,f;d=[];for(c=e=0,f=a.length;0<=f?e<f:e>f;c=0<=f?++e:--e){b=this.char_code_at(a,c);if(!b)break;d.push(b)}return d};a.pack_array=function(a){var b
;return function(){var c,d,e;e=[];for(c=0,d=a.length;c<d;c++){b=a[c];e.push(this.from_char_code(b))}return e}.call(this).join("")};a.arraycopy=function(a,b,c,d,e){var f,g,i,j,k;k=a.slice(b,b+e);for(f=i=0,j=k.length;i<j;f=++i){g=k[f];c[d+f]=g}};a.max=function(
a){var b,c,d,e,f,g,i,j;d=null;for(e=f=0,i=a.length;f<i;e=++f){b=a[e];if(b!=null){d=b;break}}for(c=g=e,j=a.length;e<=j?g<=j:g>=j;c=e<=j?++g:--g)a[c]>d&&(d=a[c]);return d};a.min=function(a){var b,c,d,e,f,g,i,j;d=null;for(e=f=0,i=a.length;f<i;e=++f){b=a[e];if(
b!=null){d=b;break}}for(c=g=e,j=a.length;e<=j?g<=j:g>=j;c=e<=j?++g:--g)a[c]<d&&(d=a[c]);return d};a.is_even=function(a){return a%2===0};a.is_odd=function(a){return a%2===1};return a}();a.PluralRules=function(){function a(){}a.rules={keys:["other"],rule:function(
a){return"other"}};a.all=function(){return this.rules.keys};a.rule_for=function(a){var b;try{return this.rules.rule(a)}catch(c){b=c;return"other"}};return a}();a.TimespanFormatter=function(){function b(){this.approximate_multiplier=.75;this.default_type="default"
;this.tokens={ago:{second:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"秒前",type:"plaintext"}]}},minute:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"分前",type:"plaintext"}]}},hour:{"default":{other:[{value:"{0}",type:"placeholder"
},{value:"時間前",type:"plaintext"}]}},day:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"日前",type:"plaintext"}]}},week:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"週前",type:"plaintext"}]}},month:{"default":{other:[{value:"{0}",type
:"placeholder"},{value:"か月前",type:"plaintext"}]}},year:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"年前",type:"plaintext"}]}}},until:{second:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"秒後",type:"plaintext"}]}},minute:{"default"
:{other:[{value:"{0}",type:"placeholder"},{value:"分後",type:"plaintext"}]}},hour:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"時間後",type:"plaintext"}]}},day:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"日後",type:"plaintext"}]}},week
:{"default":{other:[{value:"{0}",type:"placeholder"},{value:" 週間後",type:"plaintext"}]}},month:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"か月後",type:"plaintext"}]}},year:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"年後",type:"plaintext"
}]}}},none:{second:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"秒",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"秒",type:"plaintext"}]},abbreviated:{other:[{value:"{0}",type:"placeholder"},{value:"秒",type:"plaintext"
}]}},minute:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"分",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"分",type:"plaintext"}]},abbreviated:{other:[{value:"{0}",type:"placeholder"},{value:"分",type:"plaintext"}
]}},hour:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"時間",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"時間",type:"plaintext"}]},abbreviated:{other:[{value:"{0}",type:"placeholder"},{value:"時間",type:"plaintext"}
]}},day:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"日",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"日",type:"plaintext"}]},abbreviated:{other:[{value:"{0}",type:"placeholder"},{value:"日",type:"plaintext"}]}},
week:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"週",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"週",type:"plaintext"}]}},month:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"か月",type:"plaintext"}
]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"か月",type:"plaintext"}]}},year:{"default":{other:[{value:"{0}",type:"placeholder"},{value:"年",type:"plaintext"}]},"short":{other:[{value:"{0}",type:"placeholder"},{value:"年",type:"plaintext"}]}}}};
this.time_in_seconds={second:1,minute:60,hour:3600,day:86400,week:604800,month:2629743.83,year:31556926}}b.prototype.format=function(b,c){var d,e,f,g,i,j;c==null&&(c={});g={};for(d in c){f=c[d];g[d]=f}g.direction||(g.direction=b<0?"ago":"until");if(g.unit===
null||g.unit===void 0)g.unit=this.calculate_unit(Math.abs(b),g);g.type||(g.type=this.default_type);g.number=this.calculate_time(Math.abs(b),g.unit);e=this.calculate_time(Math.abs(b),g.unit);g.rule=a.PluralRules.rule_for(e);i=function(){var a,b,c,d;c=this.tokens
[g.direction][g.unit][g.type][g.rule];d=[];for(a=0,b=c.length;a<b;a++){j=c[a];d.push(j.value)}return d}.call(this);return i.join("").replace(/\{[0-9]\}/,e.toString())};b.prototype.calculate_unit=function(a,b){var c,d,e,f;b==null&&(b={});f={};for(c in b){e=
b[c];f[c]=e}f.approximate==null&&(f.approximate=!1);d=f.approximate?this.approximate_multiplier:1;return a<this.time_in_seconds.minute*d?"second":a<this.time_in_seconds.hour*d?"minute":a<this.time_in_seconds.day*d?"hour":a<this.time_in_seconds.week*d?"day"
:a<this.time_in_seconds.month*d?"week":a<this.time_in_seconds.year*d?"month":"year"};b.prototype.calculate_time=function(a,b){return Math.round(a/this.time_in_seconds[b])};return b}();e=typeof c!="undefined"&&c!==null?c:(this.TwitterCldr={},this.TwitterCldr
);for(b in a){d=a[b];e[b]=d}}).call(this)})